#include	"compiler.h"

#include	"pc_core.h"
#include	"i286.h"
#include	"iobridge.h"
#include	"memory.h"
#include	"bios.h"
#include	"dmac.h"
#include	"fdc.h"
#include	"pic.h"
#include	"trace.h"

#define	baseport 0x00c8

void bios0x12(void) {

	BYTE	stat;
	BYTE	result;
	BYTE	*p;
	BYTE	drv;

//	TRACE_("BIOS", 0x12);
	pic_w(8, 0x20);
	if (!pic[1].isr) {
		pic_w(0, 0x20);
	}

	stat = fdc_r(baseport);
	while(1) {
		if (!(stat & FDCSTAT_CB)) {
			if ((stat & (FDCSTAT_RQM | FDCSTAT_DIO)) != FDCSTAT_RQM) {
				break;
			}
			fdc_w(baseport+2, 0x08);
			stat = fdc_r(baseport);
		}
		if ((stat & (FDCSTAT_RQM | FDCSTAT_DIO | FDCSTAT_CB))
							!= (FDCSTAT_RQM | FDCSTAT_DIO | FDCSTAT_CB)) {
			break;
		}
		result = fdc_r(baseport+2);
		if (result == FDCRLT_IC1) {
			if (mem[0x005d7]) {
				mem[0x005d7]--;
			}
			break;
		}
		drv = result & 3;
		if (result & (FDCRLT_IC1 | FDCRLT_SE)) {
			p = mem + 0x005d8 + (drv * 2);
		}
		else {
			p = mem + 0x005d0;
		}
		while(1) {
			*p++ = result;
			stat = fdc_r(baseport);
			if ((stat & (FDCSTAT_RQM | FDCSTAT_DIO | FDCSTAT_CB))
							!= (FDCSTAT_RQM | FDCSTAT_DIO | FDCSTAT_CB)) {
				break;
			}
			result = fdc_r(baseport+2);
		}
	}
}

