#include	"compiler.h"

#include	"pc_core.h"
#include	"i286.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"gdc_sub.h"
#include	"cgrom.h"
#include	"font.h"
#include	"serial.h"
#include	"bios.h"
#include	"crtc.h"
#include	"nevent.h"
#include	"pic.h"
#include	"trace.h"

extern BYTE screenupdate;

typedef struct {
	BYTE	GBON_PTN;
	BYTE	GBBCC;
	BYTE	GBDOTU;
	BYTE	GBDSP;
	BYTE	GBCPC[4];						// little endian
	BYTE	GBSX1[2];						// little endian
	BYTE	GBSY1[2];						// little endian
	WORD	GBLNG1;							// nc
	WORD	GBWDPA;							// nc
	WORD	GBRBUF[3];						// nc
	BYTE	GBSX2[2];						// little endian
	BYTE	GBSY2[2];						// little endian
	WORD	GBMDOT;							// nc
	WORD	GBCIR;							// nc
	WORD	GBLNG2;							// nc
	BYTE	GBMDOTI[8];						// little endian
	BYTE	GBDTYP;
	BYTE	GBFILL;
} UCW_TABLE;

#define	WSWAP(a, b) { WORD tmp = (a); (a) = (b); (b) = tmp; }

static void bios0x18_47(void);


static WORD keyget(void) {

	WORD	ret;
	WORD	kbcount;
	WORD	kbbufhead;

	kbcount = MEM_GETB(MEMB_KB_COUNT);

	if (kbcount) {
		MEM_SETB(MEMB_KB_COUNT, kbcount - 1);
		kbbufhead = MEM_GETW(MEMW_KB_BUF_HEAD);
		ret = MEM_GETW(kbbufhead);
		kbbufhead += 2;
		if (kbbufhead >= 0x0522) {
			kbbufhead = 0x0502;
		}
		MEM_SETW(MEMW_KB_BUF_HEAD, kbbufhead);
		return(ret);
	}
	return(0xffff);
}


static	int		sti_waiting = 0;

void bios0x18(void) {

	char		buf[34];
	BYTE		*p;
	int			i;
	UCW_TABLE	ucw;
	WORD		tmp;

	sti_waiting ^= 1;
	if (!sti_waiting) {					// ߵĤͷ
		I286_IP--;
		I286_STI;
		nevent_forceexit();
		return;
	}

	switch(I286_AH) {
		case 0x00:						// ǡɤߤ
			if (MEM_GETB(MEMB_KB_COUNT)) {
				I286_AX = keyget();
			}
			else {
				I286_IP--;
				nevent.remainclock = -1;
				break;
			}
			break;

   		case 0x01:						// Хåե֤Υ
			if (MEM_GETB(MEMB_KB_COUNT)) {
				WORD kbbufhead = MEM_GETW(MEMW_KB_BUF_HEAD);
				I286_AX = MEM_GETW(kbbufhead);
				I286_BH = 1;
			}
			else {
				I286_BH = 0;
			}
			break;

   		case 0x02:						// եȡ֤Υ
			I286_AL = MEM_GETB(MEMB_SHIFT_STS);
			break;

   		case 0x03:						// ܡɡ󥿥եν
			bios0x09_init();
			break;

   		case 0x04:						// Ͼ֤Υ
			I286_AH = MEM_GETB(0x00052a + (I286_AL & 0x0f));
 			break;

   		case 0x05:						// ϥ
			if (MEM_GETB(MEMB_KB_COUNT)) {
				I286_AX = keyget();
				I286_BH = 1;
			}
			else {
				I286_BH = 0;
			}
 			break;

   		case 0x0a:						// CRT⡼ɤ
			MEM_SETB(MEMB_CRT_STS_FLAG, (0x80 | (I286_AL & 0x0f)));
			// GDCХåե
			if (gdc.m.cnt) {
				gdc_work(GDCWORK_MASTER);
			}
			gdc_reset(&gdc.m);

			gdc.mode1 &= ~(0x25);
			gdc.mode1 |= 0x08;
			if (I286_AL & 0x02) {
				gdc.mode1 |= 0x04;				// 40
			}
			if (I286_AL & 0x04) {
				gdc.mode1 |= 0x01;				// ȥӥ塼
			}
			if (I286_AL & 0x08) {
				gdc.mode1 |= 0x20;				// ɥ
			}
			if (I286_AL & 0x01) {					// 20
				MEM_SETB(MEMB_CRT_RASTER, 0x13);
				gdc.m.para[GDC_CSRFORM + 0] = 0x13;
				gdc.m.para[GDC_CSRFORM + 1] = 0x00;
				gdc.m.para[GDC_CSRFORM + 2] = 0x9b;
				crtc.reg.pl = 0x1e;
				crtc.reg.bl = 0x11;
			}
			else {									// 25
				MEM_SETB(MEMB_CRT_RASTER, 0x0f);
				gdc.m.para[GDC_CSRFORM + 0] = 0x0f;
				gdc.m.para[GDC_CSRFORM + 1] = 0x00;
				gdc.m.para[GDC_CSRFORM + 2] = 0x7b;
				crtc.reg.pl = 0x00;
				crtc.reg.bl = 0x0f;
			}
			crtc.reg.cl = 0x10;
			crtc.reg.ssl = 0x00;
			gdcs.textdisp |= GDCSCRN_ALLDRAW2;
			gdc_restorekacmode();
			break;

   		case 0x0b:						// CRT⡼ɤΥ
			I286_AL = MEM_GETB(MEMB_CRT_STS_FLAG);
 			break;

   		case 0x0c:						// ƥȲ̤ɽ
			if (!(gdcs.textdisp & GDCSCRN_ENABLE)) {
				gdcs.textdisp |= GDCSCRN_ENABLE;
				screenupdate |= 2;
 			}
 			break;

   		case 0x0d:						// ƥȲ̤ɽλ
			if (gdcs.textdisp & GDCSCRN_ENABLE) {
				gdcs.textdisp &= ~(GDCSCRN_ENABLE);
				screenupdate |= 2;
			}
 			break;

		case 0x0e:						// Ĥɽΰ
			// GDCХåե
			if (gdc.m.cnt) {
				gdc_work(GDCWORK_MASTER);
			}
			gdc_reset(&gdc.m);

			ZeroMemory(gdc.m.para + GDC_SCROLL, 16);
			SETWORD(gdc.m.para + GDC_SCROLL, (I286_DX >> 1));
			gdcs.textdisp |= GDCSCRN_ALLDRAW2;
			screenupdate |= 2;
 			break;

		case 0x0f:						// ʣɽΰ
			MEM_SETW(0x0053e, I286_CX);
			MEM_SETW(0x00540, I286_BX);
			MEM_SETB(0x00547, I286_DH);
			MEM_SETB(0x0053D, I286_DL);
			// wait sync int
			if ((i = I286_DL) > 0) {
				BYTE	dh = I286_DH << 2;
				WORD	cx = I286_CX;
				while((i--) && (dh < 0x10)) {
					tmp = i286_memword_read(I286_BX, cx);
					SETWORD(gdc.m.para + GDC_SCROLL + dh, (tmp >> 1));
					tmp = i286_memword_read(I286_BX, cx + 2);
					if (!(MEM_GETB(MEMB_CRT_STS_FLAG) & 1)) {		// 25
						tmp *= (16 * 16);
					}
					else {								// 20
						tmp *= (20 * 16);
					}
					SETWORD(gdc.m.para + GDC_SCROLL + 2 + dh, tmp);
					cx += 4;
					dh += 4;
				}
			}
			gdcs.textdisp |= GDCSCRN_ALLDRAW2;
			screenupdate |= 2;
			break;

   		case 0x10:						// 륿פ
			// GDCХåե
			if (gdc.m.cnt) {
				gdc_work(GDCWORK_MASTER);
			}
			gdc_reset(&gdc.m);

			gdc.m.para[GDC_CSRFORM + 0] &= 0x7f;
			gdc.m.para[GDC_CSRFORM + 1] &= 0xdf;
			gdc.m.para[GDC_CSRFORM + 1] |= (I286_AL & 1) << 5;
			gdcs.textdisp |= GDCSCRN_EXT;
 			break;

   		case 0x11:						// ɽ
			// GDCХåե
			if (gdc.m.cnt) {
				gdc_work(GDCWORK_MASTER);
			}
			gdc_reset(&gdc.m);
													// 00/08/02
			{
				BYTE newcrtrastr;
				newcrtrastr = MEM_GETB(MEMB_CRT_RASTER) | 0x80;
				if (gdc.m.para[GDC_CSRFORM] != newcrtrastr) {
					gdc.m.para[GDC_CSRFORM] = newcrtrastr;
					gdcs.textdisp |= GDCSCRN_ALLDRAW | GDCSCRN_EXT;
				}
			}
			break;

   		case 0x12:						// ɽ
			// GDCХåե
			if (gdc.m.cnt) {
				gdc_work(GDCWORK_MASTER);
			}
			gdc_reset(&gdc.m);
													// 00/08/02
			{
				BYTE newcrtrastr;
				newcrtrastr = MEM_GETB(MEMB_CRT_RASTER);
				if (gdc.m.para[GDC_CSRFORM] != newcrtrastr) {
					gdc.m.para[GDC_CSRFORM] = newcrtrastr;
					gdcs.textdisp |= GDCSCRN_ALLDRAW | GDCSCRN_EXT;
				}
			}
			break;

   		case 0x13:						// ֤
			// GDCХåե
			if (gdc.m.cnt) {
				gdc_work(GDCWORK_MASTER);
			}
			gdc_reset(&gdc.m);

			if (GETWORD(gdc.m.para + GDC_CSRW) != (I286_DX >> 1)) {
				SETWORD(gdc.m.para + GDC_CSRW, (I286_DX >> 1));
				gdcs.textdisp |= GDCSCRN_EXT;
			}
 			break;

   		case 0x14:						// եȥѥɤ߽Ф
			switch(I286_DH) {
				case 0x00:			// 8x8
					i286_memword_write(I286_BX, I286_CX, 0x0101);
					i286_memstr_write(I286_BX, I286_CX+2,
										&font[0x82000 + (I286_DL << 3)], 8);
					break;

				case 0x28:			// 8x16 KANJI
				case 0x29:
				case 0x2a:
				case 0x2b:
					i286_memword_write(I286_BX, I286_CX, 0x0102);
					i286_memstr_write(I286_BX, I286_CX+2,
						&font[((I286_DL & 0x7f) << 12)
								+ ((I286_DH - 0x20) << 4)], 16);
					break;

				case 0x80:			// 8x16 ANK
					i286_memword_write(I286_BX, I286_CX, 0x0102);
					i286_memstr_write(I286_BX, I286_CX+2,
									&font[0x80000 + (I286_DL << 4)], 16);
					break;
				default:
					buf[0] = 0x02;
					buf[1] = 0x02;
					p = &font[((I286_DL & 0x7f) << 12)
								+ (((I286_DH - 0x20) & 0x7f) << 4)];
					for (i=1; i<17; i++, p++) {
						buf[i*2+0] = *p;
						buf[i*2+1] = *(p+0x800);
					}
					i286_memstr_write(I286_BX, I286_CX, buf, 34);
					break;
			}
 			break;

 		case 0x15:						// 饤ȥڥɤߤ
 			break;

   		case 0x16:						// ƥVRAMν
			bios0x18_16(I286_DL, I286_DH);
 			break;

		case 0x17:						// ֥ε
			break;

		case 0x18:						// ֥
			break;

		case 0x19:						// 饤ȥڥ󲡲֤ν
			break;

   		case 0x1a:						// 桼ʸ
			if ((I286_DH & 0x7e) == 0x76) {
				i286_memstr_read(I286_BX, I286_CX+2, buf, 32);
				p = &font[((I286_DL & 0x7f) << 12)
								+ (((I286_DH - 0x20) & 0x7f) << 4)];
				for (i=0; i<16; i++, p++) {
					*p = buf[i*2+0];
					*(p+0x800) = buf[i*2+1];
				}
				cgwindow.writable |= 0x80;
			}
			break;

		case 0x1b:						// KCG⡼ɤ
			switch(I286_AL) {						// ˺	// ver0.28
				case 0:
					MEM_ANDB(MEMB_CRT_STS_FLAG, ~0x08);
					gdc.mode1 &= ~0x20;
					gdc_restorekacmode();
					break;
				case 1:
					MEM_ORB(MEMB_CRT_STS_FLAG, 0x08);
					gdc.mode1 |= 0x20;
					gdc_restorekacmode();
					break;
			}
			break;

   		case 0x40:						// եå̤ɽ
			if (!(gdcs.grphdisp & GDCSCRN_ENABLE)) {
				gdcs.grphdisp |= GDCSCRN_ENABLE;
				screenupdate |= 2;
			}
 			break;

   		case 0x41:						// եå̤ɽλ
			if (gdcs.grphdisp & GDCSCRN_ENABLE) {
				gdcs.grphdisp &= ~(GDCSCRN_ENABLE);
				screenupdate |= 2;
			}
 			break;

   		case 0x42:						// ɽΰ
			// GDCХåե
			if (gdc.s.cnt) {
				gdc_work(GDCWORK_SLAVE);
			}
			gdc_reset(&gdc.s);

			ZeroMemory(&gdc.s.para[GDC_SCROLL], 8);
			switch(I286_CH & 0xc0) {
				case 0x40:					// UPPER
					if ((MEM_GETB(MEMB_PRXDUPD) & 0x24) == 0x24) {
						MEM_XORB(MEMB_PRXDUPD, 4);
						gdc.clock &= ~3;
						gdc.s.para[GDC_PITCH] = 40;
						gdcs.grphdisp |= GDCSCRN_EXT;
					}
					gdc.mode1 |= 0x10;
					gdc.s.para[GDC_CSRFORM] = 1;
					gdc.s.para[GDC_SCROLL+0] = (200*40) & 0xff;
					gdc.s.para[GDC_SCROLL+1] = (200*40) >> 8;
					break;
				case 0x80:					// LOWER
					if ((MEM_GETB(MEMB_PRXDUPD) & 0x24) == 0x24) {
						MEM_XORB(MEMB_PRXDUPD, 4);
						gdc.clock &= ~3;
						gdc.s.para[GDC_PITCH] = 40;
						gdcs.grphdisp |= GDCSCRN_EXT;
					}
					gdc.mode1 |= 0x10;
					gdc.s.para[GDC_CSRFORM] = 1;
					break;
				default:					// ALL
					if ((MEM_GETB(MEMB_PRXDUPD) & 0x24) == 0x20) {
						MEM_XORB(MEMB_PRXDUPD, 4);
						gdc.clock |= 3;
						gdc.s.para[GDC_PITCH] = 80;
						gdcs.grphdisp |= GDCSCRN_EXT;
					}
					gdc.mode1 &= ~(0x10);
					gdc.s.para[GDC_CSRFORM] = 0;
					break;
			}
			gdcs.disp = (I286_CH >> 4) & 1;				// 00/05/23
			gdcs.grphdisp |= GDCSCRN_ALLDRAW2;
			screenupdate |= 2;
 			break;

		case 0x43:						// ѥåȤ
			i286_memstr_read(I286_DS, I286_BX, &ucw, sizeof(ucw));
			for (i=0; i<4; i++) {
				gdc_setdegitalpal(6-i*2, (ucw.GBCPC[i] >> 4));
				gdc_setdegitalpal(7-i*2, ucw.GBCPC[i]);
			}
			break;

		case 0x47:						// ľ
			// GDCХåե
			if (gdc.s.cnt) {
				gdc_work(GDCWORK_SLAVE);
			}
			gdc_reset(&gdc.s);
			bios0x18_47();
			break;
	}
}


void bios0x18_16(BYTE chr, BYTE atr) {

	DWORD	i;

	for (i=0xa0000; i<0xa2000; i+=2) {
		MEM_SETW(i, (WORD)chr);
	}
	for (; i<0xa3fe0; i+=2) {
		MEM_SETB(i, atr);
	}
	gdcs.textdisp |= GDCSCRN_ALLDRAW;
}


static void bios0x18_47(void) {

	WORD		x1, y1, x2, y2;
	UCW_TABLE	ucw;
	GDCSUB_FUNC	func;
	BYTE		vect[GDCVCT_SIZE];
	short		dx, dy;
	WORD		pattern;
	DWORD		csrw;

	i286_memstr_read(I286_DS, I286_BX, &ucw, sizeof(ucw));
	ZeroMemory(vect, sizeof(vect));
	x1 = GETWORD(ucw.GBSX1);
	y1 = GETWORD(ucw.GBSY1);
	x2 = GETWORD(ucw.GBSX2);
	y2 = GETWORD(ucw.GBSY2);
	switch(ucw.GBDTYP) {
		case 0x01:
			func = gdcsub_line;
			if ((x1 > x2) || ((x1 == x2) && (y1 > y2))) {
				WSWAP(x1, x2);
				WSWAP(y1, y2);
			}
			dx = x2 - x1;
			dy = y2 - y1;
			if (dy > 0) {
				if (dx < dy) {
					vect[GDCVCT_OPE] = 0;
					WSWAP(dx, dy);
				}
				else {
					vect[GDCVCT_OPE] = 1;
				}
			}
			else {
				dy = -dy;
				if (dx > dy) {
					vect[GDCVCT_OPE] = 2;
				}
				else {
					vect[GDCVCT_OPE] = 3;
					WSWAP(dx, dy);
				}
			}
			SETWORD(vect + GDCVCT_DC, dx);
			SETWORD(vect + GDCVCT_D1, dy*2);
			SETWORD(vect + GDCVCT_D, dy*2 - dx);
			SETWORD(vect + GDCVCT_D2, dy*2 - dx*2);
			break;

		case 0x02:
			func = gdcsub_box;
			if (x1 > x2) {
				WSWAP(x1, x2);
			}
			if (y1 > y2) {
				WSWAP(y1, y2);
			}
			SETWORD(vect + GDCVCT_DC, 3);
			SETWORD(vect + GDCVCT_D1, 0xffff);
			SETWORD(vect + GDCVCT_D2, x2 - x1);
			SETWORD(vect + GDCVCT_DM, x2 - x1);
			SETWORD(vect + GDCVCT_D, y2 - y1);
			break;

		default:
			return;
	}
	if ((I286_CH & 0xc0) == 0x40) {
		y1 += 200;
	}
	csrw = (y1 * 40) + (x1 >> 4);
	csrw |= (DWORD)(x1 & 0xf) << 20;
	pattern = GETWORD(ucw.GBMDOTI);
	if ((I286_CH & 0x30) == 0x30) {
		if (ucw.GBON_PTN & 1) {
			func(0x04000 | csrw, vect, pattern, GDCOPE_SET);
		}
		else {
			func(0x04000 | csrw, vect, pattern, GDCOPE_CLEAR);
		}
		if (ucw.GBON_PTN & 2) {
			func(0x08000 | csrw, vect, pattern, GDCOPE_SET);
		}
		else {
			func(0x08000 | csrw, vect, pattern, GDCOPE_CLEAR);
		}
		if (ucw.GBON_PTN & 4) {
			func(0x0c000 | csrw, vect, pattern, GDCOPE_SET);
		}
		else {
			func(0x0c000 | csrw, vect, pattern, GDCOPE_CLEAR);
		}
	}
	else {
		func(csrw + 0x4000 + ((I286_CH & 0x30) << 10), vect,
													pattern, ucw.GBDOTU);
	}
}
