/*	$Id: caption.c,v 1.3 2001/10/11 16:59:07 nonaka Exp $	*/

#include "compiler.h"

#include "np2.h"
#include "np2pc98.h"
#include "fddfile.h"
#include "dosio.h"

static DWORD lasttick = 0;
static DWORD khz = 0;
static DWORD draws = 0;
static BOOL stat_renewal = FALSE;

void
caption_statreset(void)
{

	np2stat_getstatus(NULL, NP2STAT_NONE, NP2STAT_VENEVT);
	lasttick = GetTickCount();
	khz = 0;
	draws = 0;
}


BOOL
caption_statmake(void)
{
	DWORD pasttick;
	DWORD tick;

	tick = GetTickCount();
	pasttick = tick - lasttick;
	if (pasttick >= 2000) {
		NP2STAT_T stat;
		lasttick = tick;
		np2stat_getstatus(&stat, NP2STAT_DRAW | NP2STAT_CLOCK,
		    NP2STAT_DRAW | NP2STAT_CLOCK);
		draws = ((stat.drawtimes * 10000) + (pasttick / 2)) / pasttick;
		khz = (stat.clock + (pasttick / 2)) / pasttick;
		stat_renewal = TRUE;
		return TRUE;
	}
	return FALSE;
}



void
caption_disp(BYTE flg)
{
	static char title[1024] = "";
	static char clock[64] = "";
	char work[1024+64+2];

	if (flg & 1) {
		strncpy(title, np2cfg.titles, sizeof(title));
		if (fdd_diskready(0)) {
			strncat(title, "  FDD1:", sizeof(title));
			strncat(title, getFileName(fdd_diskname(0)),
			    sizeof(title));
		}
		if (fdd_diskready(1)) {
			strncat(title, "  FDD2:", sizeof(title));
			strncat(title, getFileName(fdd_diskname(1)),
			    sizeof(title));
		}
	}

	if (flg & 6) {
		clock[0] = '\0';
		if (stat_renewal) {
			stat_renewal = FALSE;
			if (flg & 4) {
				if (draws) {
					snprintf(clock, sizeof(clock), " - %u.%1uFPS", draws / 10, draws % 10);
				} else {
					snprintf(clock, sizeof(clock), " - 0FPS");
				}
			}
			if (flg & 2) {
				snprintf(work, sizeof(work), " %2u.%03uMHz", khz / 1000, khz % 1000);
				if (clock[0] == '\0')
					strncpy(clock, " -", sizeof(clock));
				strncat(clock, work, sizeof(clock));
			}
		}
	}
	strncpy(work, title, sizeof(work));
	strncat(work, clock, sizeof(work));
	set_window_title(work);
}


void
caption_fddstat(void)
{
	NP2STAT_T stat;

	np2stat_getstatus(&stat, NP2STAT_FDD, NP2STAT_FDD);
	if (stat.fddstat)
		caption_disp(1);
}
