#include	"compiler.h"

#include	"parts.h"

#ifdef NP2_PARTS_ASM

LABEL BYTE FASTCALL AdjustAfterMultiply(BYTE value) {

		__asm {
					mov		al, cl
					aam
					shl		ah, 4
					add		al, ah
					ret
		}
}

LABEL BYTE FASTCALL AdjustBeforeDivision(BYTE value) {

		__asm {
					mov		al, cl
					mov		ah, cl
					and		al, 0fh
					shr		ah, 4
					aad
					ret
		}
}

// sjis  jis Ѵ
LABEL WORD FASTCALL sjis2jis(WORD sjis) {

		__asm {
					mov		ax, cx
					mov		dx, 211fh
					cmp		al, 40h
					jb		short s2j_err
					cmp		al, 7fh
					jb		short s2j_a
					cmp		al, 80h
					jb		short s2j_err
					inc		dl
					cmp		al, 9fh
					jb		short s2j_a
					mov		dx, 227eh
					cmp		al, 0fch
					ja		short s2j_err
s2j_a:				sub		al, dl
					mov		dl, 81h
					cmp		ah, 81h
					jb		short s2j_err
					cmp		ah, 0a0h
					jb		short s2j_b
					mov		dl, 0e0h
					add		dh, 5fh - 21h
					cmp		ah, 0e0h
					jb		short s2j_err
					cmp		ah, 0efh
					ja		short s2j_err
s2j_b:				sub		ah, dl
					shl		ah, 1
					add		ah, dh
					ret
s2j_err:			xor		ax, ax
					ret
		}
}

// jis  sjis Ѵ
LABEL WORD FASTCALL jis2sjis(WORD jis) {

		__asm {
				mov		ax, cx
				test	ax, 08080h
				jne		short j2s_err
				xor		dl, dl
				add		ah, 21h
				test	ah, 1
				je		short jis2sjis1a
				mov		dl, 5eh
jis2sjis1a:		sar		ah, 1
				add		al, dl
				xor		ah, 20h
				or		ah, 80h
				cmp		al, 60h
				jb		short jis2sjis1b
				inc		al
jis2sjis1b:		add		al, 1fh
				ret
j2s_err:		xor		ax, ax
				ret
		}
}

#else

BYTE PARTS_CALL AdjustAfterMultiply(BYTE value) {

	return((BYTE)(((value / 10) << 4) + (value % 10)));
}

BYTE PARTS_CALL AdjustBeforeDivision(BYTE value) {

	return((BYTE)(((value >> 4) * 10) + (value & 0xf)));
}

WORD PARTS_CALL sjis2jis(WORD sjis) {

	WORD	codeh, tmp;
	BYTE	codel;

	codel = (BYTE)sjis;
	codeh = (sjis - 0x8100) & 0xff00;

	tmp = 0x2100;
	if (codel > 0x7f) {
		if (codel >= 0x9f) {
			if (codel > 0xfc) {
				return(0);
			}
			tmp += 0x100;
			codel -= 0x5f;
		}
		else {
			codel--;
		}
	}
	else if ((codel == 0x7f) || (codel < 0x40)) {
		return(0);
	}
	codel -= 0x1f;
	if (codeh >= 0x1f00) {
		if ((codeh < 0x5f00) || (codeh > 0x6e00)) {
			return(0);
		}
		codeh -= 0x5f00;
		tmp += 0x5f00 - 0x2100;
	}
	return(((codeh << 1) + tmp) + codel);
}

WORD PARTS_CALL jis2sjis(WORD jis) {

	BYTE	tmp;

	if (jis & 0x8080) {
		return(0);
	}
	tmp = (BYTE)jis;
	if (!(jis & 0x100)) {
		tmp += 0x5e;
	}
	if (tmp >= 0x60) {
		tmp++;
	}
	tmp += 0x1f;
	return((((short)((jis + 0x2100) & 0xfe00) / 2) ^ 0x2000) | 0x8000 | tmp);
}

#endif
