bits    32

USE_EGCASM	equ		1

EARG1		equ		4
EARG2		equ		(EARG1+4)
EARG3		equ		(EARG2+4)
EARG4		equ		(EARG3+4)

FC_ARG3		equ		4
FC_ARG4		equ		(FC_ARG3+4)
FC_ARG5		equ		(FC_ARG4+4)
FC_ARG6		equ		(FC_ARG5+4)


VRAM_STEP	equ		100000h
VRAM_B		equ		0a8000h
VRAM_R		equ		0b0000h
VRAM_G		equ		0b8000h
VRAM_E		equ		0e0000h

%macro	VRAMPOS	1
	and	%1, VRAM_STEP | 7fffh
%endmacro

FONT_ADRS	equ		110000h
ITF_ADRS	equ		1f8000h


struc	gdcs_t
	.access		resb	1
	.disp		resb	1
	.textdisp	resb	1
	.msw_accessable	resb	1
	.grphdisp	resb	1
	.palchange	resb	1
	.mode2		resb	1
endstruc

struc	grcg_t
	.counter	resd	1
	.mode		resw	1
	.modereg	resb	1
	.padding	resb	1
	.tile_b		resw	1
	.tile_r		resw	1
	.tile_g		resw	1
	.tile_e		resw	1
	.gdcwithgrcg	resd	1
	.chip		resb	1
endstruc

struc	extmem_t
	.maxmem		resd	1
	.adrsmask	resd	1
	.pageptr	resd	4
	.target		resd	1
endstruc

struc	cgwin_t
	.low		resd	1
	.high		resd	1
	.writable	resb	1
endstruc

struc	nevent_t
	.remainclock	resd	1
	.baseclock	resd	1
	.clock		resd	1
endstruc

struc	vramop_t
	.operate	resd	1
	.tramwait	resd	1
	.vramwait	resd	1
	.grcgwait	resd	1
endstruc

struc	egc_t
	.access		resw	1
	.fgbg		resw	1
	.ope		resw	1
	.fg		resw	1
	.mask		resw	1
	.bg		resw	1
	.sft		resw	1
	.leng		resw	1
	.lastvram	resd	2
	.patreg		resd	2
	.fgc		resd	2
	.bgc		resd	2

	.func		resd	1
	.remain		resd	1
	.stack		resd	1
	.padding_b	resd	4
	.buf		resb	(4096/8 + 4*4)
	.padding_a	resd	4
	.inptr		resd	1
	.outptr		resd	1
	.mask2		resw	1
	.srcbit		resb	1
	.dstbit		resb	1
	.sft8bitl	resb	1
	.sft8bitr	resb	1
endstruc

struc	DMACH_TABLE
	.adrs		resd	1
	.leng		resd	1
	.adrsorg	resd	1
	.lengorg	resd	1
	.outproc	resd	1
	.inproc		resd	1
	.extproc	resd	1
	.action		resw	1
	.mode		resb	1
	.sreq		resb	1
	.ready		resb	1
	.mask		resb	1
endstruc

extern	mem
extern  nevent

extern	dma_proc
extern	biosfunc
