;	$Id: i286a_sb.asm,v 1.3 2002/11/05 15:18:25 nonaka Exp $

%include "np2asm.inc"
%include "cpu.inc"
%include "cpu.mcr"


extern  calc_ea_dst
extern  calc_lea
extern  get_ea


section .text

; ----- reg8

	align	16
add_r8_i:
	add	[ebx], al
	FLAG_STORE_OF
	ret

	align	16
or_r8_i:
	or	[ebx], al
	FLAG_STORE0
	ret

	align	16
adc_r8_i:
	CFLAG_LOAD
	adc	[ebx], al
	FLAG_STORE_OF
	ret

	align	16
sbb_r8_i:
	CFLAG_LOAD
	sbb	[ebx], al
	FLAG_STORE_OF
	ret

	align	16
and_r8_i:
	and	[ebx], al
	FLAG_STORE0
	ret

	align	16
sub_r8_i:
	sub	[ebx], al
	FLAG_STORE_OF
	ret

	align	16
xor_r8_i:
	xor	[ebx], al
	FLAG_STORE0
	ret

	align	16
cmp_r8_i:
	cmp	[ebx], al
	FLAG_STORE_OF
	ret


; ----- ext8

	align	16
add_ext8_i:
	add	dl, al
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
or_ext8_i:
	or	dl, al
	FLAG_STORE0
	jmp	@i286_memorywrite@8

	align	16
adc_ext8_i:
	CFLAG_LOAD
	adc	dl, al
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
sbb_ext8_i:
	CFLAG_LOAD
	sbb	dl, al
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
and_ext8_i:
	and	dl, al
	FLAG_STORE0
	jmp	@i286_memorywrite@8

	align	16
sub_ext8_i:
	sub	dl, al
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
xor_ext8_i:
	xor	dl, al
	FLAG_STORE0
	jmp	@i286_memorywrite@8

	align	16
cmp_ext8_i:
	I286CLOCKDEC
	cmp	dl, al
	FLAG_STORE_OF
	ret


section .data

; dest: I286_REG[eax] src: dl
global op8xreg8_table
op8xreg8_table	dd	add_r8_i, or_r8_i,  adc_r8_i, sbb_r8_i
		dd	and_r8_i, sub_r8_i, xor_r8_i, cmp_r8_i

; dest: ecx  src: dl
global op8xext8_table
op8xext8_table	dd	add_ext8_i, or_ext8_i,  adc_ext8_i, sbb_ext8_i
		dd	and_ext8_i, sub_ext8_i, xor_ext8_i, cmp_ext8_i

; -------------------------------------------------------------------------


section .text

; ----- reg16

	align	16
add_r16_i:
	add	[ebx], ax
	FLAG_STORE_OF
	ret

	align	16
or_r16_i:
	or	[ebx], ax
	FLAG_STORE0
	ret

	align	16
adc_r16_i:
	CFLAG_LOAD
	adc	[ebx], ax
	FLAG_STORE_OF
	ret

	align	16
sbb_r16_i:
	CFLAG_LOAD
	sbb	[ebx], ax
	FLAG_STORE_OF
	ret

	align	16
and_r16_i:
	and	[ebx], ax
	FLAG_STORE0
	ret

	align	16
sub_r16_i:
	sub	[ebx], ax
	FLAG_STORE_OF
	ret

	align	16
xor_r16_i:
	xor	[ebx], ax
	FLAG_STORE0
	ret

	align	16
cmp_r16_i:
	cmp	[ebx], ax
	FLAG_STORE_OF
	ret

; ----- ext16

	align	16
add_ext16_i:
	add	dx, ax
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
or_ext16_i:
	or	dx, ax
	FLAG_STORE0
	jmp	@i286_memorywrite_w@8

	align	16
adc_ext16_i:
	CFLAG_LOAD
	adc	dx, ax
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
sbb_ext16_i:
	CFLAG_LOAD
	sbb	dx, ax
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
and_ext16_i:
	and	dx, ax
	FLAG_STORE0
	jmp	@i286_memorywrite_w@8

	align	16
sub_ext16_i:
	sub	dx, ax
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
xor_ext16_i:
	xor	dx, ax
	FLAG_STORE0
	jmp	@i286_memorywrite_w@8

	align	16
cmp_ext16_i:
	I286CLOCKDEC
	cmp	dx, ax
	FLAG_STORE_OF
	ret


section .data

; dest: I286_REG[eax * 2] src: dx
global op8xreg16_table
op8xreg16_table	dd add_r16_i, or_r16_i,  adc_r16_i, sbb_r16_i
		dd and_r16_i, sub_r16_i, xor_r16_i, cmp_r16_i

; dest: ecx  src: dx
global op8xext16_table
op8xext16_table	dd add_ext16_i, or_ext16_i,  adc_ext16_i, sbb_ext16_i
		dd and_ext16_i, sub_ext16_i, xor_ext16_i, cmp_ext16_i


; ------------------------------------------------------------ sft byte, 1

section .text

; ----- reg8

	align	16
rol_r8_1:
	rol	byte [I286_REG + eax], 1
	FLAG_STORE_OC
	ret

	align	16
ror_r8_1:
	ror	byte [I286_REG + eax], 1
	FLAG_STORE_OC
	ret

	align	16
rcl_r8_1:
	CFLAG_LOAD
	rcl	byte [I286_REG + eax], 1
	FLAG_STORE_OC
	ret

	align	16
rcr_r8_1:
	CFLAG_LOAD
	rcr	byte [I286_REG + eax], 1
	FLAG_STORE_OC
	ret

	align	16
shl_r8_1:
	shl	byte [I286_REG + eax], 1
	FLAG_STORE_OF
	ret

	align	16
shr_r8_1:
	shr	byte [I286_REG + eax], 1
	FLAG_STORE_OF
	ret

	align	16
scl_r8_1:
	shl	byte [I286_REG + eax], 1
	mov	dl, [I286_FLAGL]
	FLAG_STORE_OF
	and	dl, 1
	or	byte [I286_REG + eax], dl
	ret

	align	16
sar_r8_1:
	sar	byte [I286_REG + eax], 1
	FLAG_STORE0
	ret

; ----- mem8

	align	16
rol_mem8_1:
	rol	byte [I286_MEM + ecx], 1
	FLAG_STORE_OC
	ret

	align	16
ror_mem8_1:
	ror	byte [I286_MEM + ecx], 1
	FLAG_STORE_OC
	ret

	align	16
rcl_mem8_1:
	CFLAG_LOAD
	rcl	byte [I286_MEM + ecx], 1
	FLAG_STORE_OC
	ret

	align	16
rcr_mem8_1:
	CFLAG_LOAD
	rcr	byte [I286_MEM + ecx], 1
	FLAG_STORE_OC
	ret

	align	16
shl_mem8_1:
	shl	byte [I286_MEM + ecx], 1
	FLAG_STORE_OF
	ret

	align	16
shr_mem8_1:
	shr	byte [I286_MEM + ecx], 1
	FLAG_STORE_OF
	ret

	align	16
scl_mem8_1:
	shl	byte [I286_MEM + ecx], 1
	mov	dl, [I286_FLAGL]
	FLAG_STORE_OF
	and	dl, 1
	or	byte [I286_REG + eax], dl
	ret

	align	16
sar_mem8_1:
	sar	byte [I286_MEM + ecx], 1
	FLAG_STORE0
	ret

; ----- ext8

	align	16
rol_ext8_1:
	rol	dl, 1
	FLAG_STORE_OC
	jmp	@i286_memorywrite@8

	align	16
ror_ext8_1:
	ror	dl, 1
	FLAG_STORE_OC
	jmp	@i286_memorywrite@8

	align	16
rcl_ext8_1:
	CFLAG_LOAD
	rcl	dl, 1
	FLAG_STORE_OC
	jmp	@i286_memorywrite@8

	align	16
rcr_ext8_1:
	CFLAG_LOAD
	rcr	dl, 1
	FLAG_STORE_OC
	jmp	@i286_memorywrite@8

	align	16
shl_ext8_1:
	shl	dl, 1
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
shr_ext8_1:
	shr	dl, 1
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
scl_ext8_1:
	shl	dl, 1
	mov	bl, [I286_FLAGL]
	FLAG_STORE_OF
	and	bl, 1
	or	dl, bl
	jmp	@i286_memorywrite@8

	align	16
sar_ext8_1:
	sar	dl, 1
	FLAG_STORE0
	jmp	@i286_memorywrite@8


section .data

global sftreg8_table
sftreg8_table	dd	rol_r8_1, ror_r8_1, rcl_r8_1, rcr_r8_1
		dd	shl_r8_1, shr_r8_1, shl_r8_1, sar_r8_1

global sftmem8_table
sftmem8_table	dd	rol_mem8_1, ror_mem8_1, rcl_mem8_1, rcr_mem8_1
		dd	shl_mem8_1, shr_mem8_1, shl_mem8_1, sar_mem8_1

global sftext8_table
sftext8_table	dd	rol_ext8_1, ror_ext8_1, rcl_ext8_1, rcr_ext8_1
		dd	shl_ext8_1, shr_ext8_1, shl_ext8_1, sar_ext8_1


; ------------------------------------------------------------ sft word, 1

section .text

; ----- reg16

	align	16
rol_r16_1:
	rol	word [I286_REG + eax * 2], 1
	FLAG_STORE_OC
	ret

	align	16
ror_r16_1:
	ror	word [I286_REG + eax * 2], 1
	FLAG_STORE_OC
	ret

	align	16
rcl_r16_1:
	CFLAG_LOAD
	rcl	word [I286_REG + eax * 2], 1
	FLAG_STORE_OC
	ret

	align	16
rcr_r16_1:
	CFLAG_LOAD
	rcr	word [I286_REG + eax * 2], 1
	FLAG_STORE_OC
	ret

	align	16
shl_r16_1:
	shl	word [I286_REG + eax * 2], 1
	FLAG_STORE_OF
	ret

	align	16
shr_r16_1:
	shr	word [I286_REG + eax * 2], 1
	FLAG_STORE_OF
	ret

	align	16
scl_r16_1:
	shl	word [I286_REG + eax * 2], 1
	mov	dl, [I286_FLAGL]
	FLAG_STORE_OF
	and	dl, 1
	or	byte [I286_REG + eax], dl
	ret

	align	16
sar_r16_1:
	sar	word [I286_REG + eax * 2], 1
	FLAG_STORE0
	ret

; ----- mem16

	align	16
rol_mem16_1:
	rol	word [I286_MEM + ecx], 1
	FLAG_STORE_OC
	ret

	align	16
ror_mem16_1:
	ror	word [I286_MEM + ecx], 1
	FLAG_STORE_OC
	ret

	align	16
rcl_mem16_1:
	CFLAG_LOAD
	rcl	word [I286_MEM + ecx], 1
	FLAG_STORE_OC
	ret

	align	16
rcr_mem16_1:
	CFLAG_LOAD
	rcr	word [I286_MEM + ecx], 1
	FLAG_STORE_OC
	ret

	align	16
shl_mem16_1:
	shl	word [I286_MEM + ecx], 1
	FLAG_STORE_OF
	ret

	align	16
shr_mem16_1:
	shr	word [I286_MEM + ecx], 1
	FLAG_STORE_OF
	ret

	align	16
scl_mem16_1:
	shl	word [I286_MEM + ecx], 1
	mov	dl, [I286_FLAGL]
	FLAG_STORE_OF
	and	dl, 1
	or	byte [I286_REG + eax], dl
	ret

	align	16
sar_mem16_1:
	sar	word [I286_MEM + ecx], 1
	FLAG_STORE0
	ret

; ----- ext16

	align	16
rol_ext16_1:
	rol	dx, 1
	FLAG_STORE_OC
	jmp	@i286_memorywrite_w@8

	align	16
ror_ext16_1:
	ror	dx, 1
	FLAG_STORE_OC
	jmp	@i286_memorywrite_w@8

	align	16
rcl_ext16_1:
	CFLAG_LOAD
	rcl	dx, 1
	FLAG_STORE_OC
	jmp	@i286_memorywrite_w@8

	align	16
rcr_ext16_1:
	CFLAG_LOAD
	rcr	dx, 1
	FLAG_STORE_OC
	jmp	@i286_memorywrite_w@8

	align	16
shl_ext16_1:
	shl	dx, 1
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
shr_ext16_1:
	shr	dx, 1
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
scl_ext16_1:
	shl	dx, 1
	mov	bl, [I286_FLAGL]
	FLAG_STORE_OF
	and	bl, 1
	or	dl, bl
	jmp	@i286_memorywrite_w@8

	align	16
sar_ext16_1:
	sar	dx, 1
	FLAG_STORE0
	jmp	@i286_memorywrite_w@8


section .data

global sftreg16_table
sftreg16_table	dd	rol_r16_1, ror_r16_1, rcl_r16_1, rcr_r16_1
		dd	shl_r16_1, shr_r16_1, shl_r16_1, sar_r16_1

global sftmem16_table
sftmem16_table	dd	rol_mem16_1, ror_mem16_1, rcl_mem16_1, rcr_mem16_1
		dd	shl_mem16_1, shr_mem16_1, shl_mem16_1, sar_mem16_1

global sftext16_table
sftext16_table	dd	rol_ext16_1, ror_ext16_1, rcl_ext16_1, rcr_ext16_1
		dd	shl_ext16_1, shr_ext16_1, shl_ext16_1, sar_ext16_1


; ------------------------------------------------------------ sft byte, cl

section .text

; ----- reg8

	align	16
rol_r8_cl:
	rol	byte [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
ror_r8_cl:
	ror	byte [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
rcl_r8_cl:
	CFLAG_LOAD
	rcl	byte [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
rcr_r8_cl:
	CFLAG_LOAD
	rcr	byte [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
shl_r8_cl:
	shl	byte [ebx], cl
	FLAG_STORE_OF
	ret

	align	16
shr_r8_cl:
	shr	byte [ebx], cl
	FLAG_STORE_OF
	ret

	align	16
scl_r8_cl:
	shl	byte [ebx], cl
	mov	dl, [I286_FLAGL]
	FLAG_STORE_OF
	and	dl, 1
	or	[ebx], dl
	ret

	align	16
sar_r8_cl:
	sar	byte [ebx], cl
	FLAG_STORE0
	ret

; ----- ext8

	align	16
rol_ext8_cl:
	rol	dl, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
ror_ext8_cl:
	ror	dl, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
rcl_ext8_cl:
	CFLAG_LOAD
	rcl	dl, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
rcr_ext8_cl:
	CFLAG_LOAD
	rcr	dl, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
shl_ext8_cl:
	shl	dl, cl
	FLAG_STORE_OF
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
shr_ext8_cl:
	shr	dl, cl
	FLAG_STORE_OF
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
scl_ext8_cl:
	shl	dl, cl
	mov	ecx, ebx
	mov	bl, [I286_FLAGL]
	FLAG_STORE_OF
	and	bl, 1
	or	dl, bl
	jmp	@i286_memorywrite@8

	align	16
sar_ext8_cl:
	sar	dl, cl
	FLAG_STORE0
	mov	ecx, ebx
	jmp	@i286_memorywrite@8


section .data

global sftreg8cl_table
sftreg8cl_table	dd rol_r8_cl, ror_r8_cl, rcl_r8_cl, rcr_r8_cl
		dd shl_r8_cl, shr_r8_cl, shl_r8_cl, sar_r8_cl

global sftext8cl_table
sftext8cl_table	dd rol_ext8_cl, ror_ext8_cl, rcl_ext8_cl, rcr_ext8_cl
		dd shl_ext8_cl, shr_ext8_cl, shl_ext8_cl, sar_ext8_cl


; ------------------------------------------------------------ sft word, cl

section .text

; ----- reg16

	align	16
rol_r16_cl:
	rol	word [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
ror_r16_cl:
	ror	word [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
rcl_r16_cl:
	CFLAG_LOAD
	rcl	word [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
rcr_r16_cl:
	CFLAG_LOAD
	rcr	word [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
shl_r16_cl:
	shl	word [ebx], cl
	FLAG_STORE_OF
	ret

	align	16
shr_r16_cl:
	shr	word [ebx], cl
	FLAG_STORE_OF
	ret

	align	16
scl_r16_cl:
	shl	word [ebx], cl
	mov	dl, [I286_FLAGL]
	FLAG_STORE_OF
	and	dl, 1
	or	[ebx], dl
	ret

	align	16
sar_r16_cl:
	sar	word [ebx], cl
	FLAG_STORE0
	ret

; ----- ext16

	align	16
rol_ext16_cl:
	rol	dx, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
ror_ext16_cl:
	ror	dx, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
rcl_ext16_cl:
	CFLAG_LOAD
	rcl	dx, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
rcr_ext16_cl:
	CFLAG_LOAD
	rcr	dx, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
shl_ext16_cl:
	shl	dx, cl
	FLAG_STORE_OF
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
shr_ext16_cl:
	shr	dx, cl
	FLAG_STORE_OF
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
scl_ext16_cl:
	shl	dx, cl
	mov	ecx, ebx
	mov	bl, [I286_FLAGL]
	FLAG_STORE_OF
	and	bl, 1
	or	dl, bl
	jmp	@i286_memorywrite_w@8

	align	16
sar_ext16_cl:
	sar	dx, cl
	FLAG_STORE0
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8


section .data

global sftreg16cl_table
sftreg16cl_table  dd rol_r16_cl, ror_r16_cl, rcl_r16_cl, rcr_r16_cl
                   dd shl_r16_cl, shr_r16_cl, shl_r16_cl, sar_r16_cl

global sftext16cl_table
sftext16cl_table  dd rol_ext16_cl, ror_ext16_cl, rcl_ext16_cl, rcr_ext16_cl
                   dd shl_ext16_cl, shr_ext16_cl, shl_ext16_cl, sar_ext16_cl


; ------------------------------------------------------------ opecode 0xf6,7

section .text

	align	16
test_ea8_data8:
	PREPART_EA8 2
	mov	bl, byte [I286_REG + eax]
	GET_PCBYTE
	test	bl, al
	FLAG_STORE0
	ret

	MEMORY_EA8 6
	mov	bl, byte [I286_MEM + ecx]
	GET_PCBYTE
	test	bl, al
	FLAG_STORE0
	ret

	EXTMEM_EA8
	mov	edx, eax
	GET_PCBYTE
	test	dl, al
	FLAG_STORE0
	ret

	align	16
not_ea8:
	PREPART_EA8 2
	not	byte [I286_REG + eax]
	ret

	MEMORY_EA8 7
	not	byte [I286_MEM + ecx]
	ret

	EXTMEM_EA8
	mov	dl, al
	not	dl
	jmp	@i286_memorywrite@8

	align	16
neg_ea8:
	PREPART_EA8 2
	neg	byte [I286_REG + eax]
	FLAG_STORE_OF
	ret

	MEMORY_EA8 7
	neg	byte [I286_MEM + ecx]
	FLAG_STORE_OF
	ret

	EXTMEM_EA8
	mov	dl, al
	neg	dl
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
mul_ea8:
	PREPART_EA8 13
	mov	al, byte [I286_REG + eax]
	mul	byte [I286_AL]
	mov	word [I286_AX], ax
	FLAG_STORE_OF
	ret

	MEMORY_EA8 16
	mov	al, byte [I286_MEM + ecx]
	mul	byte [I286_AL]
	mov	word [I286_AX], ax
	FLAG_STORE_OF
	ret

	EXTMEM_EA8
	mul	byte [I286_AL]
	mov	word [I286_AX], ax
	FLAG_STORE_OF
	ret

	align	16
imul_ea8:
	PREPART_EA8 13
	mov	al, byte [I286_REG + eax]
	imul	byte [I286_AL]
	mov	word [I286_AX], ax
	FLAG_STORE_OF
	ret

	MEMORY_EA8 16
	mov	al, byte [I286_MEM + ecx]
	imul	byte [I286_AL]
	mov	word [I286_AX], ax
	FLAG_STORE_OF
	ret

	EXTMEM_EA8
	imul	byte [I286_AL]
	mov	word [I286_AX], ax
	FLAG_STORE_OF
	ret

	align	16
div_ea8:
	PREPART_EA8 14
	movzx	ecx, byte [I286_REG + eax]
	jmp	.divcheck

	MEMORY_EA8 22
	movzx	ecx, byte [I286_MEM + ecx]
	jmp	.divcheck

	EXTMEM_EA8
	xor	ecx, ecx
	mov	cl, al
.divcheck:
	jcxz	.divovf
	mov	ax, word [I286_AX]
	xor	dx, dx
	div	cx
	mov	byte [I286_AL], al
	mov	byte [I286_AH], dl
	mov	dx, ax
	FLAG_STORE_OF
	cmp	dh, dh
	jne	.divovf
	ret

.divovf:
	INT_NUM 0

	align	16
idiv_ea8:
	PREPART_EA8 17
	movsx	ecx, byte [I286_REG + eax]
	jmp	.idivcheck

	MEMORY_EA8 25
	movsx	ecx, byte [I286_MEM + ecx]
	jmp	.idivcheck

	EXTMEM_EA8
	cbw
	xor	ecx, ecx
	mov	cx, ax
.idivcheck:
	jcxz	.idivovf
	mov	ax, word [I286_AX]
	cwd
	idiv	cx
	mov	byte [I286_AL], al
	mov	byte [I286_AH], dl
	mov	dx, ax
	FLAG_STORE_OF
	bt	dx, 7
	adc	dh, 0
	jne	.idivovf
	ret

.idivovf:
	INT_NUM 0

	align	16
test_ea16_data16:
	PREPART_EA16 2
	mov	bx, word [I286_REG + eax * 2]
	GET_PCWORD
	test	bx, ax
	FLAG_STORE0
	ret

	MEMORY_EA16 6
	mov	bx, word [I286_MEM + ecx]
	GET_PCWORD
	test	bx, ax
	FLAG_STORE0
	ret

	EXTMEM_EA16
	mov	edx, eax
	GET_PCWORD
	test	dx, ax
	FLAG_STORE0
	ret

	align	16
not_ea16:
	PREPART_EA16 2
	not	word [I286_REG + eax * 2]
	ret

	MEMORY_EA16 7
	not	word [I286_MEM + ecx]
	ret

	EXTMEM_EA16
	mov	dx, ax
	not	dx
	jmp	@i286_memorywrite_w@8

	align	16
neg_ea16:
	PREPART_EA16 2
	neg	word [I286_REG + eax * 2]
	FLAG_STORE_OF
	ret

	MEMORY_EA16 7
	neg	word [I286_MEM + ecx]
	FLAG_STORE_OF
	ret

	EXTMEM_EA16
	mov	dx, ax
	neg	dx
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
mul_ea16:
	PREPART_EA16 21
	mov	ax, word [I286_REG + eax * 2]
	mul	word [I286_AX]
	mov	word [I286_AX], ax
	mov	word [I286_DX], dx
	FLAG_STORE_OF
	ret

	MEMORY_EA16 24
	mov	ax, word [I286_MEM + ecx]
	mul	word [I286_AX]
	mov	word [I286_AX], ax
	mov	word [I286_DX], dx
	FLAG_STORE_OF
	ret

	EXTMEM_EA16
	mul	word [I286_AX]
	mov	word [I286_AX], ax
	mov	word [I286_DX], dx
	FLAG_STORE_OF
	ret

	align	16
imul_ea16:
	PREPART_EA16 21
	mov	ax, word [I286_REG + eax * 2]
	imul	word [I286_AX]
	mov	word [I286_AX], ax
	mov	word [I286_DX], dx
	FLAG_STORE_OF
	ret

	MEMORY_EA16 24
	mov	ax, word [I286_MEM + ecx]
	imul	word [I286_AX]
	mov	word [I286_AX], ax
	mov	word [I286_DX], dx
	FLAG_STORE_OF
	ret

	EXTMEM_EA16
	imul	word [I286_AX]
	mov	word [I286_AX], ax
	mov	word [I286_DX], dx
	FLAG_STORE_OF
	ret

	align	16
div_ea16:
	PREPART_EA16 17
	movzx	ecx, word [I286_REG + eax * 2]
	jmp	.divcheck

	MEMORY_EA16 25
	movzx	ecx, word [I286_MEM + ecx]
	jmp	.divcheck

	EXTMEM_EA16
	xor	ecx, ecx
	mov	cx, ax
.divcheck:
	jcxz	.divovf
	movzx	eax, word [I286_DX]
	shl	eax, 16
	mov	ax, word [I286_AX]
	xor	edx, edx
	div	ecx
	mov	word [I286_AX], ax
	mov	word [I286_DX], dx
	FLAG_STORE_OF
	cmp	eax, 10000h
	jae	.divovf
	ret

.divovf:
	INT_NUM 0

	align	16
idiv_ea16:
	PREPART_EA16 20
	movsx	ecx, word [I286_REG + eax * 2]
	jmp	.idivcheck

	MEMORY_EA16 28
	movsx	ecx, word [I286_MEM + ecx]
	jmp	.idivcheck

	EXTMEM_EA16
	cwde
	mov	ecx, eax
.idivcheck:
	jcxz	.idivovf
	movzx	eax, word [I286_DX]
	shl	eax, 16
	mov	ax, word [I286_AX]
	cdq
	idiv	ecx
	mov	word [I286_AX], ax
	mov	word [I286_DX], dx
	mov	edx, eax
	FLAG_STORE_OF
	shr	edx, 16
	adc	dx, 0
	jne	.idivovf
	ret

.idivovf:
	INT_NUM 0


section .data

global ope0xf6_table
ope0xf6_table	dd	test_ea8_data8, test_ea8_data8
		dd	not_ea8,        neg_ea8
		dd	mul_ea8,        imul_ea8
		dd	div_ea8,        idiv_ea8

global ope0xf7_table
ope0xf7_table	dd	test_ea16_data16, test_ea16_data16
		dd	not_ea16,         neg_ea16
		dd	mul_ea16,         imul_ea16
		dd	div_ea16,         idiv_ea16


; ------------------------------------------------------------ opecode 0xfe,f

section .text

	align	16
inc_ea8:
	PREPART_EA8 2
	inc	byte [I286_REG + eax]
	FLAG_STORE_NC
	ret

	MEMORY_EA8 7
	inc	byte [I286_MEM + ecx]
	FLAG_STORE_NC
	ret

	EXTMEM_EA8
	mov	edx, eax
	inc	dl
	FLAG_STORE_NC
	jmp	@i286_memorywrite@8

	align	16
dec_ea8:
	PREPART_EA8 2
	dec	byte [I286_REG + eax]
	FLAG_STORE_NC
	ret

	MEMORY_EA8 7
	dec	byte [I286_MEM + ecx]
	FLAG_STORE_NC
	ret

	EXTMEM_EA8
	mov	edx, eax
	dec	dl
	FLAG_STORE_NC
	jmp	@i286_memorywrite@8

	align	16
inc_ea16:
	PREPART_EA16 2
	inc	word [I286_REG + eax * 2]
	FLAG_STORE_NC
	ret

	MEMORY_EA16 7
	inc	word [I286_MEM + ecx]
	FLAG_STORE_NC
	ret

	EXTMEM_EA16
	mov	edx, eax
	inc	dx
	FLAG_STORE_NC
	jmp	@i286_memorywrite_w@8

	align	16
dec_ea16:
	PREPART_EA16 2
	dec	word [I286_REG + eax * 2]
	FLAG_STORE_NC
	ret

	MEMORY_EA16 7
	dec	word [I286_MEM + ecx]
	FLAG_STORE_NC
	ret

	EXTMEM_EA16
	mov	edx, eax
	dec	dx
	FLAG_STORE_NC
	jmp	@i286_memorywrite_w@8

	align	16
call_ea16:
	sub	word [I286_SP], 2
	PREPART_EA16 7
	mov	dx, word [I286_REG + eax * 2]
	xchg	dx, si
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

	MEMORY_EA16 11
	mov	dx, word [I286_MEM + ecx]
	xchg	dx, si
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

	EXTMEM_EA16
	mov	dx, si
	mov	si, ax
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

	align	16
call_far_ea16:
	cmp	al, 0c0h
	jnc	near .register_eareg16

	I286CLOCK 16
	rol	al, 2
	and	eax, 1fh
	call	[get_ea + eax * 4]
	push	edi
	push	ebx
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	mov	dx, word [I286_CS]
	sub	bx, 2
	lea	ecx, [edi + ebx]
	call	@i286_memorywrite_w@8
	mov	dx, si
	sub	bx, 2
	lea	ecx, [edi + ebx]
	call	@i286_memorywrite_w@8
	mov	word [I286_SP], bx
	pop	ebx
	pop	edi
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	si, ax
	add	bx, 2
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_CS], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	ret

.register_eareg16:
	INT_NUM 6

	align	16
jmp_ea16:
	PREPART_EA16 7
	mov	ax, word [I286_REG + eax * 2]
	mov	si, ax
	ret

	MEMORY_EA16 11
	mov	ax, word [I286_MEM + ecx]
	mov	si, ax
	ret

	EXTMEM_EA16
	mov	si, ax
	ret

	align	16
jmp_far_ea16:
	cmp	al, 0c0h
	jnc	.register_eareg16

	I286CLOCK 11
	rol	al, 2
	and	eax, 1fh
	call	[get_ea + eax * 4]
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	si, ax
	add	bx, 2
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_CS], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	ret

.register_eareg16:
	INT_NUM 6

	align	16
push_ea16:
	sub	word [I286_SP], 2
	PREPART_EA16 3
	mov	dx, word [I286_REG + eax * 2]
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

	MEMORY_EA16 5
	mov	dx, word [I286_MEM + ecx]
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

	EXTMEM_EA16
	mov	dx, ax
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

	align	16
pop_ea16:
	I286CLOCK 5
	push	eax
	movzx	ecx, word [I286_SP]
	add	word [I286_SP], 2
	add	ecx, dword [SS_BASE]
	call	@i286_memoryread_w@4
	mov	dx, ax
	pop	eax
	cmp	al, 0c0h
	jnc	.src_register
	rol	al, 2
	and	eax, 31
	call	[calc_ea_dst + eax * 4]
	jmp	@i286_memorywrite_w@8

.src_register:
	and	eax, 7
	mov	word [I286_REG + eax * 2], dx
	ret


section .data

global ope0xfe_table
ope0xfe_table	dd	inc_ea8, dec_ea8

global ope0xff_table
ope0xff_table	dd	inc_ea16,  dec_ea16
		dd	call_ea16, call_far_ea16
		dd	jmp_ea16,  jmp_far_ea16
		dd	push_ea16, pop_ea16


; ------------------------------------------------------------ sft byte, cl

section .data

shiftbase16
	db  0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15

shiftbase09
	db 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6
	db 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4
	db 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2
	db 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9
	db 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7
	db 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5
	db 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3
	db 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1
	db 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8
	db 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6
	db 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4
	db 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2
	db 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9
	db 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7
	db 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5
	db 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3

shiftbase17
	db  0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	db 16,17, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14
	db 15,16,17, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13
	db 14,15,16,17, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12
	db 13,14,15,16,17, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11
	db 12,13,14,15,16,17, 1, 2, 3, 4, 5, 6, 7, 8, 9,10
	db 11,12,13,14,15,16,17, 1, 2, 3, 4, 5, 6, 7, 8, 9
	db 10,11,12,13,14,15,16,17, 1, 2, 3, 4, 5, 6, 7, 8
	db  9,10,11,12,13,14,15,16,17, 1, 2, 3, 4, 5, 6, 7
	db  8, 9,10,11,12,13,14,15,16,17, 1, 2, 3, 4, 5, 6
	db  7, 8, 9,10,11,12,13,14,15,16,17, 1, 2, 3, 4, 5
	db  6, 7, 8, 9,10,11,12,13,14,15,16,17, 1, 2, 3, 4
	db  5, 6, 7, 8, 9,10,11,12,13,14,15,16,17, 1, 2, 3
	db  4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17, 1, 2
	db  3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17, 1
	db  2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17

; ----- reg8

section .text

	align	16
rol_r8_v30:
	mov	cl, [shiftbase16 + ecx]
	rol	byte [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
ror_r8_v30:
	mov	cl, [shiftbase16 + ecx]
	ror	byte [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
rcl_r8_v30:
	mov	cl, [shiftbase09 + ecx]
	CFLAG_LOAD
	rcl	byte [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
rcr_r8_v30:
	mov	cl, [shiftbase09 + ecx]
	CFLAG_LOAD
	rcr	byte [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
shl_r8_v30:
	mov	cl, [shiftbase16 + ecx]
	shl	byte [ebx], cl
	FLAG_STORE_OF
	ret

	align	16
shr_r8_v30:
	mov	cl, [shiftbase16 + ecx]
	shr	byte [ebx], cl
	FLAG_STORE_OF
	ret

	align	16
sar_r8_v30:
	mov	cl, [shiftbase16 + ecx]
	sar	byte [ebx], cl
	FLAG_STORE0
	ret

; ----- ext8

	align	16
rol_ext8_v30:
	mov	cl, [shiftbase16 + ecx]
	rol	dl, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
ror_ext8_v30:
	mov	cl, [shiftbase16 + ecx]
	ror	dl, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
rcl_ext8_v30:
	mov	cl, [shiftbase09 + ecx]
	CFLAG_LOAD
	rcl	dl, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
rcr_ext8_v30:
	mov	cl, [shiftbase09 + ecx]
	CFLAG_LOAD
	rcr	dl, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
shl_ext8_v30:
	mov	cl, [shiftbase16 + ecx]
	shl	dl, cl
	FLAG_STORE_OF
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
shr_ext8_v30:
	mov	cl, [shiftbase16 + ecx]
	shr	dl, cl
	FLAG_STORE_OF
	mov	ecx, ebx
	jmp	@i286_memorywrite@8

	align	16
sar_ext8_v30:
	mov	cl, [shiftbase16 + ecx]
	sar	dl, cl
	FLAG_STORE0
	mov	ecx, ebx
	jmp	@i286_memorywrite@8


section .data

global sftreg8v30_table
sftreg8v30_table dd rol_r8_v30, ror_r8_v30, rcl_r8_v30, rcr_r8_v30
                 dd shl_r8_v30, shr_r8_v30, shl_r8_v30, sar_r8_v30

global sftext8v30_table
sftext8v30_table dd rol_ext8_v30, ror_ext8_v30, rcl_ext8_v30, rcr_ext8_v30
                 dd shl_ext8_v30, shr_ext8_v30, shl_ext8_v30, sar_ext8_v30


; ------------------------------------------------------------ sft word, cl

section .text

; ----- reg16

	align	16
rol_r16_v30:
	mov	cl, [shiftbase16 + ecx]
	rol	word [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
ror_r16_v30:
	mov	cl, [shiftbase16 + ecx]
	ror	word [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
rcl_r16_v30:
	mov	cl, [shiftbase17 + ecx]
	CFLAG_LOAD
	rcl	word [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
rcr_r16_v30:
	mov	cl, [shiftbase17 + ecx]
	CFLAG_LOAD
	rcr	word [ebx], cl
	FLAG_STORE_OC
	ret

	align	16
shl_r16_v30:
	mov	cl, [shiftbase16 + ecx]
	shl	word [ebx], cl
	FLAG_STORE_OF
	ret

	align	16
shr_r16_v30:
	mov	cl, [shiftbase16 + ecx]
	shr	word [ebx], cl
	FLAG_STORE_OF
	ret

	align	16
sar_r16_v30:
	mov	cl, [shiftbase16 + ecx]
	sar	word [ebx], cl
	FLAG_STORE0
	ret

; ----- ext16

	align	16
rol_ext16_v30:
	mov	cl, [shiftbase16 + ecx]
	rol	dx, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
ror_ext16_v30:
	mov	cl, [shiftbase16 + ecx]
	ror	dx, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
rcl_ext16_v30:
	mov	cl, [shiftbase17 + ecx]
	CFLAG_LOAD
	rcl	dx, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
rcr_ext16_v30:
	mov	cl, [shiftbase17 + ecx]
	CFLAG_LOAD
	rcr	dx, cl
	FLAG_STORE_OC
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
shl_ext16_v30:
	mov	cl, [shiftbase16 + ecx]
	shl	dx, cl
	FLAG_STORE_OF
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
shr_ext16_v30:
	mov	cl, [shiftbase16 + ecx]
	shr	dx, cl
	FLAG_STORE_OF
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8

	align	16
sar_ext16_v30:
	mov	cl, [shiftbase16 + ecx]
	sar	dx, cl
	FLAG_STORE0
	mov	ecx, ebx
	jmp	@i286_memorywrite_w@8


section .data

global sftreg16v30_table
sftreg16v30_table dd rol_r16_v30, ror_r16_v30, rcl_r16_v30, rcr_r16_v30
                  dd shl_r16_v30, shr_r16_v30, shl_r16_v30, sar_r16_v30

global sftext16v30_table
sftext16v30_table dd rol_ext16_v30, ror_ext16_v30, rcl_ext16_v30, rcr_ext16_v30
                  dd shl_ext16_v30, shr_ext16_v30, shl_ext16_v30, sar_ext16_v30


; -----------------------------------------------------------------------
