#include	"compiler.h"

#include	"memory.h"
#include	"nevent.h"
#include	"i286.h"
#include	"i286c_cf.h"
#include	"i286c_mn.h"
#include	"i286c.mcr"


// ------------------------------------------------------------ opecode 0xfe,f

#if 0
I286_0fe _nop_int(DWORD op) {

	INT_NUM(6, I286_IP - 2);
}
#endif

I286_0fe _inc_ea8(DWORD op) {

	DWORD	madr;
	BYTE	*out;

	if (op >= 0xc0) {
		I286_CLOCK(2)
		out = reg8_b20[op];
	}
	else {
		I286_CLOCK(7)
		madr = c_calc_ea_dst[op]();
		if (madr >= I286_MEMWRITEMAX) {
			BYTE value = i286_memoryread(madr);
			BYTE_INC(value)
			i286_memorywrite(madr, value);
			return;
		}
		out = mem + madr;
	}
	BYTE_INC(*out)
}

I286_0fe _dec_ea8(DWORD op) {

	DWORD	madr;
	BYTE	*out;

	if (op >= 0xc0) {
		I286_CLOCK(2)
		out = reg8_b20[op];
	}
	else {
		I286_CLOCK(7)
		madr = c_calc_ea_dst[op]();
		if (madr >= I286_MEMWRITEMAX) {
			BYTE value = i286_memoryread(madr);
			BYTE_DEC(value)
			i286_memorywrite(madr, value);
			return;
		}
		out = mem + madr;
	}
	BYTE_DEC(*out)
}

I286_0fe _inc_ea16(DWORD op) {

	DWORD	madr;
	WORD	*out;

	if (op >= 0xc0) {
		I286_CLOCK(2)
		out = reg16_b20[op];
	}
	else {
		I286_CLOCK(7)
		madr = c_calc_ea_dst[op]();
		if (INHIBIT_WORDP(madr)) {
			WORD value = i286_memoryread_w(madr);
			WORD_INC(value)
			i286_memorywrite_w(madr, value);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	WORD_INC(*out)
}

I286_0fe _dec_ea16(DWORD op) {

	DWORD	madr;
	WORD	*out;

	if (op >= 0xc0) {
		I286_CLOCK(2)
		out = reg16_b20[op];
	}
	else {
		I286_CLOCK(7)
		madr = c_calc_ea_dst[op]();
		if (INHIBIT_WORDP(madr)) {
			WORD value = i286_memoryread_w(madr);
			WORD_DEC(value)
			i286_memorywrite_w(madr, value);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	WORD_DEC(*out)
}

I286_0fe _call_ea16(DWORD op) {

	WORD	src;

	if (op >= 0xc0) {
		I286_CLOCK(7)
		src = *(reg16_b20[op]);
	}
	else {
		I286_CLOCK(11)
		src = i286_memoryread_w(c_calc_ea_dst[op]());
	}
	REGPUSH0(I286_IP);
	I286_IP = src;
}

I286_0fe _call_far_ea16(DWORD op) {

	I286_CLOCK(16)
	if (op < 0xc0) {
		WORD ad = c_get_ea[op]();
		REGPUSH0(I286_CS)								// ToDo
		REGPUSH0(I286_IP)
		I286_IP = i286_memoryread_w(ad + EA_FIX);
		ad += 2;
		I286_CS = i286_memoryread_w(ad + EA_FIX);
		CS_BASE = (DWORD)I286_CS << 4;
	}
	else {
		INT_NUM(6, I286_IP - 2);
	}
}

I286_0fe _jmp_ea16(DWORD op) {

	if (op >= 0xc0) {
		I286_CLOCK(7)
		I286_IP = *(reg16_b20[op]);
	}
	else {
		I286_CLOCK(11)
		I286_IP = i286_memoryread_w(c_calc_ea_dst[op]());
	}
}

I286_0fe _jmp_far_ea16(DWORD op) {

	I286_CLOCK(11)
	if (op < 0xc0) {
		WORD ad = c_get_ea[op]();
		I286_IP = i286_memoryread_w(ad + EA_FIX);
		ad += 2;
		I286_CS = i286_memoryread_w(ad + EA_FIX);
		CS_BASE = (DWORD)I286_CS << 4;
	}
	else {
		INT_NUM(6, I286_IP - 2);
	}
}

I286_0fe _push_ea16(DWORD op) {

	WORD	src;

	if (op >= 0xc0) {
		I286_CLOCK(3)
		src = *(reg16_b20[op]);
	}
	else {
		I286_CLOCK(5)
		src = i286_memoryread_w(c_calc_ea_dst[op]());
	}
	REGPUSH0(src);
}

I286_0fe _pop_ea16(DWORD op) {

	WORD	src;

	REGPOP0(src);
	I286_CLOCK(5)
	if (op >= 0xc0) {
		*(reg16_b20[op]) = src;
	}
	else {
		i286_memorywrite_w(c_calc_ea_dst[op](), src);
	}
}


void (I286CALL_0fe * c_ope0xfe_table[])(DWORD op) = {
			_inc_ea8,			_dec_ea8};

void (I286CALL_0fe * c_ope0xff_table[])(DWORD op) = {
			_inc_ea16,			_dec_ea16,
			_call_ea16,			_call_far_ea16,
			_jmp_ea16,			_jmp_far_ea16,
			_push_ea16,			_pop_ea16};
