
%include "cpu.inc"
%include "cpu.mcr"
%include "inst_table.inc"


section .text

; exec 1step
	align	32
	global	exec_1step
exec_1step:
				xor		al, al
				mov		edi, dword cpu_inst
				mov		ecx, CPU_INST_size
				cld
				rep		stosb

	.pre:		GET_PCBYTE
				and		eax, 0ffh
				mov		bl, [insttable_info + eax]
				test	bl, INST_PREFIX
				jz		.exec
				call	[insttable_1byte16 + eax * 4]
				jmp		short .pre

	.exec:		test	bl, INST_STRING
				jz		.normal
				mov		bh, [CPU_INST_REPUSE]
				or		bh, bh
				jnz		exec_rep
	.normal:	cmp		byte [CPU_INST_OP32], 0
				jne		.op32
				jmp		[insttable_1byte16 + eax * 4]
		.op32:	jmp		[insttable_1byte32 + eax * 4]

; exec rep
exec_rep:		CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				cmp		word [CPU_CX], 0
				je		.end
				cmp		byte [CPU_INST_OP32], 0
				jne		.as16_op32

				mov		edi, [insttable_1byte16 + eax * 4]
				test	bl, REP_CHECKZF
				jz		rep16
				cmp		bh, 0f2h
				je		near repnz16
				jmp		near repz16

	.as16_op32:	mov		edi, [insttable_1byte32 + eax * 4]
				test	bl, REP_CHECKZF
				jz		rep16
				cmp		bh, 0f2h
				je		near repnz16
				jmp		short repz16

	.as32:		cmp		dword [CPU_ECX], 0
				je		.end
				cmp		byte [CPU_INST_OP32], 0
				jne		.as32_op32

				mov		edi, [insttable_1byte16 + eax * 4]
				test	bl, REP_CHECKZF
				jz		rep32
				cmp		bh, 0f2h
				je		near repnz32
				jmp		short repz32

	.as32_op32:	mov		edi, [insttable_1byte32 + eax * 4]
				test	bl, REP_CHECKZF
				jz		rep32
				cmp		bh, 0f2h
				je		near repnz32
				jmp		short repz32

		.end:	ret

; rep
	align	16
rep16:			call	edi
				dec		word [CPU_CX]
				jnz		rep16
				ret

	align	16
rep32:			call	edi
				dec		dword [CPU_ECX]
				jnz		rep32
				ret

; repz
	align	16
repz16:			call	edi
				dec		word [CPU_CX]
				jz		.end
				test	byte [CPU_FLAGL], Z_FLAG
				jnz		repz16
		.end:	ret

	align	16
repz32:			call	edi
				dec		dword [CPU_ECX]
				jz		.end
				test	byte [CPU_FLAGL], Z_FLAG
				jnz		repz32
		.end:	ret

; repnz
	align	16
repnz16:		call	edi
				dec		word [CPU_CX]
				jz		.end
				test	byte [CPU_FLAGL], Z_FLAG
				jz		repnz16
		.end:	ret

	align	16
repnz32:		call	edi
				dec		dword [CPU_ECX]
				jz		.end
				test	byte [CPU_FLAGL], Z_FLAG
				jz		repnz32
		.end:	ret
