
%include "cpu.inc"
%include "cpu.mcr"
%include "inst_table.inc"

%macro JMP_GRP_TABLE 1
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 1
				and		ebx, 7 * 4
				jmp		[%1 + ebx]
%endmacro

section .text

; group
; group 1
	align	32
	global	Grp1_EbIb
Grp1_EbIb:
				JMP_GRP_TABLE insttable_G1EbIb

	align	32
	global	Grp1_EwIb
Grp1_EwIb:
				JMP_GRP_TABLE insttable_G1EwIb

	align	32
	global	Grp1_EdIb
Grp1_EdIb:
				JMP_GRP_TABLE insttable_G1EdIb

	align	32
	global	Grp1_EwIw
Grp1_EwIw:
				JMP_GRP_TABLE insttable_G1EwIw

	align	32
	global	Grp1_EdId
Grp1_EdId:
				JMP_GRP_TABLE insttable_G1EdId

; group 2
	align	32
	global	Grp2_Eb
Grp2_Eb:
				JMP_GRP_TABLE insttable_G2Eb

	align	32
	global	Grp2_Ew
Grp2_Ew:
				JMP_GRP_TABLE insttable_G2Ew

	align	32
	global	Grp2_Ed
Grp2_Ed:
				JMP_GRP_TABLE insttable_G2Ed

	align	32
	global	Grp2_EbCL
Grp2_EbCL:
				JMP_GRP_TABLE insttable_G2EbCL

	align	32
	global	Grp2_EwCL
Grp2_EwCL:
				JMP_GRP_TABLE insttable_G2EwCL

	align	32
	global	Grp2_EdCL
Grp2_EdCL:
				JMP_GRP_TABLE insttable_G2EdCL

	align	32
	global	Grp2_EbIb
Grp2_EbIb:
				JMP_GRP_TABLE insttable_G2EbIb

	align	32
	global	Grp2_EwIb
Grp2_EwIb:
				JMP_GRP_TABLE insttable_G2EwIb

	align	32
	global	Grp2_EdIb
Grp2_EdIb:
				JMP_GRP_TABLE insttable_G2EdIb

; group 3
	align	32
	global	Grp3_Eb
Grp3_Eb:
				JMP_GRP_TABLE insttable_G3Eb

	align	32
	global	Grp3_Ew
Grp3_Ew:
				JMP_GRP_TABLE insttable_G3Ew

	align	32
	global	Grp3_Ed
Grp3_Ed:
				JMP_GRP_TABLE insttable_G3Ed

; group 4
	align	32
	global	Grp4
Grp4:
				JMP_GRP_TABLE insttable_G4

; group 5
	align	32
	global	Grp5_Ew
Grp5_Ew:
				JMP_GRP_TABLE insttable_G5Ew

	align	32
	global	Grp5_Ed
Grp5_Ed:
				JMP_GRP_TABLE insttable_G5Ed

; group 6
	align	32
	global	Grp6
Grp6:
				JMP_GRP_TABLE insttable_G6

; group 7
	align	32
	global	Grp7_16
Grp7_16:
				JMP_GRP_TABLE insttable_G7_16

	align	32
	global	Grp7_32
Grp7_32:
				JMP_GRP_TABLE insttable_G7_32

; group 8
	align	32
	global	Grp8_EwIb
Grp8_EwIb:
				JMP_GRP_TABLE insttable_G8EwIb

	align	32
	global	Grp8_EdIb
Grp8_EdIb:
				JMP_GRP_TABLE insttable_G8EdIb

; group 9
	align	32
	global	Grp9
Grp9:
				JMP_GRP_TABLE insttable_G9

