
%include "cpu.inc"
%include "groups.inc"
%include "data_trans.inc"
%include "bin_arith.inc"
%include "dec_arith.inc"
%include "logic_arith.inc"
%include "shift_rotate.inc"
%include "bit_byte.inc"
%include "ctrl_trans.inc"
%include "string.inc"
%include "flag_ctrl.inc"
%include "seg_reg.inc"
%include "system.inc"
%include "misc.inc"
%include "fp.inc"

section .data

; info of instruction
	align	32, db 0
	global	insttable_info
insttable_info:
		db		0				; 00
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; 08
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		0				; 10
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; 18
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		0				; 20
		db		0
		db		0
		db		0
		db		0
		db		0
		db		INST_PREFIX					; ES:
		db		0
		db		0				; 28
		db		0
		db		0
		db		0
		db		0
		db		0
		db		INST_PREFIX					; CS:
		db		0

		db		0				; 30
		db		0
		db		0
		db		0
		db		0
		db		0
		db		INST_PREFIX					; SS:
		db		0
		db		0				; 38
		db		0
		db		0
		db		0
		db		0
		db		0
		db		INST_PREFIX					; DS:
		db		0

		db		0				; 40
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; 48
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		0				; 50
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; 58
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		0				; 60
		db		0
		db		0
		db		0
		db		INST_PREFIX					; FS:
		db		INST_PREFIX					; GS:
		db		INST_PREFIX					; OpSize:
		db		INST_PREFIX					; AddrSize:
		db		0				; 68
		db		0
		db		0
		db		0
		db		INST_STRING					; INSB_YbDX
		db		INST_STRING					; INSW_YvDX
		db		INST_STRING					; OUTSB_DXXb
		db		INST_STRING					; OUTSW_DXXv

		db		0				; 70
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; 78
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		0				; 80
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; 88
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		0				; 90
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; 98
		db		0
		db		0
		db		INST_PREFIX					; FWAIT
		db		0
		db		0
		db		0
		db		0

		db		0				; A0
		db		0
		db		0
		db		0
		db		INST_STRING					; MOVSB_XbYb
		db		INST_STRING					; MOVSW_XvYv
		db		INST_STRING | REP_CHECKZF	; CMPSB_XbYb
		db		INST_STRING | REP_CHECKZF	; CMPSW_XvYv
		db		0				; A8
		db		0
		db		INST_STRING					; STOSB_YbAL
		db		INST_STRING					; STOSW_YveAX
		db		INST_STRING					; LODSB_ALXb
		db		INST_STRING					; LODSW_eAXXv
		db		INST_STRING | REP_CHECKZF	; SCASB_ALXb
		db		INST_STRING | REP_CHECKZF	; SCASW_eAXXv

		db		0				; B0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; B8
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		0				; C0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; C8
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		0				; D0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; D8
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		0				; E0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0				; E8
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

		db		INST_PREFIX		; F0		; LOCK
		db		0
		db		INST_PREFIX					; REPNE
		db		INST_PREFIX					; REPE
		db		0
		db		0
		db		0
		db		0
		db		0				; F8
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0
		db		0

;%define DEBUG
; for 16bit
	align	32, db 0
	global	insttable_1byte16
insttable_1byte16:
		dd		ADD_EbGb		; 00
		dd		ADD_EwGw
		dd		ADD_GbEb
		dd		ADD_GwEw
		dd		ADD_ALIb
		dd		ADD_AXIw
		dd		PUSH16_ES
		dd		POP16_ES
		dd		OR_EbGb			; 08
		dd		OR_EwGw
		dd		OR_GbEb
		dd		OR_GwEw
		dd		OR_ALIb
		dd		OR_AXIw
		dd		PUSH16_CS
		dd		_2byte_ESC16

		dd		ADC_EbGb		; 10
		dd		ADC_EwGw
		dd		ADC_GbEb
		dd		ADC_GwEw
		dd		ADC_ALIb
		dd		ADC_AXIw
		dd		PUSH16_SS
		dd		POP16_SS
		dd		SBB_EbGb		; 18
		dd		SBB_EwGw
		dd		SBB_GbEb
		dd		SBB_GwEw
		dd		SBB_ALIb
		dd		SBB_AXIw
		dd		PUSH16_DS
		dd		POP16_DS

		dd		AND_EbGb		; 20
		dd		AND_EwGw
		dd		AND_GbEb
		dd		AND_GwEw
		dd		AND_ALIb
		dd		AND_AXIw
		dd		Prefix_ES
		dd		_DAA
		dd		SUB_EbGb		; 28
		dd		SUB_EwGw
		dd		SUB_GbEb
		dd		SUB_GwEw
		dd		SUB_ALIb
		dd		SUB_AXIw
		dd		Prefix_CS
		dd		_DAS

		dd		XOR_EbGb		; 30
		dd		XOR_EwGw
		dd		XOR_GbEb
		dd		XOR_GwEw
		dd		XOR_ALIb
		dd		XOR_AXIw
		dd		Prefix_SS
		dd		_AAA
		dd		CMP_EbGb		; 38
		dd		CMP_EwGw
		dd		CMP_GbEb
		dd		CMP_GwEw
		dd		CMP_ALIb
		dd		CMP_AXIw
		dd		Prefix_DS
		dd		_AAS

		dd		INC_RX			; 40
		dd		INC_RX
		dd		INC_RX
		dd		INC_RX
		dd		INC_RX
		dd		INC_RX
		dd		INC_RX
		dd		INC_RX
		dd		DEC_RX			; 48
		dd		DEC_RX
		dd		DEC_RX
		dd		DEC_RX
		dd		DEC_RX
		dd		DEC_RX
		dd		DEC_RX
		dd		DEC_RX

		dd		PUSH_RX			; 50
		dd		PUSH_RX
		dd		PUSH_RX
		dd		PUSH_RX
		dd		PUSH_RX
		dd		PUSH_RX
		dd		PUSH_RX
		dd		PUSH_RX
		dd		POP_RX			; 58
		dd		POP_RX
		dd		POP_RX
		dd		POP_RX
		dd		POP_SP
		dd		POP_RX
		dd		POP_RX
		dd		POP_RX

		dd		_PUSHA			; 60
		dd		_POPA
		dd		BOUND_GwMa
		dd		ARPL_EwGw
		dd		Prefix_FS
		dd		Prefix_GS
		dd		OpSize
		dd		AddrSize
		dd		PUSH_Iw			; 68
		dd		IMUL_GwEwIw
		dd		PUSH_Ib
		dd		IMUL_GwEwIb
		dd		INSB_YbDX
		dd		INSW_YwDX
		dd		OUTSB_DXXb
		dd		OUTSW_DXXw

		dd		JO_Jb			; 70
		dd		JNO_Jb
		dd		JC_Jb
		dd		JNC_Jb
		dd		JZ_Jb
		dd		JNZ_Jb
		dd		JNA_Jb
		dd		JA_Jb
		dd		JS_Jb			; 78
		dd		JNS_Jb
		dd		JP_Jb
		dd		JNP_Jb
		dd		JL_Jb
		dd		JNL_Jb
		dd		JLE_Jb
		dd		JNLE_Jb

		dd		Grp1_EbIb		; 80
		dd		Grp1_EwIw
		dd		Grp1_EbIb
		dd		Grp1_EwIb
		dd		TEST_EbGb
		dd		TEST_EwGw
		dd		XCHG_EbGb
		dd		XCHG_EwGw
		dd		MOV_EbGb		; 88
		dd		MOV_EwGw
		dd		MOV_GbEb
		dd		MOV_GwEw
		dd		MOV_EwSw
		dd		LEA_GwM
		dd		MOV_SwEw
		dd		POP_Ew

		dd		_NOP			; 90
		dd		XCHG_RXAX
		dd		XCHG_RXAX
		dd		XCHG_RXAX
		dd		XCHG_RXAX
		dd		XCHG_RXAX
		dd		XCHG_RXAX
		dd		XCHG_RXAX
		dd		_CBW			; 98
		dd		_CWD
		dd		CALL16_Ap
		dd		_FWAIT
		dd		PUSHF_Fw
		dd		POPF_Fw
		dd		_SAHF
		dd		_LAHF

		dd		MOV_ALOb		; A0
		dd		MOV_AXOw
		dd		MOV_ObAL
		dd		MOV_OwAX
		dd		MOVSB_XbYb
		dd		MOVSW_XwYw
		dd		CMPSB_XbYb
		dd		CMPSW_XwYw
		dd		TEST_ALIb		; A8
		dd		TEST_AXIw
		dd		STOSB_YbAL
		dd		STOSW_YwAX
		dd		LODSB_ALXb
		dd		LODSW_AXXw
		dd		SCASB_ALXb
		dd		SCASW_AXXw

		dd		MOV_RLIb		; B0
		dd		MOV_RLIb
		dd		MOV_RLIb
		dd		MOV_RLIb
		dd		MOV_RHIb
		dd		MOV_RHIb
		dd		MOV_RHIb
		dd		MOV_RHIb
		dd		MOV_RXIw		; B8
		dd		MOV_RXIw
		dd		MOV_RXIw
		dd		MOV_RXIw
		dd		MOV_RXIw
		dd		MOV_RXIw
		dd		MOV_RXIw
		dd		MOV_RXIw

		dd		Grp2_EbIb		; C0
		dd		Grp2_EwIb
		dd		RETnear16_Iw
		dd		RETnear16
		dd		LES_GwMp
		dd		LDS_GwMp
		dd		MOV_EbIb
		dd		MOV_EwIw
		dd		ENTER_IwIb		; C8
		dd		LEAVE16
		dd		RETfar16_Iw
		dd		RETfar16
		dd		_INT3
		dd		INT_Ib
		dd		_INTO
		dd		_IRET

		dd		Grp2_Eb			; D0
		dd		Grp2_Ew
		dd		Grp2_EbCL
		dd		Grp2_EwCL
		dd		_AAM
		dd		_AAD
		dd		_SALC				; undoc(8086)
		dd		_XLAT
		dd		ESC0			; D8
		dd		ESC1
		dd		ESC2
		dd		ESC3
		dd		ESC4
		dd		ESC5
		dd		ESC6
		dd		ESC7

		dd		LOOPNE_Jb		; E0
		dd		LOOPE_Jb
		dd		LOOP_Jb
		dd		JeCXZ_Jb
		dd		IN_ALIb
		dd		IN_AXIb
		dd		OUT_IbAL
		dd		OUT_IbAX
		dd		CALL_Aw			; E8
		dd		JMP_Jw
		dd		JMP16_Ap
		dd		JMP_Jb
		dd		IN_ALDX
		dd		IN_AXDX
		dd		OUT_DXAL
		dd		OUT_DXAX

		dd		_LOCK			; F0
		dd		_INT1
		dd		_REPNE
		dd		_REPE
		dd		_HLT
		dd		_CMC
		dd		Grp3_Eb
		dd		Grp3_Ew
		dd		_CLC			; F8
		dd		_STC
		dd		_CLI
		dd		_STI
		dd		_CLD
		dd		_STD
		dd		Grp4
		dd		Grp5_Ew

	align	32, db 0
	global	insttable_2byte16
insttable_2byte16:
		dd		Grp6			; 00
		dd		Grp7_16
		dd		LAR_GwEw
		dd		LSL_GwEw
		dd		undef_op
		dd		_LOADALL286			; undoc(286)
		dd		_CLTS
		dd		_LOADALL			; undoc(386)
		dd		_INVD			; 08
		dd		_WBINVD
		dd		undef_op
		dd		_UD2
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; 10
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 18
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		MOV_RdCd		; 20
		dd		MOV_RdDd
		dd		MOV_CdRd
		dd		MOV_DdRd
		dd		MOV_RdTd
		dd		undef_op
		dd		MOV_TdRd
		dd		undef_op
		dd		undef_op		; 28
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		_WRMSR			; 30
		dd		_RDTSC
		dd		_RDMSR
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 38
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		CMOVO_GwEw		; 40
		dd		CMOVNO_GwEw
		dd		CMOVC_GwEw
		dd		CMOVNC_GwEw
		dd		CMOVZ_GwEw
		dd		CMOVNZ_GwEw
		dd		CMOVNA_GwEw
		dd		CMOVA_GwEw
		dd		CMOVS_GwEw		; 48
		dd		CMOVNS_GwEw
		dd		CMOVP_GwEw
		dd		CMOVNP_GwEw
		dd		CMOVL_GwEw
		dd		CMOVNL_GwEw
		dd		CMOVLE_GwEw
		dd		CMOVNLE_GwEw

		dd		undef_op		; 50
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 58
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; 60
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 68
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; 70
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 78
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		JO_Jw			; 80
		dd		JNO_Jw
		dd		JC_Jw
		dd		JNC_Jw
		dd		JZ_Jw
		dd		JNZ_Jw
		dd		JNA_Jw
		dd		JA_Jw
		dd		JS_Jw			; 88
		dd		JNS_Jw
		dd		JP_Jw
		dd		JNP_Jw
		dd		JL_Jw
		dd		JNL_Jw
		dd		JLE_Jw
		dd		JNLE_Jw

		dd		SETO_Eb			; 90
		dd		SETNO_Eb
		dd		SETC_Eb
		dd		SETNC_Eb
		dd		SETZ_Eb
		dd		SETNZ_Eb
		dd		SETNA_Eb
		dd		SETA_Eb
		dd		SETS_Eb			; 98
		dd		SETNS_Eb
		dd		SETP_Eb
		dd		SETNP_Eb
		dd		SETL_Eb
		dd		SETNL_Eb
		dd		SETLE_Eb
		dd		SETNLE_Eb

		dd		PUSH16_FS		; A0
		dd		POP16_FS
		dd		_CPUID
		dd		BT_EwGw
		dd		SHLD_EwGwIb
		dd		SHLD_EwGwCL
		dd		CMPXCHG_EbGb		; undoc(486)
		dd		CMPXCHG_EwGw		; undoc(486)
		dd		PUSH16_GS		; A8
		dd		POP16_GS
		dd		_RSM
		dd		BTS_EwGw
		dd		SHRD_EwGwIb
		dd		SHRD_EwGwCL
		dd		undef_op
		dd		IMUL_GwEw

		dd		CMPXCHG_EbGb	; B0
		dd		CMPXCHG_EwGw
		dd		LSS_GwMp
		dd		BTR_EwGw
		dd		LFS_GwMp
		dd		LGS_GwMp
		dd		MOVZX_GwEb
		dd		MOVZX_GdEw
		dd		undef_op		; B8
		dd		_UD2
		dd		Grp8_EwIb
		dd		BTC_EwGw
		dd		BSF_GwEw
		dd		BSR_GwEw
		dd		MOVSX_GwEb
		dd		MOVSX_GdEw

		dd		XADD_EbGb		; C0
		dd		XADD_EwGw
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		Grp9
		dd		BSWAP_ERX		; C8
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX

		dd		undef_op		; D0
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; D8
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; E0
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; E8
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; F0
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; F8
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

; for 32bit
	align	32, db 0
	global	insttable_1byte32
insttable_1byte32:
		dd		ADD_EbGb		; 00
		dd		ADD_EdGd
		dd		ADD_GbEb
		dd		ADD_GdEd
		dd		ADD_ALIb
		dd		ADD_EAXId
		dd		PUSH32_ES
		dd		POP32_ES
		dd		OR_EbGb			; 08
		dd		OR_EdGd
		dd		OR_GbEb
		dd		OR_GdEd
		dd		OR_ALIb
		dd		OR_EAXId
		dd		PUSH32_CS
		dd		_2byte_ESC32

		dd		ADC_EbGb		; 10
		dd		ADC_EdGd
		dd		ADC_GbEb
		dd		ADC_GdEd
		dd		ADC_ALIb
		dd		ADC_EAXId
		dd		PUSH32_SS
		dd		POP32_SS
		dd		SBB_EbGb		; 18
		dd		SBB_EdGd
		dd		SBB_GbEb
		dd		SBB_GdEd
		dd		SBB_ALIb
		dd		SBB_EAXId
		dd		PUSH32_DS
		dd		POP32_DS

		dd		AND_EbGb		; 20
		dd		AND_EdGd
		dd		AND_GbEb
		dd		AND_GdEd
		dd		AND_ALIb
		dd		AND_EAXId
		dd		undef_op	; Prefix_ES
		dd		_DAA
		dd		SUB_EbGb		; 28
		dd		SUB_EdGd
		dd		SUB_GbEb
		dd		SUB_GdEd
		dd		SUB_ALIb
		dd		SUB_EAXId
		dd		undef_op	; Prefix_CS
		dd		_DAS

		dd		XOR_EbGb		; 30
		dd		XOR_EdGd
		dd		XOR_GbEb
		dd		XOR_GdEd
		dd		XOR_ALIb
		dd		XOR_EAXId
		dd		undef_op	; Prefix_SS
		dd		_AAA
		dd		CMP_EbGb		; 38
		dd		CMP_EdGd
		dd		CMP_GbEb
		dd		CMP_GdEd
		dd		CMP_ALIb
		dd		CMP_EAXId
		dd		undef_op	; Prefix_DS
		dd		_AAS

		dd		INC_ERX			; 40
		dd		INC_ERX
		dd		INC_ERX
		dd		INC_ERX
		dd		INC_ERX
		dd		INC_ERX
		dd		INC_ERX
		dd		INC_ERX
		dd		DEC_ERX			; 48
		dd		DEC_ERX
		dd		DEC_ERX
		dd		DEC_ERX
		dd		DEC_ERX
		dd		DEC_ERX
		dd		DEC_ERX
		dd		DEC_ERX

		dd		PUSH_ERX		; 50
		dd		PUSH_ERX
		dd		PUSH_ERX
		dd		PUSH_ERX
		dd		PUSH_ERX
		dd		PUSH_ERX
		dd		PUSH_ERX
		dd		PUSH_ERX
		dd		POP_ERX			; 58
		dd		POP_ERX
		dd		POP_ERX
		dd		POP_ERX
		dd		POP_ESP
		dd		POP_ERX
		dd		POP_ERX
		dd		POP_ERX

		dd		_PUSHAD			; 60
		dd		_POPAD
		dd		BOUND_GdMa
		dd		ARPL_EwGw
		dd		undef_op	; Prefix_FS
		dd		undef_op	; Prefix_GS
		dd		undef_op	; OpSize
		dd		undef_op	; AddrSize
		dd		PUSH_Id			; 68
		dd		IMUL_GdEdId
		dd		PUSH_Ib
		dd		IMUL_GdEdIb
		dd		INSB_YbDX
		dd		INSD_YdDX
		dd		OUTSB_DXXb
		dd		OUTSD_DXXd

		dd		JO_Jb			; 70
		dd		JNO_Jb
		dd		JC_Jb
		dd		JNC_Jb
		dd		JZ_Jb
		dd		JNZ_Jb
		dd		JNA_Jb
		dd		JA_Jb
		dd		JS_Jb			; 78
		dd		JNS_Jb
		dd		JP_Jb
		dd		JNP_Jb
		dd		JL_Jb
		dd		JNL_Jb
		dd		JLE_Jb
		dd		JNLE_Jb

		dd		Grp1_EbIb		; 80
		dd		Grp1_EdId
		dd		Grp1_EbIb
		dd		Grp1_EdIb
		dd		TEST_EbGb
		dd		TEST_EdGd
		dd		XCHG_EbGb
		dd		XCHG_EdGd
		dd		MOV_EbGb		; 88
		dd		MOV_EdGd
		dd		MOV_GbEb
		dd		MOV_GdEd
		dd		MOV_EwSw
		dd		LEA_GdM
		dd		MOV_SwEw
		dd		POP_Ed

		dd		_NOP			; 90
		dd		XCHG_ERXEAX
		dd		XCHG_ERXEAX
		dd		XCHG_ERXEAX
		dd		XCHG_ERXEAX
		dd		XCHG_ERXEAX
		dd		XCHG_ERXEAX
		dd		XCHG_ERXEAX
		dd		_CWDE			; 98
		dd		_CDQ
		dd		CALL32_Ap
		dd		undef_op	; FWAIT
		dd		PUSHFD_Fd
		dd		POPFD_Fd
		dd		_SAHF
		dd		_LAHF

		dd		MOV_ALOb		; A0
		dd		MOV_EAXOd
		dd		MOV_ObAL
		dd		MOV_OdEAX
		dd		MOVSB_XbYb
		dd		MOVSD_XdYd
		dd		CMPSB_XbYb
		dd		CMPSD_XdYd
		dd		TEST_ALIb		; A8
		dd		TEST_EAXId
		dd		STOSB_YbAL
		dd		STOSD_YdEAX
		dd		LODSB_ALXb
		dd		LODSD_EAXXd
		dd		SCASB_ALXb
		dd		SCASD_EAXXd

		dd		MOV_RLIb		; B0
		dd		MOV_RLIb
		dd		MOV_RLIb
		dd		MOV_RLIb
		dd		MOV_RHIb
		dd		MOV_RHIb
		dd		MOV_RHIb
		dd		MOV_RHIb
		dd		MOV_ERXId		; B8
		dd		MOV_ERXId
		dd		MOV_ERXId
		dd		MOV_ERXId
		dd		MOV_ERXId
		dd		MOV_ERXId
		dd		MOV_ERXId
		dd		MOV_ERXId

		dd		Grp2_EbIb		; C0
		dd		Grp2_EdIb
		dd		RETnear32_Iw
		dd		RETnear32
		dd		LES_GdMp
		dd		LDS_GdMp
		dd		MOV_EbIb
		dd		MOV_EdId
		dd		ENTER_IwIb		; C8
		dd		LEAVE32
		dd		RETfar32_Iw
		dd		RETfar32
		dd		_INT3
		dd		INT_Ib
		dd		_INTO
		dd		_IRETD

		dd		Grp2_Eb			; D0
		dd		Grp2_Ed
		dd		Grp2_EbCL
		dd		Grp2_EdCL
		dd		_AAM
		dd		_AAD
		dd		_SALC				; undoc(8086)
		dd		_XLAT
		dd		ESC0			; D8
		dd		ESC1
		dd		ESC2
		dd		ESC3
		dd		ESC4
		dd		ESC5
		dd		ESC6
		dd		ESC7

		dd		LOOPNE_Jb		; E0
		dd		LOOPE_Jb
		dd		LOOP_Jb
		dd		JeCXZ_Jb
		dd		IN_ALIb
		dd		IN_EAXIb
		dd		OUT_IbAL
		dd		OUT_IbEAX
		dd		CALL_Ad			; E8
		dd		JMP_Jw
		dd		JMP32_Ap
		dd		JMP_Jb
		dd		IN_ALDX
		dd		IN_EAXDX
		dd		OUT_DXAL
		dd		OUT_DXEAX

		dd		_LOCK			; F0
		dd		_INT1
		dd		_REPNE
		dd		_REPE
		dd		_HLT
		dd		_CMC
		dd		Grp3_Eb
		dd		Grp3_Ed
		dd		_CLC			; F8
		dd		_STC
		dd		_CLI
		dd		_STI
		dd		_CLD
		dd		_STD
		dd		Grp4
		dd		Grp5_Ed

	align	32, db 0
	global	insttable_2byte32
insttable_2byte32:
		dd		Grp6			; 00
		dd		Grp7_32
		dd		LAR_GdEd
		dd		LSL_GdEd
		dd		undef_op
		dd		_LOADALL286			; undoc(286)
		dd		_CLTS
		dd		_LOADALL			; undoc(386)
		dd		_INVD			; 08
		dd		_WBINVD
		dd		undef_op
		dd		_UD2
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; 10
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 18
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		MOV_RdCd		; 20
		dd		MOV_RdDd
		dd		MOV_CdRd
		dd		MOV_DdRd
		dd		MOV_RdTd
		dd		undef_op
		dd		MOV_TdRd
		dd		undef_op
		dd		undef_op		; 28
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		_WRMSR			; 30
		dd		_RDTSC
		dd		_RDMSR
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 38
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		CMOVO_GdEd		; 40
		dd		CMOVNO_GdEd
		dd		CMOVC_GdEd
		dd		CMOVNC_GdEd
		dd		CMOVZ_GdEd
		dd		CMOVNZ_GdEd
		dd		CMOVNA_GdEd
		dd		CMOVA_GdEd
		dd		CMOVS_GdEd		; 48
		dd		CMOVNS_GdEd
		dd		CMOVP_GdEd
		dd		CMOVNP_GdEd
		dd		CMOVL_GdEd
		dd		CMOVNL_GdEd
		dd		CMOVLE_GdEd
		dd		CMOVNLE_GdEd

		dd		undef_op		; 50
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 58
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; 60
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 68
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; 70
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; 78
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		JO_Jd			; 80
		dd		JNO_Jd
		dd		JC_Jd
		dd		JNC_Jd
		dd		JZ_Jd
		dd		JNZ_Jd
		dd		JNA_Jd
		dd		JA_Jd
		dd		JS_Jd			; 88
		dd		JNS_Jd
		dd		JP_Jd
		dd		JNP_Jd
		dd		JL_Jd
		dd		JNL_Jd
		dd		JLE_Jd
		dd		JNLE_Jd

		dd		SETO_Eb			; 90
		dd		SETNO_Eb
		dd		SETC_Eb
		dd		SETNC_Eb
		dd		SETZ_Eb
		dd		SETNZ_Eb
		dd		SETNA_Eb
		dd		SETA_Eb
		dd		SETS_Eb			; 98
		dd		SETNS_Eb
		dd		SETP_Eb
		dd		SETNP_Eb
		dd		SETL_Eb
		dd		SETNL_Eb
		dd		SETLE_Eb
		dd		SETNLE_Eb

		dd		PUSH32_FS		; A0
		dd		POP32_FS
		dd		_CPUID
		dd		BT_EdGd
		dd		SHLD_EdGdIb
		dd		SHLD_EdGdCL
		dd		CMPXCHG_EbGb		; undoc(486)
		dd		CMPXCHG_EwGw		; undoc(486)
		dd		PUSH32_GS		; A8
		dd		POP32_GS
		dd		_RSM
		dd		BTS_EdGd
		dd		SHRD_EdGdIb
		dd		SHRD_EdGdCL
		dd		undef_op
		dd		IMUL_GdEd

		dd		CMPXCHG_EbGb	; B0
		dd		CMPXCHG_EdGd
		dd		LSS_GdMp
		dd		BTR_EdGd
		dd		LFS_GdMp
		dd		LGS_GdMp
		dd		MOVZX_GdEb
		dd		MOVZX_GdEw
		dd		undef_op		; B8
		dd		_UD2
		dd		Grp8_EdIb
		dd		BTC_EdGd
		dd		BSF_GdEd
		dd		BSR_GdEd
		dd		MOVSX_GdEb
		dd		MOVSX_GdEw

		dd		XADD_EbGb		; C0
		dd		XADD_EdGd
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		Grp9
		dd		BSWAP_ERX		; C8
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX
		dd		BSWAP_ERX

		dd		undef_op		; D0
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; D8
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; E0
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; E8
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

		dd		undef_op		; F0
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op		; F8
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

; for group
; group 1
	align	32, db 0
	global	insttable_G1EbIb
insttable_G1EbIb:
		dd		ADD_EbIb
		dd		OR_EbIb
		dd		ADC_EbIb
		dd		SBB_EbIb
		dd		AND_EbIb
		dd		SUB_EbIb
		dd		XOR_EbIb
		dd		CMP_EbIb

	align	32, db 0
	global	insttable_G1EwIb
insttable_G1EwIb:
		dd		ADD_EwIb
		dd		OR_EwIb
		dd		ADC_EwIb
		dd		SBB_EwIb
		dd		AND_EwIb
		dd		SUB_EwIb
		dd		XOR_EwIb
		dd		CMP_EwIb

	align	32, db 0
	global	insttable_G1EdIb
insttable_G1EdIb:
		dd		ADD_EdIb
		dd		OR_EdIb
		dd		ADC_EdIb
		dd		SBB_EdIb
		dd		AND_EdIb
		dd		SUB_EdIb
		dd		XOR_EdIb
		dd		CMP_EdIb

	align	32, db 0
	global	insttable_G1EwIw
insttable_G1EwIw:
		dd		ADD_EwIw
		dd		OR_EwIw
		dd		ADC_EwIw
		dd		SBB_EwIw
		dd		AND_EwIw
		dd		SUB_EwIw
		dd		XOR_EwIw
		dd		CMP_EwIw

	align	32, db 0
	global	insttable_G1EdId
insttable_G1EdId:
		dd		ADD_EdId
		dd		OR_EdId
		dd		ADC_EdId
		dd		SBB_EdId
		dd		AND_EdId
		dd		SUB_EdId
		dd		XOR_EdId
		dd		CMP_EdId

; group 2
	align	32, db 0
	global	insttable_G2Eb
insttable_G2Eb:
		dd		ROL_Eb
		dd		ROR_Eb
		dd		RCL_Eb
		dd		RCR_Eb
		dd		SHL_Eb
		dd		SHR_Eb
		dd		undef_op
		dd		SAR_Eb

	align	32, db 0
	global	insttable_G2Ew
insttable_G2Ew:
		dd		ROL_Ew
		dd		ROR_Ew
		dd		RCL_Ew
		dd		RCR_Ew
		dd		SHL_Ew
		dd		SHR_Ew
		dd		undef_op
		dd		SAR_Ew

	align	32, db 0
	global	insttable_G2Ed
insttable_G2Ed:
		dd		ROL_Ed
		dd		ROR_Ed
		dd		RCL_Ed
		dd		RCR_Ed
		dd		SHL_Ed
		dd		SHR_Ed
		dd		undef_op
		dd		SAR_Ed

	align	32, db 0
	global	insttable_G2EbCL
insttable_G2EbCL:
		dd		ROL_EbCL
		dd		ROR_EbCL
		dd		RCL_EbCL
		dd		RCR_EbCL
		dd		SHL_EbCL
		dd		SHR_EbCL
		dd		undef_op
		dd		SAR_EbCL

	align	32, db 0
	global	insttable_G2EwCL
insttable_G2EwCL:
		dd		ROL_EwCL
		dd		ROR_EwCL
		dd		RCL_EwCL
		dd		RCR_EwCL
		dd		SHL_EwCL
		dd		SHR_EwCL
		dd		undef_op
		dd		SAR_EwCL

	align	32, db 0
	global	insttable_G2EdCL
insttable_G2EdCL:
		dd		ROL_EdCL
		dd		ROR_EdCL
		dd		RCL_EdCL
		dd		RCR_EdCL
		dd		SHL_EdCL
		dd		SHR_EdCL
		dd		undef_op
		dd		SAR_EdCL

	align	32, db 0
	global	insttable_G2EbIb
insttable_G2EbIb:
		dd		ROL_EbIb
		dd		ROR_EbIb
		dd		RCL_EbIb
		dd		RCR_EbIb
		dd		SHL_EbIb
		dd		SHR_EbIb
		dd		undef_op
		dd		SAR_EbIb

	align	32, db 0
	global	insttable_G2EwIb
insttable_G2EwIb:
		dd		ROL_EwIb
		dd		ROR_EwIb
		dd		RCL_EwIb
		dd		RCR_EwIb
		dd		SHL_EwIb
		dd		SHR_EwIb
		dd		undef_op
		dd		SAR_EwIb

	align	32, db 0
	global	insttable_G2EdIb
insttable_G2EdIb:
		dd		ROL_EdIb
		dd		ROR_EdIb
		dd		RCL_EdIb
		dd		RCR_EdIb
		dd		SHL_EdIb
		dd		SHR_EdIb
		dd		undef_op
		dd		SAR_EdIb

; group 3
	align	32, db 0
	global	insttable_G3Eb
insttable_G3Eb:
		dd		TEST_EbIb
		dd		undef_op
		dd		NOT_Eb
		dd		NEG_Eb
		dd		MUL_ALEb
		dd		IMUL_ALEb
		dd		DIV_ALEb
		dd		IDIV_ALEb

	align	32, db 0
	global	insttable_G3Ew
insttable_G3Ew:
		dd		TEST_EwIw
		dd		undef_op
		dd		NOT_Ew
		dd		NEG_Ew
		dd		MUL_AXEw
		dd		IMUL_AXEw
		dd		DIV_AXEw
		dd		IDIV_AXEw

	align	32, db 0
	global	insttable_G3Ed
insttable_G3Ed:
		dd		TEST_EdId
		dd		undef_op
		dd		NOT_Ed
		dd		NEG_Ed
		dd		MUL_EAXEd
		dd		IMUL_EAXEd
		dd		DIV_EAXEd
		dd		IDIV_EAXEd

; group 4
	align	32, db 0
	global	insttable_G4
insttable_G4:
		dd		INC_Eb
		dd		DEC_Eb
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

; group 5
	align	32, db 0
	global	insttable_G5Ew
insttable_G5Ew:
		dd		INC_Ew
		dd		DEC_Ew
		dd		CALL_Ew
		dd		CALL16_Ep
		dd		JMP_Ew
		dd		JMP16_Ep
		dd		PUSH_Ew
		dd		undef_op	;POP_Ew_G5

	align	32, db 0
	global	insttable_G5Ed
insttable_G5Ed:
		dd		INC_Ed
		dd		DEC_Ed
		dd		CALL_Ed
		dd		CALL32_Ep
		dd		JMP_Ed
		dd		JMP32_Ep
		dd		PUSH_Ed
		dd		undef_op	;POP_Ed_G5

; group 6
	align	32, db 0
	global	insttable_G6
insttable_G6:
		dd		SLDT_Ew
		dd		STR_Ew
		dd		LLDT_Ew
		dd		LTR_Ew
		dd		VERR_Ew
		dd		VERW_Ew
		dd		undef_op
		dd		undef_op

; group 7
	align	32, db 0
	global	insttable_G7_16
insttable_G7_16:
		dd		SGDT16_Ms
		dd		SIDT16_Ms
		dd		LGDT16_Ms
		dd		LIDT16_Ms
		dd		SMSW_Ew
		dd		undef_op
		dd		LMSW_Ew
		dd		_INVLPG

	align	32, db 0
	global	insttable_G7_32
insttable_G7_32:
		dd		SGDT32_Ms
		dd		SIDT32_Ms
		dd		LGDT32_Ms
		dd		LIDT32_Ms
		dd		SMSW_Ew
		dd		undef_op
		dd		LMSW_Ew
		dd		_INVLPG

; group 8
	align	32, db 0
	global	insttable_G8EwIb
insttable_G8EwIb:
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		BT_EwIb
		dd		BTS_EwIb
		dd		BTR_EwIb
		dd		BTC_EwIb

	align	32, db 0
	global	insttable_G8EdIb
insttable_G8EdIb:
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		BT_EdIb
		dd		BTS_EdIb
		dd		BTR_EdIb
		dd		BTC_EdIb

; group 9
	align	32, db 0
	global	insttable_G9
insttable_G9:
		dd		undef_op
		dd		_CMPXCHG8B
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op
		dd		undef_op

