
; CONTROL TRANSFER INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"
%include "resolve.inc"
%include "debug.inc"

extern	_cpu_regs
extern	_cpu_stat
extern	cpu_inst

section .text

; jmp
	align	32
	global	JMP_Jb
JMP_Jb:
				CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JMP_Jw
JMP_Jw:
				CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JMP_Jd
JMP_Jd:
				CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

	align	32
	global	JMP16_Ap
JMP16_Ap:
				CPUCLOCK 11
				GET_PCWORD
				mov		dx, ax
				GET_PCWORD
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				movzx	esi, dx
				ret

	align	32
	global	JMP32_Ap
JMP32_Ap:
				CPUCLOCK 11
				GET_PCDWORD
				mov		edx, eax
				GET_PCWORD
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
;				mov		esi, edx
				movzx	esi, dx
				ret

	align	32
	global	JMP_Ew
JMP_Ew:
				PREPART_EA16 7
					mov		ax, [CPU_REG + eax * 4]
					movzx	esi, ax
					ret
				MEMORY_EA16 11
					mov		ax, [MAIN_MEM + ecx]
					movzx	esi, ax
					ret
				EXTMEM_EA16
					movzx	esi, ax
					ret

	align	32
	global	JMP_Ed
JMP_Ed:
				PREPART_EA32 7
					mov		eax, [CPU_REG + eax * 4]
;					mov		esi, eax
					movzx	esi, ax
					ret
				MEMORY_EA32 11
					mov		eax, [MAIN_MEM + ecx]
;					mov		esi, eax
					movzx	esi, ax
					ret
				EXTMEM_EA32
;					mov		esi, eax
					movzx	esi, ax
					ret

	align	32
	global	JMP16_Ep
JMP16_Ep:
				cmp		al, 0c0h
				jnc		.register_eareg16
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				movzx	esi, ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				ret
		.register_eareg16:
				INT_NUM 6

	global	JMP32_Ep
JMP32_Ep:
				cmp		al, 0c0h
				jnc		.register_eareg32
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
;				mov		esi, eax
				movzx	esi, ax
				add		bx, 4
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				ret
		.register_eareg32:
				INT_NUM 6

; jcc
; jo
	align	32
	global	JO_Jb
JO_Jb:
				test	word [CPU_FLAG], O_FLAG
				jne		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JO_Jw
JO_Jw:
				test	word [CPU_FLAG], O_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JO_Jd
JO_Jd:
				test	word [CPU_FLAG], O_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jno
	align	32
	global	JNO_Jb
JNO_Jb:
				test	word [CPU_FLAG], O_FLAG
				je		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JNO_Jw
JNO_Jw:
				test	word [CPU_FLAG], O_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JNO_Jd
JNO_Jd:
				test	word [CPU_FLAG], O_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jc
	align	32
	global	JC_Jb
JC_Jb:
				test	byte [CPU_FLAGL], C_FLAG
				jne		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JC_Jw
JC_Jw:
				test	byte [CPU_FLAGL], C_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JC_Jd
JC_Jd:
				test	byte [CPU_FLAGL], C_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jnc
	align	32
	global	JNC_Jb
JNC_Jb:
				test	byte [CPU_FLAGL], C_FLAG
				je		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JNC_Jw
JNC_Jw:
				test	byte [CPU_FLAGL], C_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JNC_Jd
JNC_Jd:
				test	byte [CPU_FLAGL], C_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jz
	align	32
	global	JZ_Jb
JZ_Jb:
				test	byte [CPU_FLAGL], Z_FLAG
				jne		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JZ_Jw
JZ_Jw:
				test	byte [CPU_FLAGL], Z_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JZ_Jd
JZ_Jd:
				test	byte [CPU_FLAGL], Z_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jnz
	align	32
	global	JNZ_Jb
JNZ_Jb:
				test	byte [CPU_FLAGL], Z_FLAG
				je		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JNZ_Jw
JNZ_Jw:
				test	byte [CPU_FLAGL], Z_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JNZ_Jd
JNZ_Jd:
				test	byte [CPU_FLAGL], Z_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jna
	align	32
	global	JNA_Jb
JNA_Jb:
				test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
				jne		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JNA_Jw
JNA_Jw:
				test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JNA_Jd
JNA_Jd:
				test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; ja
	align	32
	global	JA_Jb
JA_Jb:
				test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
				je		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JA_Jw
JA_Jw:
				test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JA_Jd
JA_Jd:
				test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; js
	align	32
	global	JS_Jb
JS_Jb:
				test	byte [CPU_FLAGL], S_FLAG
				jne		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JS_Jw
JS_Jw:
				test	byte [CPU_FLAGL], S_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JS_Jd
JS_Jd:
				test	byte [CPU_FLAGL], S_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jns
	align	32
	global	JNS_Jb
JNS_Jb:
				test	byte [CPU_FLAGL], S_FLAG
				je		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JNS_Jw
JNS_Jw:
				test	byte [CPU_FLAGL], S_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JNS_Jd
JNS_Jd:
				test	byte [CPU_FLAGL], S_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jp
	align	32
	global	JP_Jb
JP_Jb:
				test	byte [CPU_FLAGL], P_FLAG
				jne		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JP_Jw
JP_Jw:
				test	byte [CPU_FLAGL], P_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JP_Jd
JP_Jd:
				test	byte [CPU_FLAGL], P_FLAG
				jne		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jnp
	align	32
	global	JNP_Jb
JNP_Jb:
				test	byte [CPU_FLAGL], P_FLAG
				je		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JNP_Jw
JNP_Jw:
				test	byte [CPU_FLAGL], P_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JNP_Jd
JNP_Jd:
				test	byte [CPU_FLAGL], P_FLAG
				je		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jl
	align	32
	global	JL_Jb
JL_Jb:
				mov		dx, [CPU_FLAG]
				shl		dh, 4
				xor		dl, dh
				js		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JL_Jw
JL_Jw:
				mov		dx, [CPU_FLAG]
				shl		dh, 4
				xor		dl, dh
				js		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JL_Jd
JL_Jd:
				mov		dx, [CPU_FLAG]
				shl		dh, 4
				xor		dl, dh
				js		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jnl
	align	32
	global	JNL_Jb
JNL_Jb:
				mov		dx, [CPU_FLAG]
				shl		dh, 4
				xor		dl, dh
				jns		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JNL_Jw
JNL_Jw:
				mov		dx, [CPU_FLAG]
				shl		dh, 4
				xor		dl, dh
				jns		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JNL_Jd
JNL_Jd:
				mov		dx, [CPU_FLAG]
				shl		dh, 4
				xor		dl, dh
				jns		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jle
	align	32
	global	JLE_Jb
JLE_Jb:
				mov		dx, [CPU_FLAG]
				test	dl, Z_FLAG
				jne		.flagjump
				shl		dh, 4
				xor		dl, dh
				js		.flagjump
				CPUCLOCK 3
				inc		si
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	align	32
	global	JLE_Jw
JLE_Jw:
				mov		dx, [CPU_FLAG]
				test	dl, Z_FLAG
				jne		.flagjump
				shl		dh, 4
				xor		dl, dh
				js		.flagjump
				CPUCLOCK 3
				add		si, 2
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret

	align	32
	global	JLE_Jd
JLE_Jd:
				mov		dx, [CPU_FLAG]
				test	dl, Z_FLAG
				jne		.flagjump
				shl		dh, 4
				xor		dl, dh
				js		.flagjump
				CPUCLOCK 3
				add		si, 4
				ret
	.flagjump:	CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret

; jnle
	align	32
	global	JNLE_Jb
JNLE_Jb:
				mov		dx, [CPU_FLAG]
				test	dl, Z_FLAG
				jne		.notjump
				shl		dh, 4
				xor		dl, dh
				js		.notjump
				CPUCLOCK 7
				GET_PCBYTE
				cbw
				add		si, ax
				ret
	.notjump:	CPUCLOCK 3
				inc		si
				ret

	align	32
	global	JNLE_Jw
JNLE_Jw:
				mov		dx, [CPU_FLAG]
				test	dl, Z_FLAG
				jne		.notjump
				shl		dh, 4
				xor		dl, dh
				js		.notjump
				CPUCLOCK 7
				GET_PCWORD
				add		si, ax
				ret
	.notjump:	CPUCLOCK 3
				add		si, 2
				ret

	align	32
	global	JNLE_Jd
JNLE_Jd:
				mov		dx, [CPU_FLAG]
				test	dl, Z_FLAG
				jne		.notjump
				shl		dh, 4
				xor		dl, dh
				js		.notjump
				CPUCLOCK 7
				GET_PCDWORD
				add		esi, eax
				and		esi, 0000ffffh
				ret
	.notjump:	CPUCLOCK 3
				add		si, 4
				ret

; jcxz
	align	32
	global	JeCXZ_Jb
JeCXZ_Jb:
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				cmp		word [CPU_CX], 0
				jne		.loopend
				CPUCLOCK 8
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	.as32:		cmp		dword [CPU_ECX], 0
				jne		.loopend
				CPUCLOCK 8
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	.loopend:	CPUCLOCK 4
				inc		si
				ret

; loop
	align	32
	global	LOOPNE_Jb
LOOPNE_Jb:
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				dec		word [CPU_CX]
				je		.loopend
				test	byte [CPU_FLAGL], Z_FLAG
				jne		.loopend
				CPUCLOCK 8
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	.as32:		dec		dword [CPU_ECX]
				je		.loopend
				test	byte [CPU_FLAGL], Z_FLAG
				jne		.loopend
				CPUCLOCK 8
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	.loopend:	CPUCLOCK 4
				inc		si
				ret

	align	32
	global	LOOPE_Jb
LOOPE_Jb:
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				dec		word [CPU_CX]
				je		.loopend
				test	byte [CPU_FLAGL], Z_FLAG
				je		.loopend
				CPUCLOCK 8
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	.as32:		dec		dword [CPU_ECX]
				je		.loopend
				test	byte [CPU_FLAGL], Z_FLAG
				je		.loopend
				CPUCLOCK 8
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	.loopend:	CPUCLOCK 4
				inc		si
				ret

	align	32
	global	LOOP_Jb
LOOP_Jb:
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				dec		word [CPU_CX]
				je		.loopend
				CPUCLOCK 8
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	.as32:		dec		dword [CPU_ECX]
				je		.loopend
				CPUCLOCK 8
				GET_PCBYTE
				cbw
				add		si, ax
				ret

	.loopend:	CPUCLOCK 4
				inc		si
				ret

; call
	align	32
	global	CALL_Aw
CALL_Aw:
				CPUCLOCK 7
				GET_PCWORD
				mov		dx, si
				add		si, ax
				sub		word [CPU_SP], 2
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				jmp		__f_i286_memorywrite_w@8

	align	32
	global	CALL_Ad
CALL_Ad:
				CPUCLOCK 7
				GET_PCDWORD
				mov		edx, esi
				add		esi, eax
				and		esi, 0000ffffh
				sub		word [CPU_SP], 4
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				jmp		__f_i286_memorywrite_d@8

	align	32
	global	CALL_Ew
CALL_Ew:
				sub		word [CPU_SP], 2
				PREPART_EA16 7
					mov		dx, [CPU_REG + eax * 4]
					xchg	dx, si
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_w@8
				MEMORY_EA16 11
					mov		dx, [MAIN_MEM + ecx]
					xchg	dx, si
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_w@8
				EXTMEM_EA16
					mov		dx, si
					movzx	esi, ax
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	CALL_Ed
CALL_Ed:
				sub		word [CPU_SP], 4
				PREPART_EA32 7
					mov		edx, [CPU_REG + eax * 4]
					xchg	edx, esi
					and		esi, 0000ffffh
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_d@8
				MEMORY_EA32 11
					mov		edx, [MAIN_MEM + ecx]
					xchg	edx, esi
					and		esi, 0000ffffh
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_d@8
				EXTMEM_EA32
					mov		edx, esi
;					mov		esi, eax
					movzx	esi, ax
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	CALL16_Ap
CALL16_Ap:
				CPUCLOCK 13
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				mov		dx, [CPU_CS]
				sub		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memorywrite_w@8
				GET_PCWORD
				push	ax
				GET_PCWORD
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				pop		dx
				xchg	si, dx
				sub		bx, 2
				mov		[CPU_SP], bx
				lea		ecx, [edi + ebx]
				jmp		__f_i286_memorywrite_w@8

	align	32
	global	CALL32_Ap
CALL32_Ap:
				CPUCLOCK 13
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				movzx	edx, word [CPU_CS]
				sub		bx, 4
				lea		ecx, [edi + ebx]
				call	__f_i286_memorywrite_d@8
				GET_PCDWORD
				and		eax, 0000ffffh
				push	eax
				GET_PCWORD
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				pop		edx
				xchg	esi, edx
				sub		bx, 4
				mov		[CPU_SP], bx
				lea		ecx, [edi + ebx]
				jmp		__f_i286_memorywrite_d@8

	align	32
	global	CALL16_Ep
CALL16_Ep:
				cmp		al, 0c0h
				jnc		near .register_eareg16
				CPUCLOCK 16
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				push	edi
				push	ebx
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				mov		dx, [CPU_CS]
				sub		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memorywrite_w@8
				mov		dx, si
				sub		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memorywrite_w@8
				mov		[CPU_SP], bx
				pop		ebx
				pop		edi
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				movzx	esi, ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				ret
		.register_eareg16:
				INT_NUM 6

	align	32
	global	CALL32_Ep
CALL32_Ep:
				cmp		al, 0c0h
				jnc		near .register_eareg32
				CPUCLOCK 16
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				push	edi
				push	ebx
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				movzx	edx, word [CPU_CS]
				sub		bx, 4
				lea		ecx, [edi + ebx]
				call	__f_i286_memorywrite_d@8
				mov		edx, esi
				sub		bx, 4
				lea		ecx, [edi + ebx]
				call	__f_i286_memorywrite_d@8
				mov		[CPU_SP], bx
				pop		ebx
				pop		edi
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
;				mov		esi, eax
				movzx	esi, ax
				add		bx, 4
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				ret
		.register_eareg32:
				INT_NUM 6

; ret
	align	32
	global	RETnear16
RETnear16:
				CPUCLOCK 11
				REGPOP si
				ret

	align	32
	global	RETnear32
RETnear32:
				CPUCLOCK 11
				REGPOP32 esi
				and		esi, 0000ffffh
				ret

	align	32
	global	RETnear16_Iw
RETnear16_Iw:
				CPUCLOCK 11
				GET_PCWORD
				movzx	ecx, word [CPU_SP]
				add		ax, 2
				add		[CPU_SP], ax
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_w@4
				movzx	esi, ax
				ret

	align	32
	global	RETnear32_Iw
RETnear32_Iw:
				CPUCLOCK 11
				GET_PCDWORD
				movzx	ecx, word [CPU_SP]
				add		ax, 4
				add		[CPU_SP], ax
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_d@4
;				mov		esi, eax
				movzx	esi, ax
				ret

	align	32
	global	RETfar16
RETfar16:
				CPUCLOCK 15
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	__f_i286_memoryread_w@4
				movzx	esi, ax
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	__f_i286_memoryread_w@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				mov		[CPU_SP], bx
				ret

	align	32
	global	RETfar32
RETfar32:
				CPUCLOCK 15
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				lea		ecx, [edi + ebx]
				add		bx, 4
				call	__f_i286_memoryread_d@4
;				mov		esi, eax
				movzx	esi, ax
				lea		ecx, [edi + ebx]
				add		bx, 4
				call	__f_i286_memoryread_d@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				mov		[CPU_SP], bx
				ret

	align	32
	global	RETfar16_Iw
RETfar16_Iw:
				CPUCLOCK 15
				GET_PCWORD
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				add		[CPU_SP], ax
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	__f_i286_memoryread_w@4
				movzx	esi, ax
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				add		word [CPU_SP], 4
				ret

	align	32
	global	RETfar32_Iw
RETfar32_Iw:
				CPUCLOCK 15
				GET_PCWORD
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				add		[CPU_SP], ax
				lea		ecx, [edi + ebx]
				add		bx, 4
				call	__f_i286_memoryread_d@4
;				mov		esi, eax
				movzx	esi, ax
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				add		word [CPU_SP], 8
				ret

	align	32
	global	_IRET
_IRET:
				CPUCLOCK 31
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	__f_i286_memoryread_w@4
				movzx	esi, ax
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	__f_i286_memoryread_w@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				lea		ecx, [edi + ebx]
				add		bx, 2
				call	__f_i286_memoryread_w@4
				mov		[CPU_SP], bx
				and		ax, 7fd7h
				mov		[CPU_FLAG], ax
				and		ah, 3
				cmp		ah, 3
				sete	[CPU_TRAP]
				IRQCHECKTERM

	align	32
	global	_IRETD
_IRETD:
				CPUCLOCK 31
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				lea		ecx, [edi + ebx]
				add		bx, 4
				call	__f_i286_memoryread_d@4
;				mov		esi, eax
				movzx	esi, ax
				lea		ecx, [edi + ebx]
				add		bx, 4
				call	__f_i286_memoryread_d@4
				mov		[CPU_CS], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				lea		ecx, [edi + ebx]
				add		ebx, 4
				call	__f_i286_memoryread_d@4
				mov		[CPU_SP], bx
				and		eax, 00277fd7h
				mov		[CPU_EFLAG], eax
				test	eax, VM_FLAG
				jnz		.vm
				and		ah, 3
				cmp		ah, 3
				sete	[CPU_TRAP]
				IRQCHECKTERM

		.vm:	jmp		__f_change_vm@0

; int
	align	32
	global	_INT1
_INT1:
				CPUCLOCK 23
				INT_NUM 1

	align	32
	global	_INT3
_INT3:
				CPUCLOCK 23
				INT_NUM 3

	align	32
	global	_INTO
_INTO:
				test	word [CPU_FLAG], O_FLAG
				jne		.intovf
				CPUCLOCK 4
				ret
		.intovf:
				CPUCLOCK 24
				INT_NUM 4

	align	32
	global	INT_Ib
INT_Ib:
				CPUCLOCK 23
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				sub		bx, 2
				mov		dx, [CPU_FLAG]
				and		word [CPU_FLAG], ~ (T_FLAG | I_FLAG)
				mov		byte [CPU_TRAP], 0
				lea		ecx, [edi + ebx]
				call	__f_i286_memorywrite_w@8
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_CS]
				call	__f_i286_memorywrite_w@8
				GET_PCBYTE
				sub		bx, 2
				mov		[CPU_SP], bx
				lea		ecx, [edi + ebx]
				mov		dx, si
				mov		eax, [MAIN_MEM + eax * 4]
				movzx	esi, ax
				shr		eax, 16
				mov		[CPU_CS], ax
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				mov		ebp, eax
				jmp		__f_i286_memorywrite_w@8

; check index
	align	32
	global	BOUND_GwMa
BOUND_GwMa:
				GET_PCBYTE
				mov		ebx, 6
				cmp		al, 0c0h
				jnc		.bountint
				mov		bl, al
				shr		bl, 3
				and		ebx, 7
				CPUCLOCK 13
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				call	__f_i286_memoryread_w@4
				cmp		[CPU_REG + ebx * 4], ax
				jb		.bounttrue
				add		ecx, 2
				call	__f_i286_memoryread_w@4
				cmp		[CPU_REG + ebx * 4], ax
				ja		.bounttrue
				ret
	.bounttrue:	mov		ebx, 5
	.bountint:	INT_NUM ebx

	align	32
	global	BOUND_GdMa
BOUND_GdMa:
				GET_PCBYTE
				mov		ebx, 6
				cmp		al, 0c0h
				jnc		.bountint
				mov		bl, al
				shr		bl, 3
				and		ebx, 7
				CPUCLOCK 13
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				call	__f_i286_memoryread_d@4
				cmp		[CPU_REG + ebx * 4], eax
				jb		.bounttrue
				add		ecx, 4
				call	__f_i286_memoryread_d@4
				cmp		[CPU_REG + ebx * 4], eax
				ja		.bounttrue
				ret
	.bounttrue:	mov		ebx, 5
	.bountint:	INT_NUM ebx

; high-level
	align	32
	global	ENTER_IwIb
ENTER_IwIb:
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				GET_PCWORD
				push	eax
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_BP]
				call	__f_i286_memorywrite_w@8
				GET_PCBYTE
				and		eax, 1fh
				je		near .enter0
				dec		eax
				je		.enter1
				lea		ecx, [eax * 4 + 12]
				CPUCLOCK ecx
				push	ebp
				movzx	ebp, word [CPU_BP]
				mov		[CPU_BP], bx
		.enter_lp:
				push	eax
				sub		bp, 2
				lea		ecx, [edi + ebp]
				call	__f_i286_memoryread_w@4
				mov		edx, eax
				sub		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memorywrite_w@8
				pop		eax
				dec		eax
				jne		.enter_lp
				pop		ebp
				pop		eax
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_BP]
				sub		bx, ax
				mov		[CPU_SP], bx
				jmp		__f_i286_memorywrite_w@8
		.enter1:
				CPUCLOCK 15
				mov		dx, bx
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		[CPU_BP], dx
				pop		eax
				sub		bx, ax
				mov		[CPU_SP], bx
				jmp		__f_i286_memorywrite_w@8

		.enter0:
				CPUCLOCK 11
				mov		[CPU_BP], bx
				pop		eax
				sub		bx, ax
				mov		[CPU_SP], bx
				ret

	align	32
	global	LEAVE16
LEAVE16:
				CPUCLOCK 5
				mov		ax, [CPU_BP]
				mov		[CPU_SP], ax
				REGPOP [CPU_BP]
				ret

	align	32
	global	LEAVE32
LEAVE32:
				CPUCLOCK 5
				mov		ax, [CPU_BP]
				mov		[CPU_SP], ax
				REGPOP32 [CPU_EBP]
				ret

