
; DATA TRANSFER INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"
%include "resolve.inc"

extern	_cpu_regs
extern	_cpu_stat
extern	cpu_inst

extern	exec_1step

section .text

; mov
	align	32
	global	MOV_EbGb
MOV_EbGb:
				PREPART_EA_REG8 2
					mov		[CPU_REG + eax], dl
					ret
		.memory_eareg8:
					CPUCLOCK 3
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		dl, [CPU_REG + ebx]
					jmp		__f_i286_memorywrite@8

	align	32
	global	MOV_EwGw
MOV_EwGw:
				PREPART_EA_REG16 2
					mov		[CPU_REG + eax * 4], dx
					ret
		.memory_eareg16:
					CPUCLOCK 3
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		dx, [CPU_REG + ebx * 4]
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	MOV_EdGd
MOV_EdGd:
				PREPART_EA_REG32 2
					mov		[CPU_REG + eax * 4], edx
					ret
		.memory_eareg32:
					CPUCLOCK 3
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		edx, [CPU_REG + ebx * 4]
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	MOV_GbEb
MOV_GbEb:
				PREPART_REG8_EA 2, 5
					mov		[CPU_REG + ebx], al
					ret

	align	32
	global	MOV_GwEw
MOV_GwEw:
				PREPART_REG16_EA 2, 5
					mov		[CPU_REG + ebx * 4], ax
					ret

	align	32
	global	MOV_GdEd
MOV_GdEd:
				PREPART_REG32_EA 2, 5
					mov		[CPU_REG + ebx * 4], eax
					ret

	align	32
	global	MOV_EwSw
MOV_EwSw:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		ebx, 6
				jae		.reserved
				mov		dx, [CPU_SEGREG + ebx * 2]
				cmp		al, 0c0h
				jc		.memory_eareg16
				CPUCLOCK 2
				and		eax, 7
				mov		[CPU_REG + eax * 4], dx
				ret
		.memory_eareg16:
				CPUCLOCK 3
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				jmp		__f_i286_memorywrite_w@8
		.reserved:
				INT_NUM 6

	align	32
	global	MOV_SwEw
MOV_SwEw:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		ebx, 1
				je		near .fixcs
				cmp		ebx, 6
				jae		near .reserved
				cmp		al, 0c0h
				jc		.src_memory
				CPUCLOCK 2
				and		eax, 7
				mov		ax, [CPU_REG + eax * 4]
				mov		[CPU_SEGREG + ebx * 2], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
%if 0
				mov		[SEG_BASE + ebx * 4], eax
				cmp		ebx, 2
%else
				cmp		ebx, 2
				lea		ebx, [ebx * 4]
				mov		[SEG_BASE + ebx * 8], eax
%endif
				je		.nexts
				ret
		.src_memory:
				CPUCLOCK 5
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				call	__f_i286_memoryread_w@4
				mov		[CPU_SEGREG + ebx * 2], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
%if 0
				mov		[SEG_BASE + ebx * 4], eax
				cmp		ebx, 2
%else
				cmp		ebx, 2
				lea		ebx, [ebx * 4]
				mov		[SEG_BASE + ebx * 8], eax
%endif
				je		.nexts
				ret
		.nexts:	jmp		exec_1step
		.fixcs:
		.reserved:
				INT_NUM 6

	align	32
	global	MOV_ALOb
MOV_ALOb:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				GET_PCWORD
				movzx	ecx, ax
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		[CPU_AL], al
				ret

	.as32:		GET_PCDWORD
				mov		ecx, eax
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		[CPU_AL], al
				ret

	align	32
	global	MOV_AXOw
MOV_AXOw:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				GET_PCWORD
				movzx	ecx, ax
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		[CPU_AX], ax
				ret

	.as32:		GET_PCDWORD
				mov		ecx, eax
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		[CPU_AX], ax
				ret

	align	32
	global	MOV_EAXOd
MOV_EAXOd:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				GET_PCWORD
				movzx	ecx, ax
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		[CPU_EAX], eax
				ret

	.as32:		GET_PCDWORD
				mov		ecx, eax
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		[CPU_EAX], eax
				ret

	align	32
	global	MOV_ObAL
MOV_ObAL:
				CPUCLOCK 3
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				GET_PCWORD
				mov		dl, [CPU_AL]
				movzx	ecx, ax
				ADD_SEGBASE [DS_BASE]
				jmp		__f_i286_memorywrite@8

	.as32:		GET_PCDWORD
				mov		dl, [CPU_AL]
				mov		ecx, eax
				ADD_SEGBASE [DS_BASE]
				jmp		__f_i286_memorywrite@8

	align	32
	global	MOV_OwAX
MOV_OwAX:
				CPUCLOCK 3
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				GET_PCWORD
				mov		dx, [CPU_AX]
				movzx	ecx, ax
				ADD_SEGBASE [DS_BASE]
				jmp		__f_i286_memorywrite_w@8

	.as32:		GET_PCDWORD
				mov		dx, [CPU_AX]
				mov		ecx, eax
				ADD_SEGBASE [DS_BASE]
				jmp		__f_i286_memorywrite_w@8

	align	32
	global	MOV_OdEAX
MOV_OdEAX:
				CPUCLOCK 3
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				GET_PCWORD
				mov		edx, [CPU_EAX]
				movzx	ecx, ax
				ADD_SEGBASE [DS_BASE]
				jmp		__f_i286_memorywrite_d@8

	.as32:		GET_PCDWORD
				mov		edx, [CPU_EAX]
				mov		ecx, eax
				ADD_SEGBASE [DS_BASE]
				jmp		__f_i286_memorywrite_d@8

	align	32
	global	MOV_EbIb
MOV_EbIb:
				GET_PCBYTE
				PREPART_EA8 2
					mov		ebx, eax
					GET_PCBYTE
					mov		[CPU_REG + ebx], al
					ret
				MEMORY_EA8 3
					mov		ebx, ecx
					GET_PCBYTE
					mov		[MAIN_MEM + ebx], al
					ret
			.extmem_eareg8:
					mov		ebx, ecx
					GET_PCBYTE
					mov		dl, al
					mov		ecx, ebx
					jmp		__f_i286_memorywrite@8

	align	32
	global	MOV_EwIw
MOV_EwIw:
				GET_PCBYTE
				PREPART_EA16 2
					mov		ebx, eax
					GET_PCWORD
					mov		[CPU_REG + ebx * 4], ax
					ret
				MEMORY_EA16 3
					mov		ebx, ecx
					GET_PCWORD
					mov		[MAIN_MEM + ebx], ax
					ret
			.extmem_eareg16:
					mov		ebx, ecx
					GET_PCWORD
					mov		dx, ax
					mov		ecx, ebx
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	MOV_EdId
MOV_EdId:
				GET_PCBYTE
				PREPART_EA32 2
					mov		ebx, eax
					GET_PCDWORD
					mov		[CPU_REG + ebx * 4], eax
					ret
				MEMORY_EA32 3
					mov		ebx, ecx
					GET_PCDWORD
					mov		[MAIN_MEM + ebx], eax
					ret
			.extmem_eareg32:
					mov		ebx, ecx
					GET_PCDWORD
					mov		edx, eax
					mov		ecx, ebx
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	MOV_RLIb
MOV_RLIb:
				CPUCLOCK 2
				and		eax, 3
				mov		ebx, eax
				GET_PCBYTE
				mov		[CPU_REG + ebx * 4], al
				ret

	align	32
	global	MOV_RHIb
MOV_RHIb:
				CPUCLOCK 2
				and		eax, 3
				mov		ebx, eax
				GET_PCBYTE
				mov		[CPU_REG + ebx * 4 + 1], al
				ret

	align	32
	global	MOV_RXIw
MOV_RXIw:
				CPUCLOCK 2
				and		eax, 7
				mov		ebx, eax
				GET_PCWORD
				mov		[CPU_REG + ebx * 4], ax
				ret

	align	32
	global	MOV_ERXId
MOV_ERXId:
				CPUCLOCK 2
				and		eax, 7
				mov		ebx, eax
				GET_PCDWORD
				mov		[CPU_REG + ebx * 4], eax
				ret

; cmovcc
; cmovo
	align	32
	global	CMOVO_GwEw
CMOVO_GwEw:
				PREPART_REG16_EA 2, 5
					test	word [CPU_FLAG], O_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVO_GdEd
CMOVO_GdEd:
				PREPART_REG32_EA 2, 5
					test	word [CPU_FLAG], O_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovno
	align	32
	global	CMOVNO_GwEw
CMOVNO_GwEw:
				PREPART_REG16_EA 2, 5
					test	word [CPU_FLAG], O_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVNO_GdEd
CMOVNO_GdEd:
				PREPART_REG32_EA 2, 5
					test	word [CPU_FLAG], O_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovc
	align	32
	global	CMOVC_GwEw
CMOVC_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], C_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVC_GdEd
CMOVC_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], C_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovnc
	align	32
	global	CMOVNC_GwEw
CMOVNC_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], C_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVNC_GdEd
CMOVNC_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], C_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovz
	align	32
	global	CMOVZ_GwEw
CMOVZ_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], Z_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVZ_GdEd
CMOVZ_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], Z_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovnz
	align	32
	global	CMOVNZ_GwEw
CMOVNZ_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], Z_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVNZ_GdEd
CMOVNZ_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], Z_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovna
	align	32
	global	CMOVNA_GwEw
CMOVNA_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVNA_GdEd
CMOVNA_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmova
	align	32
	global	CMOVA_GwEw
CMOVA_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVA_GdEd
CMOVA_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovs
	align	32
	global	CMOVS_GwEw
CMOVS_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], S_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVS_GdEd
CMOVS_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], S_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovns
	align	32
	global	CMOVNS_GwEw
CMOVNS_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], S_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVNS_GdEd
CMOVNS_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], S_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovp
	align	32
	global	CMOVP_GwEw
CMOVP_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], P_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVP_GdEd
CMOVP_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], P_FLAG
					jz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovnp
	align	32
	global	CMOVNP_GwEw
CMOVNP_GwEw:
				PREPART_REG16_EA 2, 5
					test	byte [CPU_FLAGL], P_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVNP_GdEd
CMOVNP_GdEd:
				PREPART_REG32_EA 2, 5
					test	byte [CPU_FLAGL], P_FLAG
					jnz		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovl
	align	32
	global	CMOVL_GwEw
CMOVL_GwEw:
				PREPART_REG16_EA 2, 5
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					jns		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVL_GdEd
CMOVL_GdEd:
				PREPART_REG32_EA 2, 5
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					jns		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovnl
	align	32
	global	CMOVNL_GwEw
CMOVNL_GwEw:
				PREPART_REG16_EA 2, 5
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					js		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVNL_GdEd
CMOVNL_GdEd:
				PREPART_REG32_EA 2, 5
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					js		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovle
	align	32
	global	CMOVLE_GwEw
CMOVLE_GwEw:
				PREPART_REG16_EA 2, 5
					mov		dx, [CPU_FLAG]
					test	dl, Z_FLAG
					jnz		.move
					shl		dh, 4
					xor		dl, dh
					jns		.notmove
		.move:		mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVLE_GdEd
CMOVLE_GdEd:
				PREPART_REG32_EA 2, 5
					mov		dx, [CPU_FLAG]
					test	dl, Z_FLAG
					jnz		.move
					shl		dh, 4
					xor		dl, dh
					jns		.notmove
		.move:		mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; cmovnle
	align	32
	global	CMOVNLE_GwEw
CMOVNLE_GwEw:
				PREPART_REG16_EA 2, 5
					mov		dx, [CPU_FLAG]
					test	dl, Z_FLAG
					jnz		.notmove
					shl		dh, 4
					xor		dl, dh
					js		.notmove
					mov		[CPU_REG + ebx * 4], ax
		.notmove:	ret

	align	32
	global	CMOVNLE_GdEd
CMOVNLE_GdEd:
				PREPART_REG32_EA 2, 5
					mov		dx, [CPU_FLAG]
					test	dl, Z_FLAG
					jnz		.notmove
					shl		dh, 4
					xor		dl, dh
					js		.notmove
					mov		[CPU_REG + ebx * 4], eax
		.notmove:	ret

; xchg
	align	32
	global	XCHG_EbGb
XCHG_EbGb:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 2
				bt		ebx, 3
				rcl		ebx, 1
				and		ebx, 0dh
				cmp		al, 0c0h
				jc		.memory_eareg8
				shl		eax, 1
				bt		eax, 3
				rcl		eax, 1
				and		eax, 0dh
				CPUCLOCK 3
				mov		dl, [CPU_REG + ebx]
				xchg	dl, [CPU_REG + eax]
				mov		[CPU_REG + ebx], dl
				ret
		.memory_eareg8:
				CPUCLOCK 5
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_READMAX
				jae		.extmem_eareg8
				mov		dl, [CPU_REG + ebx]
				xchg	[MAIN_MEM + ecx], dl
				mov		[CPU_REG + ebx], dl
				ret
		.extmem_eareg8:
				call	__f_i286_memoryread@4
				xchg	al, [CPU_REG + ebx]
				mov		dl, al
				jmp		__f_i286_memorywrite@8

	align	32
	global	XCHG_EwGw
XCHG_EwGw:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		al, 0c0h
				jc		.memory_eareg16
				and		eax, 7
				CPUCLOCK 3
				mov		dx, [CPU_REG + ebx * 4]
				xchg	dx, [CPU_REG + eax * 4]
				mov		[CPU_REG + ebx * 4], dx
				ret
		.memory_eareg16:
				CPUCLOCK 5
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_READMAX - 1
				jae		.extmem_eareg16
				mov		dx, [MAIN_MEM + ecx]
				xchg	dx, [CPU_REG + ebx * 4]
				mov		[MAIN_MEM + ecx], dx
				ret
		.extmem_eareg16:
				call	__f_i286_memoryread_w@4
				xchg	ax, [CPU_REG + ebx * 4]
				mov		dx, ax
				jmp		__f_i286_memorywrite_w@8

	align	32
	global	XCHG_EdGd
XCHG_EdGd:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		al, 0c0h
				jc		.memory_eareg32
				and		eax, 7
				CPUCLOCK 3
				mov		edx, [CPU_REG + ebx * 4]
				xchg	edx, [CPU_REG + eax * 4]
				mov		[CPU_REG + ebx * 4], edx
				ret
		.memory_eareg32:
				CPUCLOCK 5
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_READMAX - 3
				jae		.extmem_eareg32
				mov		edx, [MAIN_MEM + ecx]
				xchg	edx, [CPU_REG + ebx * 4]
				mov		[MAIN_MEM + ecx], edx
				ret
		.extmem_eareg32:
				call	__f_i286_memoryread_d@4
				xchg	eax, [CPU_REG + ebx * 4]
				mov		edx, eax
				jmp		__f_i286_memorywrite_d@8

	align	32
	global	XCHG_RXAX
XCHG_RXAX:
				CPUCLOCK 3
				and		eax, 7
				mov		dx, [CPU_AX]
				xchg	dx, [CPU_REG + eax * 4]
				mov		[CPU_AX], dx
				ret

	align	32
	global	XCHG_ERXEAX
XCHG_ERXEAX:
				CPUCLOCK 3
				and		eax, 7
				mov		edx, [CPU_EAX]
				xchg	edx, [CPU_REG + eax * 4]
				mov		[CPU_EAX], edx
				ret

; byte swap
	align	32
	global	BSWAP_ERX
BSWAP_ERX:
				CPUCLOCK 2
				and		eax, 7
				mov		edx, [CPU_REG + eax * 4]
				bswap	edx
				mov		[CPU_REG + eax * 4], edx
				ret

; xadd
	align	32
	global	XADD_EbGb
XADD_EbGb:
				PREPART_EA_REG8 2
					xadd	[CPU_REG + eax], dl
					mov		[CPU_REG + ebx], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8 7
					xadd	[MAIN_MEM + ecx], dl
					mov		[CPU_REG + ebx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					mov		dl, al
					add		dl, [CPU_REG + ebx]
					mov		[CPU_REG + ebx], al
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	XADD_EwGw
XADD_EwGw:
				PREPART_EA_REG16 2
					xadd	[CPU_REG + eax * 4], dx
					mov		[CPU_REG + ebx * 4], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 7
					xadd	[MAIN_MEM + ecx], dx
					mov		[CPU_REG + ebx * 4], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					mov		dx, ax
					add		dx, [CPU_REG + ebx * 4]
					mov		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	XADD_EdGd
XADD_EdGd:
				PREPART_EA_REG32 2
					xadd	[CPU_REG + eax * 4], edx
					mov		[CPU_REG + ebx * 4], edx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 7
					xadd	[MAIN_MEM + ecx], edx
					mov		[CPU_REG + ebx * 4], edx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					mov		edx, eax
					add		edx, [CPU_REG + ebx * 4]
					mov		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

; cmpxchg
	align	32
	global	CMPXCHG_EbGb
CMPXCHG_EbGb:
				PREPART_EA_REG8 2
					mov		bl, [CPU_REG + eax]
					cmp		[CPU_AL], bl
					jne		.to_al
					mov		[CPU_REG + eax], dl
					FLAG_STORE_OF
					ret
			.to_al:	mov		[CPU_AL], bl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8 6
					mov		bl, [MAIN_MEM + ecx]
					cmp		[CPU_AL], bl
					jne		.to_al
					mov		[MAIN_MEM + ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					cmp		[CPU_AL], al
					jne		.to_al_ext
					mov		dl, [CPU_REG + ebx]
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8
					ret
		.to_al_ext:	mov		[CPU_AL], al
					FLAG_STORE_OF
					ret

	align	32
	global	CMPXCHG_EwGw
CMPXCHG_EwGw:
				PREPART_EA_REG16 2
					mov		bx, [CPU_REG + eax * 4]
					cmp		[CPU_AX], bx
					jne		.to_al
					mov		[CPU_REG + eax * 4], dx
					FLAG_STORE_OF
					ret
			.to_al:	mov		[CPU_AX], bx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 6
					mov		bx, [MAIN_MEM + ecx]
					cmp		[CPU_AX], bx
					jne		.to_al
					mov		[MAIN_MEM + ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					cmp		[CPU_AX], ax
					jne		.to_al_ext
					mov		dx, [CPU_REG + ebx * 4]
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8
					ret
		.to_al_ext:	mov		[CPU_AX], ax
					FLAG_STORE_OF
					ret

	align	32
	global	CMPXCHG_EdGd
CMPXCHG_EdGd:
				PREPART_EA_REG32 2
					mov		ebx, [CPU_REG + eax * 4]
					cmp		[CPU_EAX], ebx
					jne		.to_al
					mov		[CPU_REG + eax * 4], edx
					FLAG_STORE_OF
					ret
			.to_al:	mov		[CPU_EAX], ebx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 6
					mov		ebx, [MAIN_MEM + ecx]
					cmp		[CPU_EAX], ebx
					jne		.to_al
					mov		[MAIN_MEM + ecx], edx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					cmp		[CPU_EAX], eax
					jne		.to_al_ext
					mov		edx, [CPU_REG + ebx * 4]
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8
					ret
		.to_al_ext:	mov		[CPU_EAX], eax
					FLAG_STORE_OF
					ret

	align	32
	global	_CMPXCHG8B
_CMPXCHG8B:
				cmp		al, 0c0h
				jc near		.mem
				INT_NUM 6
		.mem:	CPUCLOCK 2
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_WRITEMAX - 7
				jae		.extmem
				mov		ebx, [MAIN_MEM + ecx]
				mov		eax, [MAIN_MEM + ecx + 4]
				cmp		[CPU_EAX], ebx
				jne		.to_edxeax
				cmp		[CPU_EDX], eax
				jne		.to_edxeax
				mov		ebx, [CPU_EBX]
				mov		eax, [CPU_ECX]
				mov		[MAIN_MEM + ecx], ebx
				mov		[MAIN_MEM + ecx + 4], eax
				or		byte [CPU_FLAGL], Z_FLAG
				ret
		.to_edxeax:
				mov		[CPU_EAX], ebx
				mov		[CPU_EDX], eax
				and		byte [CPU_FLAGL], ~ Z_FLAG
				ret
		.extmem:
				mov		edx, ecx
				call	__f_i286_memoryread_d@4
				mov		ebx, eax
				add		ecx, 4
				call	__f_i286_memoryread_d@4
				cmp		[CPU_EAX], ebx
				jne		.to_edxeax
				cmp		[CPU_EDX], eax
				jne		.to_edxeax
				mov		ecx, edx
				mov		edx, [CPU_EBX]
				call	__f_i286_memorywrite_d@8
				add		ecx, 4
				mov		edx, [CPU_ECX]
				call	__f_i286_memorywrite_d@8
				or		byte [CPU_FLAGL], Z_FLAG
				ret

; push
	align	32
	global	PUSH_RX
PUSH_RX:
				CPUCLOCK 3
				and		eax, 7
				REGPUSH1 [CPU_REG + eax * 4]

	align	32
	global	PUSH_ERX
PUSH_ERX:
				CPUCLOCK 3
				and		eax, 7
				REGPUSH32 [CPU_REG + eax * 4]

	align	32
	global	PUSH_Ew
PUSH_Ew:
				sub		word [CPU_SP], 2
				PREPART_EA16 3
					mov		dx, [CPU_REG + eax * 4]
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_w@8
				MEMORY_EA16 5
					mov		dx, [MAIN_MEM + ecx]
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_w@8
				EXTMEM_EA16
					mov		dx, ax
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	PUSH_Ed
PUSH_Ed:
				sub		word [CPU_SP], 4
				PREPART_EA32 3
					mov		edx, [CPU_REG + eax * 4]
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_d@8
				MEMORY_EA32 5
					mov		edx, [MAIN_MEM + ecx]
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_d@8
				EXTMEM_EA32
					mov		edx, eax
					movzx	ecx, word [CPU_SP]
					add		ecx, [SS_BASE]
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	PUSH_Ib
PUSH_Ib:
				CPUCLOCK 3
				GET_PCBYTE
				cbw
				REGPUSH1 ax

	align	32
	global	PUSH_Iw
PUSH_Iw:
				CPUCLOCK 3
				GET_PCWORD
				REGPUSH1 ax

	align	32
	global	PUSH_Id
PUSH_Id:
				CPUCLOCK 3
				GET_PCDWORD
				REGPUSH32 eax

	align	32
	global	PUSH16_CS
PUSH16_CS:
				CPUCLOCK 3
				REGPUSH1 [CPU_CS]

	align	32
	global	PUSH32_CS
PUSH32_CS:
				CPUCLOCK 3
				REGPUSH32_1 [CPU_CS]

	align	32
	global	PUSH16_DS
PUSH16_DS:
				CPUCLOCK 3
				REGPUSH1 [CPU_DS]

	align	32
	global	PUSH32_DS
PUSH32_DS:
				CPUCLOCK 3
				REGPUSH32_1 [CPU_DS]

	align	32
	global	PUSH16_ES
PUSH16_ES:
				CPUCLOCK 3
				REGPUSH1 [CPU_ES]

	align	32
	global	PUSH32_ES
PUSH32_ES:
				CPUCLOCK 3
				REGPUSH32_1 [CPU_ES]

	align	32
	global	PUSH16_FS
PUSH16_FS:
				CPUCLOCK 3
				REGPUSH1 [CPU_FS]

	align	32
	global	PUSH32_FS
PUSH32_FS:
				CPUCLOCK 3
				REGPUSH32_1 [CPU_FS]

	align	32
	global	PUSH16_GS
PUSH16_GS:
				CPUCLOCK 3
				REGPUSH1 [CPU_GS]

	align	32
	global	PUSH32_GS
PUSH32_GS:
				CPUCLOCK 3
				REGPUSH32_1 [CPU_GS]

	align	32
	global	PUSH16_SS
PUSH16_SS:
				CPUCLOCK 3
				REGPUSH1 [CPU_SS]

	align	32
	global	PUSH32_SS
PUSH32_SS:
				CPUCLOCK 3
				REGPUSH32_1 [CPU_SS]

; pop
	align	32
	global	POP_RX
POP_RX:
				CPUCLOCK 5
				and		eax, 7
				mov		ebx, eax
				REGPOP [CPU_REG + ebx * 4]
				ret

	align	32
	global	POP_ERX
POP_ERX:
				CPUCLOCK 5
				and		eax, 7
				mov		ebx, eax
				REGPOP32 [CPU_REG + ebx * 4]
				ret

	align	32
	global	POP_SP
POP_SP:
				CPUCLOCK 5
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_w@4
				mov		[CPU_SP], ax
				ret

	align	32
	global	POP_ESP
POP_ESP:
				CPUCLOCK 5
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_d@4
;				mov		[CPU_ESP], eax
				mov		[CPU_SP], ax
				ret

	align	32
	global	POP_Ew
POP_Ew:
				CPUCLOCK 5
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_w@4
				add		word [CPU_SP], 2
				mov		dx, ax
				GET_PCBYTE
				cmp		al, 0c0h
				jnc		.src_register
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				jmp		__f_i286_memorywrite_w@8
		.src_register:
				and		eax, 7
				mov		[CPU_REG + eax * 4], dx
				ret

	align	32
	global	POP_Ew_G5
POP_Ew_G5:
				CPUCLOCK 5
				mov		bx, ax
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_w@4
				add		word [CPU_SP], 2
				mov		dx, ax
				mov		ax, bx
				cmp		al, 0c0h
				jnc		.src_register
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				jmp		__f_i286_memorywrite_w@8
		.src_register:
				and		eax, 7
				mov		[CPU_REG + eax * 4], dx
				ret

	align	32
	global	POP_Ed
POP_Ed:
				CPUCLOCK 5
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_d@4
				add		word [CPU_SP], 4
				mov		edx, eax
				GET_PCBYTE
				cmp		al, 0c0h
				jnc		.src_register
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				jmp		__f_i286_memorywrite_d@8
		.src_register:
				and		eax, 7
				mov		[CPU_REG + eax * 4], edx
				ret

	align	32
	global	POP_Ed_G5
POP_Ed_G5:
				CPUCLOCK 5
				mov		bx, ax
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_d@4
				add		word [CPU_SP], 4
				mov		edx, eax
				mov		ax, bx
				cmp		al, 0c0h
				jnc		.src_register
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				jmp		__f_i286_memorywrite_d@8
		.src_register:
				and		eax, 7
				mov		[CPU_REG + eax * 4], edx
				ret

	align	32
	global	POP16_DS
POP16_DS:
				CPUCLOCK 5
				REGPOP [CPU_DS]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[DS_BASE], eax
				ret

	align	32
	global	POP32_DS
POP32_DS:
				CPUCLOCK 5
				REGPOP32_1 [CPU_DS]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[DS_BASE], eax
				ret

	align	32
	global	POP16_ES
POP16_ES:
				CPUCLOCK 5
				REGPOP [CPU_ES]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[ES_BASE], eax
				ret

	align	32
	global	POP32_ES
POP32_ES:
				CPUCLOCK 5
				REGPOP32_1 [CPU_ES]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[ES_BASE], eax
				ret

	align	32
	global	POP16_FS
POP16_FS:
				CPUCLOCK 5
				REGPOP [CPU_FS]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[FS_BASE], eax
				ret

	align	32
	global	POP32_FS
POP32_FS:
				CPUCLOCK 5
				REGPOP32_1 [CPU_FS]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[FS_BASE], eax
				ret

	align	32
	global	POP16_GS
POP16_GS:
				CPUCLOCK 5
				REGPOP [CPU_GS]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[GS_BASE], eax
				ret

	align	32
	global	POP32_GS
POP32_GS:
				CPUCLOCK 5
				REGPOP32_1 [CPU_GS]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[GS_BASE], eax
				ret

	align	32
	global	POP16_SS
POP16_SS:
				CPUCLOCK 5
				REGPOP [CPU_SS]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[SS_BASE], eax
				jmp		exec_1step

	align	32
	global	POP32_SS
POP32_SS:
				CPUCLOCK 5
				REGPOP32_1 [CPU_SS]
				and		eax, 00ffffh
				shl		eax, 4					; make segreg
				mov		[SS_BASE], eax
				jmp		exec_1step

; pusha/popa
	align	32
	global	_PUSHA
_PUSHA:
				CPUCLOCK 17
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_AX]
				call	__f_i286_memorywrite_w@8

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_CX]
				call	__f_i286_memorywrite_w@8

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_DX]
				call	__f_i286_memorywrite_w@8

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_BX]
				call	__f_i286_memorywrite_w@8

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_SP]
				call	__f_i286_memorywrite_w@8

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_BP]
				call	__f_i286_memorywrite_w@8

				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_SI]
				call	__f_i286_memorywrite_w@8

				sub		bx, 2
				mov		[CPU_SP], bx
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_DI]
				jmp		__f_i286_memorywrite_w@8

	align	32
	global	_PUSHAD
_PUSHAD:
				CPUCLOCK 17
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]

				sub		bx, 4
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_EAX]
				call	__f_i286_memorywrite_d@8

				sub		bx, 4
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_ECX]
				call	__f_i286_memorywrite_d@8

				sub		bx, 4
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_EDX]
				call	__f_i286_memorywrite_d@8

				sub		bx, 4
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_EBX]
				call	__f_i286_memorywrite_d@8

				sub		bx, 4
				lea		ecx, [edi + ebx]
				movzx	edx, word [CPU_SP]
				call	__f_i286_memorywrite_d@8

				sub		bx, 4
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_EBP]
				call	__f_i286_memorywrite_d@8

				sub		bx, 4
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_ESI]
				call	__f_i286_memorywrite_d@8

				sub		bx, 4
				mov		[CPU_SP], bx
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_EDI]
				jmp		__f_i286_memorywrite_d@8

	align	32
	global	_POPA
_POPA:
				CPUCLOCK 19
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_DI], ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_SI], ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_BP], ax
				add		bx, 4

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_BX], ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_DX], ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_CX], ax
				add		bx, 2

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_AX], ax
				add		word [CPU_SP], 16
				ret

	align	32
	global	_POPAD
_POPAD:
				CPUCLOCK 19
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_EDI], eax
				add		bx, 4

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_ESI], eax
				add		bx, 4

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_EBP], eax
				add		bx, 8

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_EBX], eax
				add		bx, 4

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_EDX], eax
				add		bx, 4

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_ECX], eax
				add		bx, 4

				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_EAX], eax
				add		word [CPU_SP], 32
				ret

; in
	align	32
	global	IN_ALDX
IN_ALDX:
				CPUCLOCK 5
				mov		cx, [CPU_DX]
				call	__f_i286_in@4
				mov		[CPU_AL], al
				ret

	align	32
	global	IN_AXDX
IN_AXDX:
				CPUCLOCK 5
				mov		cx, [CPU_DX]
				call	__f_i286_in_w@4
				mov		[CPU_AX], ax
				ret

	align	32
	global	IN_EAXDX
IN_EAXDX:
				CPUCLOCK 5
				mov		cx, [CPU_DX]
				call	__f_i286_in_d@4
				mov		[CPU_EAX], eax
				ret

	align	32
	global	IN_ALIb
IN_ALIb:
				CPUCLOCK 5
				GET_PCBYTE
				movzx	cx, al
				call	__f_i286_in@4
				mov		[CPU_AL], al
				ret

	align	32
	global	IN_AXIb
IN_AXIb:
				CPUCLOCK 5
				GET_PCBYTE
				movzx	cx, al
				call	__f_i286_in_w@4
				mov		[CPU_AX], ax
				ret

	align	32
	global	IN_EAXIb
IN_EAXIb:
				CPUCLOCK 5
				GET_PCBYTE
				movzx	cx, al
				call	__f_i286_in_d@4
				mov		[CPU_EAX], eax
				ret

; out
	align	32
	global	OUT_DXAL
OUT_DXAL:
				CPUCLOCK 3
				mov		cx, [CPU_DX]
				mov		dl, [CPU_AL]
				jmp		__f_i286_out@8

	align	32
	global	OUT_DXAX
OUT_DXAX:
				CPUCLOCK 3
				mov		cx, [CPU_DX]
				mov		dx, [CPU_AX]
				jmp		__f_i286_out_w@8

	align	32
	global	OUT_DXEAX
OUT_DXEAX:
				CPUCLOCK 3
				mov		cx, [CPU_DX]
				mov		edx, [CPU_EAX]
				jmp		__f_i286_out_d@8

	align	32
	global	OUT_IbAL
OUT_IbAL:
				CPUCLOCK 3
				GET_PCBYTE
				movzx	cx, al
				mov		dl, [CPU_AL]
				jmp		__f_i286_out@8

	align	32
	global	OUT_IbAX
OUT_IbAX:
				CPUCLOCK 3
				GET_PCBYTE
				movzx	cx, al
				mov		dx, [CPU_AX]
				jmp		__f_i286_out_w@8

	align	32
	global	OUT_IbEAX
OUT_IbEAX:
				CPUCLOCK 3
				GET_PCBYTE
				movzx	cx, al
				mov		edx, [CPU_EAX]
				jmp		__f_i286_out_d@8

; cnv
	align	32
	global	_CWD
_CWD:
				CPUCLOCK 2
				mov		ax, [CPU_AX]
				cwd
				mov		[CPU_DX], dx
				ret

	align	32
	global	_CDQ
_CDQ:
				CPUCLOCK 2
				mov		eax, [CPU_EAX]
				cdq
				mov		[CPU_EDX], edx
				ret

	align	32
	global	_CBW
_CBW:
				CPUCLOCK 2
				mov		al, [CPU_AL]
				cbw
				mov		[CPU_AH], ah
				ret

	align	32
	global	_CWDE
_CWDE:
				CPUCLOCK 2
				mov		ax, [CPU_AX]
				cwde
				mov		[CPU_EAX], eax
				ret

; movs
	align	32
	global	MOVSX_GwEb
MOVSX_GwEb:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		al, 0c0h
				jc		.mem
				CPUCLOCK 5
				shl		eax, 1
				bt		eax, 3
				rcl		eax, 1
				and		eax, 0dh
				movsx	ax, byte [CPU_REG + eax]
				mov		[CPU_REG + ebx * 4], ax
				ret
		.mem:
				CPUCLOCK 2
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_READMAX
				jae		.extmem
				movsx	ax, byte [MAIN_MEM + ecx]
				mov		[CPU_REG + ebx * 4], ax
				ret
		.extmem:
				call	__f_i286_memoryread@4
				cbw
				mov		[CPU_REG + ebx * 4], ax
				ret

	align	32
	global	MOVSX_GdEb
MOVSX_GdEb:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		al, 0c0h
				jc		.mem
				CPUCLOCK 5
				shl		eax, 1
				bt		eax, 3
				rcl		eax, 1
				and		eax, 0dh
				movsx	eax, byte [CPU_REG + eax]
				mov		[CPU_REG + ebx * 4], eax
				ret
		.mem:
				CPUCLOCK 2
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_READMAX
				jae		.extmem
				movsx	eax, byte [MAIN_MEM + ecx]
				mov		[CPU_REG + ebx * 4], eax
				ret
		.extmem:
				call	__f_i286_memoryread@4
				cbw
				cwde
				mov		[CPU_REG + ebx * 4], eax
				ret

	align	32
	global	MOVSX_GdEw
MOVSX_GdEw:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		al, 0c0h
				jc		.mem
				CPUCLOCK 5
				and		eax, 7
				movsx	eax, word [CPU_REG + eax * 4]
				mov		[CPU_REG + ebx * 4], eax
				ret
		.mem:
				CPUCLOCK 2
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_READMAX - 1
				jae		.extmem
				movsx	eax, word [MAIN_MEM + ecx]
				mov		[CPU_REG + ebx * 4], eax
				ret
		.extmem:
				call	__f_i286_memoryread_w@4
				cwde
				mov		[CPU_REG + ebx * 4], eax
				ret

; movz
	align	32
	global	MOVZX_GwEb
MOVZX_GwEb:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		al, 0c0h
				jc		.mem
				CPUCLOCK 5
				shl		eax, 1
				bt		eax, 3
				rcl		eax, 1
				and		eax, 0dh
				movzx	ax, byte [CPU_REG + eax]
				mov		[CPU_REG + ebx * 4], ax
				ret
		.mem:
				CPUCLOCK 2
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_READMAX
				jae		.extmem
				movzx	ax, byte [MAIN_MEM + ecx]
				mov		[CPU_REG + ebx * 4], ax
				ret
		.extmem:
				call	__f_i286_memoryread@4
				xor		ah, ah
				mov		[CPU_REG + ebx * 4], ax
				ret

	align	32
	global	MOVZX_GdEb
MOVZX_GdEb:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		al, 0c0h
				jc		.mem
				CPUCLOCK 5
				shl		eax, 1
				bt		eax, 3
				rcl		eax, 1
				and		eax, 0dh
				movzx	eax, byte [CPU_REG + eax]
				mov		[CPU_REG + ebx * 4], eax
				ret
		.mem:
				CPUCLOCK 2
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_READMAX
				jae		.extmem
				movzx	eax, byte [MAIN_MEM + ecx]
				mov		[CPU_REG + ebx * 4], eax
				ret
		.extmem:
				call	__f_i286_memoryread@4
				and		eax, 0ffh
				mov		[CPU_REG + ebx * 4], eax
				ret

	align	32
	global	MOVZX_GdEw
MOVZX_GdEw:
				GET_PCBYTE
				movzx	ebx, al
				shr		ebx, 3
				and		ebx, 7
				cmp		al, 0c0h
				jc		.mem
				CPUCLOCK 5
				and		eax, 7
				movzx	eax, word [CPU_REG + eax * 4]
				mov		[CPU_REG + ebx * 4], eax
				ret
		.mem:
				CPUCLOCK 2
				rol		al, 2
				and		eax, 1fh
				call	calc_ea_dst
				cmp		ecx, MAINMEM_READMAX - 1
				jae		.extmem
				movzx	eax, word [MAIN_MEM + ecx]
				mov		[CPU_REG + ebx * 4], eax
				ret
		.extmem:
				call	__f_i286_memoryread_w@4
				and		eax, 0ffffh
				mov		[CPU_REG + ebx * 4], eax
				ret

