
; LOGIC INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"
%include "resolve.inc"

extern	_cpu_regs
extern	cpu_inst

section .text

; and
	align	32
	global	AND_EbGb
AND_EbGb:
				PREPART_EA_REG8 2
					and		[CPU_REG + eax], dl
					FLAG_STORE0
					ret
				MEMORY_EA_REG8 7
					and		[MAIN_MEM + ecx], dl
					FLAG_STORE0
					ret
				EXTMEM_EA_REG8
					and		al, [CPU_REG + ebx]
					mov		dl, al
					FLAG_STORE0
					jmp		__f_i286_memorywrite@8

	align	32
	global	AND_EwGw
AND_EwGw:
				PREPART_EA_REG16 2
					and		[CPU_REG + eax * 4], dx
					FLAG_STORE0
					ret
				MEMORY_EA_REG16 7
					and		[MAIN_MEM + ecx], dx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG16
					and		ax, [CPU_REG + ebx * 4]
					mov		dx, ax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	AND_EdGd
AND_EdGd:
				PREPART_EA_REG32 2
					and		[CPU_REG + eax * 4], edx
					FLAG_STORE0
					ret
				MEMORY_EA_REG32 7
					and		[MAIN_MEM + ecx], edx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG32
					and		eax, [CPU_REG + ebx * 4]
					mov		edx, eax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	AND_GbEb
AND_GbEb:
				PREPART_REG8_EA 2, 7
					and		[CPU_REG + ebx], al
					FLAG_STORE0
					ret

	align	32
	global	AND_GwEw
AND_GwEw:
				PREPART_REG16_EA 2, 7
					and		[CPU_REG + ebx * 4], ax
					FLAG_STORE0
					ret

	align	32
	global	AND_GdEd
AND_GdEd:
				PREPART_REG32_EA 2, 7
					and		[CPU_REG + ebx * 4], eax
					FLAG_STORE0
					ret

	align	32
	global	AND_ALIb
AND_ALIb:
				CPUCLOCK 3
				GET_PCBYTE
				and		[CPU_AL], al
				FLAG_STORE0
				ret

	align	32
	global	AND_AXIw
AND_AXIw:
				CPUCLOCK 3
				GET_PCWORD
				and		[CPU_AX], ax
				FLAG_STORE0
				ret

	align	32
	global	AND_EAXId
AND_EAXId:
				CPUCLOCK 3
				GET_PCDWORD
				and		[CPU_EAX], eax
				FLAG_STORE0
				ret

	align	32
	global	AND_EbIb
AND_EbIb:
				PREPART_EA8 3
					mov		ebx, eax
					GET_PCBYTE
					and		[CPU_REG + ebx], al
					FLAG_STORE0
					ret
				MEMORY_EA8 7
					mov		ebx, ecx
					GET_PCBYTE
					and		[MAIN_MEM + ebx], al
					FLAG_STORE0
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		ecx, ebx
					and		dl, al
					FLAG_STORE0
					jmp		__f_i286_memorywrite@8

	align	32
	global	AND_EwIb
AND_EwIb:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					and		[CPU_REG + ebx * 4], ax
					FLAG_STORE0
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					and		[MAIN_MEM + ebx], ax
					FLAG_STORE0
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					mov		ecx, ebx
					and		dx, ax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	AND_EdIb
AND_EdIb:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					cwde
					and		[CPU_REG + ebx * 4], eax
					FLAG_STORE0
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					and		[MAIN_MEM + ebx], eax
					FLAG_STORE0
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					mov		ecx, ebx
					and		edx, eax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	AND_EwIw
AND_EwIw:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCWORD
					and		[CPU_REG + ebx * 4], ax
					FLAG_STORE0
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCWORD
					and		[MAIN_MEM + ebx], ax
					FLAG_STORE0
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCWORD
					mov		ecx, ebx
					and		dx, ax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	AND_EdId
AND_EdId:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCDWORD
					and		[CPU_REG + ebx * 4], eax
					FLAG_STORE0
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCDWORD
					and		[MAIN_MEM + ebx], eax
					FLAG_STORE0
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCDWORD
					mov		ecx, ebx
					and		edx, eax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_d@8

; or
	align	32
	global	OR_EbGb
OR_EbGb:
				PREPART_EA_REG8 2
					or		[CPU_REG + eax], dl
					FLAG_STORE0
					ret
				MEMORY_EA_REG8 7
					or		[MAIN_MEM + ecx], dl
					FLAG_STORE0
					ret
				EXTMEM_EA_REG8
					or		al, [CPU_REG + ebx]
					mov		dl, al
					FLAG_STORE0
					jmp		__f_i286_memorywrite@8

	align	32
	global	OR_EwGw
OR_EwGw:
				PREPART_EA_REG16 2
					or		[CPU_REG + eax * 4], dx
					FLAG_STORE0
					ret
				MEMORY_EA_REG16 7
					or		[MAIN_MEM + ecx], dx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG16
					or		ax, [CPU_REG + ebx * 4]
					mov		dx, ax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	OR_EdGd
OR_EdGd:
				PREPART_EA_REG32 2
					or		[CPU_REG + eax * 4], edx
					FLAG_STORE0
					ret
				MEMORY_EA_REG32 7
					or		[MAIN_MEM + ecx], edx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG32
					or		eax, [CPU_REG + ebx * 4]
					mov		edx, eax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	OR_GbEb
OR_GbEb:
				PREPART_REG8_EA 2, 7
					or		[CPU_REG + ebx], al
					FLAG_STORE0
					ret

	align	32
	global	OR_GwEw
OR_GwEw:
				PREPART_REG16_EA 2, 7
					or		[CPU_REG + ebx * 4], ax
					FLAG_STORE0
					ret

	align	32
	global	OR_GdEd
OR_GdEd:
				PREPART_REG32_EA 2, 7
					or		[CPU_REG + ebx * 4], eax
					FLAG_STORE0
					ret

	align	32
	global	OR_ALIb
OR_ALIb:
				CPUCLOCK 3
				GET_PCBYTE
				or		[CPU_AL], al
				FLAG_STORE0
				ret

	align	32
	global	OR_AXIw
OR_AXIw:
				CPUCLOCK 3
				GET_PCWORD
				or		[CPU_AX], ax
				FLAG_STORE0
				ret

	align	32
	global	OR_EAXId
OR_EAXId:
				CPUCLOCK 3
				GET_PCDWORD
				or		[CPU_EAX], eax
				FLAG_STORE0
				ret

	align	32
	global	OR_EbIb
OR_EbIb:
				PREPART_EA8 3
					mov		ebx, eax
					GET_PCBYTE
					or		[CPU_REG + ebx], al
					FLAG_STORE0
					ret
				MEMORY_EA8 7
					mov		ebx, ecx
					GET_PCBYTE
					or		[MAIN_MEM + ebx], al
					FLAG_STORE0
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		ecx, ebx
					or		dl, al
					FLAG_STORE0
					jmp		__f_i286_memorywrite@8

	align	32
	global	OR_EwIb
OR_EwIb:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					or		[CPU_REG + ebx * 4], ax
					FLAG_STORE0
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					or		[MAIN_MEM + ebx], ax
					FLAG_STORE0
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					mov		ecx, ebx
					or		dx, ax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	OR_EdIb
OR_EdIb:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					cwde
					or		[CPU_REG + ebx * 4], eax
					FLAG_STORE0
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					or		[MAIN_MEM + ebx], eax
					FLAG_STORE0
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					mov		ecx, ebx
					or		edx, eax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	OR_EwIw
OR_EwIw:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCWORD
					or		[CPU_REG + ebx * 4], ax
					FLAG_STORE0
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCWORD
					or		[MAIN_MEM + ebx], ax
					FLAG_STORE0
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCWORD
					mov		ecx, ebx
					or		dx, ax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	OR_EdId
OR_EdId:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCDWORD
					or		[CPU_REG + ebx * 4], eax
					FLAG_STORE0
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCDWORD
					or		[MAIN_MEM + ebx], eax
					FLAG_STORE0
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCDWORD
					mov		ecx, ebx
					or		edx, eax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_d@8

; xor
	align	32
	global	XOR_EbGb
XOR_EbGb:
				PREPART_EA_REG8 2
					xor		[CPU_REG + eax], dl
					FLAG_STORE0
					ret
				MEMORY_EA_REG8 7
					xor		[MAIN_MEM + ecx], dl
					FLAG_STORE0
					ret
				EXTMEM_EA_REG8
					xor		al, [CPU_REG + ebx]
					mov		dl, al
					FLAG_STORE0
					jmp		__f_i286_memorywrite@8

	align	32
	global	XOR_EwGw
XOR_EwGw:
				PREPART_EA_REG16 2
					xor		[CPU_REG + eax * 4], dx
					FLAG_STORE0
					ret
				MEMORY_EA_REG16 7
					xor		[MAIN_MEM + ecx], dx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG16
					xor		ax, [CPU_REG + ebx * 4]
					mov		dx, ax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	XOR_EdGd
XOR_EdGd:
				PREPART_EA_REG32 2
					xor		[CPU_REG + eax * 4], edx
					FLAG_STORE0
					ret
				MEMORY_EA_REG32 7
					xor		[MAIN_MEM + ecx], edx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG32
					xor		eax, [CPU_REG + ebx * 4]
					mov		edx, eax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	XOR_GbEb
XOR_GbEb:
				PREPART_REG8_EA 2, 7
					xor		[CPU_REG + ebx], al
					FLAG_STORE0
					ret

	align	32
	global	XOR_GwEw
XOR_GwEw:
				PREPART_REG16_EA 2, 7
					xor		[CPU_REG + ebx * 4], ax
					FLAG_STORE0
					ret

	align	32
	global	XOR_GdEd
XOR_GdEd:
				PREPART_REG32_EA 2, 7
					xor		[CPU_REG + ebx * 4], eax
					FLAG_STORE0
					ret

	align	32
	global	XOR_ALIb
XOR_ALIb:
				CPUCLOCK 3
				GET_PCBYTE
				xor		[CPU_AL], al
				FLAG_STORE0
				ret

	align	32
	global	XOR_AXIw
XOR_AXIw:
				CPUCLOCK 3
				GET_PCWORD
				xor		[CPU_AX], ax
				FLAG_STORE0
				ret

	align	32
	global	XOR_EAXId
XOR_EAXId:
				CPUCLOCK 3
				GET_PCDWORD
				xor		[CPU_EAX], eax
				FLAG_STORE0
				ret

	align	32
	global	XOR_EbIb
XOR_EbIb:
				PREPART_EA8 3
					mov		ebx, eax
					GET_PCBYTE
					xor		[CPU_REG + ebx], al
					FLAG_STORE0
					ret
				MEMORY_EA8 7
					mov		ebx, ecx
					GET_PCBYTE
					xor		[MAIN_MEM + ebx], al
					FLAG_STORE0
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		ecx, ebx
					xor		dl, al
					FLAG_STORE0
					jmp		__f_i286_memorywrite@8

	align	32
	global	XOR_EwIb
XOR_EwIb:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					xor		[CPU_REG + ebx * 4], ax
					FLAG_STORE0
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					xor		[MAIN_MEM + ebx], ax
					FLAG_STORE0
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					mov		ecx, ebx
					xor		dx, ax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	XOR_EdIb
XOR_EdIb:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					cwde
					xor		[CPU_REG + ebx * 4], eax
					FLAG_STORE0
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					xor		[MAIN_MEM + ebx], eax
					FLAG_STORE0
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					mov		ecx, ebx
					xor		edx, eax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	XOR_EwIw
XOR_EwIw:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCWORD
					xor		[CPU_REG + ebx * 4], ax
					FLAG_STORE0
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCWORD
					xor		[MAIN_MEM + ebx], ax
					FLAG_STORE0
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCWORD
					mov		ecx, ebx
					xor		dx, ax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	XOR_EdId
XOR_EdId:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCDWORD
					xor		[CPU_REG + ebx * 4], eax
					FLAG_STORE0
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCDWORD
					xor		[MAIN_MEM + ebx], eax
					FLAG_STORE0
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCDWORD
					mov		ecx, ebx
					xor		edx, eax
					FLAG_STORE0
					jmp		__f_i286_memorywrite_d@8

; not
	align	32
	global	NOT_Eb
NOT_Eb:
				PREPART_EA8 2
					not		byte [CPU_REG + eax]
					ret
				MEMORY_EA8 7
					not		byte [MAIN_MEM + ecx]
					ret
				EXTMEM_EA8
					mov		dl, al
					not		dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	NOT_Ew
NOT_Ew:
				PREPART_EA16 2
					not		word [CPU_REG + eax * 4]
					ret
				MEMORY_EA16 7
					not		word [MAIN_MEM + ecx]
					ret
				EXTMEM_EA16
					mov		dx, ax
					not		dx
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	NOT_Ed
NOT_Ed:
				PREPART_EA32 2
					not		dword [CPU_REG + eax * 4]
					ret
				MEMORY_EA32 7
					not		dword [MAIN_MEM + ecx]
					ret
				EXTMEM_EA32
					mov		edx, eax
					not		edx
					jmp		__f_i286_memorywrite_d@8

