
; SHIFT AND ROTATE INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"
%include "resolve.inc"

extern	_cpu_regs
extern	cpu_inst

section .text

; sar
	align	32
	global	SAR_Eb
SAR_Eb:
				PREPART_EA8 2
					sar		byte [CPU_REG + eax], 1
					FLAG_STORE_OF
					ret
				MEMORY_EA8 7
					sar		byte [MAIN_MEM + ecx], 1
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					sar		dl, 1
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SAR_Ew
SAR_Ew:
				PREPART_EA16 2
					sar		word [CPU_REG + eax * 4], 1
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					sar		word [MAIN_MEM + ecx], 1
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					sar		dx, 1
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SAR_Ed
SAR_Ed:
				PREPART_EA32 2
					sar		dword [CPU_REG + eax * 4], 1
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					sar		dword [MAIN_MEM + ecx], 1
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					sar		edx, 1
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SAR_EbCL
SAR_EbCL:
				PREPART_EA8 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		byte [CPU_REG + eax], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SAR_EwCL
SAR_EwCL:
				PREPART_EA16 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		word [CPU_REG + eax * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SAR_EdCL
SAR_EdCL:
				PREPART_EA32 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		dword [CPU_REG + eax * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SAR_EbIb
SAR_EbIb:
				PREPART_EA8 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		byte [CPU_REG + ebx], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SAR_EwIb
SAR_EwIb:
				PREPART_EA16 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		word [CPU_REG + ebx * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SAR_EdIb
SAR_EdIb:
				PREPART_EA32 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		dword [CPU_REG + ebx * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					sar		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

; shr
	align	32
	global	SHR_Eb
SHR_Eb:
				PREPART_EA8 2
					shr		byte [CPU_REG + eax], 1
					FLAG_STORE_OF
					ret
				MEMORY_EA8 7
					shr		byte [MAIN_MEM + ecx], 1
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					shr		dl, 1
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SHR_Ew
SHR_Ew:
				PREPART_EA16 2
					shr		word [CPU_REG + eax * 4], 1
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					shr		word [MAIN_MEM + ecx], 1
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					shr		dx, 1
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHR_Ed
SHR_Ed:
				PREPART_EA32 2
					shr		dword [CPU_REG + eax * 4], 1
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					shr		dword [MAIN_MEM + ecx], 1
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					shr		edx, 1
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SHR_EbCL
SHR_EbCL:
				PREPART_EA8 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		byte [CPU_REG + eax], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SHR_EwCL
SHR_EwCL:
				PREPART_EA16 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		word [CPU_REG + eax * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHR_EdCL
SHR_EdCL:
				PREPART_EA32 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		dword [CPU_REG + eax * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SHR_EbIb
SHR_EbIb:
				PREPART_EA8 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		byte [CPU_REG + ebx], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SHR_EwIb
SHR_EwIb:
				PREPART_EA16 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		word [CPU_REG + ebx * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHR_EdIb
SHR_EdIb:
				PREPART_EA32 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		dword [CPU_REG + ebx * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shr		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

; shl
	align	32
	global	SHL_Eb
SHL_Eb:
				PREPART_EA8 2
					shl		byte [CPU_REG + eax], 1
					FLAG_STORE_OF
					ret
				MEMORY_EA8 7
					shl		byte [MAIN_MEM + ecx], 1
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					shl		dl, 1
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SHL_Ew
SHL_Ew:
				PREPART_EA16 2
					shl		word [CPU_REG + eax * 4], 1
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					shl		word [MAIN_MEM + ecx], 1
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					shl		dx, 1
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHL_Ed
SHL_Ed:
				PREPART_EA32 2
					shl		dword [CPU_REG + eax * 4], 1
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					shl		dword [MAIN_MEM + ecx], 1
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					shl		edx, 1
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SHL_EbCL
SHL_EbCL:
				PREPART_EA8 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		byte [CPU_REG + eax], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SHL_EwCL
SHL_EwCL:
				PREPART_EA16 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		word [CPU_REG + eax * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHL_EdCL
SHL_EdCL:
				PREPART_EA32 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		dword [CPU_REG + eax * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SHL_EbIb
SHL_EbIb:
				PREPART_EA8 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		byte [CPU_REG + ebx], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SHL_EwIb
SHL_EwIb:
				PREPART_EA16 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		word [CPU_REG + ebx * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHL_EdIb
SHL_EdIb:
				PREPART_EA32 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		dword [CPU_REG + ebx * 4], cl
					FLAG_STORE_OF
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					shl		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

; shrd
	align	32
	global	SHRD_EwGwIb
SHRD_EwGwIb:
				PREPART_EA_REG16 2
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					shrd	[CPU_REG + ebx * 4], dx, cl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 7
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					shrd	[MAIN_MEM + ebx], dx, cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					push	ecx
					mov		dx, ax
					GET_PCBYTE
					mov		cl, al
					mov		ax, [CPU_REG + ebx * 4]
					shrd	dx, ax, cl
					FLAG_STORE_OF
					pop		ecx
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHRD_EdGdIb
SHRD_EdGdIb:
				PREPART_EA_REG32 2
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					shrd	[CPU_REG + ebx * 4], edx, cl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 7
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					shrd	[MAIN_MEM + ebx], edx, cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					push	ecx
					mov		edx, eax
					GET_PCBYTE
					mov		cl, al
					mov		eax, [CPU_REG + ebx * 4]
					shrd	edx, eax, cl
					FLAG_STORE_OF
					pop		ecx
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SHRD_EwGwCL
SHRD_EwGwCL:
				PREPART_EA_REG16 2
					mov		cl, [CPU_CL]
					shrd	[CPU_REG + eax * 4], dx, cl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 7
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					shrd	[MAIN_MEM + ebx], dx, cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					push	ecx
					mov		dx, ax
					mov		cl, [CPU_CL]
					mov		ax, [CPU_REG + ebx * 4]
					shrd	dx, ax, cl
					FLAG_STORE_OF
					pop		ecx
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHRD_EdGdCL
SHRD_EdGdCL:
				PREPART_EA_REG32 2
					mov		cl, [CPU_CL]
					shrd	[CPU_REG + eax * 4], edx, cl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 7
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					shrd	[MAIN_MEM + ebx], edx, cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					push	ecx
					mov		edx, eax
					mov		cl, [CPU_CL]
					mov		eax, [CPU_REG + ebx * 4]
					shrd	edx, eax, cl
					FLAG_STORE_OF
					pop		ecx
					jmp		__f_i286_memorywrite_d@8

; shld
	align	32
	global	SHLD_EwGwIb
SHLD_EwGwIb:
				PREPART_EA_REG16 2
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					shld	[CPU_REG + ebx * 4], dx, cl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 7
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					shld	[MAIN_MEM + ebx], dx, cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					push	ecx
					mov		dx, ax
					GET_PCBYTE
					mov		cl, al
					mov		ax, [CPU_REG + ebx * 4]
					shld	dx, ax, cl
					FLAG_STORE_OF
					pop		ecx
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHLD_EdGdIb
SHLD_EdGdIb:
				PREPART_EA_REG32 2
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					shld	[CPU_REG + ebx * 4], edx, cl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 7
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					shld	[MAIN_MEM + ebx], edx, cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					push	ecx
					mov		edx, eax
					GET_PCBYTE
					mov		cl, al
					mov		eax, [CPU_REG + ebx * 4]
					shld	edx, eax, cl
					FLAG_STORE_OF
					pop		ecx
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SHLD_EwGwCL
SHLD_EwGwCL:
				PREPART_EA_REG16 2
					mov		cl, [CPU_CL]
					shld	[CPU_REG + eax * 4], dx, cl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 7
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					shld	[MAIN_MEM + ebx], dx, cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					push	ecx
					mov		dx, ax
					mov		cl, [CPU_CL]
					mov		ax, [CPU_REG + ebx * 4]
					shld	dx, ax, cl
					FLAG_STORE_OF
					pop		ecx
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SHLD_EdGdCL
SHLD_EdGdCL:
				PREPART_EA_REG32 2
					mov		cl, [CPU_CL]
					shld	[CPU_REG + eax * 4], edx, cl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 7
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					shld	[MAIN_MEM + ebx], edx, cl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					push	ecx
					mov		edx, eax
					mov		cl, [CPU_CL]
					mov		eax, [CPU_REG + ebx * 4]
					shld	edx, eax, cl
					FLAG_STORE_OF
					pop		ecx
					jmp		__f_i286_memorywrite_d@8

; ror
	align	32
	global	ROR_Eb
ROR_Eb:
				PREPART_EA8 2
					ror		byte [CPU_REG + eax], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA8 7
					ror		byte [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					ror		dl, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	ROR_Ew
ROR_Ew:
				PREPART_EA16 2
					ror		word [CPU_REG + eax * 4], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA16 7
					ror		word [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					ror		dx, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ROR_Ed
ROR_Ed:
				PREPART_EA32 2
					ror		dword [CPU_REG + eax * 4], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA32 7
					ror		dword [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					ror		edx, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	ROR_EbCL
ROR_EbCL:
				PREPART_EA8 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		byte [CPU_REG + eax], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	ROR_EwCL
ROR_EwCL:
				PREPART_EA16 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		word [CPU_REG + eax * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ROR_EdCL
ROR_EdCL:
				PREPART_EA32 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		dword [CPU_REG + eax * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	ROR_EbIb
ROR_EbIb:
				PREPART_EA8 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		byte [CPU_REG + ebx], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	ROR_EwIb
ROR_EwIb:
				PREPART_EA16 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		word [CPU_REG + ebx * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ROR_EdIb
ROR_EdIb:
				PREPART_EA32 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		dword [CPU_REG + ebx * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					ror		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

; rol
	align	32
	global	ROL_Eb
ROL_Eb:
				PREPART_EA8 2
					rol		byte [CPU_REG + eax], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA8 7
					rol		byte [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					rol		dl, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	ROL_Ew
ROL_Ew:
				PREPART_EA16 2
					rol		word [CPU_REG + eax * 4], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA16 7
					rol		word [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					rol		dx, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ROL_Ed
ROL_Ed:
				PREPART_EA32 2
					rol		dword [CPU_REG + eax * 4], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA32 7
					rol		dword [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					rol		edx, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	ROL_EbCL
ROL_EbCL:
				PREPART_EA8 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		byte [CPU_REG + eax], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	ROL_EwCL
ROL_EwCL:
				PREPART_EA16 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		word [CPU_REG + eax * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ROL_EdCL
ROL_EdCL:
				PREPART_EA32 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		dword [CPU_REG + eax * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	ROL_EbIb
ROL_EbIb:
				PREPART_EA8 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		byte [CPU_REG + ebx], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	ROL_EwIb
ROL_EwIb:
				PREPART_EA16 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		word [CPU_REG + ebx * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ROL_EdIb
ROL_EdIb:
				PREPART_EA32 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		dword [CPU_REG + ebx * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					rol		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

; rcr
	align	32
	global	RCR_Eb
RCR_Eb:
				PREPART_EA8 2
					CFLAG_LOAD
					rcr		byte [CPU_REG + eax], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA8 7
					CFLAG_LOAD
					rcr		byte [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					CFLAG_LOAD
					rcr		dl, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	RCR_Ew
RCR_Ew:
				PREPART_EA16 2
					CFLAG_LOAD
					rcr		word [CPU_REG + eax * 4], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA16 7
					CFLAG_LOAD
					rcr		word [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					CFLAG_LOAD
					rcr		dx, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	RCR_Ed
RCR_Ed:
				PREPART_EA32 2
					CFLAG_LOAD
					rcr		dword [CPU_REG + eax * 4], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA32 7
					CFLAG_LOAD
					rcr		dword [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					CFLAG_LOAD
					rcr		edx, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	RCR_EbCL
RCR_EbCL:
				PREPART_EA8 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		byte [CPU_REG + eax], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	RCR_EwCL
RCR_EwCL:
				PREPART_EA16 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		word [CPU_REG + eax * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	RCR_EdCL
RCR_EdCL:
				PREPART_EA32 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		dword [CPU_REG + eax * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	RCR_EbIb
RCR_EbIb:
				PREPART_EA8 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		byte [CPU_REG + ebx], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	RCR_EwIb
RCR_EwIb:
				PREPART_EA16 2
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		word [CPU_REG + ebx * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	RCR_EdIb
RCR_EdIb:
				PREPART_EA32 2
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		dword [CPU_REG + ebx * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcr		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

; rcl
	align	32
	global	RCL_Eb
RCL_Eb:
				PREPART_EA8 2
					CFLAG_LOAD
					rcl		byte [CPU_REG + eax], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA8 7
					CFLAG_LOAD
					rcl		byte [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					CFLAG_LOAD
					rcl		dl, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	RCL_Ew
RCL_Ew:
				PREPART_EA16 2
					CFLAG_LOAD
					rcl		word [CPU_REG + eax * 4], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA16 7
					CFLAG_LOAD
					rcl		word [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					CFLAG_LOAD
					rcl		dx, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	RCL_Ed
RCL_Ed:
				PREPART_EA32 2
					CFLAG_LOAD
					rcl		dword [CPU_REG + eax * 4], 1
					FLAG_STORE_OC
					ret
				MEMORY_EA32 7
					CFLAG_LOAD
					rcl		dword [MAIN_MEM + ecx], 1
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					CFLAG_LOAD
					rcl		edx, 1
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	RCL_EbCL
RCL_EbCL:
				PREPART_EA8 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		byte [CPU_REG + eax], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	RCL_EwCL
RCL_EwCL:
				PREPART_EA16 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		word [CPU_REG + eax * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA16 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	RCL_EdCL
RCL_EdCL:
				PREPART_EA32 5
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		dword [CPU_REG + eax * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA32 8
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					mov		cl, [CPU_CL]
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	RCL_EbIb
RCL_EbIb:
				PREPART_EA8 5
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		byte [CPU_REG + ebx], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA8 8
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		byte [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		dl, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite@8

	align	32
	global	RCL_EwIb
RCL_EwIb:
				PREPART_EA16 2
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		word [CPU_REG + ebx * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		word [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		dx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	RCL_EdIb
RCL_EdIb:
				PREPART_EA32 2
					mov		ebx, eax
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		dword [CPU_REG + ebx * 4], cl
					FLAG_STORE_OC
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		dword [MAIN_MEM + ebx], cl
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					mov		cl, al
					and		ecx, 1fh
					CPUCLOCK ecx
					CFLAG_LOAD
					rcl		edx, cl
					mov		ecx, ebx
					FLAG_STORE_OC
					jmp		__f_i286_memorywrite_d@8

