
; SYSTEM INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"
%include "resolve.inc"
%include "debug.inc"

extern	_cpu_regs
extern	_cpu_sysregs
extern	_cpu_stat

section .text

; load gdtr
	align	32
	global	LGDT16_Ms
LGDT16_Ms:
				cmp		al, 0c0h
				jnc		.reg
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_GDTR_LIMIT], ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				and		eax, 00ffffffh
				mov		[CPU_GDTR_BASE], eax
				ret

		.reg:	INT_NUM 6

	align	32
	global	LGDT32_Ms
LGDT32_Ms:
				cmp		al, 0c0h
				jnc		.reg
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_GDTR_LIMIT], ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_GDTR_BASE], eax
				ret

		.reg:	INT_NUM 6

;
	align	32
	global	SGDT16_Ms
SGDT16_Ms:
				cmp		al, 0c0h
				jnc		.reg
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_GDTR_LIMIT]
				call	__f_i286_memorywrite_w@8
				add		bx, 2
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_GDTR_BASE]
				and		edx, 00ffffffh
				jmp		__f_i286_memorywrite_d@8

		.reg:	INT_NUM 6

	align	32
	global	SGDT32_Ms
SGDT32_Ms:
				cmp		al, 0c0h
				jnc		.reg
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_GDTR_LIMIT]
				call	__f_i286_memorywrite_w@8
				add		bx, 2
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_GDTR_BASE]
				jmp		__f_i286_memorywrite_d@8

		.reg:	INT_NUM 6

	align	32
	global	LLDT_Ew
LLDT_Ew:
				; in real mode
				jmp		undef_op

	align	32
	global	SLDT_Ew
SLDT_Ew:
				; in real mode
				jmp		undef_op

	align	32
	global	LTR_Ew
LTR_Ew:
				; in real mode
				jmp		undef_op

	align	32
	global	STR_Ew
STR_Ew:
				; in real mode
				jmp		undef_op

; load idtr
	align	32
	global	LIDT16_Ms
LIDT16_Ms:
				cmp		al, 0c0h
				jnc		.reg
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_IDTR_LIMIT], ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				and		eax, 00ffffffh
				mov		[CPU_IDTR_BASE], eax
				ret

		.reg:	INT_NUM 6

	align	32
	global	LIDT32_Ms
LIDT32_Ms:
				cmp		al, 0c0h
				jnc		.reg
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_IDTR_LIMIT], ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				mov		[CPU_IDTR_BASE], eax
				ret

		.reg:	INT_NUM 6

;
	align	32
	global	SIDT16_Ms
SIDT16_Ms:
				cmp		al, 0c0h
				jnc		.reg
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_IDTR_LIMIT]
				call	__f_i286_memorywrite_w@8
				add		bx, 2
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_IDTR_BASE]
				and		edx, 00ffffffh
				jmp		__f_i286_memorywrite_d@8

		.reg:	INT_NUM 6

	align	32
	global	SIDT32_Ms
SIDT32_Ms:
				cmp		al, 0c0h
				jnc		.reg
				CPUCLOCK 11
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_IDTR_LIMIT]
				call	__f_i286_memorywrite_w@8
				add		bx, 2
				lea		ecx, [edi + ebx]
				mov		edx, [CPU_IDTR_BASE]
				jmp		__f_i286_memorywrite_d@8

		.reg:	INT_NUM 6

; ctrl reg
	align	32
	global	MOV_CdRd
MOV_CdRd:
				GET_PCBYTE
				CPUCLOCK 11
				mov		bl, al
				and		eax, 7
				cmp		eax, 1
				je		.err
				cmp		eax, 4
				jg		.err
				shr		ebx, 3
				and		ebx, 7
				mov		edx, [CPU_REG + ebx * 4]
				mov		[CPU_CTRLREG + eax * 4], edx
				test	byte [CPU_CR0], CR0_PE
				jnz		.pm
				ret

		.pm:	jmp		__f_change_pm@0
		.err:	INT_NUM 6

	align	32
	global	MOV_RdCd
MOV_RdCd:
				GET_PCBYTE
				CPUCLOCK 11
				mov		bl, al
				shr		eax, 3
				and		eax, 7
				cmp		eax, 1
				je		.err
				cmp		eax, 4
				jg		.err
				and		ebx, 7
				mov		edx, [CPU_CTRLREG + eax * 4]
				mov		[CPU_REG + ebx * 4], edx
				ret

		.err:	INT_NUM 6

; load msw
	align	32
	global	LMSW_Ew
LMSW_Ew:
				PREPART_EA16 2
					mov		ax, [CPU_REG + eax * 4]
					jmp		short .set_msw
				MEMORY_EA16 3
					mov		ax, [MAIN_MEM + ecx]
					jmp		short .set_msw
				EXTMEM_EA16
			.set_msw:
					and		ax, 0fh
					and		word [CPU_CR0], ~ 0fh
					or		[CPU_CR0], ax
					test	ax, CR0_PE
					jnz		.pm
					ret

			.pm:	jmp		__f_change_pm@0

; store msw
	align	32
	global	SMSW_Ew
SMSW_Ew:
				PREPART_EA16 3
					mov		dx, [CPU_CR0]
					mov		[CPU_REG + eax * 4], dx
					ret
				MEMORY_EA16 6
					mov		ax, [CPU_CR0]
					mov		[MAIN_MEM + ecx], ax
					ret
				.extmem_eareg16:
					mov		dx, [CPU_CR0]
					jmp		__f_i286_memorywrite_w@8

;
	align	32
	global	_CLTS
_CLTS:
				and		byte [CPU_CR0], ~ CR0_TS
				ret

	align	32
	global	ARPL_EwGw
ARPL_EwGw:
				; in real mode
				jmp		undef_op

; dpl
	align	32
	global	LAR_GwEw
LAR_GwEw:
				; in real mode
				jmp		undef_op

	align	32
	global	LAR_GdEd
LAR_GdEd:
				; in real mode
				jmp		undef_op

	align	32
	global	LSL_GwEw
LSL_GwEw:
				; in real mode
				jmp		undef_op

	align	32
	global	LSL_GdEd
LSL_GdEd:
				; in real mode
				jmp		undef_op

;
	align	32
	global	VERR_Ew
VERR_Ew:
				; in real mode
				jmp		undef_op

	align	32
	global	VERW_Ew
VERW_Ew:
				; in real mode
				jmp		undef_op

; dbg reg
	align	32
	global	MOV_DdRd
MOV_DdRd:
				; unimplemented
				jmp		undef_op

	align	32
	global	MOV_RdDd
MOV_RdDd:
				; unimplemented
				jmp		undef_op

; cache
	align	32
	global	_INVD
_INVD:
				; do nothing
				ret

	align	32
	global	_WBINVD
_WBINVD:
				; do nothing
				ret

;
	align	32
	global	_INVLPG
_INVLPG:
				cmp		al, 0c0h
				jnc		.reg
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				; do nothing
				ret

		.reg:	INT_NUM 6

;
	align	32
	global	_LOCK
_LOCK:
				; do nothing
				ret

	align	32
	global	_HLT
_HLT:
				mov		dword [_nevent + NEVENT_TABLE.remainclock], -1
				dec		si
				ret

; ctrl reg
	align	32
	global	_RSM
_RSM:
				; unimplemented
				jmp		undef_op

; msr
	align	32
	global	_RDMSR
_RDMSR:
				; unimplemented
				jmp		undef_op

	align	32
	global	_WRMSR
_WRMSR:
				; unimplemented
				jmp		undef_op

; ctrl reg
	align	32
	global	_RDTSC
_RDTSC:
				; unimplemented
				jmp		undef_op

; test reg
	align	32
	global	MOV_TdRd
MOV_TdRd:
				; unimplemented
				jmp		undef_op

	align	32
	global	MOV_RdTd
MOV_RdTd:
				; unimplemented
				jmp		undef_op

