
%include "cpu.inc"
%include "cpu.mcr"

section	.text

	align	32
_nop:
				ret

; mod: 00
	align	32
bx_si:
				movzx	ebx, word [CPU_BX]
				add		bx, [CPU_SI]
				GET_PREFIX_DS

	align	32
bx_di:
				movzx	ebx, word [CPU_BX]
				add		bx, [CPU_DI]
				GET_PREFIX_DS

	align	32
bp_si:
				movzx	ebx, word [CPU_BP]
				add		bx, [CPU_SI]
				GET_PREFIX_SS

	align	32
bp_di:
				movzx	ebx, word [CPU_BP]
				add		bx, [CPU_DI]
				GET_PREFIX_SS

	align	32
_si:
				movzx	ebx, word [CPU_SI]
				GET_PREFIX_DS

	align	32
_di:
				movzx	ebx, word [CPU_DI]
				GET_PREFIX_DS

	align	32
disp16:
				GET_PCWORD
				movzx	ebx, ax
				GET_PREFIX_DS

	align	32
_bx:
				movzx	ebx, word [CPU_BX]
				GET_PREFIX_DS

; mod: 01
	align	32
bx_si_disp8:
				GET_PCBYTE
				cbw
				movzx	ebx, word [CPU_BX]
				add		bx, ax
				add		bx, [CPU_SI]
				GET_PREFIX_DS

	align	32
bx_di_disp8:
				GET_PCBYTE
				cbw
				movzx	ebx, word [CPU_BX]
				add		bx, ax
				add		bx, [CPU_DI]
				GET_PREFIX_DS

	align	32
bp_si_disp8:
				GET_PCBYTE
				cbw
				movzx	ebx, word [CPU_BP]
				add		bx, ax
				add		bx, [CPU_SI]
				GET_PREFIX_SS

	align	32
bp_di_disp8:
				GET_PCBYTE
				cbw
				movzx	ebx, word [CPU_BP]
				add		bx, ax
				add		bx, [CPU_DI]
				GET_PREFIX_SS

	align	32
si_disp8:
				GET_PCBYTE
				cbw
				movzx	ebx, word [CPU_SI]
				add		bx, ax
				GET_PREFIX_DS

	align	32
di_disp8:
				GET_PCBYTE
				cbw
				movzx	ebx, word [CPU_DI]
				add		bx, ax
				GET_PREFIX_DS

	align	32
bp_disp8:
				GET_PCBYTE
				cbw
				movzx	ebx, word [CPU_BP]
				add		bx, ax
				GET_PREFIX_SS

	align	32
bx_disp8:
				GET_PCBYTE
				cbw
				movzx	ebx, word [CPU_BX]
				add		bx, ax
				GET_PREFIX_DS

; mod: 10
	align	32
bx_si_disp16:
				GET_PCWORD
				movzx	ebx, word [CPU_BX]
				add		bx, ax
				add		bx, [CPU_SI]
				GET_PREFIX_DS

	align	32
bx_di_disp16:
				GET_PCWORD
				movzx	ebx, word [CPU_BX]
				add		bx, ax
				add		bx, [CPU_DI]
				GET_PREFIX_DS

	align	32
bp_si_disp16:
				GET_PCWORD
				movzx	ebx, word [CPU_BP]
				add		bx, ax
				add		bx, [CPU_SI]
				GET_PREFIX_SS

	align	32
bp_di_disp16:
				GET_PCWORD
				movzx	ebx, word [CPU_BP]
				add		bx, ax
				add		bx, [CPU_DI]
				GET_PREFIX_SS

	align	32
si_disp16:
				GET_PCWORD
				movzx	ebx, word [CPU_SI]
				add		bx, ax
				GET_PREFIX_DS

	align	32
di_disp16:
				GET_PCWORD
				movzx	ebx, word [CPU_DI]
				add		bx, ax
				GET_PREFIX_DS

	align	32
bp_disp16:
				GET_PCWORD
				movzx	ebx, word [CPU_BP]
				add		bx, ax
				GET_PREFIX_SS

	align	32
bx_disp16:
				GET_PCWORD
				movzx	ebx, word [CPU_BX]
				add		bx, ax
				GET_PREFIX_DS

section .data

	align	32, db 0
	global	resolve_table16
resolve_table16:
		dd		bx_si,	bx_si_disp8,	bx_si_disp16,	_nop
		dd		bx_di,	bx_di_disp8,	bx_di_disp16,	_nop
		dd		bp_si,	bp_si_disp8,	bp_si_disp16,	_nop
		dd		bp_di,	bp_di_disp8,	bp_di_disp16,	_nop
		dd		_si,	si_disp8,		si_disp16,		_nop
		dd		_di,	di_disp8,		di_disp16,		_nop
		dd		disp16,	bp_disp8,		bp_disp16,		_nop
		dd		_bx,	bx_disp8,		bx_disp16,		_nop

