
%macro CPUCLOCK 1
				sub		dword [_nevent + NEVENT_TABLE.remainclock], %1
%endmacro
%macro CPUCLOCKDEC 0
				dec		dword [_nevent + NEVENT_TABLE.remainclock]
%endmacro

%macro FLAG_LOAD 0
				mov		ah, [CPU_FLAGL]
				sahf
%endmacro

%macro CFLAG_LOAD 0
				bt		word [CPU_FLAG], 0
%endmacro

%macro FLAG_STORE 0
				lahf
				mov		[CPU_FLAGL], ah
%endmacro

%macro FLAG_STORE0 0
				lahf
				mov		[CPU_FLAGL], ah
				and		word [CPU_FLAG], ~ O_FLAG
%endmacro

%macro FLAG_STORE_OF 0
				lahf
				mov		[CPU_FLAGL], ah
				seto	ah
				shl		ah, 3
				and		word [CPU_FLAG], ~ O_FLAG
				or		[CPU_FLAGH], ah
%endmacro

%macro FLAG_STORE_NC 0
				clc
				lahf
				seto	bl
				shl		bl, 3
				and		word [CPU_FLAG], 0f701h
				or		[CPU_FLAGL], ah
				or		[CPU_FLAGH], bl
%endmacro

%macro FLAG_STORE_OC 0
				seto	bh
				setc	bl
				shl		bh, 3
				and		word [CPU_FLAG], ~ (O_FLAG | C_FLAG)
				or		[CPU_FLAG], bx
%endmacro

%macro FLAG_STORE_C 0
				setc	bl
				and		byte [CPU_FLAGL], ~ C_FLAG
				or		[CPU_FLAGL], bl
%endmacro

%macro FLAG_STORE_Z 0
				setz	bl
				shl		bl, 6
				and		byte [CPU_FLAGL], ~ Z_FLAG
				or		[CPU_FLAGL], bl
%endmacro

%macro FLAG_STORE_ZPC 0
				lahf
				and		word [CPU_FLAG], ~ (Z_FLAG | P_FLAG | C_FLAG)
				or		[CPU_FLAGL], ah
%endmacro

%macro GET_PCBYTE 0
				lea		ecx, [ebp + esi]
				inc		si
				call	__f_i286_memoryread@4
%endmacro

%macro GET_PCWORD 0
				lea		ecx, [ebp + esi]
				add		si, 2
				call	__f_i286_memoryread_w@4
%endmacro

%macro GET_PCDWORD 0
				lea		ecx, [ebp + esi]
				add		si, 4
				call	__f_i286_memoryread_d@4
%endmacro

%macro REGPUSH1 1
				mov		dx, %1
				sub		word [CPU_SP], 2
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				jmp		__f_i286_memorywrite_w@8
%endmacro

%macro REGPUSH32 1
				mov		edx, %1
				sub		word [CPU_SP], 4
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				jmp		__f_i286_memorywrite_d@8
%endmacro

%macro REGPUSH32_1 1
				movzx	edx, word %1
				sub		word [CPU_SP], 4
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				jmp		__f_i286_memorywrite_d@8
%endmacro

%macro REGPOP 1
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_w@4
				mov		%1, ax
				add		word [CPU_SP], 2
%endmacro

%macro REGPOP32 1
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_d@4
				mov		%1, eax
				add		word [CPU_SP], 4
%endmacro

%macro REGPOP32_1 1
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_d@4
				mov		%1, ax
				add		word [CPU_SP], 4
%endmacro

%macro INT_NUM 1
				mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_FLAG]
				and		word [CPU_FLAG], ~ (T_FLAG | I_FLAG)
				mov		byte [CPU_TRAP], 0
				call	__f_i286_memorywrite_w@8
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_CS]
				call	__f_i286_memorywrite_w@8
				sub		bx, 2
				mov		[CPU_SP], bx
				lea		ecx, [edi + ebx]
				mov		dx, si
				mov		eax, [MAIN_MEM + %1 * 4]
				mov		si, ax
				shr		eax, 16
				mov		[CPU_CS], ax
				shl		eax, 4
				mov		[CS_BASE], eax
				mov		ebp, eax
				sub		dword [_nevent + NEVENT_TABLE.remainclock], 20
				jmp		__f_i286_memorywrite_w@8
%endmacro

%macro STRING_DIR 0
				xor		eax, eax
				test	word [CPU_FLAG], D_FLAG
				setz	al
				add		al, al
				dec		eax
%endmacro

%macro STRING_DIRx2 0
				xor		eax, eax
				test	word [CPU_FLAG], D_FLAG
				setz	al
				shl		al, 2
				sub		eax, 2
%endmacro

%macro STRING_DIRx4 0
				xor		eax, eax
				test	word [CPU_FLAG], D_FLAG
				setz	al
				shl		al, 3
				sub		eax, 4
%endmacro

%macro IRQCHECKTERM 0
				xor		eax, eax
				cmp		[_nevent + NEVENT_TABLE.remainclock], eax
				jle		%%nonremainclr
				xchg	[_nevent + NEVENT_TABLE.remainclock], eax
				sub		[_nevent + NEVENT_TABLE.baseclock], eax
		%%nonremainclr:
				ret
%endmacro

