/*	$Id: cpu_io.c,v 1.1 2003/07/22 15:09:43 nonaka Exp $	*/

/*
 * Copyright (c) 2003 NONAKA Kimihiro
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "cpu.h"


BYTE
cpu_in(WORD port)
{
	BYTE data;

	if (!CPU_INST_PM) {
		data = i286_in(port);
	} else {
		assert(0);
		data = 0xff;
	}
	return data;
}

WORD
cpu_in_w(WORD port)
{
	WORD data;

	if (!CPU_INST_PM) {
		data = i286_in_w(port);
	} else {
		assert(0);
		data = 0xffff;
	}
	return data;
}

DWORD
cpu_in_d(WORD port)
{
	DWORD data;

	if (!CPU_INST_PM) {
		data = i286_in_d(port);
	} else {
		assert(0);
		data = 0xffffffff;
	}
	return data;
}

void
cpu_out(WORD port, BYTE data)
{

	if (!CPU_INST_PM) {
		i286_out(port, data);
	} else {
		assert(0);
	}
}

void
cpu_out_w(WORD port, WORD data)
{

	if (!CPU_INST_PM) {
		i286_out_w(port, data);
	} else {
		assert(0);
	}
}

void
cpu_out_d(WORD port, DWORD data)
{

	if (!CPU_INST_PM) {
		i286_out_d(port, data);
	} else {
		assert(0);
	}
}
