#ifdef NP2_MEMORY_ASM					// ֥Ǥ ɬfastcall
#undef	MEM_CALL
#define	MEM_CALL	FASTCALL
#endif


#ifdef __cplusplus
extern "C" {
#endif

extern	BYTE	mem[0x200000];


// 000000-0fffff ᥤ
// 100000-10ffef HMA
// 110000-193fff FONT-ROM/RAM
// 1a8000-1e7fff VRAM1
// 1f8000-1fffff ITF-ROM

#define	VRAM_STEP	0x100000
#define	VRAM_B		0x0a8000
#define	VRAM_R		0x0b0000
#define	VRAM_G		0x0b8000
#define	VRAM_E		0x0e0000

#define	VRAM_POS(a)	(a & (VRAM_STEP | 0x7fff))

#define	VRAM0_B		VRAM_B
#define	VRAM0_R		VRAM_R
#define	VRAM0_G		VRAM_G
#define	VRAM0_E		VRAM_E
#define	VRAM1_B		(VRAM_STEP + VRAM_B)
#define	VRAM1_R		(VRAM_STEP + VRAM_R)
#define	VRAM1_G		(VRAM_STEP + VRAM_G)
#define	VRAM1_E		(VRAM_STEP + VRAM_E)

#define	FONT_ADRS	0x110000
#define	ITF_ADRS	0x1f8000

#if defined(CPU386)
#if 0
#define	LOWMEM		0x100000
#else
#define	LOWMEM		0x10fff0
#endif
#endif	/* CPU386 */


#ifdef NP2_LITTLEENDIAN
#define	MEM_SETB(pos, data)		mem[pos] = data
#define	MEM_ANDB(pos, data)		mem[pos] &= data
#define	MEM_XORB(pos, data)		mem[pos] ^= data
#define	MEM_ORB(pos, data)		mem[pos] |= data
#define	MEM_SETW(pos, data)		*(WORD *)(mem + (pos)) = (data)
#define	MEM_SETD(pos, data)		*(DWORD *)(mem + (pos)) = (data)
#define	MEM_GETB(pos)			(mem[pos])
#define	MEM_GETW(pos)			(*(WORD *)(mem + (pos)))
#define	MEM_GETD(pos)			(*(DWORD *)(mem + (pos)))
#endif


#ifdef NP2_BIGENDIAN
#define	MEM_SETB(pos, data)		mem[pos] = data
#define	MEM_ANDB(pos, data)		mem[pos] &= data
#define	MEM_XORB(pos, data)		mem[pos] ^= data
#define	MEM_ORB(pos, data)		mem[pos] |= data
#define	MEM_SETW(pos, data)												\
			mem[(pos)] = (BYTE)data;									\
			mem[(pos) + 1] = (BYTE)(data >> 8);
#define	MEM_SETD(pos, data)												\
			mem[(pos)] = (BYTE)data;									\
			mem[(pos) + 1] = (BYTE)(data >> 8);							\
			mem[(pos) + 2] = (BYTE)(data >> 16);						\
			mem[(pos) + 3] = (BYTE)(data >> 24);
#define	MEM_GETB(pos)			(mem[pos])
#define	MEM_GETW(pos)													\
			(((WORD)mem[(pos) + 1] << 8) | mem[(pos)])
#define	MEM_GETD(pos)													\
			(((DWORD)mem[(pos) + 3] << 24) |							\
			 ((DWORD)mem[(pos) + 2] << 16) |							\
			  ((WORD)mem[(pos) + 1] <<  8) | mem[(pos)])
#endif


void MEM_CALL i286_vram_dispatch(DWORD operate);

void MEM_CALL __i286_memorywrite(DWORD address, BYTE value);
void MEM_CALL __i286_memorywrite_w(DWORD address, WORD value);
void MEM_CALL __i286_memorywrite_d(DWORD address, DWORD value);
BYTE MEM_CALL __i286_memoryread(DWORD address);
WORD MEM_CALL __i286_memoryread_w(DWORD address);
DWORD MEM_CALL __i286_memoryread_d(DWORD address);

#ifndef CPU386
#define	i286_memorywrite(a,v)	__i286_memorywrite(a,v)
#define	i286_memorywrite_w(a,v)	__i286_memorywrite_w(a,v)
#define	i286_memorywrite_d(a,v)	__i286_memorywrite_d(a,v)
#define	i286_memoryread(a)		__i286_memoryread(a)
#define	i286_memoryread_w(a)	__i286_memoryread_w(a)
#define	i286_memoryread_d(a)	__i286_memoryread_d(a)
#else	/* CPU386 */
void MEM_CALL cpu_memorywrite(DWORD address, BYTE value);
void MEM_CALL cpu_memorywrite_w(DWORD address, WORD value);
void MEM_CALL cpu_memorywrite_d(DWORD address, DWORD value);
BYTE MEM_CALL cpu_memoryread(DWORD address);
WORD MEM_CALL cpu_memoryread_w(DWORD address);
DWORD MEM_CALL cpu_memoryread_d(DWORD address);
#define	i286_memorywrite(a,v)	cpu_memorywrite(a,v)
#define	i286_memorywrite_w(a,v)	cpu_memorywrite_w(a,v)
#define	i286_memorywrite_d(a,v)	cpu_memorywrite_d(a,v)
#define	i286_memoryread(a)		cpu_memoryread(a)
#define	i286_memoryread_w(a)	cpu_memoryread_w(a)
#define	i286_memoryread_d(a)	cpu_memoryread_d(a)
#endif

#ifdef NP2_MEMORY_ASM
BYTE MEM_CALL i286_membyte_read(WORD seg, WORD off);
WORD MEM_CALL i286_memword_read(WORD seg, WORD off);
void MEM_CALL i286_membyte_write(WORD seg, WORD off, BYTE dat);
void MEM_CALL i286_memword_write(WORD seg, WORD off, WORD dat);
#else
#define	i286_membyte_read(a, b)										\
				i286_memoryread(((DWORD)(a) << 4) + (WORD)(b))
#define	i286_memword_read(a, b)										\
				i286_memoryread_w(((DWORD)(a) << 4) + (WORD)(b))

#define	i286_membyte_write(a, b, c)									\
				i286_memorywrite(((DWORD)(a) << 4) + (WORD)(b), (c))
#define	i286_memword_write(a, b, c)									\
				i286_memorywrite_w(((DWORD)(a) << 4) + (WORD)(b), (c))
#endif

void MEM_CALL i286_memstr_read(WORD seg, WORD off, void *dat, DWORD leng);
void MEM_CALL i286_memstr_write(WORD seg, WORD off, void *dat, DWORD leng);

void MEM_CALL i286_memx_read(DWORD address, void *dat, DWORD leng);
void MEM_CALL i286_memx_write(DWORD address, void *dat, DWORD leng);

#ifdef __cplusplus
}
#endif
