
#define	NEKO


#ifdef KEROPI
#include	<windows.h>
#include	"fddfile.h"
#include	"fdd_xdf.h"
#include	"../win32/common.h"
#include	"../win32/fileio.h"

#define		FILEHDL		FILEH
#define		FILE_OPEN	File_Open
#define		FILE_READ	File_Read
#define		FILE_SEEK	File_Seek
#define		FILE_CLOSE	File_Close
#endif

#ifdef NEKO
#include	"compiler.h"
#include	"fddfile.h"
#include	"fdd_xdf.h"
#include	"np2.h"
#include	"dosio.h"
#include	"iobridge.h"
#include	"dmac.h"
#include	"fdc.h"

#define		FILEHDL		FILEH
#define		FILE_OPEN	file_open
#define		FILE_READ	file_read
#define		FILE_WRITE	file_write
#define		FILE_SEEK	file_seek
#define		FILE_CLOSE	file_close
#endif


static XDF_INFO xdfinfo[MAX_FDDFILE];


static const XDF_INFO supportxdf[] = {
#if 0
			// 256
			{154, 26, 1, DISKTYPE_2HD, 0, {0}},
			// 512
			{154, 15, 2, DISKTYPE_2HD, 0, {0}},
#endif
			// 1024
			{154,  8, 3, DISKTYPE_2HD, 0, {0}},
			// 1.44MB
			{160, 18, 2, DISKTYPE_2HD, 1, {0}},
};


BOOL fdd_set_xdf(BYTE drv, LPSTR fname, int ro) {				// ver0.28

	WORD	attr;
	FILEH	fh;
	long	fdsize;
	int	i;

	if ((attr = file_attr(fname)) & 0x18) {
		return(FAILURE);
	}
	if ((fh = file_open(fname)) == (FILEH)-1) {
		return(FAILURE);
	}
	fdsize = file_seek(fh, 0, FSEEK_END);
	file_close(fh);

	for (i=0; i<(int)(sizeof(supportxdf)/sizeof(XDF_INFO)); i++) {
		long	size;
		size = supportxdf[i].tracks;
		size *= supportxdf[i].sectors;
		size <<= (7 + supportxdf[i].n);
		if (size == fdsize) {
			strcpy(fddfile[drv].fname, fname);
			fddfile[drv].type = DISKTYPE_BETA;
			fddfile[drv].protect = (((attr & 1) || (ro))?TRUE:FALSE);
			xdfinfo[drv] = supportxdf[i];
			return(SUCCESS);
		}
	}
	return(FAILURE);
}


BOOL fdd_eject_xdf(BYTE drv) {

	fddfile[drv].fname[0] = '\0';
	fddfile[drv].type = DISKTYPE_NOTREADY;
	return(SUCCESS);
}


BOOL fdd_diskaccess_xdf(void) {

	if (CTRL_FDMEDIA != DISKTYPE_2HD) {
		return(FAILURE);
	}
	return(SUCCESS);
}

BOOL fdd_seek_xdf(void) {

	if ((!fddfile[fdc.us].fname[0]) ||
		(fddfile[fdc.us].type != DISKTYPE_BETA) ||
		(CTRL_FDMEDIA != DISKTYPE_2HD) ||
		(fdc.rpm != xdfinfo[fdc.us].rpm) ||							// ver0.31
		(fdc.ncn >= (xdfinfo[fdc.us].tracks >> 1))) {
		return(FAILURE);
	}
	return(SUCCESS);
}


BOOL fdd_seeksector_xdf(void) {

	if ((!fddfile[fdc.us].fname[0]) ||
		(fddfile[fdc.us].type != DISKTYPE_BETA) ||
		(CTRL_FDMEDIA != DISKTYPE_2HD) ||
		(fdc.rpm != xdfinfo[fdc.us].rpm) ||							// ver0.31
		(fdc.treg[fdc.us] >= (xdfinfo[fdc.us].tracks >> 1))) {
		fddlasterror = 0xe0;										// ver0.28
		return(FAILURE);
	}
	if ((!fdc.R) || (fdc.R > xdfinfo[fdc.us].sectors)) {
		fddlasterror = 0xc0;									// ver0.28
		return(FAILURE);
	}
	// ver0.29
	if ((fdc.mf != 0xff) && (fdc.mf != 0x40)) {
		fddlasterror = 0xc0;									// ver0.28
		return(FAILURE);
	}
	return(SUCCESS);
}


BOOL fdd_read_xdf(void) {

	FILEHDL	hdl;
	DWORD	seekp;
	WORD	secsize;

	fddlasterror = 0x00;										// ver0.28
	if (fdd_seeksector_xdf()) {
		return(FAILURE);
	}
	if (fdc.N != xdfinfo[fdc.us].n) {
		fddlasterror = 0xc0;									// ver0.28
		return(FAILURE);
	}

	seekp = (fdc.treg[fdc.us] << 1) + fdc.hd;
	seekp *= xdfinfo[fdc.us].sectors;
	seekp += fdc.R - 1;
	seekp <<= (7 + xdfinfo[fdc.us].n);
	secsize = 128 << xdfinfo[fdc.us].n;

	if ((hdl = FILE_OPEN(fddfile[fdc.us].fname)) == (FILEHDL)-1) {
		fddlasterror = 0xe0;									// ver0.28
		return(FAILURE);
	}
	if ((FILE_SEEK(hdl, seekp, FSEEK_SET) != seekp) ||
		(FILE_READ(hdl, fdc.buf, secsize) != secsize)) {
		FILE_CLOSE(hdl);
		fddlasterror = 0xe0;									// ver0.28
		return(FAILURE);
	}
	FILE_CLOSE(hdl);
	fdc.bufcnt = secsize;
	fddlasterror = 0x00;										// ver0.28
	return(SUCCESS);
}


BOOL fdd_write_xdf(void) {

	FILEHDL	hdl;
	DWORD	seekp;
	WORD	secsize;

	fddlasterror = 0x00;										// ver0.28
	if (fdd_seeksector_xdf()) {
		fddlasterror = 0xe0;									// ver0.28
		return(FAILURE);
	}
	if (fddfile[fdc.us].protect) {
		fddlasterror = 0x70;									// ver0.28
		return(FAILURE);
	}
	if (fdc.N != xdfinfo[fdc.us].n) {
		fddlasterror = 0xc0;									// ver0.28
		return(FAILURE);
	}

	seekp = (fdc.treg[fdc.us] << 1) + fdc.hd;
	seekp *= xdfinfo[fdc.us].sectors;
	seekp += fdc.R - 1;
	seekp <<= (7 + xdfinfo[fdc.us].n);
	secsize = 128 << xdfinfo[fdc.us].n;

	if ((hdl = FILE_OPEN(fddfile[fdc.us].fname)) == (FILEHDL)-1) {
		fddlasterror = 0xc0;									// ver0.28
		return(FAILURE);
	}
	if ((FILE_SEEK(hdl, seekp, FSEEK_SET) != seekp) ||
		(FILE_WRITE(hdl, fdc.buf, secsize) != secsize)) {
		FILE_CLOSE(hdl);
		fddlasterror = 0xc0;									// ver0.28
		return(FAILURE);
	}
	FILE_CLOSE(hdl);
	fdc.bufcnt = secsize;
	fddlasterror = 0x00;										// ver0.28
	return(SUCCESS);
}

BOOL fdd_readid_xdf(void) {

	fddlasterror = 0x00;										// ver0.28
	if ((fdc.rpm != xdfinfo[fdc.us].rpm) ||						// ver0.31
		(fdc.crcn >= xdfinfo[fdc.us].sectors)) {
		fddlasterror = 0xe0;									// ver0.31
		return(FAILURE);
	}
	fdc.C = fdc.treg[fdc.us];
	fdc.H = fdc.hd;
	fdc.R = ++fdc.crcn;
	fdc.N = xdfinfo[fdc.us].n;
	return(SUCCESS);
}

