#include	"compiler.h"

#include	"np2.h"
#include	"iobridge.h"
#include	"crtc.h"
#include	"gdc.h"
#include	"maketext.h"
#include	"memory.h"
#include	"vram.h"
#include	"trace.h"

	CRTC_TABLE	crtc;

#ifdef __cplusplus
extern "C" {
#endif
	GRCG_TABLE	grcg;
#ifdef __cplusplus
}
#endif

void crtc_init(void) {

	ZeroMemory(&grcg, sizeof(grcg));
	ZeroMemory(&crtc, sizeof(crtc));
	crtc.reg.bl = 0x0f;
	crtc.reg.cl = 0x10;
	grcg.chip = np2cfg.grcg & 3;			// GRCGưΥԡ
}

I286_OUT crtc_w(WORD port, BYTE value) {

	port &= 0x0f;
	switch(port) {
		case 0x00:
		case 0x02:
		case 0x04:
		case 0x06:
		case 0x08:
		case 0x0a:
			value &= 0x1f;
			if (crtc.b[port >> 1] != value) {
				crtc.b[port >> 1] = value;
				gdcs.textdisp |= GDCSCRN_ALLDRAW;
			}
			break;

		case 0x0c:
//			TRACEOUT(0x7c, value);
			if (grcg.chip) {
				grcg.modereg = value;
				grcg.counter = 0;
				vramop.operate &= VOP_GRCGMASK;
				vramop.operate |= ((value & 0xc0) >> 4);
				if (grcg.chip >= 2) {
					grcg.gdcwithgrcg = (value >> 4) & 0x0c;
				}
				i286_vram_dispatch(vramop.operate);
			}
			break;

		case 0x0e:								// 00/05/18
//			TRACEOUT(0x7e, value);
			grcg.tile[grcg.counter].b[0] = value;
			grcg.tile[grcg.counter].b[1] = value;
			grcg.counter = (grcg.counter + 1) & 3;
			break;
	}
}

I286_INB crtc_r(WORD port) {

	switch(port & 0x0f) {
		case 0x0c:
			return(grcg.modereg);
	}
	return(0xff);
}

