#include	"compiler.h"

#include	"i286.h"
#include	"iobridge.h"
#include	"itimer.h"
#include	"sndboard.h"
#include	"cs4231.h"
#include	"pic.h"
#include	"cgrom.h"
#include	"crtc.h"
#include	"extmem.h"
#include	"serial.h"
#include	"gdc.h"
#include	"mouseif.h"
#include	"nevent.h"
#include	"sysport.h"
#include	"mpu98ii.h"
#include	"printif.h"
#include	"dipsw.h"
#include	"dmac.h"
#include	"fdc.h"
#include	"fdd_2d.h"
#include	"egc.h"
#include	"cpuio.h"
#include	"nmiio.h"
#include	"np2sysp.h"
#include	"artic.h"
#include	"trace.h"

extern I286_OUT itf_ctrl(WORD port, BYTE value);

// ֥å
BYTE IO_CALL i286_in(WORD port) {

//	TRACEIN(port);

	if ((port & 0xfff1) == 0xa460) {				// PC-9801-86
		return(sndproc.pcm_r(port));
	}
	else if ((port & 0x08f9) == 0x0088) {
		return(sndproc.fm_r(port));
	}
	else if (((port & 0xfffb) == 0x3fdb) ||			// PD8253-5
			((port & 0x0cf1) == 0x0071)) {
		return(itimer_r(port));
	}
	else if ((port & 0x0cf1) == 0x0000) {			// PD71059C
		return(pic_r(port));
	}
	else if ((port & 0x0cf1) == 0x00a1) {			// CG-ROM
		return(cgrom_r(port));
	}
	else if ((port & 0x0cf1) == 0x0070) {			// PD7220A
		return(crtc_r(port));
	}
	else if ((port & 0x0cf1) == 0x00a0) {
		return(gdc_slave_r(port));
	}
	else if ((port & 0x0cf1) == 0x0060) {
		return(gdc_master_r(port));
	}
	else if ((port & 0x0cf9) == 0x0031) {
		return(systemport_r(port));
	}
	else if ((port & 0x0cf9) == 0x0040) {
		return(printif_r(port));
	}
	else if ((port & 0x0cfd) == 0x0041) {			// PD8251A
		return(keyboard_r(port));
	}
	else if ((port & 0x0cfd) == 0x0030) {
		return(rs232c_r(port));
	}
	else if ((port & 0xfff9) == 0x7fd9) {			// 8255A
		return(mouseif_r(port));
	}
	else if ((port & 0xfff1) == mpu98.port) {		// MPU-98II		// ver0.28
		return(mpu98ii_r(port));
	}
	else if ((port & 0xfff1) == 0x08e1) {			// EMM
		return(emm_r(port));
	}
	else if ((port & 0xf0ff) == 0x801e) {
		return(dipsw_r(port));
	}
	else if ((port & 0xfff1) == 0x0090) {
		return(fdc_r(port));
	}
	else if ((port & 0xfff9) == 0x00C8) {
		return(fdc2dd_r(port));
	}
	else if ((port & 0x0ce1) == 0x0001) {
		return(dmac_r(port));
	}
	else if ((port & 0x0cf1) == 0x0021) {
		return(dmabank_r(port));
	}
	else if ((port & 0x00f9) == 0x51) {
		return(fdd320_r(port));
	}
	else if ((port & 0x0ffd) == 0x7ed) {
		return(np2sysp_r(port));
	}
	else if ((port & 0xfff0) == cs4231.port) {
		return(cs4231_r(port));
	}
	else if ((port & 0xfff1) == 0x0c20) {
		return(cs4231p_r(port));
	}
	else if ((port & 0x0cf9) == 0x00f0) {
		return(cpuio_r(port));
	}
	else if ((port & 0xfffc) == 0x005c) {							// ver0.28
		return(artic_r(port));
	}
#if 0
	else if (port == 0x98f0) {
		return(nmiio_r(port));
	}
#endif
//	TRACEIN(port);
	return(0xff);
}

WORD IO_CALL i286_in_w(WORD port) {

	if ((port & 0xfffc) == 0x005c) {								// ver0.28
		return(artic_r_w(port));
	}
	return(0xff00 | i286_in(port));
}

DWORD IO_CALL i286_in_d(WORD port) {

	return(0xffff0000 | i286_in_w(port));
}


void IO_CALL i286_out(WORD port, BYTE value) {

//	TRACEOUT(port, value);

	if ((port & 0xfff1) == 0xa460) {				// PC-9801-86
		sndproc.pcm_w(port, value);
	}
	else if ((port & 0x08f9) == 0x0088) {
		sndproc.fm_w(port, value);
	}
	else if (port == 0x5f) {						// wait port
		nevent.remainclock -= 20;
	}
	else if (((port & 0xfffb) == 0x3fdb) ||			// PD8253-5
			((port & 0x0cf1) == 0x0071)) {
		itimer_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x0000) {			// PD71059C
		pic_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x00a1) {			// CG-ROM
		cgrom_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x0070) {			// PD7220A
		crtc_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x00a0) {
		gdc_slave_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x0060) {
		gdc_master_w(port, value);
	}
	else if ((port & 0x0cf9) == 0x0031) {
		systemport_w(port, value);
	}
	else if ((port & 0x0cf9) == 0x0040) {
		printif_w(port, value);
	}
	else if ((port & 0x0cfd) == 0x0041) {			// PD8251A
		keyboard_w(port, value);
	}
	else if ((port & 0x0cfd) == 0x0030) {
		rs232c_w(port, value);
	}
	else if ((port & 0xfff9) == 0x7fd9) {			// 8255A
		mouseif_w(port, value);
	}
	else if (port == 0xbfdb) {
		mousetiming_w(port, value);
	}
	else if ((port & 0xfff1) == mpu98.port) {		// MPU-98II		// ver0.28
		mpu98ii_w(port, value);
	}
	else if ((port & 0xfff1) == 0x08e1) {			// EMM
		emm_w(port, value);
	}
	else if ((port & 0xf0ff) == 0x801e) {
		dipsw_w(port, value);
	}
	else if ((port & 0xfff1) == 0x0090) {
		fdc_w(port, value);
	}
	else if ((port & 0xfff9) == 0x00c8) {
		fdc2dd_w(port, value);
	}
	else if ((port & 0x0ce1) == 0x0001) {
		dmac_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x0021) {
		dmabank_w(port, value);
	}
	else if (port == 0x043d) {
		itf_ctrl(port, value);
	}
	else if ((port & 0x00f9) == 0x51) {
		fdd320_w(port, value);
	}
	else if ((port & 0x0ffd) == 0x7ed) {
		np2sysp_w(port, value);
	}
	else if ((port & 0xfff0) == cs4231.port) {
		cs4231_w(port, value);
	}
	else if ((port & 0xfff1) == 0x0c20) {
		cs4231p_w(port, value);
	}
	else if ((port & 0x0cf9) == 0x00f0) {
		cpuio_w(port, value);
	}
	else if ((port & 0x0cf1) == 0x0050) {
		nmiio_w(port, value);
	}
#ifdef TRACE
#if 0
	else if (port == 0xffff) {
		trace_sw = value;
	}
#endif
	else {
//		TRACEOUT(port, value);
	}
#endif
}

void IO_CALL i286_out_w(WORD port, WORD value) {

	if ((port & 0xfff1) == 0x04a0) {
		egc_w(port, value);
	}
	else {
		i286_out(port, (BYTE)value);
	}
}

void IO_CALL i286_out_d(WORD port, DWORD value) {

	i286_out_w(port, (WORD)value);
	i286_out_w(port + 2, (WORD)(value >> 16));
}
