#define	SURFACE_WIDTH		640
#define	SURFACE_HEIGHT		480
#define	SCRN_BUFSIZE		0x4b000

									// for os_draw
extern	BYTE	renewal_line[SURFACE_HEIGHT + 4];
extern	BYTE	np2_tram[SCRN_BUFSIZE];
extern	BYTE	np2_vram[2][SCRN_BUFSIZE];



									// for memory
#ifdef __cplusplus
extern "C" {
#endif

extern	BYTE	vramupdate[0x8000];
extern	BYTE	tramupdate[0x1000];

#ifdef __cplusplus
}
#endif



BOOL np2_getmemsw(void);

void np2_init(void);
void np2_reset(void);
void np2_term(void);

// ------------------------------------------------------------------ main


// NP2ν򣱥ե졼ʬԤ
// TURE Υե졼褹

void np2main_exec(BOOL screenupdate);

// ------------------------------------------------------------------ stat

#define	NP2STAT_FDD			0x0001
#define	NP2STAT_DRAW		0x0100
#define	NP2STAT_CLOCK		0x0200
#define	NP2STAT_VENEVT		0xff00

#define	NP2STAT_NONE		0x0000
#define	NP2STAT_ALL			0xffff

typedef struct {
	int		fddstat;
	long	drawtimes;			// ¼
	long	clock;				// ưå
} NP2STAT_T;


// NP2ξΤ
// set = åȤbitmap / reset = ꥻåȤbitmap
void np2stat_getstatus(NP2STAT_T *stat, int set, int reset);


// ------------------------------------------------------------------ disk

// HDD᡼ / fname=NULL remove
void np2disk_changehdd(BYTE drv, char *fname);

// Ƥ HDD᡼֤
char *np2disk_gethddname(BYTE drv);

// FDD᡼ / fname=NULL eject
void np2disk_changefdd(BYTE drv, char *fname, int delay);

// Ƥ FDD᡼֤
char *np2disk_getfddname(BYTE drv);


// ------------------------------------------------------------------ layer

#define	LAYER_ROL			2
#define	LAYER_NORDISP		4
#define	LAYER_EXTSKIPLINE	8

extern void (*layer8tbl[])(void);
extern void (*layer16tbl[])(void);
extern void (*layer24tbl[])(void);
extern void (*layer32tbl[])(void);

// 
// redraw = TRUE 
void np2layer_outpreparing(BOOL redraw);


// ᥤ
// func = ؿ
// flag = ˡ
// surface = ХåեΥݥ󥿡 linealing = 饤ʬΥХȿ
void np2layer_out(void (*func[])(void), int flag,
											void *surface, int linealign);

// 轪λ
BYTE np2layer_outresult(void);


// ------------------------------------------------------------------ palettes

// NP2ѥåȤν (np2init˻Ȥ礬Τ)
void np2pal_initpalettes(void);

// OS¦Υ꡼⡼ɤꤹ
// bit = ӥå
void np2pal_setcolorbit(int bit);

// 16bitλγƿͭӥå
void np2pal_make16mask(DWORD bmask, DWORD rmask, DWORD gmask);

// 32bit 16bit
WORD np2pal_get16pal(DWORD pal);

// ǡĤ....
void np2pal_makegrad(PALETTE_TABLE *pal, int pals, DWORD bg, DWORD fg);


// ------------------------------------------------------------------ sound

typedef struct {
	long	*buf1;
	int		len1;
	long	*buf2;
	int		len2;
} NP2SNDBUF_T;

// ɤν
void np2sound_init(DWORD rate, void (*callback)(void));

// ɤνλ
void np2sound_term(void);

// ɥХåեμ
void np2sound_getsounddata(int leng, NP2SNDBUF_T *np2sndbuf);

void np2sound_clrsounddata(void);

// ɥ塼Υå
void np2sound_volume(void);


// ------------------------------------------------------------------ serial

// ܡɥǡ
// data = PC-98ΥСɥ٥Υǡ
void np2serial_keyout(BYTE data);



// ܡɥ٥礻
void np2key_resetjoykey(void);
void np2key_resetcopyhelp(void);
void np2key_forcerelease(BYTE value);


// ------------------------------------------------------------------ trace

// NP2¦ξ֤ե˽񤭽Ф
void np2trace_status(void);

// ᥤʬե˽񤭽Ф
void np2trace_memorydump(void);

#ifdef TRACE
// ǥХѥå
extern	BYTE	np2trace_sw;
#endif
