/*	$Id: np2.c,v 1.11 2003/06/05 18:10:17 nonaka Exp $	*/

/*
 * Copyright (c) 2001-2003 NONAKA Kimihiro
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "compiler.h"

#include "np2.h"
#include "np2pc98.h"
#include "pc_core.h"
#include "iobridge.h"

#include "caption.h"
#include "timing.h"

NP2_CFG np2cfg = {
#ifndef CPU386
	"Neko Project II",
#else	/* CPU386 */
	"Neko Project II + IA32",
#endif
	"NP2",
	PCBASECLOCK25, 4, 0,
	{0x3e, 0x63, 0x7a},
	{0x48, 0x05, 0x0c, 0x00, 0x01, 0x00, 0x00, 0x6E},
	{0x0c, 0x08, 0x0c, 0x06, 0x03, 0x0c},
	{1, 1, 6, 1, 8, 1},
	0,
#ifdef NOSOUND
	0,	/* disable sound board */
#else
	4,	/* PC-9801-86 */
#endif
	0, 2, 32, 22050, 800, 1, 0, 0, 0, 0, 1, 1,
	0, 0, 0, 0, {1, 2, 2, 1},
	0, 0, 57600,
	{0, 0, 0}, 0xd1, 0x7f, 0xd1, 0x82,
	1, 80, 3, 1, 1, 0, 0x000000, 0xffffff,
	0, 0, 0, 0xff, 0, 0, 0, 0, 0x40, 0,
	64, 64, 64, 64, 64,
	0, 0, 0xffffff, 0xffbf6a,
	1, 1, 2, 0, 1,
	0,	/* mouse ratio */
	0	/* sound driver */
};

char modulefile[MAX_PATH];

int winx = SCREEN_WIDTH;
int winy = SCREEN_HEIGHT;

void
processwait(WORD cnt)
{

	if (timing_getcount() >= cnt) {
		timing_setcount(0);
		framecnt = 0;
		if (np2cfg.DISPCLK) {
			if (caption_statmake())
				caption_disp(np2cfg.DISPCLK << 1);
		}
	}
}
