;	$Id: i286a_n.asm,v 1.3 2002/11/05 15:13:32 nonaka Exp $

%include "np2asm.inc"
%include "cpu.inc"
%include "cpu.mcr"


extern	calc_ea_dst
extern	calc_lea
extern	get_ea
extern	op8xreg8_table
extern	op8xext8_table
extern	op8xreg16_table
extern	op8xext16_table
extern	sftreg8cl_table
extern	sftreg16cl_table
extern	sftreg8_table
extern	sftmem8_table
extern	sftext8_table
extern	sftreg16_table
extern	sftmem16_table
extern	sftext16_table
extern	sftreg8cl_table
extern	sftext8cl_table
extern	sftreg16cl_table
extern	sftext16cl_table

extern	_cts
extern	ope0xf6_table
extern	ope0xf7_table
extern	ope0xfe_table
extern	ope0xff_table
extern	sftreg8v30_table
extern	sftext8v30_table
extern	sftreg16v30_table
extern	sftext16v30_table
extern	rep_insb
extern	rep_insw
extern	rep_outsb
extern	rep_outsw
extern	rep_movsb
extern	rep_movsw
extern	rep_stosb
extern	rep_stosw
extern	rep_lodsb
extern	rep_lodsw
extern	rep_insb
extern	rep_insw
extern	rep_outsb
extern	rep_outsw
extern	rep_movsb
extern	rep_movsw
extern	rep_stosb
extern	rep_stosw
extern	rep_lodsb
extern	rep_lodsw
extern	repe_cmpsb
extern	repe_cmpsw
extern	repe_scasb
extern	repe_scasw
extern	repne_cmpsb
extern	repne_cmpsw
extern	repne_scasb
extern	repne_scasw


%macro	I286IRQCHECKTERM	0
	xor	eax, eax
	cmp	dword [nevent + nevent_t.remainclock], eax
	jle	.nonremainclr
	xchg	dword [nevent + nevent_t.remainclock], eax
	sub	dword [nevent + nevent_t.baseclock], eax
.nonremainclr:	
	ret
%endmacro


section .text

	align	16
global i286
i286:
	pushad
	mov	ebp, dword [CS_BASE]
	movzx	esi, word [I286_IP]
	test	byte [CPUTYPE], CPUTYPE_V30
	jne	.v30mnlp

.i286mnlp:	GET_PCBYTEEX
	call	[i286op + ebx * 4]
	cmp	dword [nevent + nevent_t.remainclock], 0
	jg	.i286mnlp
	mov	word [I286_IP], si
	popad
	ret

	align	16
.v30mnlp:	GET_PCBYTEEX
	call	[v30op + ebx * 4]
	cmp	dword [nevent + nevent_t.remainclock], 0
	jg	.v30mnlp
	mov	word [I286_IP], si
	popad
	ret


	align	16
global i286withtrap
i286withtrap:
	pushad
	mov	ebp, dword [CS_BASE]
	movzx	esi, word [I286_IP]
	test	byte [CPUTYPE], CPUTYPE_V30
	jne	.v30mnlp

	GET_PCBYTEEX
	call	[i286op + ebx * 4]
	mov	word [I286_IP], si
	cmp	dword [I286_TRAP], 0
	jne	short .trapping
.notrap:
	popad
	ret

	align	16
.v30mnlp:
	GET_PCBYTEEX
	call	[v30op + ebx * 4]
	mov	word [I286_IP], si
	cmp	dword [I286_TRAP], 0
	je	short .notrap

.trapping:
	mov	ecx, 1
	call	i286a_interrupt
	popad
	ret


	align	16
global i286withdma
i286withdma:
	pushad
	mov	ebp, dword [CS_BASE]
	movzx	esi, word [I286_IP]
	test	byte [CPUTYPE], CPUTYPE_V30
	jne	.v30mnlp

.i286mnlp:
	GET_PCBYTEEX
	call	[i286op + ebx * 4]
	pushad
	call	dma_proc
	popad
	cmp	dword [nevent + nevent_t.remainclock], 0
	jg	.i286mnlp
	mov	word [I286_IP], si
	popad
	ret

	align	16
.v30mnlp:
	GET_PCBYTEEX
	call	[v30op + ebx * 4]
	pushad
	call	dma_proc
	popad
	cmp	dword [nevent + nevent_t.remainclock], 0
	jg	.v30mnlp
	mov	word [I286_IP], si
	popad
	ret



	align	16
global i286_step
i286_step:
	pushad
	mov	ebp, dword [CS_BASE]
	movzx	esi, word [I286_IP]
	test	byte [CPUTYPE], CPUTYPE_V30
	jne	.v30mnstp

	GET_PCBYTEEX
	call	[i286op + ebx * 4]
	mov	word [I286_IP], si
	call	dma_proc
	popad
	ret

	align	16
.v30mnstp:
	GET_PCBYTEEX
	call	[v30op + ebx * 4]
	mov	word [I286_IP], si
	call	dma_proc
	popad
	ret


	align	16
;global i286a_interrupt
i286a_interrupt:
	push	ebx
	push	ecx
	push	edi

	; hlt..
	movzx	ecx, word [I286_IP]
	add	ecx, dword [CS_BASE]
	call	@i286_memoryread@4
	cmp	al, 0f4h	; hlt
	jne	short .nonhlt
	inc	word [I286_IP]
.nonhlt:
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_FLAG]
	and	dh, 0fh
	and	word [I286_FLAG], ~(T_FLAG | I_FLAG)
	mov	dword [I286_TRAP], 0
	call	@i286_memorywrite_w@8
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_CS]
	call	@i286_memorywrite_w@8
	sub	bx, 2
	mov	word [I286_SP], bx
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_IP]
	call	@i286_memorywrite_w@8
	pop	edi
	pop	ecx
	pop	ebx

	movzx	eax, cl
	mov	eax, dword [I286_MEM + eax * 4]
	mov	word [I286_IP], ax
	shr	eax, 16
	mov	word [I286_CS], ax
	shl	eax, 4			; make segreg
	mov	dword [CS_BASE], eax
	ret


	align	16
removeprefix:
	mov	dword [i286s + I286STAT.prefix], 0
	movzx	eax, word [I286_DS]
	shl	eax, 4
	mov	dword [DS_FIX], eax
	movzx	eax, word [I286_SS]
	shl	eax, 4
	mov	dword [SS_FIX], eax
	ret


	align	16
_reserved:
	INT_NUM 6


	align	16
; 90: nop / bios func
_nop:
	I286CLOCK 3
	lea	ecx, [ebp + esi - 1]
	cmp	ecx, 0f8000h
	jc	.biosend
	cmp	ecx, 100000h
	jnc	.biosend

	mov	word [I286_IP], si
	pushad
	push	ecx
	call	biosfunc
	pop	ecx
	mov	[esp + 28], eax
	popad
	cmp	al, ah
	je	.biosend
	movzx	esi, word [I286_IP]
	movzx	eax, word [I286_ES]
	shl	eax, 4
	mov	dword [ES_BASE], eax
	movzx	ebp, word [I286_CS]
	shl	ebp, 4
	mov	dword [CS_BASE], ebp
	movzx	eax, word [I286_SS]
	shl	eax, 4
	mov	dword [SS_BASE], eax
	mov	dword [SS_FIX], eax
	movzx	eax, word [I286_DS]
	shl	eax, 4
	mov	dword [DS_BASE], eax
	mov	dword [DS_FIX], eax

.biosend:
	ret

	align	16
; 00: add EA, REG8
add_ea_r8:
	PREPART_EA_REG8(2)
	add	byte [I286_REG + eax], dl
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG8(7)
	add	byte [I286_MEM + ecx], dl
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG8
	add	al, byte [I286_REG + ebx]
	mov	dl, al
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
; 01: add EA, REG16
add_ea_r16:
	PREPART_EA_REG16(2)
	add	word [I286_REG + eax * 2], dx
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG16(7)
	add	word [I286_MEM + ecx], dx
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG16
	add	ax, word [I286_REG + ebx * 2]
	mov	dx, ax
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
; 02: add REG8, EA
add_r8_ea:
	PREPART_REG8_EA 2, 7
	add	byte [I286_REG + ebx], al
	FLAG_STORE_OF
	ret

	align	16
; 03: add REG16, EA
add_r16_ea:
	PREPART_REG16_EA 2, 7 
	add	word [I286_REG + ebx * 2], ax
	FLAG_STORE_OF
	ret

	align	16
; 04: add al, DATA8
add_al_data8:
	I286CLOCK 3
	INC_PCBYTE
	add	byte [I286_AL], ah
	FLAG_STORE_OF
	ret

	align	16
; 05: add ax, DATA16
add_ax_data16:
	I286CLOCK 3
	GET_PCWORD
	add	word [I286_AX], ax
	FLAG_STORE_OF
	ret

	align	16
; 06: push es
push_es:
	I286CLOCK 3 
	REGPUSH1 word [I286_ES]

	align	16
; 07: pop es
pop_es:
	I286CLOCK 5 
	REGPOP word [I286_ES] 
	and	eax, 00ffffh
	shl	eax, 4			; make segreg
	mov	dword [ES_BASE], eax
	ret

	align	16
; 08: or EA, REG8
or_ea_r8:
	PREPART_EA_REG8(2)
	or	byte [I286_REG + eax], dl
	FLAG_STORE0
	ret

	MEMORY_EA_REG8(7)
	or	byte [I286_MEM + ecx], dl
	FLAG_STORE0
	ret

	EXTMEM_EA_REG8
	or	al, byte [I286_REG + ebx]
	mov	dl, al
	FLAG_STORE0
	jmp	@i286_memorywrite@8

	align	16
; 09: or EA, REG16
or_ea_r16:
	PREPART_EA_REG16(2)
	or	word [I286_REG + eax * 2], dx
	FLAG_STORE0
	ret

	MEMORY_EA_REG16(7)
	or	word [I286_MEM + ecx], dx
	FLAG_STORE0
	ret

	EXTMEM_EA_REG16
	or	ax, word [I286_REG + ebx * 2]
	mov	dx, ax
	FLAG_STORE0
	jmp	@i286_memorywrite_w@8

	align	16
; 0A: or REG8, EA
or_r8_ea:
	PREPART_REG8_EA 2, 7
	or	byte [I286_REG + ebx], al
	FLAG_STORE0
	ret

	align	16
; 0B: or REG16, EA
or_r16_ea:
	PREPART_REG16_EA 2, 7
	or	word [I286_REG + ebx * 2], ax
	FLAG_STORE0
	ret

	align	16
; 0C: or al, DATA8
or_al_data8:
	I286CLOCK 3
	INC_PCBYTE
	or	byte [I286_AL], ah
	FLAG_STORE0
	ret

	align	16
; 0D: or ax, DATA16
or_ax_data16:
	I286CLOCK 3
	GET_PCWORD
	or	word [I286_AX], ax
	FLAG_STORE0
	ret

	align	16
; 0E: push es
push_cs:
	I286CLOCK 3
	REGPUSH1 word [I286_CS]


	align	16
; 10: adc EA, REG8
adc_ea_r8:
	PREPART_EA_REG8(2)
	CFLAG_LOAD
	adc	byte [I286_REG + eax], dl
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG8(7)
	CFLAG_LOAD
	adc	byte [I286_MEM + ecx], dl
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG8
	CFLAG_LOAD
	adc	al, byte [I286_REG + ebx]
	mov	dl, al
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
; 11: adc EA, REG16
adc_ea_r16:
	PREPART_EA_REG16(2)
	CFLAG_LOAD
	adc	word [I286_REG + eax * 2], dx
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG16(7)
	CFLAG_LOAD
	adc	word [I286_MEM + ecx], dx
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG16
	CFLAG_LOAD
	adc	ax, word [I286_REG + ebx * 2]
	mov	dx, ax
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
; 12: adc REG8, EA
adc_r8_ea:
	PREPART_REG8_EA 2, 7
	CFLAG_LOAD
	adc	byte [I286_REG + ebx], al
	FLAG_STORE_OF
	ret

	align	16
; 13: adc REG16, EA
adc_r16_ea:
	PREPART_REG16_EA 2, 7
	CFLAG_LOAD
	adc	word [I286_REG + ebx * 2], ax
	FLAG_STORE_OF
	ret

	align	16
; 14: adc al, DATA8
adc_al_data8:
	I286CLOCK 3
	INC_PCBYTE
	CFLAG_LOAD
	adc	byte [I286_AL], ah
	FLAG_STORE_OF
	ret

	align	16
; 15: adc ax, DATA16
adc_ax_data16:
	I286CLOCK 3
	GET_PCWORD
	CFLAG_LOAD
	adc	word [I286_AX], ax
	FLAG_STORE_OF
	ret

	align	16
; 16: push ss
push_ss:
	I286CLOCK 3
	REGPUSH1 word [I286_SS]

	align	16
; 17: pop ss
pop_ss:
	I286CLOCK 5
	REGPOP word [I286_SS]
	and	eax, 00ffffh
	shl	eax, 4				; make segreg
	mov	dword [SS_BASE], eax
	mov	dword [SS_FIX], eax
	cmp	dword [i286s + I286STAT.prefix], 0	; 00/06/24
	je	.noprefix

	call	removeprefix
	pop	eax
.noprefix:
	GET_PCBYTEEX
	jmp	[i286op + ebx * 4]

	align	16
; 18: sbb EA, REG8
sbb_ea_r8:
	PREPART_EA_REG8(2)
	CFLAG_LOAD
	sbb	byte [I286_REG + eax], dl
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG8(7)
	CFLAG_LOAD
	sbb	byte [I286_MEM + ecx], dl
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG8
	CFLAG_LOAD
	sbb	al, byte [I286_REG + ebx]
	mov	dl, al
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

	align	16
; 19: sbb EA, REG16
sbb_ea_r16:
	PREPART_EA_REG16(2)
	CFLAG_LOAD
	sbb	word [I286_REG + eax * 2], dx
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG16(7)
	CFLAG_LOAD
	sbb	word [I286_MEM + ecx], dx
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG16
	CFLAG_LOAD
	sbb	ax, word [I286_REG + ebx * 2]
	mov	dx, ax
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

	align	16
; 1A: sbb REG8, EA
sbb_r8_ea:
	PREPART_REG8_EA 2, 7
	CFLAG_LOAD
	sbb	byte [I286_REG + ebx], al
	FLAG_STORE_OF
	ret

	align	16
; 1B: sbb REG16, EA
sbb_r16_ea:
	PREPART_REG16_EA 2, 7
	CFLAG_LOAD
	sbb	word [I286_REG + ebx * 2], ax
	FLAG_STORE_OF
	ret

	align	16
; 1C: sbb al, DATA8
sbb_al_data8:
	I286CLOCK 3
	INC_PCBYTE
	CFLAG_LOAD
	sbb	byte [I286_AL], ah
	FLAG_STORE_OF
	ret

	align	16
; 1D: sbb ax, DATA16
sbb_ax_data16:
	I286CLOCK 3
	GET_PCWORD
	CFLAG_LOAD
	sbb	word [I286_AX], ax
	FLAG_STORE_OF
	ret

	align	16
; 1E: push ds
push_ds:
	I286CLOCK 3
	REGPUSH1 word [I286_DS]

	align	16
; 1F: pop ds
pop_ds:
	I286CLOCK 5
	REGPOP word [I286_DS]
	and	eax, 00ffffh
	shl	eax, 4				; make segreg
	mov	dword [DS_BASE], eax
	mov	dword [DS_FIX], eax
	ret

; 20: and EA, REG8
	align	16
and_ea_r8:
	PREPART_EA_REG8(2)
	and	byte [I286_REG + eax], dl
	FLAG_STORE0
	ret

	MEMORY_EA_REG8(7)
	and	byte [I286_MEM + ecx], dl
	FLAG_STORE0
	ret

	EXTMEM_EA_REG8
	and	al, byte [I286_REG + ebx]
	mov	dl, al
	FLAG_STORE0
	jmp	@i286_memorywrite@8

; 21: and EA, REG16
	align	16
and_ea_r16:
	PREPART_EA_REG16(2)
	and	word [I286_REG + eax * 2], dx
	FLAG_STORE0
	ret

	MEMORY_EA_REG16(7)
	and	word [I286_MEM + ecx], dx
	FLAG_STORE0
	ret

	EXTMEM_EA_REG16
	and	ax, word [I286_REG + ebx * 2]
	mov	dx, ax
	FLAG_STORE0
	jmp	@i286_memorywrite_w@8

; 22: and REG8, EA
	align	16
and_r8_ea:
	PREPART_REG8_EA 2, 7
	and	byte [I286_REG + ebx], al
	FLAG_STORE0
	ret

; 23: and REG16, EA
	align	16
and_r16_ea:
	PREPART_REG16_EA 2, 7
	and	word [I286_REG + ebx * 2], ax
	FLAG_STORE0
	ret

; 24: and al, DATA8
	align	16
and_al_data8:
	I286CLOCK 3
	INC_PCBYTE
	and	byte [I286_AL], ah
	FLAG_STORE0
	ret

; 25: and ax, DATA16
	align	16
and_ax_data16:
	I286CLOCK 3
	GET_PCWORD
	and	word [I286_AX], ax
	FLAG_STORE0
	ret

; 26: es:
	align	16
segprefix_es:
	mov	eax, dword [ES_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op + ebx * 4]

; 27: daa
	align	16
_daa:
	I286CLOCK 3
	FLAG_LOAD
	mov	ax, word [I286_AX]
	daa
	mov	word [I286_AX], ax
	FLAG_STORE
	ret

; 28: sub EA, REG8
	align	16
sub_ea_r8:
	PREPART_EA_REG8(2)
	sub	byte [I286_REG + eax], dl
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG8(7)
	sub	byte [I286_MEM + ecx], dl
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG8
	sub	al, byte [I286_REG + ebx]
	mov	dl, al
	FLAG_STORE_OF
	jmp	@i286_memorywrite@8

; 29: sub EA, REG16
	align	16
sub_ea_r16:
	PREPART_EA_REG16(2)
	sub	word [I286_REG + eax * 2], dx
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG16(7)
	sub	word [I286_MEM + ecx], dx
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG16
	sub	ax, word [I286_REG + ebx * 2]
	mov	dx, ax
	FLAG_STORE_OF
	jmp	@i286_memorywrite_w@8

; 2A: sub REG8, EA
	align	16
sub_r8_ea:
	PREPART_REG8_EA 2, 7
	sub	byte [I286_REG + ebx], al
	FLAG_STORE_OF
	ret

; 2B: sub REG16, EA
	align	16
sub_r16_ea:
	PREPART_REG16_EA 2, 7
	sub	word [I286_REG + ebx * 2], ax
	FLAG_STORE_OF
	ret

; 2C: sub al, DATA8
	align	16
sub_al_data8:
	I286CLOCK 3
	INC_PCBYTE
	sub	byte [I286_AL], ah
	FLAG_STORE_OF
	ret

; 2D: sub ax, DATA16
	align	16
sub_ax_data16:
	I286CLOCK 3
	GET_PCWORD
	sub	word [I286_AX], ax
	FLAG_STORE_OF
	ret

; 2E: cs:
	align	16
segprefix_cs:
	mov	eax, dword [CS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op + ebx * 4]

; 2F: das
	align	16
_das:
	I286CLOCK 3
	FLAG_LOAD
	mov	ax, word [I286_AX]
	das
	mov	word [I286_AX], ax
	FLAG_STORE
	ret

; 30: xor EA, REG8
	align	16
xor_ea_r8:
	PREPART_EA_REG8(2)
	xor	byte [I286_REG + eax], dl
	FLAG_STORE0
	ret

	MEMORY_EA_REG8(7)
	xor	byte [I286_MEM + ecx], dl
	FLAG_STORE0
	ret

	EXTMEM_EA_REG8
	xor	al, byte [I286_REG + ebx]
	mov	dl, al
	FLAG_STORE0
	jmp	@i286_memorywrite@8

; 31: xor EA, REG16
	align	16
xor_ea_r16:
	PREPART_EA_REG16(2)
	xor	word [I286_REG + eax * 2], dx
	FLAG_STORE0
	ret

	MEMORY_EA_REG16(7)
	xor	word [I286_MEM + ecx], dx
	FLAG_STORE0
	ret

	EXTMEM_EA_REG16
	xor	ax, word [I286_REG + ebx * 2]
	mov	dx, ax
	FLAG_STORE0
	jmp	@i286_memorywrite_w@8

; 32: xor REG8, EA
	align	16
xor_r8_ea:
	PREPART_REG8_EA 2, 7
	xor	byte [I286_REG + ebx], al
	FLAG_STORE0
	ret

; 33: xor REG16, EA
	align	16
xor_r16_ea:
	PREPART_REG16_EA 2, 7
	xor	word [I286_REG + ebx * 2], ax
	FLAG_STORE0
	ret

; 34: xor al, DATA8
	align	16
xor_al_data8:
	I286CLOCK 3
	INC_PCBYTE
	xor	byte [I286_AL], ah
	FLAG_STORE0
	ret

; 35: xor ax, DATA16
	align	16
xor_ax_data16:
	I286CLOCK 3
	GET_PCWORD
	xor	word [I286_AX], ax
	FLAG_STORE0
	ret

; 36: ss:
	align	16
segprefix_ss:
	mov	eax, dword [SS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op + ebx * 4]

; 37: aaa
	align	16
_aaa:
	I286CLOCK 3
	FLAG_LOAD
	mov	ax, word [I286_AX]
	aaa
	mov	word [I286_AX], ax
	FLAG_STORE
	ret

; 38: cmp EA, REG8
	align	16
cmp_ea_r8:
	PREPART_EA_REG8(2)
	cmp	byte [I286_REG + eax], dl
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG8(6)
	cmp	byte [I286_MEM + ecx], dl
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG8
	cmp	al, byte [I286_REG + ebx]
	FLAG_STORE_OF
	ret

; 39: cmp EA, REG16
	align	16
cmp_ea_r16:
	PREPART_EA_REG16(2)
	cmp	word [I286_REG + eax * 2], dx
	FLAG_STORE_OF
	ret

	MEMORY_EA_REG16(6)
	cmp	word [I286_MEM + ecx], dx
	FLAG_STORE_OF
	ret

	EXTMEM_EA_REG16
	cmp	ax, word [I286_REG + ebx * 2]
	FLAG_STORE_OF
	ret

; 3A: cmp REG8, EA
	align	16
cmp_r8_ea:
	PREPART_REG8_EA 2, 6
	cmp	byte [I286_REG + ebx], al
	FLAG_STORE_OF
	ret

; 3B: cmp REG16, EA
	align	16
cmp_r16_ea:
	PREPART_REG16_EA 2, 6
	cmp	word [I286_REG + ebx * 2], ax
	FLAG_STORE_OF
	ret

; 3C: cmp al, DATA8
	align	16
cmp_al_data8:
	I286CLOCK 3
	INC_PCBYTE
	cmp	byte [I286_AL], ah
	FLAG_STORE_OF
	ret

; 3D: cmp ax, DATA16
	align	16
cmp_ax_data16:
	I286CLOCK 3
	GET_PCWORD
	cmp	word [I286_AX], ax
	FLAG_STORE_OF
	ret

; 3E: ds:
	align	16
segprefix_ds:
	mov	eax, dword [DS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op + ebx * 4]

; 3F: aas
	align	16
_aas:
	I286CLOCK 3
	FLAG_LOAD
	mov	ax, word [I286_AX]
	aas
	mov	word [I286_AX], ax
	FLAG_STORE
	ret

; 40-47: inc reg16
	align	16
inc_reg16:
	I286CLOCK 2
	and	ebx, 7
	inc	word [I286_REG + ebx * 2]
	FLAG_STORE_NC
	ret

; 48-4f: dec reg16
	align	16
dec_reg16:
	I286CLOCK 2
	and	ebx, 7
	dec	word [I286_REG + ebx * 2]
	FLAG_STORE_NC
	ret

; 50: push ax
	align	16
push_ax:
	I286CLOCK 3
	REGPUSH1 word [I286_AX]

; 51: push cx
	align	16
push_cx:
	I286CLOCK 3
	REGPUSH1 word [I286_CX]

; 52: push dx
	align	16
push_dx:
	I286CLOCK 3
	REGPUSH1 word [I286_DX]

; 53: push bx
	align	16
push_bx:
	I286CLOCK 3
	REGPUSH1 word [I286_BX]

; 54: push sp
	align	16
push_sp:
	I286CLOCK 3
	REGPUSH1 word [I286_SP]

; 55: push bp
	align	16
push_bp:
	I286CLOCK 3
	REGPUSH1 word [I286_BP]

; 56: push si
	align	16
push_si:
	I286CLOCK 3
	REGPUSH1 word [I286_SI]

; 57: push di
	align	16
push_di:
	I286CLOCK 3
	REGPUSH1 word [I286_DI]

; 58: pop ax
	align	16
pop_ax:
	I286CLOCK 5
	REGPOP word [I286_AX]
	ret

; 59: pop cx
	align	16
pop_cx:
	I286CLOCK 5
	REGPOP word [I286_CX]
	ret

; 5A: pop dx
	align	16
pop_dx:
	I286CLOCK 5
	REGPOP word [I286_DX]
	ret

; 5B: pop bx
	align	16
pop_bx:
	I286CLOCK 5
	REGPOP word [I286_BX]
	ret

; 5C: pop sp
	align	16
pop_sp:
	I286CLOCK 5
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	call	@i286_memoryread_w@4
	mov	word [I286_SP], ax
	ret

; 5D: pop bp
	align	16
pop_bp:
	I286CLOCK 5
	REGPOP word [I286_BP]
	ret

; 5E: pop si
	align	16
pop_si:
	I286CLOCK 5
	REGPOP word [I286_SI]
	ret

; 5F: pop di
	align	16
pop_di:
	I286CLOCK 5
	REGPOP word [I286_DI]
	ret

; 60: pusha
	align	16
_pusha:
	I286CLOCK 17
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]

	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_AX]
	call	@i286_memorywrite_w@8

	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_CX]
	call	@i286_memorywrite_w@8

	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_DX]
	call	@i286_memorywrite_w@8

	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_BX]
	call	@i286_memorywrite_w@8

	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_SP]
	call	@i286_memorywrite_w@8

	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_BP]
	call	@i286_memorywrite_w@8

	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_SI]
	call	@i286_memorywrite_w@8

	sub	bx, 2
	mov	word [I286_SP], bx
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_DI]
	jmp	@i286_memorywrite_w@8

; 61: popa
	align	16
_popa:
	I286CLOCK 19
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]

	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_DI], ax
	add	bx, 2

	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_SI], ax
	add	bx, 2

	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_BP], ax
	add	bx, 4

	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_BX], ax
	add	bx, 2

	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_DX], ax
	add	bx, 2

	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_CX], ax
	add	bx, 2

	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_AX], ax
	add	word [I286_SP], 16
	ret

	align	16
_bound:
	GET_PCBYTE_C
	mov	ebx, 6
	cmp	al, 0c0h
	jnc	.bountint

	mov	bl, al
	shr	bl, 3
	and	ebx, 7
	I286CLOCK 13
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	call	@i286_memoryread_w@4
	cmp	word [I286_REG + ebx * 2], ax
	jb	.bounttrue
	add	ecx, 2
	call	@i286_memoryread_w@4
	cmp	word [I286_REG + ebx * 2], ax
	ja	.bounttrue
	ret

.bounttrue:
	mov	ebx, 5
.bountint:
	INT_NUM ebx

	align	16
_arpl:
	INC_PCBYTE
	cmp	ah, 0c0h
	mov	eax, 0
	setc	al
	add	si, ax
	add	ax, 10
	I286CLOCK eax
	INT_NUM 6

; 68: push DATA16
	align	16
push_data16:
	I286CLOCK 3
	GET_PCWORD
	REGPUSH1 ax

; 69: imul REG, EA, DATA16
	align	16
imul_reg_ea_data16:
	PREPART_REG16_EA 21, 24
	mov	edx, eax
	GET_PCWORD
	imul	dx
	mov	word [I286_REG + ebx * 2], ax
	mov	al, ah
	lahf
	and	ah, 0feh
	and	byte [I286_FLAGL], 0feh
	or	byte [I286_FLAGL], ah
	rcl	al, 1
	adc	dx, 0
	jne	.imulnooverflow
	or	word [I286_FLAG], (O_FLAG | C_FLAG)
.imulnooverflow:
	ret


; 6A: push DATA8
	align	16
push_data8:
	I286CLOCK 3
	INC_PCBYTE
	mov	al, ah
	cbw
	REGPUSH1 ax

; 6B: imul REG, EA, DATA8
	align	16
imul_reg_ea_data8:
	PREPART_REG16_EA 21, 24
	mov	edx, eax
	GET_PCBYTE
	cbw
	imul	dx
	mov	word [I286_REG + ebx * 2], ax
	mov	al, ah
	lahf
	and	ah, 0feh
	and	byte [I286_FLAGL], 0feh
	or	byte [I286_FLAGL], ah
	rcl	al, 1
	adc	dx, 0
	jne	.imulnooverflow
	or	word [I286_FLAG], (O_FLAG | C_FLAG)
.imulnooverflow:
	ret

; 6C: insb
	align	16
_insb:
	I286CLOCK 5
	mov	cx, word [I286_DX]
	call	@i286_in@4
	mov	dl, al
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	STRING_DIR
	add	word [I286_DI], ax
	jmp	@i286_memorywrite@8

; 6D: insw
	align	16
_insw:
	I286CLOCK 5
	mov	cx, word [I286_DX]
	call	@i286_in_w@4
	mov	dx, ax
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	STRING_DIRx2
	add	word [I286_DI], ax
	jmp	@i286_memorywrite_w@8

; 6E: outsb
	align	16
_outsb:
	I286CLOCK 3
	movzx	ecx, word [I286_SI]
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread@4
	mov	dl, al
	STRING_DIR
	add	word [I286_SI], ax
	mov	cx, word [I286_DX]
	jmp	@i286_out@8

; 6F: outsw
	align	16
_outsw:
	I286CLOCK 3
	movzx	ecx, word [I286_SI]
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread_w@4
	mov	dx, ax
	STRING_DIRx2
	add	word [I286_SI], ax
	mov	cx, word [I286_DX]
	jmp	@i286_out_w@8

; 70: jo short
	align	16
jo_short:
	INC_PCBYTE
	test	word [I286_FLAG], O_FLAG
	jne	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 71: jno short
	align	16
jno_short:
	INC_PCBYTE
	test	word [I286_FLAG], O_FLAG
	je	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 72: jnae/jb/jc short
	align	16
jc_short:
	INC_PCBYTE
	test	word [I286_FLAG], C_FLAG
	jne	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 73: jae/jnb/jnc short
	align	16
jnc_short:
	INC_PCBYTE
	test	word [I286_FLAG], C_FLAG
	je	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 74: je/jz short
	align	16
jz_short:
	INC_PCBYTE
	test	word [I286_FLAG], Z_FLAG
	jne	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 75: jne/jnz short
	align	16
jnz_short:
	INC_PCBYTE
	test	word [I286_FLAG], Z_FLAG
	je	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 76: jna/jbe short
	align	16
jna_short:
	INC_PCBYTE
	test	word [I286_FLAG], (Z_FLAG | C_FLAG)
	jne	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 77: ja/jnbe short
	align	16
ja_short:
	INC_PCBYTE
	test	word [I286_FLAG], (Z_FLAG | C_FLAG)
	je	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 78: js short
	align	16
js_short:
	INC_PCBYTE
	test	word [I286_FLAG], S_FLAG
	jne	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 79: jns short
	align	16
jns_short:
	INC_PCBYTE
	test	word [I286_FLAG], S_FLAG
	je	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 7A: jp/jpe short
	align	16
jp_short:
	INC_PCBYTE
	test	word [I286_FLAG], P_FLAG
	jne	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 7B: jnp/jpo short
	align	16
jnp_short:
	INC_PCBYTE
	test	word [I286_FLAG], P_FLAG
	je	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 7C: jl/jnge short
	align	16
jl_short:
	INC_PCBYTE
	mov	dx, word [I286_FLAG]
	shl	dh, 4
	xor	dl, dh
	js	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 7D: jnl/jge short
	align	16
jnl_short:
	INC_PCBYTE
	mov	dx, word [I286_FLAG]
	shl	dh, 4
	xor	dl, dh
	jns	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 7E: jle/jng short
	align	16
jle_short:
	INC_PCBYTE
	mov	dx, word [I286_FLAG]
	test	dx, Z_FLAG
	jne	.flagjump
	shl	dh, 4
	xor	dl, dh
	js	.flagjump
	I286CLOCK 3
	ret

.flagjump:
	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

; 7F: jg/jnle short
	align	16
jnle_short:
	INC_PCBYTE
	mov	dx, word [I286_FLAG]
	test	dx, Z_FLAG
	jne	.notjump
	shl	dh, 4
	xor	dl, dh
	js	.notjump

	I286CLOCK 7
	mov	al, ah
	cbw
	add	si, ax
	ret

.notjump:
	I286CLOCK 3
	ret

; 80,82: op EA8, DATA8
	align	16
calc_ea8_i8:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK 3
	bt	ax, 2
	rcl	eax, 1
	and	eax, 7
	lea	ebx, [I286_REG + eax]
	GET_PCBYTE
	jmp	[op8xreg8_table + edi * 4]

.memory_eareg8:
	I286CLOCK 7
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMWRITEMAX
	jnc	.extmem_eareg8
	lea	ebx, [I286_MEM + ecx]
	GET_PCBYTE
	jmp	[op8xreg8_table + edi * 4]

.extmem_eareg8:
	call	@i286_memoryread@4
	mov	dl, al
	push	ecx
	GET_PCBYTE
	pop	ecx
	jmp	[op8xext8_table + edi * 4]

; 81: op EA16, DATA16
	align	16
calc_ea16_i16:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 1
	and	edi, 7 * 4	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK 3
	and	eax, 7
	lea	ebx, [I286_REG + eax * 2]
	GET_PCWORD
	jmp	[op8xreg16_table + edi]

.memory_eareg8:
	I286CLOCK 7
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMWRITEMAX
	jnc	.extmem_eareg8
	lea	ebx, [I286_MEM + ecx]
	GET_PCWORD
	jmp	[op8xreg16_table + edi]

.extmem_eareg8:
	call	@i286_memoryread_w@4
	mov	edx, eax
	push	ecx
	GET_PCWORD
	pop	ecx
	jmp	[op8xext16_table + edi]

; 83: op EA16, DATA8
	align	16
calc_ea16_i8:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7		; opcode
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK 3
	and	eax, 7
	lea	ebx, [I286_REG + eax * 2]
	GET_PCBYTE
	cbw
	jmp	[op8xreg16_table + edi * 4]

.memory_eareg8:
	I286CLOCK 7
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, (I286_MEMWRITEMAX - 1)
	jnc	.extmem_eareg8
	lea	ebx, [I286_MEM + ecx]
	GET_PCBYTE
	cbw
	jmp	[op8xreg16_table + edi * 4]

.extmem_eareg8:
	call	@i286_memoryread_w@4
	mov	edx, eax
	push	ecx
	GET_PCBYTE
	cbw
	pop	ecx
	jmp	[op8xext16_table + edi * 4]

; 84: test EA, REG8
	align	16
test_ea_r8:
	PREPART_EA_REG8(2)
	test	byte [I286_REG + eax], dl
	FLAG_STORE0
	ret

	MEMORY_EA_REG8(7)
	test	byte [I286_MEM + ecx], dl
	FLAG_STORE0
	ret

	EXTMEM_EA_REG8
	test	al, byte [I286_REG + ebx]
	FLAG_STORE0
	ret

; 85: test EA, REG16
	align	16
test_ea_r16:
	PREPART_EA_REG16(2)
	test	word [I286_REG + eax * 2], dx
	FLAG_STORE0
	ret

	MEMORY_EA_REG16(6)
	test	word [I286_MEM + ecx], dx
	FLAG_STORE0
	ret

	EXTMEM_EA_REG16
	test	ax, word [I286_REG + ebx * 2]
	FLAG_STORE0
	ret

; 86: xchg EA, REG8
	align	16
xchg_ea_r8:
	GET_PCBYTE_C
	mov	ebx, eax
	shr	ebx, 3
	bt	bx, 2
	rcl	ebx, 1
	and	ebx, 7
	cmp	al, 0c0h
	jc	.memory_eareg8

	bt	ax, 2
	rcl	eax, 1
	and	eax, 7
	I286CLOCK 3
	mov	dl, byte [I286_REG + ebx]
	xchg	dl, byte [I286_REG + eax]
	mov	byte [I286_REG + ebx], dl
	ret

.memory_eareg8:
	I286CLOCK 5
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMREADMAX
	jae	.extmem_eareg8
	mov	dl, byte [I286_REG + ebx]
	xchg	byte [I286_MEM + ecx], dl
	mov	byte [I286_REG + ebx], dl
	ret

.extmem_eareg8:
	call	@i286_memoryread@4
	xchg	al, byte [I286_REG + ebx]
	mov	dl, al
	jmp	@i286_memorywrite@8

; 87: xchg EA, REG16
	align	16
xchg_ea_r16:
	GET_PCBYTE_C
	mov	ebx, eax
	shr	ebx, 3
	and	ebx, 7
	cmp	al, 0c0h
	jc	.memory_eareg16

	and	eax, 7
	I286CLOCK 3
	mov	dx, word [I286_REG + ebx * 2]
	xchg	dx, word [I286_REG + eax * 2]
	mov	word [I286_REG + ebx * 2], dx
	ret

.memory_eareg16:
	I286CLOCK 5
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, (I286_MEMREADMAX - 1)
	jae	.extmem_eareg16
	mov	dx, word [I286_MEM + ecx]
	xchg	dx, word [I286_REG + ebx * 2]
	mov	word [I286_MEM + ecx], dx
	ret

.extmem_eareg16:
	call	@i286_memoryread_w@4
	xchg	ax, word [I286_REG + ebx * 2]
	mov	dx, ax
	jmp	@i286_memorywrite_w@8

; 88: mov EA, REG8
	align	16
mov_ea_r8:
	PREPART_EA_REG8(2)
	mov	byte [I286_REG + eax], dl
	ret

.memory_eareg8:
	I286CLOCK 3
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	mov	dl, byte [I286_REG + ebx]
	jmp	@i286_memorywrite@8

; 89: mov EA, REG16
	align	16
mov_ea_r16:
	PREPART_EA_REG16(2)
	mov	word [I286_REG + eax * 2], dx
	ret

.memory_eareg16:
	I286CLOCK 3
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	mov	dx, word [I286_REG + ebx * 2]
	jmp	@i286_memorywrite_w@8

; 8A: mov REG8, EA
	align	16
mov_r8_ea:
	PREPART_REG8_EA 2, 5
	mov	byte [I286_REG + ebx], al
	ret

; 8B: add REG16, EA
	align	16
mov_r16_ea:
	PREPART_REG16_EA 2, 5
	mov	word [I286_REG + ebx * 2], ax
	ret

; 8C: mov EA, segreg
	align	16
mov_ea_seg:
	GET_PCBYTE_C
	mov	ebx, eax
	shr	ebx, 2
	and	ebx, 3 * 2
	mov	dx, word [I286_SEGREG + ebx]
	cmp	al, 0c0h
	jc	.memory_eareg16

	I286CLOCK 2
	and	eax, 7
	mov	word [I286_REG + eax * 2], dx
	ret

.memory_eareg16:
	I286CLOCK 3
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	jmp	@i286_memorywrite_w@8

; 8D: lea REG16, EA
	align	16
lea_r16_ea:
	GET_PCBYTE_C
	cmp	al, 0c0h
	jnc	.src_register

	I286CLOCK 3
	mov	ebx, eax
	shr	ebx, 2
	and	ebx, 7 * 2
	rol	al, 2
	and	eax, 1fh
	call	[calc_lea + eax * 4]
	mov	word [I286_REG + ebx], ax
	ret

.src_register:
	INT_NUM 6

; 8E: mov segrem, EA
	align	16
mov_seg_ea:
	GET_PCBYTE_C
	mov	ebx, eax
	shr	ebx, 3
	and	ebx, 3
	cmp	ebx, 1
	je	near .fixcs

	cmp	al, 0c0h
	jc	.src_memory

	I286CLOCK 2
	and	eax, 7
	mov	ax, word [I286_REG + eax * 2]
	jmp	.segset

.src_memory:
	I286CLOCK 5
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	call	@i286_memoryread_w@4
.segset:
	mov	word [I286_SEGREG + ebx * 2], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [SEG_BASE + ebx * 4], eax
	sub	ebx, 2
	jc	.segsetr
	mov	dword [SS_FIX + ebx * 4], eax
	je	.setss
.segsetr:
	ret

.setss:
	cmp	dword [i286s + I286STAT.prefix], 0	; 00/05/13
	je	.noprefix
	call	removeprefix
	pop	eax	; eax<-offset removeprefix
.noprefix:
;	GET_PCBYTEEX
;	jmp	[i286op + ebx * 4]
	ret

.fixcs:
	INT_NUM 6

; 8F: pop EA
	align	16
pop_ea:
	I286CLOCK 5
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	call	@i286_memoryread_w@4
	add	word [I286_SP], 2
	mov	dx, ax
	GET_PCBYTE
	cmp	al, 0c0h
	jnc	.src_register

	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	jmp	@i286_memorywrite_w@8

.src_register:
	and	eax, 7
	mov	word [I286_REG + eax * 2], dx
	ret

; 91-97: xchg ax, reg16
	align	16
xchg_ax_reg:
	I286CLOCK 3
	and	ebx, 7
	mov	dx, word [I286_AX]
	xchg	dx, word [I286_REG + ebx * 2]
	mov	word [I286_AX], dx
	ret

; 98: cbw
	align	16
_cbw:
	I286CLOCK 2
	test	byte [I286_AL], 80h
	setz	byte [I286_AH]
	dec	byte [I286_AH]
	ret

; 99: cwd	;
	align	16
_cwd:
	I286CLOCK 2
	mov	ah, byte [I286_AH]
	sar	ax, 15
	mov	word [I286_DX], ax
	ret

; 9A: call far
	align	16
call_far:
	I286CLOCK 13
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	mov	dx, word [I286_CS]
	sub	bx, 2
	lea	ecx, [edi + ebx]
	call	@i286_memorywrite_w@8
	GET_PCWORD
	push	eax
	GET_PCWORD
	mov	word [I286_CS], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	pop	edx
	xchg	si, dx
	sub	bx, 2
	mov	word [I286_SP], bx
	lea	ecx, [edi + ebx]
	jmp	@i286_memorywrite_w@8

; 9B: wait
	align	16
_wait:
	ret

; 9C: pushf
	align	16
_pushf:
	I286CLOCK 3
	mov	dx, word [I286_FLAG]
	and	dh, 0fh
	sub	word [I286_SP], 2
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

; 9D: popf
	align	16
_popf:
	I286CLOCK 5
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	call	@i286_memoryread_w@4
	add	word [I286_SP], 2
	and	ax, 0fffh
	mov	word [I286_FLAG], ax
	and	ah, 3
	cmp	ah, 3
	sete	byte [I286_TRAP]
	I286IRQCHECKTERM

; 9E: sahf
	align	16
_sahf:
	I286CLOCK 2
	mov	al, byte [I286_AH]
	mov	byte [I286_FLAGL], al
	ret

; 9F: lahf
	align	16
_lahf:
	I286CLOCK 2
	mov	al, byte [I286_FLAGL]
	mov	byte [I286_AH], al
	ret

; A0: mov al, m8
	align	16
mov_al_m8:
	I286CLOCK 5
	GET_PCWORD
	movzx	ecx, ax
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread@4
	mov	byte [I286_AL], al
	ret

; A1: mov ax, m16
	align	16
mov_ax_m16:
	I286CLOCK 5
	GET_PCWORD
	movzx	ecx, ax
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread_w@4
	mov	word [I286_AX], ax
	ret

; A2: mov m8, al
	align	16
mov_m8_al:
	I286CLOCK 3
	GET_PCWORD
	mov	dl, byte [I286_AL]
	movzx	ecx, ax
	add	ecx, dword [DS_FIX]
	jmp	@i286_memorywrite@8

; A3: mov m16, ax
	align	16
mov_m16_ax:
	I286CLOCK 3
	GET_PCWORD
	mov	dx, word [I286_AX]
	movzx	ecx, ax
	add	ecx, dword [DS_FIX]
	jmp	@i286_memorywrite_w@8

; A4: movsb
	align	16
_movsb:
	I286CLOCK 5
	movzx	ecx, word [I286_SI]
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread@4
	mov	dl, al
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	STRING_DIR
	add	word [I286_SI], ax
	add	word [I286_DI], ax
	jmp	@i286_memorywrite@8

; A5: movsw
	align	16
_movsw:
	I286CLOCK 5
	movzx	ecx, word [I286_SI]
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread_w@4
	mov	dx, ax
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	STRING_DIRx2
	add	word [I286_SI], ax
	add	word [I286_DI], ax
	jmp	@i286_memorywrite_w@8

; A6: cmpsb
	align	16
_cmpsb:
	I286CLOCK 8
	movzx	ecx, word [I286_SI]
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread@4
	mov	bl, al
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	call	@i286_memoryread@4
	cmp	bl, al
	FLAG_STORE_OF
	STRING_DIR
	add	word [I286_SI], ax
	add	word [I286_DI], ax
	ret

; A7: cmpsw
	align	16
_cmpsw:
	I286CLOCK 8
	movzx	ecx, word [I286_SI]
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread_w@4
	mov	bx, ax
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	call	@i286_memoryread_w@4
	cmp	bx, ax
	FLAG_STORE_OF
	STRING_DIRx2
	add	word [I286_SI], ax
	add	word [I286_DI], ax
	ret

; A8: test al, DATA8
	align	16
test_al_data8:
	I286CLOCK 3
	INC_PCBYTE
	test	byte [I286_AL], ah
	FLAG_STORE0
	ret

; A9: test ax, DATA16
	align	16
test_ax_data16:
	I286CLOCK 3
	GET_PCWORD
	test	word [I286_AX], ax
	FLAG_STORE0
	ret

; AA: stosb
	align	16
_stosb:
	I286CLOCK 3
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	STRING_DIR
	add	word [I286_DI], ax
	mov	dl, byte [I286_AL]
	jmp	@i286_memorywrite@8

; AB: stosw
	align	16
_stosw:
	I286CLOCK 3
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	STRING_DIRx2
	add	word [I286_DI], ax
	mov	dx, word [I286_AX]
	jmp	@i286_memorywrite_w@8

; AC: lodsb
	align	16
_lodsb:
	I286CLOCK 5
	movzx	ecx, word [I286_SI]
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread@4
	mov	byte [I286_AL], al
	STRING_DIR
	add	word [I286_SI], ax
	ret

; AD: lodsw
	align	16
_lodsw:
	I286CLOCK 5
	movzx	ecx, word [I286_SI]
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread_w@4
	mov	word [I286_AX], ax
	STRING_DIRx2
	add	word [I286_SI], ax
	ret

; AE: scasb
	align	16
_scasb:
	I286CLOCK 7
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	call	@i286_memoryread@4
	cmp	byte [I286_AL], al
	FLAG_STORE_OF
	STRING_DIR
	add	word [I286_DI], ax
	ret

; AF: scasw
	align	16
_scasw:
	I286CLOCK 7
	movzx	ecx, word [I286_ES]
	shl	ecx, 4
	movzx	eax, word [I286_DI]
	add	ecx, eax
	call	@i286_memoryread_w@4
	cmp	word [I286_AX], ax
	FLAG_STORE_OF
	STRING_DIRx2
	add	word [I286_DI], ax
	ret

; B0: mov al, imm8
	align	16
mov_al_imm:
	I286CLOCK 2
	INC_PCBYTE
	mov	byte [I286_AL], ah
	ret

; B1: mov cl, imm8
	align	16
mov_cl_imm:
	I286CLOCK 2
	INC_PCBYTE
	mov	byte [I286_CL], ah
	ret

; B2: mov dl, imm8
	align	16
mov_dl_imm:
	I286CLOCK 2
	INC_PCBYTE
	mov	byte [I286_DL], ah
	ret

; B3: mov bl, imm8
	align	16
mov_bl_imm:
	I286CLOCK 2
	INC_PCBYTE
	mov	byte [I286_BL], ah
	ret

; B4: mov ah, imm8
	align	16
mov_ah_imm:
	I286CLOCK 2
	INC_PCBYTE
	mov	byte [I286_AH], ah
	ret

; B5: mov ch, imm8
	align	16
mov_ch_imm:
	I286CLOCK 2
	INC_PCBYTE
	mov	byte [I286_CH], ah
	ret

; B6: mov dh, imm8
	align	16
mov_dh_imm:
	I286CLOCK 2
	INC_PCBYTE
	mov	byte [I286_DH], ah
	ret

; B7: mov bh, imm8
	align	16
mov_bh_imm:
	I286CLOCK 2
	INC_PCBYTE
	mov	byte [I286_BH], ah
	ret

; B8: mov ax, imm16
	align	16
mov_ax_imm:
	I286CLOCK 2
	GET_PCWORD
	mov	word [I286_AX], ax
	ret

; B9: mov cx, imm16
	align	16
mov_cx_imm:
	I286CLOCK 2
	GET_PCWORD
	mov	word [I286_CX], ax
	ret

; BA: mov dx, imm16
	align	16
mov_dx_imm:
	I286CLOCK 2
	GET_PCWORD
	mov	word [I286_DX], ax
	ret

; BB: mov bx, imm16
	align	16
mov_bx_imm:
	I286CLOCK 2
	GET_PCWORD
	mov	word [I286_BX], ax
	ret

; BC: mov sp, imm16
	align	16
mov_sp_imm:
	I286CLOCK 2
	GET_PCWORD
	mov	word [I286_SP], ax
	ret

; BD: mov bp, imm16
	align	16
mov_bp_imm:
	I286CLOCK 2
	GET_PCWORD
	mov	word [I286_BP], ax
	ret

; BE: mov si, imm16
	align	16
mov_si_imm:
	I286CLOCK 2
	GET_PCWORD
	mov	word [I286_SI], ax
	ret

; BF: mov di, imm16
	align	16
mov_di_imm:
	I286CLOCK 2
	GET_PCWORD
	mov	word [I286_DI], ax
	ret

; C0: shift EA8, DATA8
	align	16
shift_ea8_data8:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK 5
	bt	ax, 2
	rcl	eax, 1
	and	eax, 7
	lea	ebx, [I286_REG + eax]
	GET_PCBYTE
	mov	ecx, eax
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftreg8cl_table + edi * 4]

.memory_eareg8:
	I286CLOCK 8
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMWRITEMAX
	jnc	.extmem_eareg8

	lea	ebx, [I286_MEM + ecx]
	GET_PCBYTE
	mov	ecx, eax
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftreg8cl_table + edi * 4]

.extmem_eareg8:
	call	@i286_memoryread@4
	mov	edx, eax
	GET_PCBYTE
	mov	ecx, eax
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftext8cl_table + edi * 4]

; C1: shift EA16, DATA8
	align	16
shift_ea16_data8:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg16

	and	eax, 7
	I286CLOCK 5
	lea	ebx, [I286_REG + eax * 2]
	GET_PCBYTE
	mov	ecx, eax
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftreg16cl_table + edi * 4]

.memory_eareg16:
	I286CLOCK 8
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, (I286_MEMWRITEMAX-1)
	jnc	.extmem_eareg16
	lea	ebx, [I286_MEM + ecx]
	GET_PCBYTE
	mov	ecx, eax
	and	ecx, 31
	I286CLOCK ecx
	jmp	[sftreg16cl_table + edi * 4]

.extmem_eareg16:
	call	@i286_memoryread_w@4
	mov	edx, eax
	mov	ebx, ecx
	GET_PCBYTE
	mov	ecx, eax
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftext16cl_table + edi * 4]

; C2: ret near DATA16
	align	16
ret_near_data16:
	I286CLOCK 11
	GET_PCWORD
	movzx	ecx, word [I286_SP]
	add	ax, 2
	add	word [I286_SP], ax
	add	ecx, dword [SS_BASE]
	call	@i286_memoryread_w@4
	mov	si, ax
	ret

; C3: ret near
	align	16
ret_near:
	I286CLOCK 11
	REGPOP si
	ret

; C4: les REG16, EA
	align	16
les_r16_ea:
	GET_PCBYTE_C
	cmp	al, 0c0h
	jnc	.src_register

	I286CLOCK 3
	push	eax
	rol	al, 2
	and	eax, 1fh
	call	[get_ea + eax * 4]
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	pop	edx
	shr	edx, 2
	and	edx, 14
	mov	word [I286_REG + edx], ax
	add	bx, 2
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_ES], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [ES_BASE], eax
	ret

.src_register:
	INT_NUM 6

; C5: lds REG16, EA
	align	16
lds_r16_ea:
	GET_PCBYTE_C
	cmp	al, 0c0h
	jnc	.src_register

	I286CLOCK 3
	push	eax
	rol	al, 2
	and	eax, 1fh
	call	[get_ea + eax * 4]
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	pop	edx
	shr	edx, 2
	and	edx, 14
	mov	word [I286_REG + edx], ax
	add	bx, 2
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_DS], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [DS_BASE], eax
	mov	dword [DS_FIX], eax
	ret

.src_register:
	INT_NUM 6

; C6: mov EA8, DATA8
	align	16
mov_ea8_data8:
	GET_PCBYTE_C
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK 2
	bt	ax, 2
	rcl	eax, 1
	and	eax, 7
	mov	ebx, eax
	GET_PCBYTE
	mov	byte [I286_REG + ebx], al
	ret

.memory_eareg8:
	I286CLOCK 3
	rol	al, 2
	and	eax, 1fh
	call	[get_ea + eax * 4]
	GET_PCBYTE
	mov	dx, ax
	lea	ecx, [edi + ebx]
	jmp	@i286_memorywrite@8

; C7: mov EA16, DATA16
	align	16
mov_ea16_data16:
	GET_PCBYTE_C
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK 2
	and	eax, 7
	lea	ebx, [I286_REG + eax * 2]
	GET_PCWORD
	mov	[ebx], ax
	ret

.memory_eareg8:
	I286CLOCK 3
	rol	al, 2
	and	eax, 1fh
	call	[get_ea + eax * 4]
	GET_PCWORD
	mov	dx, ax
	lea	ecx, [edi + ebx]
	jmp	@i286_memorywrite_w@8

; C8: enter DATA16, DATA8
	align	16
_enter:
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	GET_PCWORD
	push	eax
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_BP]
	call	@i286_memorywrite_w@8
	GET_PCBYTE
	and	eax, 1fh
	je	.enter0
	dec	eax
	je	.enter1

	lea	ecx, [eax * 4 + 12]
	I286CLOCK ecx
	push	ebp
	movzx	ebp, word [I286_BP]
	mov	word [I286_BP], bx
.enter_lp:
	push	eax
	sub	bp, 2
	lea	ecx, [edi + ebp]
	call	@i286_memoryread_w@4
	mov	edx, eax
	sub	bx, 2
	lea	ecx, [edi + ebx]
	call	@i286_memorywrite_w@8
	pop	eax
	dec	eax
	jne	.enter_lp
	pop	ebp
	pop	eax
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_BP]
	sub	bx, ax
	mov	word [I286_SP], bx
	jmp	@i286_memorywrite_w@8

.enter0:
	I286CLOCK 11
	mov	word [I286_BP], bx
	pop	eax
	sub	bx, ax
	mov	word [I286_SP], bx
	ret

.enter1:
	I286CLOCK 15
	mov	dx, bx
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	word [I286_BP], dx
	pop	eax
	sub	bx, ax
	mov	word [I286_SP], bx
	jmp	@i286_memorywrite_w@8

; C9: leave
	align	16
_leave:
	I286CLOCK 5
	mov	ax, word [I286_BP]
	mov	word [I286_SP], ax
	REGPOP word [I286_BP]
	ret

; CA: ret far DATA16
	align	16
ret_far_data16:
	I286CLOCK 15
	GET_PCWORD
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	add	word [I286_SP], ax
	lea	ecx, [edi + ebx]
	add	bx, 2
	call	@i286_memoryread_w@4
	mov	si, ax
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_CS], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	add	word [I286_SP], 4
	ret

; CB: ret far
	align	16
ret_far:
	I286CLOCK 15
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	lea	ecx, [edi + ebx]
	add	bx, 2
	call	@i286_memoryread_w@4
	mov	si, ax
	lea	ecx, [edi + ebx]
	add	bx, 2
	call	@i286_memoryread_w@4
	mov	word [I286_CS], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	mov	word [I286_SP], bx
	ret

; CC: int 3
	align	16
int_03:
	I286CLOCK 23
	INT_NUM 3

; CD: int DATA8
	align	16
int_data8:
	I286CLOCK 23
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	sub	bx, 2
	mov	dx, word [I286_FLAG]
	and	word [I286_FLAG], ~(T_FLAG | I_FLAG)
	mov	dword [I286_TRAP], 0
	lea	ecx, [edi + ebx]
	call	@i286_memorywrite_w@8
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_CS]
	call	@i286_memorywrite_w@8
	GET_PCBYTE
	and	eax, 0ffh
	sub	bx, 2
	mov	word [I286_SP], bx
	lea	ecx, [edi + ebx]
	mov	dx, si
	mov	eax, dword [I286_MEM + eax * 4]
	mov	si, ax
	shr	eax, 16
	mov	word [I286_CS], ax
	shl	eax, 4			; make segreg
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	jmp	@i286_memorywrite_w@8

; CE: into
	align	16
_into:
	test	word [I286_FLAG], O_FLAG
	jne	.intovf
	I286CLOCK 4
	ret

.intovf:
	I286CLOCK 24
	INT_NUM 4

; CF: iret
	align	16
_iret:
	I286CLOCK 31
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	lea	ecx, [edi + ebx]
	add	bx, 2
	call	@i286_memoryread_w@4
	mov	si, ax
	lea	ecx, [edi + ebx]
	add	bx, 2
	call	@i286_memoryread_w@4
	mov	word [I286_CS], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	lea	ecx, [edi + ebx]
	add	bx, 2
	call	@i286_memoryread_w@4
	mov	word [I286_SP], bx
	and	ax, 0fffh
	mov	word [I286_FLAG], ax
	and	ah, 3
	cmp	ah, 3
	sete	byte [I286_TRAP]
	I286IRQCHECKTERM

; D0: shift EA8, 1
	align	16
shift_ea8_1:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg8

	bt	ax, 2
	rcl	eax, 1
	and	eax, 7
	I286CLOCK 2
	mov	ecx, ebx
	jmp	[sftreg8_table + edi * 4]

.memory_eareg8:
	I286CLOCK 7
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMWRITEMAX
	jnc	.extmem_eareg8
	jmp	[sftmem8_table + edi * 4]

.extmem_eareg8:
	call	@i286_memoryread@4
	mov	edx, eax
	jmp	[sftext8_table + edi * 4]

; D1: shift EA16, 1
	align	16
shift_ea16_1:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg16

	I286CLOCK 2
	and	eax, 7
	jmp	[sftreg16_table + edi * 4]

.memory_eareg16:
	I286CLOCK 7
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, (I286_MEMWRITEMAX-1)
	jnc	.extmem_eareg16
	jmp	[sftmem16_table + edi * 4]

.extmem_eareg16:
	call	@i286_memoryread_w@4
	mov	edx, eax
	jmp	[sftext16_table + edi * 4]


; D2: shift EA8, cl
	align	16
shift_ea8_cl:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK 5
	bt	ax, 2
	rcl	eax, 1
	and	eax, 7
	lea	ebx, [I286_REG + eax]
	movzx	ecx, byte [I286_CL]
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftreg8cl_table + edi * 4]

.memory_eareg8:
	I286CLOCK 8
	rol	al, 2
	and	eax, 31
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMWRITEMAX
	jnc	.extmem_eareg8

	lea	ebx, [I286_MEM + ecx]
	movzx	ecx, byte [I286_CL]
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftreg8cl_table + edi * 4]

.extmem_eareg8:
	call	@i286_memoryread@4
	mov	edx, eax
	mov	ebx, ecx
	movzx	ecx, byte [I286_CL]
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftext8cl_table + edi * 4]

; D3: shift EA16, cl
	align	16
shift_ea16_cl:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg16

	I286CLOCK 5
	and	eax, 7
	lea	ebx, [I286_REG + eax * 2]
	movzx	ecx, byte [I286_CL]
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftreg16cl_table + edi * 4]

.memory_eareg16:
	I286CLOCK 8
	rol	al, 2
	and	eax, 31
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, (I286_MEMWRITEMAX-1)
	jnc	.extmem_eareg16
	lea	ebx, [I286_MEM + ecx]
	movzx	ecx, byte [I286_CL]
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftreg16cl_table + edi * 4]

.extmem_eareg16:
	call	@i286_memoryread_w@4
	mov	edx, eax
	mov	ebx, ecx
	movzx	ecx, byte [I286_CL]
	and	ecx, 1fh
	I286CLOCK ecx
	jmp	[sftext16cl_table + edi * 4]


; D4: AAM
; TODO: flag !!!
	align	16
_aam:
	GET_PCBYTE_C
	cmp	al, 0
	je	.div0

	I286CLOCK 16
	mov	cl, al
	movzx	eax, byte [I286_AL]
	div	cl
	xchg	al, ah
	mov	word [I286_AX], ax
	and	byte [I286_FLAGL], ~(S_FLAG | Z_FLAG | P_FLAG)
	mov	dh, ah
	and	dh, S_FLAG
	or	ax, ax
	jne	short .nzflagsed
	or	dh, Z_FLAG

.nzflagsed:
	xor	al, ah
	and	eax, 00ffh
	mov	al, byte [iflags + eax]
	and	al, P_FLAG
	or	al, dh
	or	byte [I286_FLAGL], al
	ret

.div0:
	INT_NUM 0

; D5: AAD
; TODO: flag !!!
	align	16
_aad:
	I286CLOCK 14
	INC_PCBYTE
	mov	al, byte [I286_AH]
	mul	ah
	add	al, byte [I286_AL]
	mov	ah, 0
	mov	word [I286_AX], ax
	and	byte [I286_FLAGL], ~(S_FLAG | Z_FLAG | P_FLAG)
	and	eax, 00ffh
	mov	al, byte [iflags + eax]
	and	al, (P_FLAG | Z_FLAG)
	or	byte [I286_FLAGL], al
	ret

; D6: setalc(80286)
	align	16
_setalc:
	setnc	byte [I286_AL]
	dec	byte [I286_AL]
	ret

; D7: xlat
	align	16
_xlat:
	I286CLOCK 5
	movzx	ecx, byte [I286_AL]
	add	cx, word [I286_BX]
	add	ecx, dword [DS_FIX]
	call	@i286_memoryread@4
	mov	byte [I286_AL], al
	ret

; D8-DF: esc
	align	16
_esc:
	GET_PCBYTE_C
	cmp	al, 0c0h
	jnc	.ea_reg8

	rol	al, 2
	and	eax, 1fh
	call	[calc_lea + eax * 4]

.ea_reg8:
	ret

; E0: loopnz
	align	16
_loopnz:
	INC_PCBYTE
	dec	word [I286_CX]
	je	.loopend
	test	word [I286_FLAG], Z_FLAG
	jne	.loopend

	I286CLOCK 8
	mov	al, ah
	cbw
	add	si, ax
	ret

.loopend:
	I286CLOCK 4
	ret

; E1: loopz
	align	16
_loopz:
	INC_PCBYTE
	dec	word [I286_CX]
	je	.loopend
	test	word [I286_FLAG], Z_FLAG
	je	.loopend

	I286CLOCK 8
	mov	al, ah
	cbw
	add	si, ax
	ret

.loopend:
	I286CLOCK 4
	ret

; E2: loop
	align	16
_loop:
	INC_PCBYTE
	dec	word [I286_CX]
	je	.loopend

	I286CLOCK 8
	mov	al, ah
	cbw
	add	si, ax
	ret

.loopend:
	I286CLOCK 4
	ret

; E3: jcxz
	align	16
_jcxz:
	INC_PCBYTE
	cmp	word [I286_CX], 0
	jne	.loopend

	I286CLOCK 8
	mov	al, ah
	cbw
	add	si, ax
	ret

.loopend:
	I286CLOCK 4
	ret

; E4: in al, DATA8
	align	16
in_al_data8:
	I286CLOCK 5
	INC_PCBYTE
	movzx	ecx, ah
	call	@i286_in@4
	mov	byte [I286_AL], al
	ret

; E5: in ax, DATA8
	align	16
in_ax_data8:
	I286CLOCK 5
	INC_PCBYTE
	movzx	ecx, ah
	call	@i286_in_w@4
	mov	word [I286_AX], ax
	ret

; E6: out DATA8, al
	align	16
out_data8_al:
	I286CLOCK 3
	INC_PCBYTE
	movzx	ecx, ah
	mov	dl, byte [I286_AL]
	jmp	@i286_out@8

; E7: out DATA8, ax
	align	16
out_data8_ax:
	I286CLOCK 3
	INC_PCBYTE
	movzx	ecx, ah
	mov	dx, word [I286_AX]
	jmp	@i286_out_w@8

; E8: call near
	align	16
call_near:
	I286CLOCK 7
	GET_PCWORD
	mov	dx, si
	add	si, ax
	sub	word [I286_SP], 2
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

; E9: jmp near
	align	16
jmp_near:
	I286CLOCK 7
	GET_PCWORD
	add	si, ax
	ret

; EA: jmp far
	align	16
jmp_far:
	I286CLOCK 11
	GET_PCWORD
	push	eax
	GET_PCWORD
	mov	word [I286_CS], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	pop	esi
	and	esi, 0x0000ffff
	ret

; EB: jmp short
	align	16
jmp_short:
	I286CLOCK 7
	INC_PCBYTE
	mov	al, ah
	cbw
	add	si, ax
	ret

; EC: in al, dx
	align	16
in_al_dx:
	I286CLOCK 5
	mov	cx, word [I286_DX]
	call	@i286_in@4
	mov	byte [I286_AL], al
	ret

; ED: in ax, dx
	align	16
in_ax_dx:
	I286CLOCK 5
	mov	cx, word [I286_DX]
	call	@i286_in_w@4
	mov	word [I286_AX], ax
	ret

; EE: out dx, al
	align	16
out_dx_al:
	I286CLOCK 3
	mov	cx, word [I286_DX]
	mov	dl, byte [I286_AL]
	jmp	@i286_out@8

; EF: out dx, ax
	align	16
out_dx_ax:
	I286CLOCK 3
	mov	cx, word [I286_DX]
	mov	dx, word [I286_AX]
	jmp	@i286_out_w@8

; F0: lock
	align	16
_lock:
	ret

; F2: repne
	align	16
_repne:
	GET_PCBYTEEX
	jmp	[i286op_repne + ebx * 4]

; F3: repe
	align	16
_repe:
	GET_PCBYTEEX
	jmp	[i286op_repe + ebx * 4]

; F4: hlt
	align	16
_hlt:
	mov	dword [nevent + nevent_t.remainclock], -1
	dec	si
	ret

; F5: cmc
	align	16
_cmc:
	I286CLOCK 2
	xor	word [I286_FLAG], C_FLAG
	ret

; F6: 
	align	16
_ope0xf6:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 1
	and	edi, 7 * 4
	jmp	[ope0xf6_table + edi]

; F7: 
	align	16
_ope0xf7:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 1
	and	edi, 7 * 4
	jmp	[ope0xf7_table + edi]

; F8: clc
	align	16
_clc:
	I286CLOCK 2
	and	word [I286_FLAG], ~C_FLAG
	ret

; F9: stc
	align	16
_stc:
	I286CLOCK 2
	or	word [I286_FLAG], C_FLAG
	ret

; FA: cli
	align	16
_cli:
	I286CLOCK 2
	and	word [I286_FLAG], ~I_FLAG
	mov	dword [I286_TRAP], 0
	ret

; FB: sti
	align	16
_sti:
	I286CLOCK 2
	or	word [I286_FLAG], I_FLAG
	test	word [I286_FLAG], T_FLAG
	setne	byte [I286_TRAP]

	cmp	dword [i286s + I286STAT.prefix], 0	; ver0.26 00/10/08
	je	.noprefix
	call	removeprefix
	pop	eax	; eax<-offset removeprefix

.noprefix:
	GET_PCBYTEEX
	call	[i286op + ebx * 4]

	I286IRQCHECKTERM

; FC: cld
	align	16
_cld:
	I286CLOCK 2
	and	word [I286_FLAG], ~D_FLAG
	ret

; FD: std
	align	16
_std:
	I286CLOCK 2
	or	word [I286_FLAG], D_FLAG
	ret

; FE: 
	align	16
_ope0xfe:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 1
	and	edi, 1 * 4
	jmp	[ope0xfe_table + edi]

; FF: 
	align	16
_ope0xff:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 1
	and	edi, 7 * 4
	jmp	[ope0xff_table + edi]

; -------------------------------------------------------------------------

section .data

	align	16
i286op	dd	add_ea_r8		; 00:	add	EA, REG8
	dd	add_ea_r16		; 01:	add	EA, REG16
	dd	add_r8_ea		; 02:	add	REG8, EA
	dd	add_r16_ea		; 03:	add	REG16, EA
	dd	add_al_data8		; 04:	add	al, DATA8
	dd	add_ax_data16		; 05:	add	ax, DATA16
	dd	push_es			; 06:	push	es
	dd	pop_es			; 07:	pop	es
	dd	or_ea_r8		; 08:	or	EA, REGF8
	dd	or_ea_r16		; 09:	or	EA, REG16
	dd	or_r8_ea		; 0A:	or	REG8, EA
	dd	or_r16_ea		; 0B:	or	REG16, EA
	dd	or_al_data8		; 0C:	or	al, DATA8
	dd	or_ax_data16		; 0D:	or	ax, DATA16
	dd	push_cs			; 0E:	push	cs
	dd	_cts			; 0F:	i286 upper opcode

	dd	adc_ea_r8		; 10:	adc	EA, REG8
	dd	adc_ea_r16		; 11:	adc	EA, REG16
	dd	adc_r8_ea		; 12:	adc	REG8, EA
	dd	adc_r16_ea		; 13:	adc	REG16, EA
	dd	adc_al_data8		; 14:	adc	al, DATA8
	dd	adc_ax_data16		; 15:	adc	ax, DATA16
	dd	push_ss			; 16:	push	ss
	dd	pop_ss			; 17:	pop	ss
	dd	sbb_ea_r8		; 18:	sbb	EA, REG8
	dd	sbb_ea_r16		; 19:	sbb	EA, REG16
	dd	sbb_r8_ea		; 1A:	sbb	REG8, EA
	dd	sbb_r16_ea		; 1B:	sbb	REG16, EA
	dd	sbb_al_data8		; 1C:	sbb	al, DATA8
	dd	sbb_ax_data16		; 1D:	sbb	ax, DATA16
	dd	push_ds			; 1E:	push	ds
	dd	pop_ds			; 1F:	pop	ds

	dd	and_ea_r8		; 20:	and	EA, REG8
	dd	and_ea_r16		; 21:	and	EA, REG16
	dd	and_r8_ea		; 22:	and	REG8, EA
	dd	and_r16_ea		; 23:	and	REG16, EA
	dd	and_al_data8		; 24:	and	al, DATA8
	dd	and_ax_data16		; 25:	and	ax, DATA16
	dd	segprefix_es		; 26:	es:
	dd	_daa			; 27:	daa
	dd	sub_ea_r8		; 28:	sub	EA, REG8
	dd	sub_ea_r16		; 29:	sub	EA, REG16
	dd	sub_r8_ea		; 2A:	sub	REG8, EA
	dd	sub_r16_ea		; 2B:	sub	REG16, EA
	dd	sub_al_data8		; 2C:	sub	al, DATA8
	dd	sub_ax_data16		; 2D:	sub	ax, DATA16
	dd	segprefix_cs		; 2E:	cs:
	dd	_das			; 2F:	das

	dd	xor_ea_r8		; 30:	xor	EA, REG8
	dd	xor_ea_r16		; 31:	xor	EA, REG16
	dd	xor_r8_ea		; 32:	xor	REG8, EA
	dd	xor_r16_ea		; 33:	xor	REG16, EA
	dd	xor_al_data8		; 34:	xor	al, DATA8
	dd	xor_ax_data16		; 35:	xor	ax, DATA16
	dd	segprefix_ss		; 36:	ss:
	dd	_aaa			; 37:	aaa
	dd	cmp_ea_r8		; 38:	cmp	EA, REG8
	dd	cmp_ea_r16		; 39:	cmp	EA, REG16
	dd	cmp_r8_ea		; 3A:	cmp	REG8, EA
	dd	cmp_r16_ea		; 3B:	cmp	REG16, EA
	dd	cmp_al_data8		; 3C:	cmp	al, DATA8
	dd	cmp_ax_data16		; 3D:	cmp	ax, DATA16
	dd	segprefix_ds		; 3E:	ds:
	dd	_aas			; 3F:	aas

	dd	inc_reg16		; 40:	inc	ax
	dd	inc_reg16		; 41:	inc	cx
	dd	inc_reg16		; 42:	inc	dx
	dd	inc_reg16		; 43:	inc	bx
	dd	inc_reg16		; 44:	inc	sp
	dd	inc_reg16		; 45:	inc	bp
	dd	inc_reg16		; 46:	inc	si
	dd	inc_reg16		; 47:	inc	di
	dd	dec_reg16		; 48:	dec	ax
	dd	dec_reg16		; 49:	dec	cx
	dd	dec_reg16		; 4A:	dec	dx
	dd	dec_reg16		; 4B:	dec	bx
	dd	dec_reg16		; 4C:	dec	sp
	dd	dec_reg16		; 4D:	dec	bp
	dd	dec_reg16		; 4E:	dec	si
	dd	dec_reg16		; 4F:	dec	di

	dd	push_ax			; 50:	push	ax
	dd	push_cx			; 51:	push	cx
	dd	push_dx			; 52:	push	dx
	dd	push_bx			; 53:	push	bx
	dd	push_sp			; 54:	push	sp
	dd	push_bp			; 55:	push	bp
	dd	push_si			; 56:	push	si
	dd	push_di			; 57:	push	di
	dd	pop_ax			; 58:	pop	ax
	dd	pop_cx			; 59:	pop	cx
	dd	pop_dx			; 5A:	pop	dx
	dd	pop_bx			; 5B:	pop	bx
	dd	pop_sp			; 5C:	pop	sp
	dd	pop_bp			; 5D:	pop	bp
	dd	pop_si			; 5E:	pop	si
	dd	pop_di			; 5F:	pop	di

	dd	_pusha			; 60:	pusha
	dd	_popa			; 61:	popa
	dd	_bound			; 62:	bound
	dd	_arpl			; 63:	arpl
	dd	_reserved		; 64:	reserved
	dd	_reserved		; 65:	reserved
	dd	_reserved		; 66:	reserved
	dd	_reserved		; 67:	reserved
	dd	push_data16		; 68:	push	DATA16
	dd	imul_reg_ea_data16	; 69:	imul	REG, EA, DATA16
	dd	push_data8		; 6A:	push	DATA8
	dd	imul_reg_ea_data8	; 6B:	imul	REG, EA, DATA8
	dd	_insb			; 6C:	insb
	dd	_insw			; 6D:	insw
	dd	_outsb			; 6E:	outsb
	dd	_outsw			; 6F:	outsw

	dd	jo_short		; 70:	jo short
	dd	jno_short		; 71:	jno short
	dd	jc_short		; 72:	jnae/jb/jc short
	dd	jnc_short		; 73:	jae/jnb/jnc short
	dd	jz_short		; 74:	je/jz short
	dd	jnz_short		; 75:	jne/jnz short
	dd	jna_short		; 76:	jna/jbe short
	dd	ja_short		; 77:	ja/jnbe short
	dd	js_short		; 78:	js short
	dd	jns_short		; 79:	jns short
	dd	jp_short		; 7A:	jp/jpe short
	dd	jnp_short		; 7B:	jnp/jpo short
	dd	jl_short		; 7C:	jl/jnge short
	dd	jnl_short		; 7D:	jnl/jge short
	dd	jle_short		; 7E:	jle/jng short
	dd	jnle_short		; 7F:	jg/jnle short

	dd	calc_ea8_i8		; 80:	op	EA8, DATA8
	dd	calc_ea16_i16		; 81:	op	EA16, DATA16
	dd	calc_ea8_i8		; 82:	op	EA8, DATA8
	dd	calc_ea16_i8		; 83:	op	EA16, DATA8
	dd	test_ea_r8		; 84:	test	EA, REG8
	dd	test_ea_r16		; 85:	test	EA, REG16
	dd	xchg_ea_r8		; 86:	xchg	EA, REG8
	dd	xchg_ea_r16		; 87:	xchg	EA, REG16
	dd	mov_ea_r8		; 88:	mov	EA, REG8
	dd	mov_ea_r16		; 89:	mov	EA, REG16
	dd	mov_r8_ea		; 8A:	mov	REG8, EA
	dd	mov_r16_ea		; 8B:	add	REG16, EA
	dd	mov_ea_seg		; 8C:	mov	EA, segreg
	dd	lea_r16_ea		; 8D:	lea	REG16, EA
	dd	mov_seg_ea		; 8E:	mov	segrem, EA
	dd	pop_ea			; 8F:	pop	EA

	dd	_nop			; 90:	xchg	ax, ax
	dd	xchg_ax_reg		; 91:	xchg	ax, cx
	dd	xchg_ax_reg		; 92:	xchg	ax, dx
	dd	xchg_ax_reg		; 93:	xchg	ax, bx
	dd	xchg_ax_reg		; 94:	xchg	ax, sp
	dd	xchg_ax_reg		; 95:	xchg	ax, bp
	dd	xchg_ax_reg		; 96:	xchg	ax, si
	dd	xchg_ax_reg		; 97:	xchg	ax, di
	dd	_cbw			; 98:	cbw
	dd	_cwd			; 99:	cwd
	dd	call_far		; 9A:	call far
	dd	_wait			; 9B:	wait
	dd	_pushf			; 9C:	pushf
	dd	_popf			; 9D:	popf
	dd	_sahf			; 9E:	sahf
	dd	_lahf			; 9F:	lahf

	dd	mov_al_m8		; A0:	mov	al, m8
	dd	mov_ax_m16		; A1:	mov	ax, m16
	dd	mov_m8_al		; A2:	mov	m8, al
	dd	mov_m16_ax		; A3:	mov	m16, ax
	dd	_movsb			; A4:	movsb
	dd	_movsw			; A5:	movsw
	dd	_cmpsb			; A6:	cmpsb
	dd	_cmpsw			; A7:	cmpsw
	dd	test_al_data8		; A8:	test	al, DATA8
	dd	test_ax_data16		; A9:	test	ax, DATA16
	dd	_stosb			; AA:	stosw
	dd	_stosw			; AB:	stosw
	dd	_lodsb			; AC:	lodsb
	dd	_lodsw			; AD:	lodsw
	dd	_scasb			; AE:	scasb
	dd	_scasw			; AF:	scasw

	dd	mov_al_imm		; B0:	mov	al, imm8
	dd	mov_cl_imm		; B1:	mov	cl, imm8
	dd	mov_dl_imm		; B2:	mov	dl, imm8
	dd	mov_bl_imm		; B3:	mov	bl, imm8
	dd	mov_ah_imm		; B4:	mov	ah, imm8
	dd	mov_ch_imm		; B5:	mov	ch, imm8
	dd	mov_dh_imm		; B6:	mov	dh, imm8
	dd	mov_bh_imm		; B7:	mov	bh, imm8
	dd	mov_ax_imm		; B8:	mov	ax, imm16
	dd	mov_cx_imm		; B9:	mov	cx, imm16
	dd	mov_dx_imm		; BA:	mov	dx, imm16
	dd	mov_bx_imm		; BB:	mov	bx, imm16
	dd	mov_sp_imm		; BC:	mov	sp, imm16
	dd	mov_bp_imm		; BD:	mov	bp, imm16
	dd	mov_si_imm		; BE:	mov	si, imm16
	dd	mov_di_imm		; BF:	mov	di, imm16

	dd	shift_ea8_data8		; C0:	shift	EA8, DATA8
	dd	shift_ea16_data8	; C1:	shift	EA16, DATA8
	dd	ret_near_data16		; C2:	ret near DATA16
	dd	ret_near		; C3:	ret near
	dd	les_r16_ea		; C4:	les	REG16, EA
	dd	lds_r16_ea		; C5:	lds	REG16, EA
	dd	mov_ea8_data8		; C6:	mov	EA8, DATA8
	dd	mov_ea16_data16		; C7:	mov	EA16, DATA16
	dd	_enter			; C8:	enter	DATA16, DATA8
	dd	_leave			; C9:	leave
	dd	ret_far_data16		; CA:	ret far	DATA16
	dd	ret_far			; CB:	ret far
	dd	int_03			; CC:	int	3
	dd	int_data8		; CD:	int	DATA8
	dd	_into			; CE:	into
	dd	_iret			; CF:	iret

	dd	shift_ea8_1		; D0:	shift EA8, 1
	dd	shift_ea16_1		; D1:	shift EA16, 1
	dd	shift_ea8_cl		; D2:	shift EA8, cl
	dd	shift_ea16_cl		; D3:	shift EA16, cl
	dd	_aam			; D4:	AAM
	dd	_aad			; D5:	AAD
	dd	_setalc			; D6:	setalc (80286)
	dd	_xlat			; D7:	xlat
	dd	_esc			; D8:	esc
	dd	_esc			; D9:	esc
	dd	_esc			; DA:	esc
	dd	_esc			; DB:	esc
	dd	_esc			; DC:	esc
	dd	_esc			; DD:	esc
	dd	_esc			; DE:	esc
	dd	_esc			; DF:	esc

	dd	_loopnz			; E0:	loopnz
	dd	_loopz			; E1:	loopz
	dd	_loop			; E2:	loop
	dd	_jcxz			; E3:	jcxz
	dd	in_al_data8		; E4:	in	al, DATA8
	dd	in_ax_data8		; E5:	in	ax, DATA8
	dd	out_data8_al		; E6:	out	DATA8, al
	dd	out_data8_ax		; E7:	out	DATA8, ax
	dd	call_near		; E8:	call near
	dd	jmp_near		; E9:	jmp near
	dd	jmp_far			; EA:	jmp far
	dd	jmp_short		; EB:	jmp short
	dd	in_al_dx		; EC:	in	al, dx
	dd	in_ax_dx		; ED:	in	ax, dx
	dd	out_dx_al		; EE:	out	dx, al
	dd	out_dx_ax		; EF:	out	dx, ax

	dd	_lock			; F0:	lock
	dd	_lock			; F1:	lock
	dd	_repne			; F2:	repne
	dd	_repe			; F3:	repe
	dd	_hlt			; F4:	hlt
	dd	_cmc			; F5:	cmc
	dd	_ope0xf6		; F6:	
	dd	_ope0xf7		; F7:	
	dd	_clc			; F8:	clc
	dd	_stc			; F9:	stc
	dd	_cli			; FA:	cli
	dd	_sti			; FB:	sti
	dd	_cld			; FC:	cld
	dd	_std			; FD:	std
	dd	_ope0xfe		; FE:	
	dd	_ope0xff		; FF:	

; ----------------------------------------------------------------- repe

section .text

	align	16
repe_segprefix_es:
	mov	eax, dword [ES_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op_repe + ebx * 4]

	align	16
repe_segprefix_cs:
	mov	eax, dword [CS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op_repe + ebx * 4]

	align	16
repe_segprefix_ss:
	mov	eax, dword [SS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op_repe + ebx * 4]

	align	16
repe_segprefix_ds:
	mov	eax, dword [DS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op_repe + ebx * 4]


section .data

	align	16
i286op_repe dd	add_ea_r8		; 00:	add	EA, REG8
            dd	add_ea_r16		; 01:	add	EA, REG16
            dd	add_r8_ea		; 02:	add	REG8, EA
            dd	add_r16_ea		; 03:	add	REG16, EA
            dd	add_al_data8		; 04:	add	al, DATA8
            dd	add_ax_data16		; 05:	add	ax, DATA16
            dd	push_es			; 06:	push	es
            dd	pop_es			; 07:	pop	es
            dd	or_ea_r8		; 08:	or	EA, REGF8
            dd	or_ea_r16		; 09:	or	EA, REG16
            dd	or_r8_ea		; 0A:	or	REG8, EA
            dd	or_r16_ea		; 0B:	or	REG16, EA
            dd	or_al_data8		; 0C:	or	al, DATA8
            dd	or_ax_data16		; 0D:	or	ax, DATA16
            dd	push_cs			; 0E:	push	cs
            dd	_cts			; 0F:	i286 upper opcode

            dd	adc_ea_r8		; 10:	adc	EA, REG8
            dd	adc_ea_r16		; 11:	adc	EA, REG16
            dd	adc_r8_ea		; 12:	adc	REG8, EA
            dd	adc_r16_ea		; 13:	adc	REG16, EA
            dd	adc_al_data8		; 14:	adc	al, DATA8
            dd	adc_ax_data16		; 15:	adc	ax, DATA16
            dd	push_ss			; 16:	push	ss
            dd	pop_ss			; 17:	pop	ss
            dd	sbb_ea_r8		; 18:	sbb	EA, REG8
            dd	sbb_ea_r16		; 19:	sbb	EA, REG16
            dd	sbb_r8_ea		; 1A:	sbb	REG8, EA
            dd	sbb_r16_ea		; 1B:	sbb	REG16, EA
            dd	sbb_al_data8		; 1C:	sbb	al, DATA8
            dd	sbb_ax_data16		; 1D:	sbb	ax, DATA16
            dd	push_ds			; 1E:	push	ds
            dd	pop_ds			; 1F:	pop	ds

            dd	and_ea_r8		; 20:	and	EA, REG8
            dd	and_ea_r16		; 21:	and	EA, REG16
            dd	and_r8_ea		; 22:	and	REG8, EA
            dd	and_r16_ea		; 23:	and	REG16, EA
            dd	and_al_data8		; 24:	and	al, DATA8
            dd	and_ax_data16		; 25:	and	ax, DATA16
            dd	repe_segprefix_es	; 26:	repe es:
            dd	_daa			; 27:	daa
            dd	sub_ea_r8		; 28:	sub	EA, REG8
            dd	sub_ea_r16		; 29:	sub	EA, REG16
            dd	sub_r8_ea		; 2A:	sub	REG8, EA
            dd	sub_r16_ea		; 2B:	sub	REG16, EA
            dd	sub_al_data8		; 2C:	sub	al, DATA8
            dd	sub_ax_data16		; 2D:	sub	ax, DATA16
            dd	repe_segprefix_cs	; 2E:	repe cs:
            dd	_das			; 2F:	das

            dd	xor_ea_r8		; 30:	xor	EA, REG8
            dd	xor_ea_r16		; 31:	xor	EA, REG16
            dd	xor_r8_ea		; 32:	xor	REG8, EA
            dd	xor_r16_ea		; 33:	xor	REG16, EA
            dd	xor_al_data8		; 34:	xor	al, DATA8
            dd	xor_ax_data16		; 35:	xor	ax, DATA16
            dd	repe_segprefix_ss	; 36:	repe ss:
            dd	_aaa			; 37:	aaa
            dd	cmp_ea_r8		; 38:	cmp	EA, REG8
            dd	cmp_ea_r16		; 39:	cmp	EA, REG16
            dd	cmp_r8_ea		; 3A:	cmp	REG8, EA
            dd	cmp_r16_ea		; 3B:	cmp	REG16, EA
            dd	cmp_al_data8		; 3C:	cmp	al, DATA8
            dd	cmp_ax_data16		; 3D:	cmp	ax, DATA16
            dd	repe_segprefix_ds	; 3E:	repe ds:
            dd	_aas			; 3F:	aas

            dd	inc_reg16		; 40:	inc	ax
            dd	inc_reg16		; 41:	inc	cx
            dd	inc_reg16		; 42:	inc	dx
            dd	inc_reg16		; 43:	inc	bx
            dd	inc_reg16		; 44:	inc	sp
            dd	inc_reg16		; 45:	inc	bp
            dd	inc_reg16		; 46:	inc	si
            dd	inc_reg16		; 47:	inc	di
            dd	dec_reg16		; 48:	dec	ax
            dd	dec_reg16		; 49:	dec	cx
            dd	dec_reg16		; 4A:	dec	dx
            dd	dec_reg16		; 4B:	dec	bx
            dd	dec_reg16		; 4C:	dec	sp
            dd	dec_reg16		; 4D:	dec	bp
            dd	dec_reg16		; 4E:	dec	si
            dd	dec_reg16		; 4F:	dec	di

            dd	push_ax			; 50:	push	ax
            dd	push_cx			; 51:	push	cx
            dd	push_dx			; 52:	push	dx
            dd	push_bx			; 53:	push	bx
            dd	push_sp			; 54:	push	sp
            dd	push_bp			; 55:	push	bp
            dd	push_si			; 56:	push	si
            dd	push_di			; 57:	push	di
            dd	pop_ax			; 58:	pop	ax
            dd	pop_cx			; 59:	pop	cx
            dd	pop_dx			; 5A:	pop	dx
            dd	pop_bx			; 5B:	pop	bx
            dd	pop_sp			; 5C:	pop	sp
            dd	pop_bp			; 5D:	pop	bp
            dd	pop_si			; 5E:	pop	si
            dd	pop_di			; 5F:	pop	di

            dd	_pusha			; 60:	pusha
            dd	_popa			; 61:	popa
            dd	_bound			; 62:	bound
            dd	_arpl			; 63:	arpl
            dd	_reserved		; 64:	reserved
            dd	_reserved		; 65:	reserved
            dd	_reserved		; 66:	reserved
            dd	_reserved		; 67:	reserved
            dd	push_data16		; 68:	push	DATA16
            dd	imul_reg_ea_data16	; 69:	imul	REG, EA, DATA16
            dd	push_data8		; 6A:	push	DATA8
            dd	imul_reg_ea_data8	; 6B:	imul	REG, EA, DATA8
            dd	rep_insb		; 6C:	rep insb
            dd	rep_insw		; 6D:	rep insw
            dd	rep_outsb		; 6E:	rep outsb
            dd	rep_outsw		; 6F:	rep outsw

            dd	jo_short		; 70:	jo short
            dd	jno_short		; 71:	jno short
            dd	jc_short		; 72:	jnae/jb/jc short
            dd	jnc_short		; 73:	jae/jnb/jnc short
            dd	jz_short		; 74:	je/jz short
            dd	jnz_short		; 75:	jne/jnz short
            dd	jna_short		; 76:	jna/jbe short
            dd	ja_short		; 77:	ja/jnbe short
            dd	js_short		; 78:	js short
            dd	jns_short		; 79:	jns short
            dd	jp_short		; 7A:	jp/jpe short
            dd	jnp_short		; 7B:	jnp/jpo short
            dd	jl_short		; 7C:	jl/jnge short
            dd	jnl_short		; 7D:	jnl/jge short
            dd	jle_short		; 7E:	jle/jng short
            dd	jnle_short		; 7F:	jg/jnle short

            dd	calc_ea8_i8		; 80:	op	EA8, DATA8
            dd	calc_ea16_i16		; 81:	op	EA16, DATA16
            dd	calc_ea8_i8		; 82:	op	EA8, DATA8
            dd	calc_ea16_i8		; 83:	op	EA16, DATA8
            dd	test_ea_r8		; 84:	test	EA, REG8
            dd	test_ea_r16		; 85:	test	EA, REG16
            dd	xchg_ea_r8		; 86:	xchg	EA, REG8
            dd	xchg_ea_r16		; 87:	xchg	EA, REG16
            dd	mov_ea_r8		; 88:	mov	EA, REG8
            dd	mov_ea_r16		; 89:	mov	EA, REG16
            dd	mov_r8_ea		; 8A:	mov	REG8, EA
            dd	mov_r16_ea		; 8B:	add	REG16, EA
            dd	mov_ea_seg		; 8C:	mov	EA, segreg
            dd	lea_r16_ea		; 8D:	lea	REG16, EA
            dd	mov_seg_ea		; 8E:	mov	segrem, EA
            dd	pop_ea			; 8F:	pop	EA

            dd	_nop			; 90:	xchg	ax, ax
            dd	xchg_ax_reg		; 91:	xchg	ax, cx
            dd	xchg_ax_reg		; 92:	xchg	ax, dx
            dd	xchg_ax_reg		; 93:	xchg	ax, bx
            dd	xchg_ax_reg		; 94:	xchg	ax, sp
            dd	xchg_ax_reg		; 95:	xchg	ax, bp
            dd	xchg_ax_reg		; 96:	xchg	ax, si
            dd	xchg_ax_reg		; 97:	xchg	ax, di
            dd	_cbw			; 98:	cbw
            dd	_cwd			; 99:	cwd
            dd	call_far		; 9A:	call far
            dd	_wait			; 9B:	wait
            dd	_pushf			; 9C:	pushf
            dd	_popf			; 9D:	popf
            dd	_sahf			; 9E:	sahf
            dd	_lahf			; 9F:	lahf

            dd	mov_al_m8		; A0:	mov	al, m8
            dd	mov_ax_m16		; A1:	mov	ax, m16
            dd	mov_m8_al		; A2:	mov	m8, al
            dd	mov_m16_ax		; A3:	mov	m16, ax
            dd	rep_movsb		; A4:	rep movsb
            dd	rep_movsw		; A5:	rep movsw
            dd	repe_cmpsb		; A6:	repe cmpsb
            dd	repe_cmpsw		; A7:	repe cmpsw
            dd	test_al_data8		; A8:	test	al, DATA8
            dd	test_ax_data16		; A9:	test	ax, DATA16
            dd	rep_stosb		; AA:	rep stosw
            dd	rep_stosw		; AB:	rep stosw
            dd	rep_lodsb		; AC:	rep lodsb
            dd	rep_lodsw		; AD:	rep lodsw
            dd	repe_scasb		; AE:	repe scasb
            dd	repe_scasw		; AF:	repe scasw

            dd	mov_al_imm		; B0:	mov	al, imm8
            dd	mov_cl_imm		; B1:	mov	cl, imm8
            dd	mov_dl_imm		; B2:	mov	dl, imm8
            dd	mov_bl_imm		; B3:	mov	bl, imm8
            dd	mov_ah_imm		; B4:	mov	ah, imm8
            dd	mov_ch_imm		; B5:	mov	ch, imm8
            dd	mov_dh_imm		; B6:	mov	dh, imm8
            dd	mov_bh_imm		; B7:	mov	bh, imm8
            dd	mov_ax_imm		; B8:	mov	ax, imm16
            dd	mov_cx_imm		; B9:	mov	cx, imm16
            dd	mov_dx_imm		; BA:	mov	dx, imm16
            dd	mov_bx_imm		; BB:	mov	bx, imm16
            dd	mov_sp_imm		; BC:	mov	sp, imm16
            dd	mov_bp_imm		; BD:	mov	bp, imm16
            dd	mov_si_imm		; BE:	mov	si, imm16
            dd	mov_di_imm		; BF:	mov	di, imm16

            dd	shift_ea8_data8		; C0:	shift	EA8, DATA8
            dd	shift_ea16_data8	; C1:	shift	EA16, DATA8
            dd	ret_near_data16		; C2:	ret near DATA16
            dd	ret_near		; C3:	ret near
            dd	les_r16_ea		; C4:	les	REG16, EA
            dd	lds_r16_ea		; C5:	lds	REG16, EA
            dd	mov_ea8_data8		; C6:	mov	EA8, DATA8
            dd	mov_ea16_data16		; C7:	mov	EA16, DATA16
            dd	_enter			; C8:	enter	DATA16, DATA8
            dd	_leave			; C9:	leave
            dd	ret_far_data16		; CA:	ret far	DATA16
            dd	ret_far			; CB:	ret far
            dd	int_03			; CC:	int	3
            dd	int_data8		; CD:	int	DATA8
            dd	_into			; CE:	into
            dd	_iret			; CF:	iret

            dd	shift_ea8_1		; D0:	shift EA8, 1
            dd	shift_ea16_1		; D1:	shift EA16, 1
            dd	shift_ea8_cl		; D2:	shift EA8, cl
            dd	shift_ea16_cl		; D3:	shift EA16, cl
            dd	_aam			; D4:	AAM
            dd	_aad			; D5:	AAD
            dd	_setalc			; D6:	setalc (80286)
            dd	_xlat			; D7:	xlat
            dd	_esc			; D8:	esc
            dd	_esc			; D9:	esc
            dd	_esc			; DA:	esc
            dd	_esc			; DB:	esc
            dd	_esc			; DC:	esc
            dd	_esc			; DD:	esc
            dd	_esc			; DE:	esc
            dd	_esc			; DF:	esc

            dd	_loopnz			; E0:	loopnz
            dd	_loopz			; E1:	loopz
            dd	_loop			; E2:	loop
            dd	_jcxz			; E3:	jcxz
            dd	in_al_data8		; E4:	in	al, DATA8
            dd	in_ax_data8		; E5:	in	ax, DATA8
            dd	out_data8_al		; E6:	out	DATA8, al
            dd	out_data8_ax		; E7:	out	DATA8, ax
            dd	call_near		; E8:	call near
            dd	jmp_near		; E9:	jmp near
            dd	jmp_far			; EA:	jmp far
            dd	jmp_short		; EB:	jmp short
            dd	in_al_dx		; EC:	in	al, dx
            dd	in_ax_dx		; ED:	in	ax, dx
            dd	out_dx_al		; EE:	out	dx, al
            dd	out_dx_ax		; EF:	out	dx, ax

            dd	_lock			; F0:	lock
            dd	_lock			; F1:	lock
            dd	_repne			; F2:	repne
            dd	_repe			; F3:	repe
            dd	_hlt			; F4:	hlt
            dd	_cmc			; F5:	cmc
            dd	_ope0xf6		; F6:	
            dd	_ope0xf7		; F7:	
            dd	_clc			; F8:	clc
            dd	_stc			; F9:	stc
            dd	_cli			; FA:	cli
            dd	_sti			; FB:	sti
            dd	_cld			; FC:	cld
            dd	_std			; FD:	std
            dd	_ope0xfe		; FE:	
            dd	_ope0xff		; FF:	

; ----------------------------------------------------------------- repne

section .text

	align	16
repne_segprefix_es:
	mov	eax, dword [ES_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op_repne + ebx * 4]

	align	16
repne_segprefix_cs:
	mov	eax, dword [CS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op_repne + ebx * 4]

	align	16
repne_segprefix_ss:
	mov	eax, dword [SS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op_repne + ebx * 4]

	align	16
repne_segprefix_ds:
	mov	eax, dword [DS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[i286op_repne + ebx * 4]


section .data

	align	16
i286op_repne	dd	add_ea_r8		; 00:	add	EA, REG8
		dd	add_ea_r16		; 01:	add	EA, REG16
		dd	add_r8_ea		; 02:	add	REG8, EA
		dd	add_r16_ea		; 03:	add	REG16, EA
		dd	add_al_data8		; 04:	add	al, DATA8
		dd	add_ax_data16		; 05:	add	ax, DATA16
		dd	push_es			; 06:	push	es
		dd	pop_es			; 07:	pop	es
		dd	or_ea_r8		; 08:	or	EA, REGF8
		dd	or_ea_r16		; 09:	or	EA, REG16
		dd	or_r8_ea		; 0A:	or	REG8, EA
		dd	or_r16_ea		; 0B:	or	REG16, EA
		dd	or_al_data8		; 0C:	or	al, DATA8
		dd	or_ax_data16		; 0D:	or	ax, DATA16
		dd	push_cs			; 0E:	push	cs
		dd	_cts			; 0F:	i286 upper opcode

		dd	adc_ea_r8		; 10:	adc	EA, REG8
		dd	adc_ea_r16		; 11:	adc	EA, REG16
		dd	adc_r8_ea		; 12:	adc	REG8, EA
		dd	adc_r16_ea		; 13:	adc	REG16, EA
		dd	adc_al_data8		; 14:	adc	al, DATA8
		dd	adc_ax_data16		; 15:	adc	ax, DATA16
		dd	push_ss			; 16:	push	ss
		dd	pop_ss			; 17:	pop	ss
		dd	sbb_ea_r8		; 18:	sbb	EA, REG8
		dd	sbb_ea_r16		; 19:	sbb	EA, REG16
		dd	sbb_r8_ea		; 1A:	sbb	REG8, EA
		dd	sbb_r16_ea		; 1B:	sbb	REG16, EA
		dd	sbb_al_data8		; 1C:	sbb	al, DATA8
		dd	sbb_ax_data16		; 1D:	sbb	ax, DATA16
		dd	push_ds			; 1E:	push	ds
		dd	pop_ds			; 1F:	pop	ds

		dd	and_ea_r8		; 20:	and	EA, REG8
		dd	and_ea_r16		; 21:	and	EA, REG16
		dd	and_r8_ea		; 22:	and	REG8, EA
		dd	and_r16_ea		; 23:	and	REG16, EA
		dd	and_al_data8		; 24:	and	al, DATA8
		dd	and_ax_data16		; 25:	and	ax, DATA16
		dd	repne_segprefix_es	; 26:	repne es:
		dd	_daa			; 27:	daa
		dd	sub_ea_r8		; 28:	sub	EA, REG8
		dd	sub_ea_r16		; 29:	sub	EA, REG16
		dd	sub_r8_ea		; 2A:	sub	REG8, EA
		dd	sub_r16_ea		; 2B:	sub	REG16, EA
		dd	sub_al_data8		; 2C:	sub	al, DATA8
		dd	sub_ax_data16		; 2D:	sub	ax, DATA16
		dd	repne_segprefix_cs	; 2E:	repne cs:
		dd	_das			; 2F:	das

		dd	xor_ea_r8		; 30:	xor	EA, REG8
		dd	xor_ea_r16		; 31:	xor	EA, REG16
		dd	xor_r8_ea		; 32:	xor	REG8, EA
		dd	xor_r16_ea		; 33:	xor	REG16, EA
		dd	xor_al_data8		; 34:	xor	al, DATA8
		dd	xor_ax_data16		; 35:	xor	ax, DATA16
		dd	repne_segprefix_ss	; 36:	repne ss:
		dd	_aaa			; 37:	aaa
		dd	cmp_ea_r8		; 38:	cmp	EA, REG8
		dd	cmp_ea_r16		; 39:	cmp	EA, REG16
		dd	cmp_r8_ea		; 3A:	cmp	REG8, EA
		dd	cmp_r16_ea		; 3B:	cmp	REG16, EA
		dd	cmp_al_data8		; 3C:	cmp	al, DATA8
		dd	cmp_ax_data16		; 3D:	cmp	ax, DATA16
		dd	repne_segprefix_ds	; 3E:	repne ds:
		dd	_aas			; 3F:	aas

		dd	inc_reg16		; 40:	inc	ax
		dd	inc_reg16		; 41:	inc	cx
		dd	inc_reg16		; 42:	inc	dx
		dd	inc_reg16		; 43:	inc	bx
		dd	inc_reg16		; 44:	inc	sp
		dd	inc_reg16		; 45:	inc	bp
		dd	inc_reg16		; 46:	inc	si
		dd	inc_reg16		; 47:	inc	di
		dd	dec_reg16		; 48:	dec	ax
		dd	dec_reg16		; 49:	dec	cx
		dd	dec_reg16		; 4A:	dec	dx
		dd	dec_reg16		; 4B:	dec	bx
		dd	dec_reg16		; 4C:	dec	sp
		dd	dec_reg16		; 4D:	dec	bp
		dd	dec_reg16		; 4E:	dec	si
		dd	dec_reg16		; 4F:	dec	di

		dd	push_ax			; 50:	push	ax
		dd	push_cx			; 51:	push	cx
		dd	push_dx			; 52:	push	dx
		dd	push_bx			; 53:	push	bx
		dd	push_sp			; 54:	push	sp
		dd	push_bp			; 55:	push	bp
		dd	push_si			; 56:	push	si
		dd	push_di			; 57:	push	di
		dd	pop_ax			; 58:	pop	ax
		dd	pop_cx			; 59:	pop	cx
		dd	pop_dx			; 5A:	pop	dx
		dd	pop_bx			; 5B:	pop	bx
		dd	pop_sp			; 5C:	pop	sp
		dd	pop_bp			; 5D:	pop	bp
		dd	pop_si			; 5E:	pop	si
		dd	pop_di			; 5F:	pop	di

		dd	_pusha			; 60:	pusha
		dd	_popa			; 61:	popa
		dd	_bound			; 62:	bound
		dd	_arpl			; 63:	arpl
		dd	_reserved		; 64:	reserved
		dd	_reserved		; 65:	reserved
		dd	_reserved		; 66:	reserved
		dd	_reserved		; 67:	reserved
		dd	push_data16		; 68:	push	DATA16
		dd	imul_reg_ea_data16	; 69:	imul	REG, EA, DATA16
		dd	push_data8		; 6A:	push	DATA8
		dd	imul_reg_ea_data8	; 6B:	imul	REG, EA, DATA8
		dd	rep_insb		; 6C:	rep insb
		dd	rep_insw		; 6D:	rep insw
		dd	rep_outsb		; 6E:	rep outsb
		dd	rep_outsw		; 6F:	rep outsw

		dd	jo_short		; 70:	jo short
		dd	jno_short		; 71:	jno short
		dd	jc_short		; 72:	jnae/jb/jc short
		dd	jnc_short		; 73:	jae/jnb/jnc short
		dd	jz_short		; 74:	je/jz short
		dd	jnz_short		; 75:	jne/jnz short
		dd	jna_short		; 76:	jna/jbe short
		dd	ja_short		; 77:	ja/jnbe short
		dd	js_short		; 78:	js short
		dd	jns_short		; 79:	jns short
		dd	jp_short		; 7A:	jp/jpe short
		dd	jnp_short		; 7B:	jnp/jpo short
		dd	jl_short		; 7C:	jl/jnge short
		dd	jnl_short		; 7D:	jnl/jge short
		dd	jle_short		; 7E:	jle/jng short
		dd	jnle_short		; 7F:	jg/jnle short

		dd	calc_ea8_i8		; 80:	op	EA8, DATA8
		dd	calc_ea16_i16		; 81:	op	EA16, DATA16
		dd	calc_ea8_i8		; 82:	op	EA8, DATA8
		dd	calc_ea16_i8		; 83:	op	EA16, DATA8
		dd	test_ea_r8		; 84:	test	EA, REG8
		dd	test_ea_r16		; 85:	test	EA, REG16
		dd	xchg_ea_r8		; 86:	xchg	EA, REG8
		dd	xchg_ea_r16		; 87:	xchg	EA, REG16
		dd	mov_ea_r8		; 88:	mov	EA, REG8
		dd	mov_ea_r16		; 89:	mov	EA, REG16
		dd	mov_r8_ea		; 8A:	mov	REG8, EA
		dd	mov_r16_ea		; 8B:	add	REG16, EA
		dd	mov_ea_seg		; 8C:	mov	EA, segreg
		dd	lea_r16_ea		; 8D:	lea	REG16, EA
		dd	mov_seg_ea		; 8E:	mov	segrem, EA
		dd	pop_ea			; 8F:	pop	EA

		dd	_nop			; 90:	xchg	ax, ax
		dd	xchg_ax_reg		; 91:	xchg	ax, cx
		dd	xchg_ax_reg		; 92:	xchg	ax, dx
		dd	xchg_ax_reg		; 93:	xchg	ax, bx
		dd	xchg_ax_reg		; 94:	xchg	ax, sp
		dd	xchg_ax_reg		; 95:	xchg	ax, bp
		dd	xchg_ax_reg		; 96:	xchg	ax, si
		dd	xchg_ax_reg		; 97:	xchg	ax, di
		dd	_cbw			; 98:	cbw
		dd	_cwd			; 99:	cwd
		dd	call_far		; 9A:	call far
		dd	_wait			; 9B:	wait
		dd	_pushf			; 9C:	pushf
		dd	_popf			; 9D:	popf
		dd	_sahf			; 9E:	sahf
		dd	_lahf			; 9F:	lahf

		dd	mov_al_m8		; A0:	mov	al, m8
		dd	mov_ax_m16		; A1:	mov	ax, m16
		dd	mov_m8_al		; A2:	mov	m8, al
		dd	mov_m16_ax		; A3:	mov	m16, ax
		dd	rep_movsb		; A4:	rep movsb
		dd	rep_movsw		; A5:	rep movsw
		dd	repne_cmpsb		; A6:	repne cmpsb
		dd	repne_cmpsw		; A7:	repne cmpsw
		dd	test_al_data8		; A8:	test	al, DATA8
		dd	test_ax_data16		; A9:	test	ax, DATA16
		dd	rep_stosb		; AA:	rep stosw
		dd	rep_stosw		; AB:	rep stosw
		dd	rep_lodsb		; AC:	rep lodsb
		dd	rep_lodsw		; AD:	rep lodsw
		dd	repne_scasb		; AE:	repne scasb
		dd	repne_scasw		; AF:	repne scasw

		dd	mov_al_imm		; B0:	mov	al, imm8
		dd	mov_cl_imm		; B1:	mov	cl, imm8
		dd	mov_dl_imm		; B2:	mov	dl, imm8
		dd	mov_bl_imm		; B3:	mov	bl, imm8
		dd	mov_ah_imm		; B4:	mov	ah, imm8
		dd	mov_ch_imm		; B5:	mov	ch, imm8
		dd	mov_dh_imm		; B6:	mov	dh, imm8
		dd	mov_bh_imm		; B7:	mov	bh, imm8
		dd	mov_ax_imm		; B8:	mov	ax, imm16
		dd	mov_cx_imm		; B9:	mov	cx, imm16
		dd	mov_dx_imm		; BA:	mov	dx, imm16
		dd	mov_bx_imm		; BB:	mov	bx, imm16
		dd	mov_sp_imm		; BC:	mov	sp, imm16
		dd	mov_bp_imm		; BD:	mov	bp, imm16
		dd	mov_si_imm		; BE:	mov	si, imm16
		dd	mov_di_imm		; BF:	mov	di, imm16

		dd	shift_ea8_data8		; C0:	shift	EA8, DATA8
		dd	shift_ea16_data8	; C1:	shift	EA16, DATA8
		dd	ret_near_data16		; C2:	ret near DATA16
		dd	ret_near		; C3:	ret near
		dd	les_r16_ea		; C4:	les	REG16, EA
		dd	lds_r16_ea		; C5:	lds	REG16, EA
		dd	mov_ea8_data8		; C6:	mov	EA8, DATA8
		dd	mov_ea16_data16		; C7:	mov	EA16, DATA16
		dd	_enter			; C8:	enter	DATA16, DATA8
		dd	_leave			; C9:	leave
		dd	ret_far_data16		; CA:	ret far	DATA16
		dd	ret_far			; CB:	ret far
		dd	int_03			; CC:	int	3
		dd	int_data8		; CD:	int	DATA8
		dd	_into			; CE:	into
		dd	_iret			; CF:	iret

		dd	shift_ea8_1		; D0:	shift EA8, 1
		dd	shift_ea16_1		; D1:	shift EA16, 1
		dd	shift_ea8_cl		; D2:	shift EA8, cl
		dd	shift_ea16_cl		; D3:	shift EA16, cl
		dd	_aam			; D4:	AAM
		dd	_aad			; D5:	AAD
		dd	_setalc			; D6:	setalc (80286)
		dd	_xlat			; D7:	xlat
		dd	_esc			; D8:	esc
		dd	_esc			; D9:	esc
		dd	_esc			; DA:	esc
		dd	_esc			; DB:	esc
		dd	_esc			; DC:	esc
		dd	_esc			; DD:	esc
		dd	_esc			; DE:	esc
		dd	_esc			; DF:	esc

		dd	_loopnz			; E0:	loopnz
		dd	_loopz			; E1:	loopz
		dd	_loop			; E2:	loop
		dd	_jcxz			; E3:	jcxz
		dd	in_al_data8		; E4:	in	al, DATA8
		dd	in_ax_data8		; E5:	in	ax, DATA8
		dd	out_data8_al		; E6:	out	DATA8, al
		dd	out_data8_ax		; E7:	out	DATA8, ax
		dd	call_near		; E8:	call near
		dd	jmp_near		; E9:	jmp near
		dd	jmp_far			; EA:	jmp far
		dd	jmp_short		; EB:	jmp short
		dd	in_al_dx		; EC:	in	al, dx
		dd	in_ax_dx		; ED:	in	ax, dx
		dd	out_dx_al		; EE:	out	dx, al
		dd	out_dx_ax		; EF:	out	dx, ax

		dd	_lock			; F0:	lock
		dd	_lock			; F1:	lock
		dd	_repne			; F2:	repne
		dd	_repe			; F3:	repe
		dd	_hlt			; F4:	hlt
		dd	_cmc			; F5:	cmc
		dd	_ope0xf6		; F6:	
		dd	_ope0xf7		; F7:	
		dd	_clc			; F8:	clc
		dd	_stc			; F9:	stc
		dd	_cli			; FA:	cli
		dd	_sti			; FB:	sti
		dd	_cld			; FC:	cld
		dd	_std			; FD:	std
		dd	_ope0xfe		; FE:	
		dd	_ope0xff		; FF:	


; --------------------------------------------------------------------------

section .text

	align	16
v30_reserved:
	ret

; 17: pop ss
	align	16
v30pop_ss:
	I286CLOCK 5
	REGPOP word [I286_SS]
	and	eax, 00ffffh
	shl	eax, 4			; make segreg
	mov	dword [SS_BASE], eax
	mov	dword [SS_FIX], eax
	cmp	dword [i286s + I286STAT.prefix], 0	; 00/06/24
	je	.noprefix
	call	removeprefix
	pop	eax
.noprefix:
	GET_PCBYTEEX
	jmp	[v30op + ebx * 4]

; 26: es:
	align	16
v30segprefix_es:
	mov	eax, dword [ES_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op + ebx * 4]

; 2E: cs:
	align	16
v30segprefix_cs:
	mov	eax, dword [CS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op + ebx * 4]

; 36: ss:
	align	16
v30segprefix_ss:
	mov	eax, dword [SS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op + ebx * 4]

; 3E: ds:
	align	16
v30segprefix_ds:
	mov	eax, dword [DS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op + ebx * 4]

; 54: push sp
	align	16
v30push_sp:
	I286CLOCK 3
	sub	word [I286_SP], 2
	movzx	ecx, word [I286_SP]
	mov	edx, ecx
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

; 5C: pop sp
	align	16
v30pop_sp:
	I286CLOCK 5
	REGPOP word [I286_SP]
	ret

; 8E: mov segrem, EA
	align	16
v30mov_seg_ea:
	GET_PCBYTE_C
	mov	ebx, eax
	shr	ebx, 3
	and	ebx, 3
	cmp	ebx, 1
	je	.segsetr

	cmp	al, 0c0h
	jc	.src_memory

	I286CLOCK 2
	and	eax, 7
	mov	ax, word [I286_REG + eax * 2]
	jmp	.segset

.src_memory:
	I286CLOCK 5
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	call	@i286_memoryread_w@4
.segset:
	mov	word [I286_SEGREG + ebx * 2], ax
	and	eax, 0000ffffh
	shl	eax, 4			; make segreg
	mov	dword [SEG_BASE + ebx * 4], eax
	sub	ebx, 2
	jc	.segsetr
	mov	dword [SS_FIX + ebx * 4], eax
	je	.setss
.segsetr:
	ret

.setss:
	cmp	dword [i286s + I286STAT.prefix], 0	; 00/05/13
	je	.noprefix
	call	removeprefix
	pop	eax	; eax<-offset removeprefix
.noprefix:
	GET_PCBYTEEX
	jmp	[v30op + ebx * 4]

; 9C: pushf
	align	16
v30_pushf:
	I286CLOCK 3
	mov	dx, word [I286_FLAG]
	or	dh, 0f0h
	sub	word [I286_SP], 2
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8

; 9D: popf
	align	16
v30_popf:
	I286CLOCK 5
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	call	@i286_memoryread_w@4
	add	word [I286_SP], 2
	or	ah, 0f0h
	mov	word [I286_FLAG], ax
	and	ah, 3
	cmp	ah, 3
	sete	byte [I286_TRAP]
	I286IRQCHECKTERM

; C0: shift EA8, DATA8
	align	16
v30shift_ea8_data8:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK 5
	bt	ax, 2
	rcl	eax, 1
	and	eax, 7
	lea	ebx, [I286_REG + eax]
	GET_PCBYTE
	movzx	ecx, al
	I286CLOCK ecx
	jmp	[sftreg8v30_table + edi * 4]

.memory_eareg8:
	I286CLOCK 8
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMWRITEMAX
	jnc	.extmem_eareg8
	lea	ebx, [I286_MEM + ecx]
	GET_PCBYTE
	movzx	ecx, al
	I286CLOCK ecx
	jmp	[sftreg8v30_table + edi * 4]

.extmem_eareg8:
	call	@i286_memoryread@4
	mov	edx, eax
	GET_PCBYTE
	movzx	ecx, al
	I286CLOCK ecx
	jmp	[sftext8v30_table + edi * 4]

; C1: shift EA16, DATA8
	align	16
v30shift_ea16_data8:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg16

	and	eax, 7
	I286CLOCK 5
	lea	ebx, [I286_REG + eax * 2]
	GET_PCBYTE
	movzx	ecx, al
	I286CLOCK ecx
	jmp	[sftreg16v30_table + edi * 4]

.memory_eareg16:
	I286CLOCK 8
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, (I286_MEMWRITEMAX-1)
	jnc	.extmem_eareg16
	lea	ebx, [I286_MEM + ecx]
	GET_PCBYTE
	movzx	ecx, al
	I286CLOCK ecx
	jmp	[sftreg16v30_table + edi * 4]

.extmem_eareg16:
	call	@i286_memoryread_w@4
	mov	edx, eax
	mov	ebx, ecx
	GET_PCBYTE
	movzx	ecx, al
	I286CLOCK ecx
	jmp	[sftext16v30_table + edi * 4]


; D2: shift EA8, cl
	align	16
v30shift_ea8_cl:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK 5
	bt	ax, 2
	rcl	eax, 1
	and	eax, 7
	lea	ebx, [I286_REG + eax]
	movzx	ecx, byte [I286_CL]
	I286CLOCK ecx
	jmp	[sftreg8v30_table + edi * 4]

.memory_eareg8:
	I286CLOCK 8
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMWRITEMAX
	jnc	.extmem_eareg8
	lea	ebx, [I286_MEM + ecx]
	movzx	ecx, byte [I286_CL]
	I286CLOCK ecx
	jmp	[sftreg8v30_table + edi * 4]

.extmem_eareg8:
	call	@i286_memoryread@4
	mov	edx, eax
	mov	ebx, ecx
	movzx	ecx, byte [I286_CL]
	I286CLOCK ecx
	jmp	[sftext8v30_table + edi * 4]

; D3: shift EA16, cl
	align	16
v30shift_ea16_cl:
	GET_PCBYTE_C
	mov	edi, eax
	shr	edi, 3
	and	edi, 7	; opcode
	cmp	al, 0c0h
	jc	.memory_eareg16

	I286CLOCK 5
	and	eax, 7
	lea	ebx, [I286_REG + eax * 2]
	movzx	ecx, byte [I286_CL]
	I286CLOCK ecx
	jmp	[sftreg16v30_table + edi * 4]

.memory_eareg16:
	I286CLOCK 8
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, (I286_MEMWRITEMAX-1)
	jnc	.extmem_eareg16
	lea	ebx, [I286_MEM + ecx]
	movzx	ecx, byte [I286_CL]
	I286CLOCK ecx
	jmp	[sftreg16v30_table + edi * 4]

.extmem_eareg16:
	call	@i286_memoryread_w@4
	mov	edx, eax
	mov	ebx, ecx
	movzx	ecx, byte [I286_CL]
	I286CLOCK ecx
	jmp	[sftext16v30_table + edi * 4]


; D4: AAM
	align	16
v30_aam:
	INC_PCBYTE
	I286CLOCK 16
	mov	ax, word [I286_AX]
	aam
	mov	word [I286_AX], ax
	FLAG_STORE
	ret

; D5: AAD
	align	16
v30_aad:
	INC_PCBYTE
	I286CLOCK 14
	mov	ax, word [I286_AX]
	aad
	mov	word [I286_AX], ax
	FLAG_STORE
	ret

; F2: repne
	align	16
v30_repne:
	GET_PCBYTEEX
	jmp	[v30op_repne + ebx * 4]

; F3: repe
	align	16
v30_repe:
	GET_PCBYTEEX
	jmp	[v30op_repe + ebx * 4]


section .data

	align	16
v30op	dd	add_ea_r8		; 00:	add	EA, REG8
	dd	add_ea_r16		; 01:	add	EA, REG16
	dd	add_r8_ea		; 02:	add	REG8, EA
	dd	add_r16_ea		; 03:	add	REG16, EA
	dd	add_al_data8		; 04:	add	al, DATA8
	dd	add_ax_data16		; 05:	add	ax, DATA16
	dd	push_es			; 06:	push	es
	dd	pop_es			; 07:	pop	es
	dd	or_ea_r8		; 08:	or	EA, REGF8
	dd	or_ea_r16		; 09:	or	EA, REG16
	dd	or_r8_ea		; 0A:	or	REG8, EA
	dd	or_r16_ea		; 0B:	or	REG16, EA
	dd	or_al_data8		; 0C:	or	al, DATA8
	dd	or_ax_data16		; 0D:	or	ax, DATA16
	dd	push_cs			; 0E:	push	cs
	dd	_cts			; 0F:	i286 upper opcode

	dd	adc_ea_r8		; 10:	adc	EA, REG8
	dd	adc_ea_r16		; 11:	adc	EA, REG16
	dd	adc_r8_ea		; 12:	adc	REG8, EA
	dd	adc_r16_ea		; 13:	adc	REG16, EA
	dd	adc_al_data8		; 14:	adc	al, DATA8
	dd	adc_ax_data16		; 15:	adc	ax, DATA16
	dd	push_ss			; 16:	push	ss
	dd	v30pop_ss		; 17:	pop	ss
	dd	sbb_ea_r8		; 18:	sbb	EA, REG8
	dd	sbb_ea_r16		; 19:	sbb	EA, REG16
	dd	sbb_r8_ea		; 1A:	sbb	REG8, EA
	dd	sbb_r16_ea		; 1B:	sbb	REG16, EA
	dd	sbb_al_data8		; 1C:	sbb	al, DATA8
	dd	sbb_ax_data16		; 1D:	sbb	ax, DATA16
	dd	push_ds			; 1E:	push	ds
	dd	pop_ds			; 1F:	pop	ds

	dd	and_ea_r8		; 20:	and	EA, REG8
	dd	and_ea_r16		; 21:	and	EA, REG16
	dd	and_r8_ea		; 22:	and	REG8, EA
	dd	and_r16_ea		; 23:	and	REG16, EA
	dd	and_al_data8		; 24:	and	al, DATA8
	dd	and_ax_data16		; 25:	and	ax, DATA16
	dd	v30segprefix_es		; 26:	es:
	dd	_daa			; 27:	daa
	dd	sub_ea_r8		; 28:	sub	EA, REG8
	dd	sub_ea_r16		; 29:	sub	EA, REG16
	dd	sub_r8_ea		; 2A:	sub	REG8, EA
	dd	sub_r16_ea		; 2B:	sub	REG16, EA
	dd	sub_al_data8		; 2C:	sub	al, DATA8
	dd	sub_ax_data16		; 2D:	sub	ax, DATA16
	dd	v30segprefix_cs		; 2E:	cs:
	dd	_das			; 2F:	das

	dd	xor_ea_r8		; 30:	xor	EA, REG8
	dd	xor_ea_r16		; 31:	xor	EA, REG16
	dd	xor_r8_ea		; 32:	xor	REG8, EA
	dd	xor_r16_ea		; 33:	xor	REG16, EA
	dd	xor_al_data8		; 34:	xor	al, DATA8
	dd	xor_ax_data16		; 35:	xor	ax, DATA16
	dd	v30segprefix_ss		; 36:	ss:
	dd	_aaa			; 37:	aaa
	dd	cmp_ea_r8		; 38:	cmp	EA, REG8
	dd	cmp_ea_r16		; 39:	cmp	EA, REG16
	dd	cmp_r8_ea		; 3A:	cmp	REG8, EA
	dd	cmp_r16_ea		; 3B:	cmp	REG16, EA
	dd	cmp_al_data8		; 3C:	cmp	al, DATA8
	dd	cmp_ax_data16		; 3D:	cmp	ax, DATA16
	dd	v30segprefix_ds		; 3E:	ds:
	dd	_aas			; 3F:	aas

	dd	inc_reg16		; 40:	inc	ax
	dd	inc_reg16		; 41:	inc	cx
	dd	inc_reg16		; 42:	inc	dx
	dd	inc_reg16		; 43:	inc	bx
	dd	inc_reg16		; 44:	inc	sp
	dd	inc_reg16		; 45:	inc	bp
	dd	inc_reg16		; 46:	inc	si
	dd	inc_reg16		; 47:	inc	di
	dd	dec_reg16		; 48:	dec	ax
	dd	dec_reg16		; 49:	dec	cx
	dd	dec_reg16		; 4A:	dec	dx
	dd	dec_reg16		; 4B:	dec	bx
	dd	dec_reg16		; 4C:	dec	sp
	dd	dec_reg16		; 4D:	dec	bp
	dd	dec_reg16		; 4E:	dec	si
	dd	dec_reg16		; 4F:	dec	di

	dd	push_ax			; 50:	push	ax
	dd	push_cx			; 51:	push	cx
	dd	push_dx			; 52:	push	dx
	dd	push_bx			; 53:	push	bx
	dd	v30push_sp		; 54:	push	sp
	dd	push_bp			; 55:	push	bp
	dd	push_si			; 56:	push	si
	dd	push_di			; 57:	push	di
	dd	pop_ax			; 58:	pop	ax
	dd	pop_cx			; 59:	pop	cx
	dd	pop_dx			; 5A:	pop	dx
	dd	pop_bx			; 5B:	pop	bx
	dd	v30pop_sp		; 5C:	pop	sp
	dd	pop_bp			; 5D:	pop	bp
	dd	pop_si			; 5E:	pop	si
	dd	pop_di			; 5F:	pop	di

	dd	_pusha			; 60:	pusha
	dd	_popa			; 61:	popa
	dd	_bound			; 62:	bound
	dd	v30_reserved		; 63:	reserved
	dd	v30_reserved		; 64:	reserved
	dd	v30_reserved		; 65:	reserved
	dd	v30_reserved		; 66:	reserved
	dd	v30_reserved		; 67:	reserved
	dd	push_data16		; 68:	push	DATA16
	dd	imul_reg_ea_data16	; 69:	imul	REG, EA, DATA16
	dd	push_data8		; 6A:	push	DATA8
	dd	imul_reg_ea_data8	; 6B:	imul	REG, EA, DATA8
	dd	_insb			; 6C:	insb
	dd	_insw			; 6D:	insw
	dd	_outsb			; 6E:	outsb
	dd	_outsw			; 6F:	outsw

	dd	jo_short		; 70:	jo short
	dd	jno_short		; 71:	jno short
	dd	jc_short		; 72:	jnae/jb/jc short
	dd	jnc_short		; 73:	jae/jnb/jnc short
	dd	jz_short		; 74:	je/jz short
	dd	jnz_short		; 75:	jne/jnz short
	dd	jna_short		; 76:	jna/jbe short
	dd	ja_short		; 77:	ja/jnbe short
	dd	js_short		; 78:	js short
	dd	jns_short		; 79:	jns short
	dd	jp_short		; 7A:	jp/jpe short
	dd	jnp_short		; 7B:	jnp/jpo short
	dd	jl_short		; 7C:	jl/jnge short
	dd	jnl_short		; 7D:	jnl/jge short
	dd	jle_short		; 7E:	jle/jng short
	dd	jnle_short		; 7F:	jg/jnle short

	dd	calc_ea8_i8		; 80:	op	EA8, DATA8
	dd	calc_ea16_i16		; 81:	op	EA16, DATA16
	dd	calc_ea8_i8		; 82:	op	EA8, DATA8
	dd	calc_ea16_i8		; 83:	op	EA16, DATA8
	dd	test_ea_r8		; 84:	test	EA, REG8
	dd	test_ea_r16		; 85:	test	EA, REG16
	dd	xchg_ea_r8		; 86:	xchg	EA, REG8
	dd	xchg_ea_r16		; 87:	xchg	EA, REG16
	dd	mov_ea_r8		; 88:	mov	EA, REG8
	dd	mov_ea_r16		; 89:	mov	EA, REG16
	dd	mov_r8_ea		; 8A:	mov	REG8, EA
	dd	mov_r16_ea		; 8B:	add	REG16, EA
	dd	mov_ea_seg		; 8C:	mov	EA, segreg
	dd	lea_r16_ea		; 8D:	lea	REG16, EA
	dd	v30mov_seg_ea		; 8E:	mov	segrem, EA
	dd	pop_ea			; 8F:	pop	EA

	dd	_nop			; 90:	xchg	ax, ax
	dd	xchg_ax_reg		; 91:	xchg	ax, cx
	dd	xchg_ax_reg		; 92:	xchg	ax, dx
	dd	xchg_ax_reg		; 93:	xchg	ax, bx
	dd	xchg_ax_reg		; 94:	xchg	ax, sp
	dd	xchg_ax_reg		; 95:	xchg	ax, bp
	dd	xchg_ax_reg		; 96:	xchg	ax, si
	dd	xchg_ax_reg		; 97:	xchg	ax, di
	dd	_cbw			; 98:	cbw
	dd	_cwd			; 99:	cwd
	dd	call_far		; 9A:	call far
	dd	_wait			; 9B:	wait
	dd	v30_pushf		; 9C:	pushf
	dd	v30_popf		; 9D:	popf
	dd	_sahf			; 9E:	sahf
	dd	_lahf			; 9F:	lahf

	dd	mov_al_m8		; A0:	mov	al, m8
	dd	mov_ax_m16		; A1:	mov	ax, m16
	dd	mov_m8_al		; A2:	mov	m8, al
	dd	mov_m16_ax		; A3:	mov	m16, ax
	dd	_movsb			; A4:	movsb
	dd	_movsw			; A5:	movsw
	dd	_cmpsb			; A6:	cmpsb
	dd	_cmpsw			; A7:	cmpsw
	dd	test_al_data8	; A8:	test	al, DATA8
	dd	test_ax_data16	; A9:	test	ax, DATA16
	dd	_stosb			; AA:	stosw
	dd	_stosw			; AB:	stosw
	dd	_lodsb			; AC:	lodsb
	dd	_lodsw			; AD:	lodsw
	dd	_scasb			; AE:	scasb
	dd	_scasw			; AF:	scasw

	dd	mov_al_imm		; B0:	mov	al, imm8
	dd	mov_cl_imm		; B1:	mov	cl, imm8
	dd	mov_dl_imm		; B2:	mov	dl, imm8
	dd	mov_bl_imm		; B3:	mov	bl, imm8
	dd	mov_ah_imm		; B4:	mov	ah, imm8
	dd	mov_ch_imm		; B5:	mov	ch, imm8
	dd	mov_dh_imm		; B6:	mov	dh, imm8
	dd	mov_bh_imm		; B7:	mov	bh, imm8
	dd	mov_ax_imm		; B8:	mov	ax, imm16
	dd	mov_cx_imm		; B9:	mov	cx, imm16
	dd	mov_dx_imm		; BA:	mov	dx, imm16
	dd	mov_bx_imm		; BB:	mov	bx, imm16
	dd	mov_sp_imm		; BC:	mov	sp, imm16
	dd	mov_bp_imm		; BD:	mov	bp, imm16
	dd	mov_si_imm		; BE:	mov	si, imm16
	dd	mov_di_imm		; BF:	mov	di, imm16

	dd	v30shift_ea8_data8	; C0:	shift	EA8, DATA8
	dd	v30shift_ea16_data8	; C1:	shift	EA16, DATA8
	dd	ret_near_data16		; C2:	ret near DATA16
	dd	ret_near		; C3:	ret near
	dd	les_r16_ea		; C4:	les	REG16, EA
	dd	lds_r16_ea		; C5:	lds	REG16, EA
	dd	mov_ea8_data8		; C6:	mov	EA8, DATA8
	dd	mov_ea16_data16		; C7:	mov	EA16, DATA16
	dd	_enter			; C8:	enter	DATA16, DATA8
	dd	_leave			; C9:	leave
	dd	ret_far_data16		; CA:	ret far	DATA16
	dd	ret_far			; CB:	ret far
	dd	int_03			; CC:	int	3
	dd	int_data8		; CD:	int	DATA8
	dd	_into			; CE:	into
	dd	_iret			; CF:	iret

	dd	shift_ea8_1		; D0:	shift EA8, 1
	dd	shift_ea16_1		; D1:	shift EA16, 1
	dd	v30shift_ea8_cl		; D2:	shift EA8, cl
	dd	v30shift_ea16_cl	; D3:	shift EA16, cl
	dd	v30_aam			; D4:	AAM
	dd	v30_aad			; D5:	AAD
	dd	_xlat			; D6:	xlat (8086/V30)
	dd	_xlat			; D7:	xlat
	dd	_esc			; D8:	esc
	dd	_esc			; D9:	esc
	dd	_esc			; DA:	esc
	dd	_esc			; DB:	esc
	dd	_esc			; DC:	esc
	dd	_esc			; DD:	esc
	dd	_esc			; DE:	esc
	dd	_esc			; DF:	esc

	dd	_loopnz			; E0:	loopnz
	dd	_loopz			; E1:	loopz
	dd	_loop			; E2:	loop
	dd	_jcxz			; E3:	jcxz
	dd	in_al_data8		; E4:	in	al, DATA8
	dd	in_ax_data8		; E5:	in	ax, DATA8
	dd	out_data8_al		; E6:	out	DATA8, al
	dd	out_data8_ax		; E7:	out	DATA8, ax
	dd	call_near		; E8:	call near
	dd	jmp_near		; E9:	jmp near
	dd	jmp_far			; EA:	jmp far
	dd	jmp_short		; EB:	jmp short
	dd	in_al_dx		; EC:	in	al, dx
	dd	in_ax_dx		; ED:	in	ax, dx
	dd	out_dx_al		; EE:	out	dx, al
	dd	out_dx_ax		; EF:	out	dx, ax

	dd	_lock			; F0:	lock
	dd	_lock			; F1:	lock
	dd	v30_repne		; F2:	repne
	dd	v30_repe		; F3:	repe
	dd	_hlt			; F4:	hlt
	dd	_cmc			; F5:	cmc
	dd	_ope0xf6		; F6:	
	dd	_ope0xf7		; F7:	
	dd	_clc			; F8:	clc
	dd	_stc			; F9:	stc
	dd	_cli			; FA:	cli
	dd	_sti			; FB:	sti
	dd	_cld			; FC:	cld
	dd	_std			; FD:	std
	dd	_ope0xfe		; FE:	
	dd	_ope0xff		; FF:	


; ----------------------------------------------------------------- repe

section .text

	align	16
v30repe_segprefix_es:
	mov	eax, dword [ES_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op_repe + ebx * 4]

	align	16
v30repe_segprefix_cs:
	mov	eax, dword [CS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op_repe + ebx * 4]

	align	16
v30repe_segprefix_ss:
	mov	eax, dword [SS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op_repe + ebx * 4]

	align	16
v30repe_segprefix_ds:
	mov	eax, dword [DS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op_repe + ebx * 4]


section .data

	align	16
v30op_repe dd	add_ea_r8		; 00:	add	EA, REG8
           dd	add_ea_r16		; 01:	add	EA, REG16
           dd	add_r8_ea		; 02:	add	REG8, EA
           dd	add_r16_ea		; 03:	add	REG16, EA
           dd	add_al_data8		; 04:	add	al, DATA8
           dd	add_ax_data16		; 05:	add	ax, DATA16
           dd	push_es			; 06:	push	es
           dd	pop_es			; 07:	pop	es
           dd	or_ea_r8		; 08:	or	EA, REGF8
           dd	or_ea_r16		; 09:	or	EA, REG16
           dd	or_r8_ea		; 0A:	or	REG8, EA
           dd	or_r16_ea		; 0B:	or	REG16, EA
           dd	or_al_data8		; 0C:	or	al, DATA8
           dd	or_ax_data16		; 0D:	or	ax, DATA16
           dd	push_cs			; 0E:	push	cs
           dd	_cts			; 0F:	i286 upper opcode

           dd	adc_ea_r8		; 10:	adc	EA, REG8
           dd	adc_ea_r16		; 11:	adc	EA, REG16
           dd	adc_r8_ea		; 12:	adc	REG8, EA
           dd	adc_r16_ea		; 13:	adc	REG16, EA
           dd	adc_al_data8		; 14:	adc	al, DATA8
           dd	adc_ax_data16		; 15:	adc	ax, DATA16
           dd	push_ss			; 16:	push	ss
           dd	v30pop_ss		; 17:	pop	ss
           dd	sbb_ea_r8		; 18:	sbb	EA, REG8
           dd	sbb_ea_r16		; 19:	sbb	EA, REG16
           dd	sbb_r8_ea		; 1A:	sbb	REG8, EA
           dd	sbb_r16_ea		; 1B:	sbb	REG16, EA
           dd	sbb_al_data8		; 1C:	sbb	al, DATA8
           dd	sbb_ax_data16		; 1D:	sbb	ax, DATA16
           dd	push_ds			; 1E:	push	ds
           dd	pop_ds			; 1F:	pop	ds

           dd	and_ea_r8		; 20:	and	EA, REG8
           dd	and_ea_r16		; 21:	and	EA, REG16
           dd	and_r8_ea		; 22:	and	REG8, EA
           dd	and_r16_ea		; 23:	and	REG16, EA
           dd	and_al_data8		; 24:	and	al, DATA8
           dd	and_ax_data16		; 25:	and	ax, DATA16
           dd	v30repe_segprefix_es	; 26:	repe es:
           dd	_daa			; 27:	daa
           dd	sub_ea_r8		; 28:	sub	EA, REG8
           dd	sub_ea_r16		; 29:	sub	EA, REG16
           dd	sub_r8_ea		; 2A:	sub	REG8, EA
           dd	sub_r16_ea		; 2B:	sub	REG16, EA
           dd	sub_al_data8		; 2C:	sub	al, DATA8
           dd	sub_ax_data16		; 2D:	sub	ax, DATA16
           dd	v30repe_segprefix_cs	; 2E:	repe cs:
           dd	_das			; 2F:	das

           dd	xor_ea_r8		; 30:	xor	EA, REG8
           dd	xor_ea_r16		; 31:	xor	EA, REG16
           dd	xor_r8_ea		; 32:	xor	REG8, EA
           dd	xor_r16_ea		; 33:	xor	REG16, EA
           dd	xor_al_data8		; 34:	xor	al, DATA8
           dd	xor_ax_data16		; 35:	xor	ax, DATA16
           dd	v30repe_segprefix_ss	; 36:	repe ss:
           dd	_aaa			; 37:	aaa
           dd	cmp_ea_r8		; 38:	cmp	EA, REG8
           dd	cmp_ea_r16		; 39:	cmp	EA, REG16
           dd	cmp_r8_ea		; 3A:	cmp	REG8, EA
           dd	cmp_r16_ea		; 3B:	cmp	REG16, EA
           dd	cmp_al_data8		; 3C:	cmp	al, DATA8
           dd	cmp_ax_data16		; 3D:	cmp	ax, DATA16
           dd	v30repe_segprefix_ds	; 3E:	repe ds:
           dd	_aas			; 3F:	aas

           dd	inc_reg16		; 40:	inc	ax
           dd	inc_reg16		; 41:	inc	cx
           dd	inc_reg16		; 42:	inc	dx
           dd	inc_reg16		; 43:	inc	bx
           dd	inc_reg16		; 44:	inc	sp
           dd	inc_reg16		; 45:	inc	bp
           dd	inc_reg16		; 46:	inc	si
           dd	inc_reg16		; 47:	inc	di
           dd	dec_reg16		; 48:	dec	ax
           dd	dec_reg16		; 49:	dec	cx
           dd	dec_reg16		; 4A:	dec	dx
           dd	dec_reg16		; 4B:	dec	bx
           dd	dec_reg16		; 4C:	dec	sp
           dd	dec_reg16		; 4D:	dec	bp
           dd	dec_reg16		; 4E:	dec	si
           dd	dec_reg16		; 4F:	dec	di

           dd	push_ax			; 50:	push	ax
           dd	push_cx			; 51:	push	cx
           dd	push_dx			; 52:	push	dx
           dd	push_bx			; 53:	push	bx
           dd	v30push_sp		; 54:	push	sp
           dd	push_bp			; 55:	push	bp
           dd	push_si			; 56:	push	si
           dd	push_di			; 57:	push	di
           dd	pop_ax			; 58:	pop	ax
           dd	pop_cx			; 59:	pop	cx
           dd	pop_dx			; 5A:	pop	dx
           dd	pop_bx			; 5B:	pop	bx
           dd	v30pop_sp		; 5C:	pop	sp
           dd	pop_bp			; 5D:	pop	bp
           dd	pop_si			; 5E:	pop	si
           dd	pop_di			; 5F:	pop	di

           dd	_pusha			; 60:	pusha
           dd	_popa			; 61:	popa
           dd	_bound			; 62:	bound
           dd	v30_reserved		; 63:	reserved
           dd	v30_reserved		; 64:	reserved
           dd	v30_reserved		; 65:	reserved
           dd	v30_reserved		; 66:	reserved
           dd	v30_reserved		; 67:	reserved
           dd	push_data16		; 68:	push	DATA16
           dd	imul_reg_ea_data16	; 69:	imul	REG, EA, DATA16
           dd	push_data8		; 6A:	push	DATA8
           dd	imul_reg_ea_data8	; 6B:	imul	REG, EA, DATA8
           dd	rep_insb		; 6C:	rep insb
           dd	rep_insw		; 6D:	rep insw
           dd	rep_outsb		; 6E:	rep outsb
           dd	rep_outsw		; 6F:	rep outsw

           dd	jo_short		; 70:	jo short
           dd	jno_short		; 71:	jno short
           dd	jc_short		; 72:	jnae/jb/jc short
           dd	jnc_short		; 73:	jae/jnb/jnc short
           dd	jz_short		; 74:	je/jz short
           dd	jnz_short		; 75:	jne/jnz short
           dd	jna_short		; 76:	jna/jbe short
           dd	ja_short		; 77:	ja/jnbe short
           dd	js_short		; 78:	js short
           dd	jns_short		; 79:	jns short
           dd	jp_short		; 7A:	jp/jpe short
           dd	jnp_short		; 7B:	jnp/jpo short
           dd	jl_short		; 7C:	jl/jnge short
           dd	jnl_short		; 7D:	jnl/jge short
           dd	jle_short		; 7E:	jle/jng short
           dd	jnle_short		; 7F:	jg/jnle short

           dd	calc_ea8_i8		; 80:	op	EA8, DATA8
           dd	calc_ea16_i16		; 81:	op	EA16, DATA16
           dd	calc_ea8_i8		; 82:	op	EA8, DATA8
           dd	calc_ea16_i8		; 83:	op	EA16, DATA8
           dd	test_ea_r8		; 84:	test	EA, REG8
           dd	test_ea_r16		; 85:	test	EA, REG16
           dd	xchg_ea_r8		; 86:	xchg	EA, REG8
           dd	xchg_ea_r16		; 87:	xchg	EA, REG16
           dd	mov_ea_r8		; 88:	mov	EA, REG8
           dd	mov_ea_r16		; 89:	mov	EA, REG16
           dd	mov_r8_ea		; 8A:	mov	REG8, EA
           dd	mov_r16_ea		; 8B:	add	REG16, EA
           dd	mov_ea_seg		; 8C:	mov	EA, segreg
           dd	lea_r16_ea		; 8D:	lea	REG16, EA
           dd	mov_seg_ea		; 8E:	mov	segrem, EA
           dd	pop_ea			; 8F:	pop	EA

           dd	_nop			; 90:	xchg	ax, ax
           dd	xchg_ax_reg		; 91:	xchg	ax, cx
           dd	xchg_ax_reg		; 92:	xchg	ax, dx
           dd	xchg_ax_reg		; 93:	xchg	ax, bx
           dd	xchg_ax_reg		; 94:	xchg	ax, sp
           dd	xchg_ax_reg		; 95:	xchg	ax, bp
           dd	xchg_ax_reg		; 96:	xchg	ax, si
           dd	xchg_ax_reg		; 97:	xchg	ax, di
           dd	_cbw			; 98:	cbw
           dd	_cwd			; 99:	cwd
           dd	call_far		; 9A:	call far
           dd	_wait			; 9B:	wait
           dd	v30_pushf		; 9C:	pushf
           dd	v30_popf		; 9D:	popf
           dd	_sahf			; 9E:	sahf
           dd	_lahf			; 9F:	lahf

           dd	mov_al_m8		; A0:	mov	al, m8
           dd	mov_ax_m16		; A1:	mov	ax, m16
           dd	mov_m8_al		; A2:	mov	m8, al
           dd	mov_m16_ax		; A3:	mov	m16, ax
           dd	rep_movsb		; A4:	rep movsb
           dd	rep_movsw		; A5:	rep movsw
           dd	repe_cmpsb		; A6:	repe cmpsb
           dd	repe_cmpsw		; A7:	repe cmpsw
           dd	test_al_data8		; A8:	test	al, DATA8
           dd	test_ax_data16		; A9:	test	ax, DATA16
           dd	rep_stosb		; AA:	rep stosw
           dd	rep_stosw		; AB:	rep stosw
           dd	rep_lodsb		; AC:	rep lodsb
           dd	rep_lodsw		; AD:	rep lodsw
           dd	repe_scasb		; AE:	repe scasb
           dd	repe_scasw		; AF:	repe scasw

           dd	mov_al_imm		; B0:	mov	al, imm8
           dd	mov_cl_imm		; B1:	mov	cl, imm8
           dd	mov_dl_imm		; B2:	mov	dl, imm8
           dd	mov_bl_imm		; B3:	mov	bl, imm8
           dd	mov_ah_imm		; B4:	mov	ah, imm8
           dd	mov_ch_imm		; B5:	mov	ch, imm8
           dd	mov_dh_imm		; B6:	mov	dh, imm8
           dd	mov_bh_imm		; B7:	mov	bh, imm8
           dd	mov_ax_imm		; B8:	mov	ax, imm16
           dd	mov_cx_imm		; B9:	mov	cx, imm16
           dd	mov_dx_imm		; BA:	mov	dx, imm16
           dd	mov_bx_imm		; BB:	mov	bx, imm16
           dd	mov_sp_imm		; BC:	mov	sp, imm16
           dd	mov_bp_imm		; BD:	mov	bp, imm16
           dd	mov_si_imm		; BE:	mov	si, imm16
           dd	mov_di_imm		; BF:	mov	di, imm16

           dd	v30shift_ea8_data8	; C0:	shift	EA8, DATA8
           dd	v30shift_ea16_data8	; C1:	shift	EA16, DATA8
           dd	ret_near_data16		; C2:	ret near DATA16
           dd	ret_near		; C3:	ret near
           dd	les_r16_ea		; C4:	les	REG16, EA
           dd	lds_r16_ea		; C5:	lds	REG16, EA
           dd	mov_ea8_data8		; C6:	mov	EA8, DATA8
           dd	mov_ea16_data16		; C7:	mov	EA16, DATA16
           dd	_enter			; C8:	enter	DATA16, DATA8
           dd	_leave			; C9:	leave
           dd	ret_far_data16		; CA:	ret far	DATA16
           dd	ret_far			; CB:	ret far
           dd	int_03			; CC:	int	3
           dd	int_data8		; CD:	int	DATA8
           dd	_into			; CE:	into
           dd	_iret			; CF:	iret

           dd	shift_ea8_1		; D0:	shift EA8, 1
           dd	shift_ea16_1		; D1:	shift EA16, 1
           dd	v30shift_ea8_cl		; D2:	shift EA8, cl
           dd	v30shift_ea16_cl	; D3:	shift EA16, cl
           dd	v30_aam			; D4:	AAM
           dd	v30_aad			; D5:	AAD
           dd	_xlat			; D6:	xlat (8086/V30)
           dd	_xlat			; D7:	xlat
           dd	_esc			; D8:	esc
           dd	_esc			; D9:	esc
           dd	_esc			; DA:	esc
           dd	_esc			; DB:	esc
           dd	_esc			; DC:	esc
           dd	_esc			; DD:	esc
           dd	_esc			; DE:	esc
           dd	_esc			; DF:	esc

           dd	_loopnz			; E0:	loopnz
           dd	_loopz			; E1:	loopz
           dd	_loop			; E2:	loop
           dd	_jcxz			; E3:	jcxz
           dd	in_al_data8		; E4:	in	al, DATA8
           dd	in_ax_data8		; E5:	in	ax, DATA8
           dd	out_data8_al		; E6:	out	DATA8, al
           dd	out_data8_ax		; E7:	out	DATA8, ax
           dd	call_near		; E8:	call near
           dd	jmp_near		; E9:	jmp near
           dd	jmp_far			; EA:	jmp far
           dd	jmp_short		; EB:	jmp short
           dd	in_al_dx		; EC:	in	al, dx
           dd	in_ax_dx		; ED:	in	ax, dx
           dd	out_dx_al		; EE:	out	dx, al
           dd	out_dx_ax		; EF:	out	dx, ax

           dd	_lock			; F0:	lock
           dd	_lock			; F1:	lock
           dd	v30_repne		; F2:	repne
           dd	v30_repe		; F3:	repe
           dd	_hlt			; F4:	hlt
           dd	_cmc			; F5:	cmc
           dd	_ope0xf6		; F6:	
           dd	_ope0xf7		; F7:	
           dd	_clc			; F8:	clc
           dd	_stc			; F9:	stc
           dd	_cli			; FA:	cli
           dd	_sti			; FB:	sti
           dd	_cld			; FC:	cld
           dd	_std			; FD:	std
           dd	_ope0xfe		; FE:	
           dd	_ope0xff		; FF:	


; ----------------------------------------------------------------- repne

section .text

	align	16
v30repne_segprefix_es:
	mov	eax, dword [ES_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op_repne + ebx * 4]

	align	16
v30repne_segprefix_cs:
	mov	eax, dword [CS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op_repne + ebx * 4]

	align	16
v30repne_segprefix_ss:
	mov	eax, dword [SS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op_repne + ebx * 4]

	align	16
v30repne_segprefix_ds:
	mov	eax, dword [DS_BASE]
	mov	dword [DS_FIX], eax
	mov	dword [SS_FIX], eax
	bts	dword [i286s + I286STAT.prefix], 0
	jc	.fixed
	push	dword removeprefix
.fixed:
	GET_PCBYTEEX
	jmp	[v30op_repne + ebx * 4]


section .data

	align	16
v30op_repne	dd	add_ea_r8		; 00:	add	EA, REG8
		dd	add_ea_r16		; 01:	add	EA, REG16
		dd	add_r8_ea		; 02:	add	REG8, EA
		dd	add_r16_ea		; 03:	add	REG16, EA
		dd	add_al_data8		; 04:	add	al, DATA8
		dd	add_ax_data16		; 05:	add	ax, DATA16
		dd	push_es			; 06:	push	es
		dd	pop_es			; 07:	pop	es
		dd	or_ea_r8		; 08:	or	EA, REGF8
		dd	or_ea_r16		; 09:	or	EA, REG16
		dd	or_r8_ea		; 0A:	or	REG8, EA
		dd	or_r16_ea		; 0B:	or	REG16, EA
		dd	or_al_data8		; 0C:	or	al, DATA8
		dd	or_ax_data16		; 0D:	or	ax, DATA16
		dd	push_cs			; 0E:	push	cs
		dd	_cts			; 0F:	i286 upper opcode

		dd	adc_ea_r8		; 10:	adc	EA, REG8
		dd	adc_ea_r16		; 11:	adc	EA, REG16
		dd	adc_r8_ea		; 12:	adc	REG8, EA
		dd	adc_r16_ea		; 13:	adc	REG16, EA
		dd	adc_al_data8		; 14:	adc	al, DATA8
		dd	adc_ax_data16		; 15:	adc	ax, DATA16
		dd	push_ss			; 16:	push	ss
		dd	v30pop_ss		; 17:	pop	ss
		dd	sbb_ea_r8		; 18:	sbb	EA, REG8
		dd	sbb_ea_r16		; 19:	sbb	EA, REG16
		dd	sbb_r8_ea		; 1A:	sbb	REG8, EA
		dd	sbb_r16_ea		; 1B:	sbb	REG16, EA
		dd	sbb_al_data8		; 1C:	sbb	al, DATA8
		dd	sbb_ax_data16		; 1D:	sbb	ax, DATA16
		dd	push_ds			; 1E:	push	ds
		dd	pop_ds			; 1F:	pop	ds

		dd	and_ea_r8		; 20:	and	EA, REG8
		dd	and_ea_r16		; 21:	and	EA, REG16
		dd	and_r8_ea		; 22:	and	REG8, EA
		dd	and_r16_ea		; 23:	and	REG16, EA
		dd	and_al_data8		; 24:	and	al, DATA8
		dd	and_ax_data16		; 25:	and	ax, DATA16
		dd	v30repne_segprefix_es	; 26:	repne es:
		dd	_daa			; 27:	daa
		dd	sub_ea_r8		; 28:	sub	EA, REG8
		dd	sub_ea_r16		; 29:	sub	EA, REG16
		dd	sub_r8_ea		; 2A:	sub	REG8, EA
		dd	sub_r16_ea		; 2B:	sub	REG16, EA
		dd	sub_al_data8		; 2C:	sub	al, DATA8
		dd	sub_ax_data16		; 2D:	sub	ax, DATA16
		dd	v30repne_segprefix_cs	; 2E:	repne cs:
		dd	_das			; 2F:	das

		dd	xor_ea_r8		; 30:	xor	EA, REG8
		dd	xor_ea_r16		; 31:	xor	EA, REG16
		dd	xor_r8_ea		; 32:	xor	REG8, EA
		dd	xor_r16_ea		; 33:	xor	REG16, EA
		dd	xor_al_data8		; 34:	xor	al, DATA8
		dd	xor_ax_data16		; 35:	xor	ax, DATA16
		dd	v30repne_segprefix_ss	; 36:	repne ss:
		dd	_aaa			; 37:	aaa
		dd	cmp_ea_r8		; 38:	cmp	EA, REG8
		dd	cmp_ea_r16		; 39:	cmp	EA, REG16
		dd	cmp_r8_ea		; 3A:	cmp	REG8, EA
		dd	cmp_r16_ea		; 3B:	cmp	REG16, EA
		dd	cmp_al_data8		; 3C:	cmp	al, DATA8
		dd	cmp_ax_data16		; 3D:	cmp	ax, DATA16
		dd	v30repne_segprefix_ds	; 3E:	repne ds:
		dd	_aas			; 3F:	aas

		dd	inc_reg16		; 40:	inc	ax
		dd	inc_reg16		; 41:	inc	cx
		dd	inc_reg16		; 42:	inc	dx
		dd	inc_reg16		; 43:	inc	bx
		dd	inc_reg16		; 44:	inc	sp
		dd	inc_reg16		; 45:	inc	bp
		dd	inc_reg16		; 46:	inc	si
		dd	inc_reg16		; 47:	inc	di
		dd	dec_reg16		; 48:	dec	ax
		dd	dec_reg16		; 49:	dec	cx
		dd	dec_reg16		; 4A:	dec	dx
		dd	dec_reg16		; 4B:	dec	bx
		dd	dec_reg16		; 4C:	dec	sp
		dd	dec_reg16		; 4D:	dec	bp
		dd	dec_reg16		; 4E:	dec	si
		dd	dec_reg16		; 4F:	dec	di

		dd	push_ax			; 50:	push	ax
		dd	push_cx			; 51:	push	cx
		dd	push_dx			; 52:	push	dx
		dd	push_bx			; 53:	push	bx
		dd	v30push_sp		; 54:	push	sp
		dd	push_bp			; 55:	push	bp
		dd	push_si			; 56:	push	si
		dd	push_di			; 57:	push	di
		dd	pop_ax			; 58:	pop	ax
		dd	pop_cx			; 59:	pop	cx
		dd	pop_dx			; 5A:	pop	dx
		dd	pop_bx			; 5B:	pop	bx
		dd	v30pop_sp		; 5C:	pop	sp
		dd	pop_bp			; 5D:	pop	bp
		dd	pop_si			; 5E:	pop	si
		dd	pop_di			; 5F:	pop	di

		dd	_pusha			; 60:	pusha
		dd	_popa			; 61:	popa
		dd	_bound			; 62:	bound
		dd	v30_reserved		; 63:	reserved
		dd	v30_reserved		; 64:	reserved
		dd	v30_reserved		; 65:	reserved
		dd	v30_reserved		; 66:	reserved
		dd	v30_reserved		; 67:	reserved
		dd	push_data16		; 68:	push	DATA16
		dd	imul_reg_ea_data16	; 69:	imul	REG, EA, DATA16
		dd	push_data8		; 6A:	push	DATA8
		dd	imul_reg_ea_data8	; 6B:	imul	REG, EA, DATA8
		dd	rep_insb		; 6C:	rep insb
		dd	rep_insw		; 6D:	rep insw
		dd	rep_outsb		; 6E:	rep outsb
		dd	rep_outsw		; 6F:	rep outsw

		dd	jo_short		; 70:	jo short
		dd	jno_short		; 71:	jno short
		dd	jc_short		; 72:	jnae/jb/jc short
		dd	jnc_short		; 73:	jae/jnb/jnc short
		dd	jz_short		; 74:	je/jz short
		dd	jnz_short		; 75:	jne/jnz short
		dd	jna_short		; 76:	jna/jbe short
		dd	ja_short		; 77:	ja/jnbe short
		dd	js_short		; 78:	js short
		dd	jns_short		; 79:	jns short
		dd	jp_short		; 7A:	jp/jpe short
		dd	jnp_short		; 7B:	jnp/jpo short
		dd	jl_short		; 7C:	jl/jnge short
		dd	jnl_short		; 7D:	jnl/jge short
		dd	jle_short		; 7E:	jle/jng short
		dd	jnle_short		; 7F:	jg/jnle short

		dd	calc_ea8_i8		; 80:	op	EA8, DATA8
		dd	calc_ea16_i16		; 81:	op	EA16, DATA16
		dd	calc_ea8_i8		; 82:	op	EA8, DATA8
		dd	calc_ea16_i8		; 83:	op	EA16, DATA8
		dd	test_ea_r8		; 84:	test	EA, REG8
		dd	test_ea_r16		; 85:	test	EA, REG16
		dd	xchg_ea_r8		; 86:	xchg	EA, REG8
		dd	xchg_ea_r16		; 87:	xchg	EA, REG16
		dd	mov_ea_r8		; 88:	mov	EA, REG8
		dd	mov_ea_r16		; 89:	mov	EA, REG16
		dd	mov_r8_ea		; 8A:	mov	REG8, EA
		dd	mov_r16_ea		; 8B:	add	REG16, EA
		dd	mov_ea_seg		; 8C:	mov	EA, segreg
		dd	lea_r16_ea		; 8D:	lea	REG16, EA
		dd	mov_seg_ea		; 8E:	mov	segrem, EA
		dd	pop_ea			; 8F:	pop	EA

		dd	_nop			; 90:	xchg	ax, ax
		dd	xchg_ax_reg		; 91:	xchg	ax, cx
		dd	xchg_ax_reg		; 92:	xchg	ax, dx
		dd	xchg_ax_reg		; 93:	xchg	ax, bx
		dd	xchg_ax_reg		; 94:	xchg	ax, sp
		dd	xchg_ax_reg		; 95:	xchg	ax, bp
		dd	xchg_ax_reg		; 96:	xchg	ax, si
		dd	xchg_ax_reg		; 97:	xchg	ax, di
		dd	_cbw			; 98:	cbw
		dd	_cwd			; 99:	cwd
		dd	call_far		; 9A:	call far
		dd	_wait			; 9B:	wait
		dd	v30_pushf		; 9C:	pushf
		dd	v30_popf		; 9D:	popf
		dd	_sahf			; 9E:	sahf
		dd	_lahf			; 9F:	lahf

		dd	mov_al_m8		; A0:	mov	al, m8
		dd	mov_ax_m16		; A1:	mov	ax, m16
		dd	mov_m8_al		; A2:	mov	m8, al
		dd	mov_m16_ax		; A3:	mov	m16, ax
		dd	rep_movsb		; A4:	rep movsb
		dd	rep_movsw		; A5:	rep movsw
		dd	repne_cmpsb		; A6:	repne cmpsb
		dd	repne_cmpsw		; A7:	repne cmpsw
		dd	test_al_data8		; A8:	test	al, DATA8
		dd	test_ax_data16		; A9:	test	ax, DATA16
		dd	rep_stosb		; AA:	rep stosw
		dd	rep_stosw		; AB:	rep stosw
		dd	rep_lodsb		; AC:	rep lodsb
		dd	rep_lodsw		; AD:	rep lodsw
		dd	repne_scasb		; AE:	repne scasb
		dd	repne_scasw		; AF:	repne scasw

		dd	mov_al_imm		; B0:	mov	al, imm8
		dd	mov_cl_imm		; B1:	mov	cl, imm8
		dd	mov_dl_imm		; B2:	mov	dl, imm8
		dd	mov_bl_imm		; B3:	mov	bl, imm8
		dd	mov_ah_imm		; B4:	mov	ah, imm8
		dd	mov_ch_imm		; B5:	mov	ch, imm8
		dd	mov_dh_imm		; B6:	mov	dh, imm8
		dd	mov_bh_imm		; B7:	mov	bh, imm8
		dd	mov_ax_imm		; B8:	mov	ax, imm16
		dd	mov_cx_imm		; B9:	mov	cx, imm16
		dd	mov_dx_imm		; BA:	mov	dx, imm16
		dd	mov_bx_imm		; BB:	mov	bx, imm16
		dd	mov_sp_imm		; BC:	mov	sp, imm16
		dd	mov_bp_imm		; BD:	mov	bp, imm16
		dd	mov_si_imm		; BE:	mov	si, imm16
		dd	mov_di_imm		; BF:	mov	di, imm16

		dd	v30shift_ea8_data8	; C0:	shift	EA8, DATA8
		dd	v30shift_ea16_data8	; C1:	shift	EA16, DATA8
		dd	ret_near_data16		; C2:	ret near DATA16
		dd	ret_near		; C3:	ret near
		dd	les_r16_ea		; C4:	les	REG16, EA
		dd	lds_r16_ea		; C5:	lds	REG16, EA
		dd	mov_ea8_data8		; C6:	mov	EA8, DATA8
		dd	mov_ea16_data16		; C7:	mov	EA16, DATA16
		dd	_enter			; C8:	enter	DATA16, DATA8
		dd	_leave			; C9:	leave
		dd	ret_far_data16		; CA:	ret far	DATA16
		dd	ret_far			; CB:	ret far
		dd	int_03			; CC:	int	3
		dd	int_data8		; CD:	int	DATA8
		dd	_into			; CE:	into
		dd	_iret			; CF:	iret

		dd	shift_ea8_1		; D0:	shift EA8, 1
		dd	shift_ea16_1		; D1:	shift EA16, 1
		dd	v30shift_ea8_cl		; D2:	shift EA8, cl
		dd	v30shift_ea16_cl	; D3:	shift EA16, cl
		dd	v30_aam			; D4:	AAM
		dd	v30_aad			; D5:	AAD
		dd	_xlat			; D6:	xlat (8086/V30)
		dd	_xlat			; D7:	xlat
		dd	_esc			; D8:	esc
		dd	_esc			; D9:	esc
		dd	_esc			; DA:	esc
		dd	_esc			; DB:	esc
		dd	_esc			; DC:	esc
		dd	_esc			; DD:	esc
		dd	_esc			; DE:	esc
		dd	_esc			; DF:	esc

		dd	_loopnz			; E0:	loopnz
		dd	_loopz			; E1:	loopz
		dd	_loop			; E2:	loop
		dd	_jcxz			; E3:	jcxz
		dd	in_al_data8		; E4:	in	al, DATA8
		dd	in_ax_data8		; E5:	in	ax, DATA8
		dd	out_data8_al		; E6:	out	DATA8, al
		dd	out_data8_ax		; E7:	out	DATA8, ax
		dd	call_near		; E8:	call near
		dd	jmp_near		; E9:	jmp near
		dd	jmp_far			; EA:	jmp far
		dd	jmp_short		; EB:	jmp short
		dd	in_al_dx		; EC:	in	al, dx
		dd	in_ax_dx		; ED:	in	ax, dx
		dd	out_dx_al		; EE:	out	dx, al
		dd	out_dx_ax		; EF:	out	dx, ax

		dd	_lock			; F0:	lock
		dd	_lock			; F1:	lock
		dd	v30_repne		; F2:	repne
		dd	v30_repne		; F3:	repne
		dd	_hlt			; F4:	hlt
		dd	_cmc			; F5:	cmc
		dd	_ope0xf6		; F6:	
		dd	_ope0xf7		; F7:	
		dd	_clc			; F8:	clc
		dd	_stc			; F9:	stc
		dd	_cli			; FA:	cli
		dd	_sti			; FB:	sti
		dd	_cld			; FC:	cld
		dd	_std			; FD:	std
		dd	_ope0xfe		; FE:	
		dd	_ope0xff		; FF:	
